c
c    Copyright (C) 1997  Peter Vernon Lanspeary
c
c    This program is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    This program is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program; if not, write to the Free Software
c    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c

      PROGRAM GENACQ
c
c               ******************************************
c               **                                      **
c               **   General Data Acquisition Program   **
c               **                                      **
c               ******************************************
c
c       :- written by Peter V Lanspeary for PC - XT
c Specific Purpose :- to acquire data from turbulent boundary layer
c                     and other experiments onto a permanent storage
c                     device
c
c include genacq.def
c
c include genacq.cmn
c
c  logical *1 equery,   # Function : displays request and returns reply
c             emgopn,   #          : open message file
c             emgwrt,   #          : write message
c             fmlcal,   # 'calibration module used' flag
c             fmlacq,   # 'acquisition module used' flag
c             fmodqy,   # query execution of each module at run time
c             fsbcgo,   # SBC has been started flag
c             fstmdl,   # first module selected flag
c             foldmq,   # old value of fmodqy - same usage as foldq
c             foldq     # old value of fquiet - only used when converting from
c                       #   or to manual mode .
c  integer *2 i,        # looping index
c             ilabel(3),# array of number of initial messages
c             Jresp     # Function : accepts & checks response to a menu request
c  character CskipC*26  # Skip calibration module ?
c  subroutine sinit,    # initialize module
c             scalib,   # calibration module
c             sacqu,    # data acquisition module
c             Sdisp,    # display module
c             sclose,   # close data file module
c             sbstop,   # stop the SBC
c             scfopn,   # open a command file
c             smgwrt,   # get a message - verbosity adjusted
c             sopwrt,   # write a value to output command file
c             srdfil    # read file names
c Messages
c  00101 - select prompt
c  00300 - program label
c  01101 - mode ?
c  02001 - switched to manual
c  02101 - module
c  02201 - 1st module = initialize
c  02301 - must calibrate
c  02401 - last module = close
c  02501 - separate initialize with close
c
      implicit none
      include 'genacq.kon'
c
      logical *1 equery, emgopn, emgwrt, fmlcal, fmlacq, fsbcgo, fstmdl,
     1  foldq, foldmq, fmodqy
      integer *2 i, ilabel(3), Jresp
      character CskipC *26
      include 'genacq.cmn'
      data ilabel / 1, 2, 6 /, fsbcgo, foldq, foldmq / 3 * .false. /
      data Cskipc / 'Skip calibration module ? ' /
c0
c0
c0
      fdfopn = .false.
      call srdfil( 'c:\genacq\bin\genacq.fil' )
      if ( .not. emgopn( Hmsglu, Cmsgfil ) ) then                         1b
        write( Hvdulu, 9 )
9       format( ' GENACQ : FATAL : Cannot open message file' )
        stop
        end if                                                            1e
c     repeat                                                              1b
1       if ( .not. emgwrt( Hvdulu, 00101 ) ) then                         2b
          write( Hvdulu, 10 )
10        format( ' GENACQ : FATAL : Cannot get messages' )
          stop
          end if                                                          2e
        Ipropt = Jresp( Hkbdlu, -1, 3, Hntries )
        if ( Ipropt .eq. Hexit ) stop
c                  initialize log file
        if ( Ipropt .eq. Hlfinz )
     1    fstlfr = .true.
        if ( Ipropt .le. 0 ) goto 1
c     until ( Ipropt > 0 )                                                1e
c0
c0      Program label
c0
      Ipropt = 10 * Ipropt
      do 3 i = 1, ilabel( Ipropt / 10 )                                   1b
        call smgwrt( 00300 + i )
        read ( Hkbdlu, 2 )
2       format( )
3       continue                                                          1e
      nmode = 0
c1
c1      Start Select mode loop
c1
4       fquiet = .false.
        fmodqy = .false.
        call smgwrt( 01101 )                                              1b
        Imode = Jresp( Hkbdlu, Hexit, Hexecute, Hntries )
        if ( Imode .eq. Hexit ) goto 8
        nmode = nmode + 1
        if ( Imode .eq. Hmanual ) then                                    2b
c1
c1    Assign files for manual mode
c1
          Iipf1 = Hkbdlu
          Iipf2 = Hnullu
          Iopf1 = Hnullu
          fenxeq = .true.
          Cipf1 = 'keyboard'
          Cipf2 = 'no file'
          Copf1 = 'no file'
        else if ( Imode .eq. Hcopy ) then                                 2m
c1
c1      Assign files for copy mode
c1
          Iipf1 = Hkbdlu
          Iipf2 = Hnullu
          Iopf1 = Hncflu
          fenxeq = .true.
          Cipf1 = 'keyboard'
          Cipf2 = 'no file'
          call scfopen( Copf1, 1 )
        else if ( Imode .eq. Hwrite ) then                                 2m
c1
c1      Assign files for write mode
c1
          Iipf1 = Hkbdlu
          Iipf2 = Hnullu
          Iopf1 = Hncflu
          fenxeq = .false.
          Cipf1 = 'keyboard'
          Cipf2 = 'no file'
          call scfopen( Copf1, 1 )
        else if ( Imode .eq. Hread ) then                                  2m
c1
c1      Assign files for read mode
c1
          Iipf1 = Hocflu
          Iipf2 = Hnullu
          Iopf1 = Hvdulu
          fenxeq = .false.
          call scfopen( Cipf1, 2 )
          Cipf2 = 'no file'
          Copf1 = 'video display unit'
        else if ( Imode .eq. Hexecute ) then                              2m
c1
c1      Assign files for execute mode
c1
          Iipf1 = Hocflu
          Iipf2 = Hkbdlu
          Iopf1 = Hvdulu
          fenxeq = .true.
          call scfopen( Cipf1, 2 )
          fquiet = Equery( Hkbdlu,
     1      'Shall I suppress prompts and responses ?' )
          fmodqy = Equery( Hkbdlu,
     1      'Query execution/skipping of each module ?' )
          Cipf2 = 'keyboard'
          Copf1 = 'video display unit'
          end if                                                          2e
c1
c1      Open the secondary input file
c1
        fipf2 = .false.
        if ( Imode .le. Hwrite ) then                                     2b
          if ( equery( Hkbdlu, 'Will you open secondary input files ?' )
     1        ) then                                                      3b
            Iipf2 = Hocflu
            fipf2 = .true.
            end if                                                        3e
          end if                                                          2e
c1
c1      Initialize flags
c1
        fstmdl = .true.
        fmdcpy = .false.
        fmdxeq = .false.
        fmlcal = .false.
        fmlacq = .false.
c2
c2      start select module loop
c2
5         if ( fmdcpy .or. fmdxeq )                                       2b
     1      call smgwrt( 02001 )
c
c               select module
c
          call smgwrt( 02101 )
          if ( Imode .eq. Hmanual ) then                                  3b
            Imodul = Jresp( Iipf1, Hexit, Hclose, Hntries )
          else                                                            3m
            Imodul = Jresp( Iipf1, Hexit, Hconvert, Hntries )
            if ( fmdcpy .and. ( Imodul .eq. Hconvert .or.
     1          Imodul .eq. Hexit ) ) then                                4b
c2
c2      Change back from 'converted to manual' to copy mode
c2
              fmdcpy = .false.
              Iopf1 = Hncflu
              goto 5
              end if                                                      4e
            if ( fmdxeq .and. ( Imodul .eq. Hconvert .or.
     1          Imodul .eq. Hexit ) ) then                                4b
c2
c2      Change back from 'converted to manual' to execute mode
c2
              fmdxeq = .false.
              fquiet = foldq
              fmodqy = foldmq
              Iipf1 = Hocflu
              Iipf2 = Hkbdlu
              Iopf1 = Hvdulu
              goto 5
              end if                                                      4e
            end if                                                        3e
          if ( Imodul .eq. Hexit ) goto 6
          if ( Imode .eq. Hcopy .or. Imode .eq. Hexecute .or.
     1        Imodul .ne. Hconvert ) then                                 3b
            if ( Imodul .eq. Hconvert )
     1          call sopwrt( Hconvert, Hint2 )
c2
c2      Change from copy or write to manual mode
c2
            if ( Imodul .eq. Hconvert .and. ( Imode .eq. Hwrite .or.
     1          Imode .eq. Hcopy ) ) then                                 4b
              fmdcpy = .true.
              Iopf1 = Hnullu
              end if                                                      4e
c2
c2      Change from execute to manual mode
c2
            if ( Imodul .eq. Hconvert .and. Imode .eq. Hexecute ) then    4b
              fmdxeq = .true.
              foldq = fquiet
              foldmq = fmodqy
              fmodqy = .false.
              fquiet = .false.
              Iopf1 = Hnullu
              Iipf1 = Hkbdlu
              Iipf2 = Hnullu
              end if                                                      4e
            if ( Imodul .eq. Hconvert .and. ( fmdcpy .or. fmdxeq ) )
     1          goto 5
c2
c2      call display module
c2
            if ( Imodul .eq. Hdisp ) then                                 4b
              call sopwrt( Hdisp, Hint2 )
              call Sdisp
            else if ( Imodul .eq. Hinit .and. .not. fstmdl ) then         4b
              call smgwrt( 02501 )
              if ( equery( Hkbdlu,
     1  'May I call CLOSE ? ( else disable INITIALIZE )' ) ) then         5b
c2
c2      Rule 5
c2
                if ( fmlacq .and. .not. fmlcal ) then                     6b
c2
c2      Rule 2
c2
                  call smgwrt( 02301 )
                  call sopwrt( Hcalib, Hint2 )
                  if ( fmodqy ) then                                      7b
                    fenxeq = .not. Equery( Hkbdlu, CskipC )
                    call Scalib
                    fenxeq = .true.
                  else                                                    7m
                    call Scalib
                    end if                                                7e
                  end if                                                  6e
c2
c2      put a call to CLOSE before a call to INITIALIZE
c2
                call sopwrt( Hclose, Hint2 )
                call Sclose
                call sopwrt( Hinit, Hint2 )
                call Sinit( fsbcgo )
                fmlcal = .false.
                fstmdl = .false.
                fmlacq = .false.
                end if                                                    5e
            else if ( fstmdl ) then                                       4m
c2
c2      Rule 1 : first module is initialize
c2
              if ( Imodul .ne. Hinit )
     1          call smgwrt( 02201 )
              call sopwrt( Hinit, Hint2 )
              call Sinit( fsbcgo )
              fmlcal = .false.
              fstmdl = .false.
              fmlacq = .false.
              end if
c2
c2      call calibrate module
c2
            if ( Imodul .eq. Hcalib ) then                                4m
              call sopwrt( Hcalib, Hint2 )
              if ( fmodqy ) then                                          5b
                fenxeq = .not. Equery( Hkbdlu, CskipC )
                call Scalib
                fenxeq = .true.
              else                                                        5m
                call Scalib
                end if                                                    5e
              fmlcal = .true.
c2
c2      call acquisition module
c2
            else if ( Imodul .eq. Hacqu ) then                            4m
              call sopwrt( Hacqu, Hint2 )
              if ( fmodqy ) then                                          5b
                fenxeq = .not. Equery( Hkbdlu,
     1              'Skip acquisition module ?' )
                call Sacqu
                fenxeq = .true.
              else                                                        5m
                call Sacqu
                end if                                                    5e
              fmlacq = .true.
c2
c2      Call CLOSE module
c2
c2      Rule 2 : Calibrate
c2
            else if ( Imodul .eq. Hclose ) then                           4m
              if ( fmlacq .and. .not. fmlcal ) then                       5b
                call smgwrt( 02301 )
                call sopwrt( Hcalib, Hint2 )
                if ( fmodqy ) then                                        6b
                  fenxeq = .not. Equery( Hkbdlu, CskipC )
                  call Scalib
                  fenxeq = .true.
                else                                                      6m
                  call Scalib
                  end if                                                  6e
                end if                                                    5e
              call sopwrt( Hclose, Hint2 )
              call Sclose
              fstmdl = .true.
              end if                                                      4e
          else                                                            3m
            call sopwrt( Imodul, Hint2 )
            end if                                                        3e
          goto 5
c2
c2        end of select module loop                                       2e
c2
6       if ( .not. fstmdl ) then                                          2b
c2
c2      Rule 3
c2
          call smgwrt( 02401 )
          if ( fmlacq .and. .not. fmlcal ) then                           3b
c2
c2      Rule 2
c2
            call smgwrt( 02301 )
            call sopwrt( Hcalib, Hint2 )
            if ( fmodqy ) then                                            4b
              fenxeq = .not. Equery( Hkbdlu, CskipC )
              call Scalib
              fenxeq = .true.
            else                                                          4m
              call Scalib
              end if                                                      4e
            end if                                                        3e
c2
c2      Call close module
c2
          call sopwrt( Hclose, Hint2 )
          call Sclose
          end if                                                          2e
c1
c1      Close command files
c1
        call sopwrt( Hexit, Hint2 )
        if ( fmdcpy )
     1    write( Hncflu, 7 ) Hexit
7         format( i2 )
        if ( Iopf1 .eq. Hncflu )
     1    close( Hncflu )
        if ( Iipf1 .eq. Hocflu )
     1    close( Hocflu )
        goto 4
c1
c1      end of select mode loop                                           1e
c1
8     if ( fsbcgo )
     1  call sbstop
      stop
      end
