c
c    Copyright (C) 1997  Peter Vernon Lanspeary
c
c    This program is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    This program is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program; if not, write to the Free Software
c    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c


      SUBROUTINE SDEBUG(III)
c
c       debug routine
c  dump all variables in the module common block
c
c Argument
c  integer *2 iii      # where from ? key
c Variables
c  subroutine sdump    # dump variables
c
      implicit none
      include 'genacq.kon'
c
      integer *2 iii
      logical *1 equery
      include 'genacq.cmn'
      include 'module.cmn'
c
      write( Hvdulu, 1 ) iii
1     format( // ' SDEBUG : ' , i6 )
      if ( Equery( Hkbdlu, 'display ? ' ) )
     1    call sdump(iblock)
      return
      end


      SUBROUTINE SDUMP( IBLK )
c
c     dump variables in a data block
c
      implicit none
      include 'genacq.kon'
c
      integer *2 iblk
      include 'genacq.cmn'
      include 'module.cmn'
c
      write( Hvdulu, 1 ) iblock
1     format( ' iblock = ', i6 )
c
      write( Hvdulu, 2 ) gacqc(Hhalt,iblk), gacqc(Huttvs,iblk),
     1  iacqc(Hhcid,iblk),    iacqc(Htvsid,iblk),
     2  racqv(Hhcyt,iblk),    racqv( 0 + Htvsoff ,iblk),
     3  iacqv(Hhncy,iblk),    racqv( 1 + Htvsoff ,iblk),
     4  iacqv(Hhchan,iblk),   racqv( 2 + Htvsoff ,iblk),
     5  gacqc(Hhamon ,iblk),  racqv( 3 + Htvsoff ,iblk),
     6  racqv(Hhmon ,iblk),   racqv( 4 + Htvsoff ,iblk),
     7  racqv(Hhtol ,iblk)
2     format( / ' pause ? ', l1, t40, 'using traverse ? ', l1 /
     1  '  A/D id = ', i7, t42, 'traverse id = ', a2 /
     2  '  cycle time = ', g14.7, t55, 'x = ', g14.7 /
     3  '  no. of cycles = ', i7, t55, 'y = ', g14.7 /
     4  '  A/D chan = ', i7, t55, 'z = ', g14.7 /
     5  '  auto monitor ? ', l1, t51, 'theta = ', g14.7 /
     6  '    monitor voltage = ', g14.7, t53, 'phi = ', g14.7 /
     7  '    monitor tolerance = ', g14.7 // )
      write( Hvdulu, 3 ) gacqc(H2cdb,iblk), gacqc(H1cdb,iblk),
     1  iacqc(H2cid,iblk),           iacqc(H1cid,iblk),
     2  racqv(Hcytim+Hsecoff,iblk),  racqv(Hcytim+Hprimoff,iblk),
     3  racqv(Hsampd+Hsecoff,iblk),  racqv(Hsampd+Hprimoff,iblk),
     4  iacqv(Hnocy+Hsecoff,iblk),   iacqv(Hnocy+Hprimoff,iblk),
     5  iacqv(Hcylen+Hsecoff,iblk),  iacqv(Hcylen+Hprimoff,iblk),
     6  gacqc(H2unp,iblk),           gacqc(H1unp,iblk),
     7  gacqc(H2kbdv,iblk),          gacqc(H1kbdv,iblk),
     8  iacqv(Hcntr+Hsecoff,iblk),   iacqv(Hcntr+Hprimoff,iblk)
3     format( ' secondary sub-block ? ', l1, t40, 'primary ? ', l1 /
     1  '  A/D id = ', i2, t60, i2 /
     2  '  cycle time = ', g14.7, t60, g14.7 /
     3  '  sample time = ', g14.7, t60, g14.7 /
     4  '  no. of cycles = ', i12, t65, i12 /
     5  '  cycle length = ', i3, t60, i3 /
     6  '  unpacking ? ', l1, t60, l1 /
     7  '  kbd ref value ? ', l1, t60, l1 /
     8  '  event / loop counter ', i6, t60, i6 )
      return
      end


      SUBROUTINE SHVARS
c
c       display all variable settings and limits
c
      implicit none
      include 'genacq.kon'
c
      logical *1 Equery
      integer *2 i
      include 'genacq.cmn'
      include 'module.cmn'
c
      write( Hvdulu, 1 ) iblock, nvars(iblock)
1     format( ' SHVARS : block ', i6, ' no. of vars = ', i6 )
      if ( Equery( Hkbdlu, 'Display ?' ) ) then                             2b
        write( Hvdulu, 6 )
6       format( '   index   type lin/log  level    start         ',
     1    'end    increment' )
        do 4 i = 1, nvars(iblock)                                           3b
          if ( Itype(i,iblock) .eq. Hreal ) then                            4b
            write( Hvdulu, 2 ) jindex(i,iblock), itype(i,iblock),
     1        linlog(i,iblock), ilevel(i,iblock),
     2        rstart(i,iblock), rend(i,iblock), rinc(i,iblock)
2           format( 1x, 4i7, 3g13.6 )
          else if ( Itype(i,iblock) .eq. Hint2 .or.
     1        Itype(i,iblock) .eq. Hint4 ) then                             4m
            write( Hvdulu, 3 ) jindex(i,iblock), itype(i,iblock),
     1        linlog(i,iblock), ilevel(i,iblock),
     2        istart(i,iblock), iend(i,iblock), rinc(i,iblock)
3           format( 1x, 4i7, i9, 4x, i9, 4x, g13.6 )
          else                                                              4m
            call sfail( Htyperr )
            end if                                                          4e
4         continue                                                          3e
        end if                                                              2e
      return
      end
