
      BLOCK DATA MODBLK
c
c           Initializes the MODULE common block
c
      implicit none
      include 'genacq.kon'
      include 'module.cmn'
c
      data  iitype / Hreal, 2*Hint2, 7*Hreal, Hint2, 2*Hreal, Hint4,
     1  2*Hint2, 2*Hreal, Hint4, Hint2 /
      data frepen /.false. /
      end


      SUBROUTINE SGTDAT
c
c       Gets the preliminary and main data blocks .
c
      implicit none
      include 'genacq.kon'
      include 'genacq.cmn'
      include 'module.cmn'
      external saqdbk
c
      if ( fenxeq ) then                                                  1b
c
c       get prelim, main and extra data block
c
        do 1 iblock = 1, 3                                                2b
          if ( fblock( iblock ) ) then                                    3b
            if ( nvars(iblock) .gt. 0 ) then                              4b
              call sdo( saqdbk )
            else                                                          4m
              call saqdbk
              end if                                                      4e
            end if                                                        3e
1         continue                                                        2e
        end if                                                            1e
      return
      end


      SUBROUTINE SDO( SUBR )
c
c Other parameters passed through common block :-
c       RACQV, RSTART, REND, RINC, JINDEX, ITYPE, LINLOG
c
c     Subroutine to execute the subroutine SUBR, inside ILEVEL nested levels
c  simulated do loops on the variables in RACQV , which are specified by the
c  indices in in JINDEX, according to the 'do loop' parameters RSTART, REND and
c  RINC . The first variable referred to in the JINDEX, RSTART, REND and RINC
c  lists is on the outside loop . The last is on the inside loop . The
c  increment can be linear or logarithmic . LINLOG(i,iblock) = 1 for linear ;
c  LINLOG(i,iblock) = 2 for logarithmic increment . If ILEVEL(i,iblock) != 0,
c  the Ith variable is on the same loop level as the (I-1)th variable . Ie.
c  the Ith and (I-1)th variables increment simultaneously . The variables in
c  RACQU can be of integer*2, integer*4 or real*4 type , but all variables
c  are allocated 4 bytes of space . The type of each variable is specified by :
c  ITYPE = 1  real *4            The subroutine SUBR has an empty argument
c        = 2  integer *2         list . All its parameters must be passed
c        = 3  integer *4         through a common block .
c
c Argument
c  subroutine subr             # executed within the nested loops
c Variables
c  logical *1 first(Hlevel)    # first pass through loop
c             fok, fok1        # flags for error testing
c  integer *2 i,               # level index
c             i1,              # current variable pointer
c             iindex,          # loop variable index
c             imaxlev,         # pointer to last independent variable
c             itemp            # temporary
c  real rendt                  # end limit - corrected for limited precision
c
      implicit none
      include 'genacq.kon'
      include 'genacq.cmn'
      include 'module.cmn'
c
      logical *1 first(Hlevel), fok, fok1
      integer *2 i, i1, iindex, imaxlev, itemp
      real rendt
c
      external subr
c
c       check the input parameters
c       **************************
c
c       check number of variables
c
      if ( iblock .le. 0 .or. iblock .gt. Hnblks ) then                    1b
        write( Hvdulu, 15 ) iblock
15      format( ' SDO : ABORT : Illegal block number ', i6 )
      else if ( nvars(iblock) .le. 0 .or. nvars(iblock) .gt. Hlevel )
     1    then                                                             1m
        write( Hvdulu, 10 ) nvars(iblock)
10      format( ' SDO : ABORT : Can''t have ', i5, ' variables' )
        fok = .false.
      else if ( 0 .ne. ilevel(1,iblock) ) then                             1m
        write( Hvdulu, 11 )
11      format( ' SDO : ABORT : Level 1 can''t depend on nonexistent',
     1    ' previous level' )
        fok = .false.
      else                                                                 1m
c
c       for each variable
c
        fok = .true.
        do 1 i = 1, nvars(iblock)                                          2b
          fok1 = .true.
c
c       check variable location, type & increment type
c
          if ( jindex(i,iblock) .lt. 1 .or.
     1         jindex(i,iblock) .gt. Hnvars .or.
     2         linlog(i,iblock) .ne. Hlin .and.
     3         linlog(i,iblock) .ne. Hlog .or.
     4         itype(i,iblock) .lt. Hreal .or.
     5         itype(i,iblock) .gt. Hint4 ) then                           3b
            write( Hvdulu, 12 ) i, jindex(i,iblock), linlog(i,iblock),
     1        itype(i,iblock)
12          format( ' SDO : ABORT : Arg. list error in row ', i2 /
     1        10x, 'index = ', i6, / 10x, 'linlog = ', i6 /
     1        10x, 'itype = ', i6 )
            fok1 = .false.
c
c       check limits & increments - for log increment
c
          else if ( linlog(i,iblock) .eq. Hlog ) then                      3m
            if ( itype(i,iblock) .eq. Hint2 .or.
     1          itype(i,iblock) .eq. Hint4 ) then                          4b
              fok1 = rinc(i,iblock) .gt. 0.0 .and.
     1          istart(i,iblock) .ne. 0 .and.
     2          iend(i,iblock) .ne. 0 .and.
     3          rinc(i,iblock) .ne. 1.0 .and.
     4          real( iend(i,iblock) - istart(i,iblock) ) *
     5          ( rinc(i,iblock) - 1.0 ) .gt. 0
              itemp = min( abs( istart(i,iblock) ),
     1          abs( iend(i,iblock) ) )
              if ( fok1 )
     1          fok1 = int( itemp * max( rinc(i,iblock),
     2             1.0 / rinc(i,iblock) ) ) .gt. itemp
            else if ( itype(i,iblock) .eq. Hreal ) then                    4m
              fok1 = rinc(i,iblock) .gt. 0.0 .and.
     1          rstart(i,iblock) .ne. 0.0 .and.
     2          rend(i,iblock) .ne. 0.0 .and.
     3          rinc(i,iblock) .ne. 1.0 .and.
     4          ( rend(i,iblock) - rstart(i,iblock) ) *
     5          ( rinc(i,iblock) - 1.0 ) .gt. 0.0
            else                                                           4m
              call sfail( Htyperr )
              end if                                                       4e
            if ( .not. fok1 )
     1        write( Hvdulu, 13 ) i
13            format( ' SDO : ABORT : Error in increment or limit - ',
     1          'row ', i5 )
c
c       check limits and increments - for linear increment
c
          else if ( linlog(i,iblock) .eq. Hlin ) then                      3m
            if ( itype(i,iblock) .eq. Hint2 .or.
     1          itype(i,iblock) .eq. Hint4 ) then                          4b
              fok1 = real( iend(i,iblock) - istart(i,iblock) ) *
     1          rinc(i,iblock) .gt. 0
            else if ( itype(i,iblock) .eq. Hreal ) then                    4m
              fok1 = ( rend(i,iblock) - rstart(i,iblock) ) *
     1          rinc(i,iblock) .gt. 0
            else                                                           4m
              call sfail( Htyperr )
              end if                                                       4e
            if ( .not. fok1 )
     1        write (Hvdulu, 13 ) i
            end if                                                         3e
          fok = fok .and. fok1
1         continue                                                         2e
        end if                                                             1e
c
c             end of checking - start the real work
c
      if ( .not. fok ) then                                                1b
        write( Hvdulu, 14 )
14      format( ' SDO : ABORT' )
      else                                                                 1e
c
c             find the maximum level of nesting
c
        imaxlev = nvars(iblock)
2       if ( 0 .ne. ilevel(imaxlev,iblock) ) then                          2b
          imaxlev = imaxlev - 1
          goto 2
          end if                                                           2e
        i = 1
c
c             start of loop
c             *************
c
c             initialize starting values
c
100     i1 = i
c       repeat                                                             2b
3         iacqv(jindex(i1,iblock) ,iblock) = istart(i1,iblock)
          first(i1) = .true.
          i1 = i1 + 1
          if ( 0 .ne. ilevel(i1,iblock) .and. i1 .le. Hlevel ) goto 3
c         until( 0 .eq. ilevel(i1,iblock) .or. i1 .gt. Hlevel )            2e
        goto 300
c
c             decrement loop level
c
c       repeat                                                             2b
200       i = i - 1
          if ( i .eq. 0 )
     1      return
          if ( 0 .ne. ilevel(i,iblock) .and. i .gt. 1 ) goto 200
c         until( 0 .eq. ilevel(i,iblock) .or. i .le. 1 )                   2e
c
c             increment loop variable and test for end of loop
c             ************************************************
c
300     i1 = i
c       repeat                                                             2b
4         iindex = jindex(i1,iblock)
          if ( itype(i1,iblock) .eq. Hreal ) then                          3b
            if ( .not. first(i1) ) then                                    4b
              if ( linlog(i1,iblock) .eq. Hlin ) then                      5b
                racqv(iindex,iblock) = racqv(iindex,iblock) +
     1            rinc(i1,iblock)
              else                                                         5m
                racqv(iindex,iblock) = racqv(iindex,iblock) *
     1            rinc(i1,iblock)
                end if                                                     5e
              end if                                                       4e
            rendt = rend(i1,iblock) + ( rend(i1,iblock) -
     1        rstart(i1,iblock) ) * 1.0e-6
            if ( rstart(i1,iblock) .lt. rend(i1,iblock) ) then             4b
              if ( racqv(iindex ,iblock) .gt. rendt ) goto 200
            else                                                           4m
              if ( racqv(iindex ,iblock) .lt. rendt ) goto 200
              end if                                                       4e
          else if ( itype(i1,iblock) .eq. Hint4 .or.
     1        itype(i1,iblock) .eq. Hint2 ) then                           3m
            if ( .not. first(i1) ) then                                    4b
              if ( linlog(i1,iblock) .eq. Hlin ) then                      5b
                iacqv(iindex,iblock) =  iacqv(iindex,iblock) +
     1            iinc(i1,iblock)
              else                                                         5m
                iacqv(iindex,iblock) = int( iacqv(iindex,iblock) *
     1            rinc(i1,iblock) )
                end if                                                     5e
              end if                                                       4e
            if ( istart(i1,iblock) .lt. iend(i1,iblock) ) then             4b
              if ( iacqv(iindex,iblock) .gt. iend(i1,iblock) ) goto 200
            else                                                           4m
              if ( iacqv(iindex,iblock) .lt. iend(i1,iblock) ) goto 200
              end if                                                       4e
          else                                                             3m
            call sfail( Htyperr )
            end if                                                         3e
          first(i1) = .false.
          i1 = i1 + 1
          if ( 0 .ne. ilevel(i1,iblock) .and. i1 .lt. Hlevel ) goto 4
c        until( 0 .eq. ilevel(i1,iblock) .or. i1 .ge. Hlevel )             2e
c
c             inside the loop
c             ***************
c
        if ( i .eq. imaxlev ) then                                         2b
          call subr
          goto 300
          end if                                                           2e
c
c             go up to the next level
c
c       repeat                                                             2b
5         i = i + 1
          if (  0 .ne. ilevel(i,iblock) .and. i .lt. imaxlev ) goto 5
c         until( 0 .eq. ilevel(i,iblock) .or. i .ge. imaxlev )             2e
        goto 100
        end if                                                             1e
      return
      end


      SUBROUTINE SAQDBK
c
c       Acquire a data block, and write header and data blocks onto data file
c
c Variables
c  logical *1 fhamon,           # automatic monitor flag
c             ok,               # monitored voltage is OK, & return value of da*
c             daflush,          # function : flush data file buffer
c             daput,            #          : put values onto data file
c             daputc,           #          : put character string onto data file
c             equery,           #          : logical response
c             sdelay            #          : SBC time delay
c  integer *2 i,                # sample counting loop index
c             iadid,            # A/D converter identifier
c             ichan,            # A/D chan address
c             ihamon,           # automatic monitor flag
c             inocy,            # no. of A/D cycles
c             itvsid,           # traverse identifier chars
c             mdata(Hdatbuf)    # data buffer
c             timdat(3)         # time hh:mm:ss and date dd:mm:yy stamps
c             nhdr              # no. of bytes in header record
c  integer *4 dnocy             # no. of A/D cycles
c             dpdata            # number of data bytes obtained
c  real rnorm,                  # constant to convert A/D reading to volts
c       rhmon,                  # monitor target voltage
c       rtvsxx(5),              # actual probe position
c       rcytim,                 # A/D cycle time
c  character Cstring*8          # returned string containing time and date stamp
c            Cblkhdr(3)*8       # block header labels
c  subroutine gettvs,           # get position of traverse
c             puttvs,           # drive traverse to a position
c             saqebk,           # acquire a primary or secondary data sub-block
c             sbunpk,           # enable / disable unpacking
c             sloacq,           # SBC pseudo-directives - DAS 1128
c             sanacq            # SBC pseudo-directives - DAS 250A random
      implicit none
      include 'genacq.kon'
      character Cblkhdr(3)*8
      data Cblkhdr / '##prelim', '##main  ', '##extra ' /
c
      logical *1 fhamon, ok, daflush, daput, daputc, equery, sdelay
      integer *2 i, iadid, ichan, ihamon, inocy, itvsid,
     1  mdata(Hdatbuf), nhdr, timdat(3)
      integer *4 dnocy, dpdata
      real rnorm, rhmon, rtvsxx(5), rcytim
      character Cstring*8
c
      include 'genacq.cmn'
      include 'module.cmn'
      equivalence ( dpdata, mdata(1) ), ( fhamon, ihamon ),
     1  ( inocy, dnocy )
c
c           perform the initial block header delay if it is required
c           first check for illegal arguments
c
      if ( ibdelay(Hbdelm,iblock) .lt. 0  .or.
     1     ibdelay(Hbdels,iblock) .lt. 0  .or.
     2     ibdelay(Hbdelt,iblock) .lt. 0 ) then
        ibdelay(Hbdelm,iblock) = 0
        ibdelay(Hbdels,iblock) = 0
        ibdelay(Hbdelt,iblock) = 0
      else if ( ibdelay(Hbdelm,iblock) .ne. 0 .or.
     1          ibdelay(Hbdels,iblock) .ne. 0 .or.
     2          ibdelay(Hbdelt,iblock) .ne. 0 ) then
        call sbwrtq()
        ok = sdelay( ibdelay(Hbdelm,iblock), ibdelay(Hbdels,iblock),
     1                 ibdelay(Hbdelt,iblock) )
        call sbxeqq( mdata, -1 )
        end if
c
c           write data file block header
c
      ok = daputc( irec, Cblkhdr( iblock ) )
      ok = ok .and. daput( irec, 18, 2 )
c           time stamp  hours:minutes:seconds
      call time( Cstring )
      read( Cstring, 9 ) timdat
9     format( i2, 1x, i2, 1x, i2 )
      ok = ok .and. daput( irec, timdat, 6 )
c           date stamp
      call date( Cstring )
      read( Cstring, 9 ) timdat(2), timdat(1), timdat(3)
      ok = ok .and. daput( irec, timdat, 6 )
c           time delay minutes:seconds:milliseconds
      ok = ok .and. daput( irec, ibdelay(Hbdelm,iblock), 6 )
      ok = ok .and. daflush( irec )
      if ( .not. ok )
     1  call sfail( Hblkerr )
c
c           pause sub-block
c           ###############
c
      if ( gacqc(Hhalt,iblock) ) then                                      1b
        iadid = iacqc(Hhcid,iblock)
c
c           simple <CR> pause
c
        if ( iadid .ne. Hslo .and. iadid .ne. 2 ) then                     2b
          nhdr = 2
          write( Hvdulu, 1 )
1         format( ' pause <CR> ? ' )
          read( Hkbdlu, 4 )
4         format( )
c
c           monitored pause
c
        else                                                               2m
          rcytim = racqv(Hhcyt,iblock)
          dnocy = iacqv(Hhncy,iblock)
          ichan = iacqv(Hhchan,iblock)
c         repeat                                                           3b
2           if ( iadid .eq. Hslo ) then                                    4b
c
c           pause with DAS 1128 A/D
c
              call sbunpk( .true. )
              call sloacq( rcytim, dnocy, 1, ichan, mdata, -1 )
              rnorm = 400.0
c
c           pause with DAS 250A A/D
c
            else                                                           4m
              call sbunpk( .true. )
              call sanacq( rcytim, dnocy, 1, ichan, mdata, -1 )
              rnorm = - 409.6
              end if                                                       4e
c
c            average the data
c
            rmonav = 0.0
            if ( dpdata .gt. 0 ) then                                      4b
              do 3 i = 3, inocy + 2                                        5b
3               rmonav = rmonav + real( mdata( i ) )                       5e
              end if                                                       4e
            rmonav = rmonav / real( dnocy ) / rnorm
            ihamon = 0
            fhamon = gacqc(Hhamon,iblock)
c
c           automatic monitor
c
            if ( fhamon ) then                                             4b
              nhdr = 28
              rhmon = racqv(Hhmon,iblock)
              ok = abs( rhmon - rmonav ) .lt. racqv(Hhtol,iblock)
              write( Hvdulu, 5 ) ichan, rmonav, rhmon
5             format( ' A/D chan ', i2, 3x, f8.4, ' Volts  >>> ',
     1          f8.4, ' Volts' )
c
c           manual monitor
c
            else                                                           4m
              nhdr = 20
              write( Hvdulu, 6 ) ichan, rmonav
6             format( ' A/D chan ', i2, 3x, f8.4, ' Volts' )
              ok = equery( Hkbdlu, ' ok ?' )
              end if                                                       4e
            if ( .not. ok ) goto 2
c           until( ok )                                                    3e
          write( Hvdulu, 7 ) 7
7         format( ' ***** GOT IT ******', a1 )
          end if                                                           2e
c
c           write pause sub-block header record
c
        ok = daputc( irec, '###pause' )
        ok = ok .and. daput( irec, nhdr, 2 )
        ok = ok .and. daput( irec, iacqc(Hhcid,iblock), 2 )
        if ( nhdr .gt. 2 ) then                                            2b
c           rhcytm, ihncy, ihchan
          ok = ok .and. daput( irec, rcytim, 4 )
          ok = ok .and. daput( irec, dpdata, 4 )
          ok = ok .and. daput( irec, iacqv(Hhchan,iblock), 4 )
          ok = ok .and. daput( irec, ihamon, 2 )
          if ( fhamon )
     1      ok = ok .and. daput( irec, racqv(Hhmon,iblock), 8 )
          ok = ok .and. daput( irec, rmonav, 4 )
          end if                                                           2e
        ok = ok .and. daflush( irec )
        if ( .not. ok )
     1    call sfail( Hsbkerr )

        end if                                                             1e
c
c           traverse sub-block
c           ##################
c
      if ( gacqc(Huttvs,iblock) ) then                                     1b
        itvsid = iacqc(Htvsid,iblock)
        call puttvs( itvsid, racqv(Htvsoff,iblock) )
        call gettvs( itvsid, rtvsxx )
c
c           write traverse sub-block header record
c
        ok = daputc( irec, '###trav ' )
        ok = ok .and. daput( irec, 42, 2 )
        ok = ok .and. daput( irec, itvsid, 2 )
        ok = ok .and. daput( irec, racqv(Htvsoff,iblock), 20 )
        ok = ok .and. daput( irec, rtvsxx, 20 )
        ok = ok .and. daflush( irec )
        if ( .not. ok )
     1    call sfail( Hsbkerr )
        end if                                                              1e
c
c           secondary data sub-block
c           ########################
c
      if ( gacqc(H2cdb,iblock) )
     1  call saqebk( '###2dat2', Hsecoff, H2chls, H2unp )
c
c           primary data sub-block
c           ######################
c
      if ( gacqc(H1cdb,iblock) )
     1  call saqebk( '###1dat1', Hprimoff, H1chls, H1unp )
      return
      end


      SUBROUTINE SAQEBK( CLABEL, IVAROF, ICHOF, IUPOF )
c
c   Acquire a secondary or primary data block, write the sub-block header
c  and data records onto data file .
c
c Character Clabel*(*)          # sub-block header label
c  integer *2 ivarof,           # variable parameter offset
c             ichof,            # A/D chan addr offset
c             iupof             # unpack switch offset
c Variables
c  logical *1 fkbdv,            # using reference from keyboard
c             franad,           # random channel addressing on A/D
c             fupflg,           # data to be packed flag
c             ok,               # returned value of DAPUT etc
c             daflush,          # function : flush data file buffer
c             daputc            #          : write character string to data file
c             daput             #          : write value to data file
c  integer *2 iadid,            # A/D converter identifier
c             icylen,           # A/D cycle length
c             ikbdv,            # keyboard value used
c             iupflg,           # data to be unpacked in situ
c             jrec,             # sub-block header record number
c             nhdr              # no. of bytes in data file header record
c  integer *4 dnocy,            # no. of A/D cycles
c             dnbyte,           # number of data bytes collected
c  real  rcytim,                # A/D cycle time
c        rkbdrv,                # keyboard reference value
c        rsampd,                # A/D chan to chan sampling period
c        qresp                  # function : accept real value
c  subroutine sloacq            # SBC - data from DAS 1128
c             seqacq            # SBC - data from DAS 250 A - sequential
c             sanacq            # SBC - data from DAS 250 A - random
c             simacq            # SBC - data from `Una Voce' A/D
c
      implicit none
      include 'genacq.kon'
c
      logical *1 fkbdv, franad, fupflg, ok, daflush, daputc, daput
      integer *2 iadid, icylen, ikbdv, iupflg, jrec, nhdr, ivarof,
     1  ichof, iupof
      integer *4 dnocy, dnbyte
      real  rcytim, rkbdrv, rsampd, qresp
      character Clabel*(*)
c
      include 'genacq.cmn'
      include 'module.cmn'
      equivalence ( iupflg, fupflg ), ( ikbdv, fkbdv )
c
c       get variables & constants from arrays
c
      rcytim = racqv( ivarof + Hcytim ,iblock)
      rsampd = racqv( ivarof + Hsampd ,iblock)
      iadid = iacqc( iupof + 1 ,iblock)
      icylen = iacqv( ivarof + Hcylen ,iblock)
      dnocy = iacqv( ivarof + Hnocy ,iblock)
      iupflg = 0
      fupflg = gacqc( iupof ,iblock)
      rkbdrv = 0.0
      ikbdv = 0
      fkbdv = gacqc( iupof + 2 ,iblock)
      if ( fkbdv ) then                                                   1b
        write( Hvdulu, 1 )
1       format( ' Keyboard reference value (real) ? ' )
        rkbdrv = Qresp( Hkbdlu, -1.6e38, 1.6e38, Hntries )
        end if                                                            1e
c
c       leave a space for the header record - one record only
c
      jrec = irec
      irec = irec + 1
c
c       get data onto file
c
      call sbunpk( iadid .ne. Hslo .and. fupflg )
      if ( iadid .eq. Hslo ) then                                         1b
        call sloacq( rcytim, dnocy, icylen, iacqc(ichof,iblock),
     1    Hdatlu, irec )
      else if ( iadid .eq. Hseq ) then                                    1m
        call seqacq( rcytim, rsampd, dnocy, icylen, Hdatlu, irec )
      else if ( iadid .eq. Hsan ) then                                    1m
        call sanacq( rcytim, dnocy, icylen, iacqc(ichof,iblock),
     1    Hdatlu, irec )
      else if ( iadid .eq. Hsim ) then                                    1m
        call simacq( dnocy, icylen, Hdatlu, irec )
        end if                                                            1e
      dnbyte = dnocy * icylen
      if ( iadid .ne. Hslo .and. .not. fupflg ) then                      1b
        dnbyte = iand( dnbyte, 1 ) + 3 * dnbyte / 2
      else                                                                1m
        dnbyte = dnbyte * 2
        end if                                                            1e
      dtnbyt = dtnbyt + dnbyte
      ok = daflush( irec )
c
c       write sub-block header record
c
      nhdr = 28
      franad = iadid .eq. Hslo .or. iadid .eq. Hsan
      if ( franad )
     1  nhdr = nhdr + 2 * icylen
      ok = daputc( jrec, Clabel )
      ok = ok .and. daput( jrec, nhdr, 2 )
      ok = ok .and. daput( jrec, ikbdv, 2 )
      ok = ok .and. daput( jrec, rkbdrv, 4 )
      ok = ok .and. daput( jrec, iadid, 2 )
      ok = ok .and. daput( jrec, iupflg, 2 )
      ok = ok .and. daput( jrec, iacqv(ivarof,iblock), 4 )
      ok = ok .and. daput( jrec, rcytim, 4 )
      ok = ok .and. daput( jrec, rsampd, 4 )
      ok = ok .and. daput( jrec, dnocy, 4 )
      ok = ok .and. daput( jrec, icylen, 2 )
      if ( franad )
     1  ok = ok .and. daput( jrec, iacqc(ichof,iblock), 2 * icylen )
      ok = ok .and. daflush( jrec )
      if ( .not. ok )
     1  call sfail( Hsbkerr )
      return
      end


      SUBROUTINE SETDBK
c
c       Set up the parameters for a data block
c
c constants
c  integer *4 Hignore=999999.0
c             Hminch=0
c             Hmaxch=15
c             Hminnocy=1
c             Hmaxnocy=20480
c  real Hmintol=0.0
c       Hmaxtol=5.0
c Variables
c  logical *1 f,                # temporary switch
c             fvar(5),          # specify which parameters are variables
c             notok,            # traverse id is OK flag
c             eask              # function : display request and return reply
c  integer *2 i,                # looping index
c             iadid,            # A/D converter identifier
c             imask,            # bit switch selection mask
c             imin,             # index of variable with minimum level
c             itvgsw,           # traverse coordinates required switch
c             itvpsw(5),        # traverse plug config. coords. required
c             itvtsw(7),        # traverse tower config. coords. required
c             item,             # specifies which parameters are variables
c             j,                # control variable index
c             minlev,           # minimum level found
c             jljstr,           # function : left justify string
c             jresp             #          : accept & check an integer response
c  real rminct(2),              # minimum cycle time for pause sub-block
c       rmaxct(2),              # maximum "                            "
c       vmax(2),                # maximum target voltage for pause sub-block
c       vmin(2)                 # minimum target voltage for pause sub-block
c  characters Ctvid*6,          # 1st traverse identifier character
c             Cspchar(3)*1      # append char for secondary I/P file
c  subroutine setadb            # set params for primary & secondary sub-block
c             setvar,           # determine values of variable parameter
c             sipf2d,           # Select entry point for secondary I/P file
c             smgwrt,           # display numbered message
c             sopwrt,           # write a value to primary output file
c             sopwrtc,          # write a string to primary output file
c             ssipf2,           # Disables access to secondary I/P file
c             swap, swapi       # swap 4 & 2 bytes
c Messages
c  23007 - A/D id ?
c  23008 - cycle time ?
c  23009 - no. of cycles ?
c  23030 - A/D channel ?
c  23031 - monitor voltage ?
c  23032 - monitor voltage tolerance ?
c  23033 - traverse id ?
c  23034 - invalid traverse id
c  23035 to 23039 - x, y, z, theta, phi
c  23060 - traverse coordinates ?
c
      implicit none
      integer *4 Hminch, Hmaxch, Hminnocy
      real Hmintol, Hmaxtol, Hignore
      parameter( Hminch=0, Hmaxch=15, Hminnocy=1,
     1 Hignore=999999.0, Hmintol=0.0, Hmaxtol=5.0 )
      include 'genacq.kon'
c
      logical *1 notok, f, fvar(5), eask
      integer *2 i, iadid, imask, imin, itvgsw, itvpsw(5), itvtsw(7),
     1  item, j, minlev, jljstr, jresp
      real rminct(2), rmaxct(2), vmax(2), vmin(2)
      character Ctvid*6, Cspchar(3)*1
c
      include 'genacq.cmn'
      include 'module.cmn'
c
      data rminct, rmaxct / 56.75e-6, 80.45e-6, 4.194, 36.612e-3 /
      data itvpsw, itvtsw / 13, 13, 5, 0, 0, 26, 10, 10, 10, 2, 0, 0 /
      data Vmin / 0.0, -10.000 /, Vmax / 10.240, 0.0 /
      data Cspchar / 'p', 'm', 'e' /
c
c       initialize variable & constant arrays
c       *************************************
c
      nvars(iblock) = 0
      ibdelay(Hbdelm,iblock) = 0
      ibdelay(Hbdels,iblock) = 0
      ibdelay(Hbdelt,iblock) = 0
      do 16 i = 1, Hlevel
        itype(i,iblock)  = 0
        ilevel(i,iblock) = 0
        linlog(i,iblock) = 0
        jindex(i,iblock) = -1
        istart(i,iblock) = 0
        iend(i,iblock)   = 0
16      iinc(i,iblock)   = 0
      do 1 i = 1, 20
1       racqv(i,iblock) = 0.0
      do 2 i = 1, 41
2       iacqc(i,iblock) = 0
c
c       initial data block delay
c       ************************
c
      f = eask( 'Do you want an inter-block delay ?' )
      call sopwrt( f, Hlog1 )
      if ( f ) then
c                           Minutes ?
        call smgwrt( 23207 )
        ibdelay(Hbdelm,iblock) = Jresp( Iipf1, 0, 32767, Hntries )
        call sopwrt( ibdelay(Hbdelm,iblock), Hint2 )
c                           Seconds ?
        call smgwrt( 23208 )
        ibdelay(Hbdels,iblock) = Jresp( Iipf1, 0, 32767, Hntries )
        call sopwrt( ibdelay(Hbdels,iblock), Hint2 )
c                           Milli-seconds ?
        call smgwrt( 23209 )
        ibdelay(Hbdelt,iblock) = Jresp( Iipf1, 0, 32767, Hntries )
        call sopwrt( ibdelay(Hbdelt,iblock), Hint2 )
      else
        ibdelay(Hbdelm,iblock) = 0
        ibdelay(Hbdels,iblock) = 0
        ibdelay(Hbdelt,iblock) = 0
        end if
c
c       pause sub-block
c       ***************
c
      f = eask( 'Are you using pause sub-block ?' )
      call sopwrt( f, Hlog1 )
      gacqc(Hhalt,iblock) = f
      if ( f ) then                                                       1b
        call ssipf2( '##acquh' // cspchar(iblock), ' ' )
c
c       decide which parameters are variable
c
      do 3 i = 1, 5
3       fvar(i) = .false.
c     start of loop                                                       2b
4       if ( .not. fquiet )
     1    write( Hvdulu, 5 ) fvar
5         format( 1x, 5l1 )
        call smgwrt( 23203 )
        item = Jresp( Iipf1, -5, 5, Hntries )
        call sopwrt( item, Hint2 )
        if ( item .ne. 0 ) then                                           3b
          fvar( abs( item ) ) = item .gt. 0
          goto 4
          end if                                                          3e
c       end of loop                                                       2e
c
c       A/D id
c
        call smgwrt( 23007 )
        iadid = Jresp( Iipf1, 0, 2, Hntries )
        call sopwrt( iadid, Hint2 )
        iacqc(Hhcid,iblock) = iadid
c
c       monitored pause
c
        if ( iadid .gt. 0 ) then                                          2b
c
c       cycle time
c
          call setvar( Hhcyt, 23008, rminct(iadid), rmaxct(iadid),
     1      fvar(Hhcyt) )
c
c       no. of cycles
c
          call setvar( Hhncy, 23009, Hminnocy, Hdatbuf-2, fvar(Hhncy) )
c
c       A/D channel
c
          call setvar( Hhchan, 23030, Hminch, Hmaxch, fvar(Hhchan) )
c
c       automatic / manual monitoring
c
          f = eask( 'Automatic monitoring of this channel ?' )
          call sopwrt( f, Hlog1 )
          gacqc(Hhamon,iblock) = f
          if ( f ) then                                                   3b
c
c       monitor voltage
c
            call setvar( Hhmon, 23031, Vmin(iadid), Vmax(iadid),
     1        fvar(Hhmon) )
c
c       monitor voltage tolerance
c
            call setvar( Hhtol, 23032, Hmintol, Hmaxtol, fvar(Hhtol)  )
          else if ( fvar(Hhmon) .or. fvar(Hhtol) ) then                   3m
            call smgwrt( 23204 )
            end if                                                        3e
          end if                                                          2e
        call sipf2d
        end if                                                            1e
c
c       traverse sub-block
c       ******************
c
      f = eask( 'Are you using the traverse ?' )
      call sopwrt( f, Hlog1 )
      gacqc(Huttvs,iblock) = f
      if ( f ) then                                                       1b
        call ssipf2( '##acqut' // Cspchar(iblock), ' ' )
c
c        traverse identifier
c
c       repeat                                                            2b
c         repeat                                                          3b
6           call smgwrt( 23033 )
            read( iipf1, 7 ) ctvid
7           format( a )
            if ( jljstr( ctvid ) .lt. 2 ) goto 6
c           until( no. of chars >= 2 )                                    3e
          notok = index( 'pqrsn', ctvid(1:1) ) .eq. 0 .or.
     1         index( 'tmnaofe', ctvid(2:2) ) .eq. 0
          if ( notok )
     1      call smgwrt( 23034 )
          if ( notok ) goto 6
c         until ( ok )                                                    2e
        iacqc(Htvsid,iblock) = ichar( ctvid(2:2) ) * 256 +
     1    ichar( ctvid(1:1) )
        call sopwrtc( ctvid(1:2) )
c
c        set up 'required coordinates' flags
c
        itvgsw = itvpsw( index( 'pqrsn', ctvid(1:1) ) )
        itvgsw = ior( itvgsw, itvtsw( index( 'tmnaofe', ctvid(2:2) ) ) )
c
c         decide which parameters are variable
c
        do 8 i = 1, 5
8         fvar(i) = .false.
c       start of loop                                                     2b
9         if ( .not. fquiet )
     1      write( Hvdulu, 5 ) fvar
          call smgwrt( 23205 )
          imask = 1
          do 10 i = 0, 4                                                  3b
            if ( iand( imask, itvgsw ) .ne. 0 )
     1        call smgwrt( 23035 + i )
            imask = 2 * imask
10          continue                                                      3e
11        item = Jresp( Iipf1, -5, 5, Hntries )
          call sopwrt( item, Hint2 )
          if ( item .ne. 0 ) then                                         3b
            imask = 2** ( abs( item ) - 1 )
            if ( iand( imask, itvgsw ) .ne. 0 ) then                      4b
              fvar( abs( item) ) = item .gt. 0
              goto 9
            else                                                          4m
              call smgwrt( 23206 )
              goto 11
              end if                                                      4e
            end if                                                        3e
c         end of loop                                                     2e
c
c        get coordinates
c
        call smgwrt( 23060 )
        imask = 1
        do 12 i = 0, 4                                                    2b
          if ( iand( imask, itvgsw ) .ne. 0 ) then                        3b
            call smgwrt( 23035 + i )
            f = eask( 'Ignore ?' )
            call sopwrt( f, Hlog1 )
            if ( f ) then                                                 4b
              racqv(  Htvsoff + i ,iblock) = Hignore
            else                                                          4m
              call setvar( Htvsoff + i, 23035 + i, Hphysmin, Hphysmax,
     1          fvar( i + 1 ) )
              end if                                                      4e
            end if                                                        3e
          imask = 2 * imask
12        continue                                                        2e
        call sipf2d
        end if                                                            1e
c
c        secondary data sub-block
c        ************************
c
      f = eask( 'Are you collecting a secondary data sub-block ?' )
      call sopwrt( f, Hlog1 )
      gacqc(H2cdb,iblock) = f
      if ( f ) then                                                       1b
        call ssipf2( '##acqus' // Cspchar(iblock), ' ' )
        call setadb( Hsecoff, H2chls, H2unp )
        call sipf2d
        end if                                                            1e
c
c       primary data sub-block
c       **********************
c
      f = eask( 'Are you collecting a primary data sub-block ?' )
      call sopwrt( f, Hlog1 )
      gacqc(H1cdb,iblock) = f
      if ( f ) then                                                       1b
        call ssipf2( '##acqup' // Cspchar(iblock), ' ' )
        call setadb( Hprimoff, H1chls, H1unp )
        call sipf2d
        end if                                                            1e
c
c       sort variable controls into order of ascending level
c
      if ( nvars(iblock) .gt. 1 ) then                                            1b
        do 14 i = 1, nvars(iblock) - 1                                            2b
          imin = i
          minlev = ilevel( i,iblock)
          do 13 j = i + 1, nvars(iblock)                                          3b
            if ( minlev .gt. ilevel(j,iblock) )
     1        imin = j
13          continue                                                      3e
          call swapi( ilevel(i,iblock), ilevel(imin,iblock) )
          call swapi( jindex(i,iblock), jindex(imin,iblock) )
          call swapi( itype(i,iblock), itype(imin,iblock) )
          call swapi( linlog(i,iblock), linlog(imin,iblock) )
          call swap( istart(i,iblock), istart(imin,iblock) )
          call swap( iend(i,iblock), iend(imin,iblock) )
          call swap( iinc(i,iblock), iinc(imin,iblock) )
14        continue                                                        2e
c
c       change level indicators into logical values  ( 0=false, 1=true )
c
        do 15 i = nvars(iblock), 2, -1                                            2b
          imin = ilevel(i,iblock)
          ilevel(i,iblock) = 0
          if ( imin .le. ilevel( i - 1 ,iblock) )
     1      ilevel(i,iblock) = 1
15        continue                                                        2e
        end if                                                            1e
      ilevel(1,iblock) = 0
      return
      end


      SUBROUTINE SETADB( IVAROF, ICHOF, IUPOF )
c
c       Set parameters for Data acquisition sub-block
c
c Arguments
c  integer *2 ivarof,           # variable parameter offset
c             ichof,            # A/D chan addr list offset in const array
c             iupof,            # unpack switch offset in constants array
c Constants
c  integer *4 Hminctr=0
c             Hmaxctr=32767
c             Hmincylen=1
c             Hmincy=1
c  real       Hminspd=3.91063e-6
c Variables
c  logical *1 f,                # temporary variable
c             fvar(5),          # specify which parameters are variables
c             eask              # function : logical response
c  integer *2 i                 # channel counter
c             iadid,            # A/D converter identifier
c             ichan,            # A/D channel address
c             icylen,           # A/D acquisition cycle length
c             item,             # specifies which parameters are variables
c             Jresp,            # accept & check integer response
c             Jresp,            # accept & check integer response
c  integer *4 dnsam(4),         # max possible no. of data samples
c             dmaxcy,           # max possible no. of cycles
c             imaxcl(4)         # maximum cycle length for each A/D
c  real rsampd(4),              # sampling period   #  for calculating cycle
c       rsamov(3),              # sampling overhead #  time lower limits
c       rmaxct(3),              # maximum cycle period
c       rminct                  # minimum cycle period
c  subroutines smgwrt,          # display numbered message
c              sopwrt,          # write a value to numbered output file
c              setvar,          # define values of variable parameter
c Messages
c  23008 - cycle time ?
c  23061 - A/D id ?
c  23062 - sampling period ?
c  23063 - number of cycles ?
c  23064 - cycle length
c  23065 - channel address list ?
c  23104 - event / loop counter ?
c
      implicit none
      integer *4 Hminctr, Hmaxctr, Hmincylen, Hmincy
      real Hminspd
      parameter( Hminctr=0, Hmaxctr=32767, Hmincylen=1, Hmincy=1,
     1  Hminspd=3.91063e-6 )
      include 'genacq.kon'
c
      logical *1 f, fvar(5), eask
      integer *2 ivarof, ichof, iupof, i, iadid, ichan, icylen,
     1  item, Jresp
      integer *4 dnsam(4), dmaxcy, imaxcl(4)
      real rsampd(4), rsamov(3), rmaxct(3), rminct
c
      include 'genacq.cmn'
      include 'module.cmn'
c
c                    DAS 1128  DAS 250As  DAS 250Ar  Una Voce
      data imaxcl /        16,        16,        16,         8 /
      data rsampd /  24.25e-6,       0.0,  20.67e-6,       0.0 /
      data rsamov /   32.5e-6,  .5587e-6,  59.79e-6 /
      data rmaxct /     4.194, 36.612e-3, 36.612e-3 /
      data dnsam  /     20480,   1398100,   1398100,   1398100 /
c
c       using keyboard reference value ?
c
      f = eask( 'Using keyboard reference value ?' )
      call sopwrt( f, Hlog1 )
      gacqc( iupof + 2 ,iblock) = f
c
c       A/D id
c
      call smgwrt( 23061 )
      iadid = Jresp( iipf1, Hslo, Hsim, Hntries )
      call sopwrt( iadid, Hint2 )
      iacqc( iupof + 1 ,iblock) = iadid
c
c       determine which parameters are variables
c
      do 1 i = 1, 5
1       fvar(i) = .false.
c     start of loop                                                        1b
2       if ( .not. fquiet )
     1    write( Hvdulu, 3 ) fvar
3         format( 1x, 5l1 )
        call smgwrt( 23200 )
        item = Jresp( Iipf1, -5, 5, Hntries )
        call sopwrt( item, Hint2 )
        if ( item .lt. 0 ) then                                            2b
          fvar( -item ) = .false.
          goto 2
        else if ( item .gt. 0 ) then                                       2m
          if ( ( item .eq. 5 .or. item .eq. 2 ) .and. iadid .eq. Hsim
     1        ) then                                                       3b
            call smgwrt( 23201 )
          else if ( item .eq. 3 .and. iadid .ne. Hseq ) then               3b
            call smgwrt( 23202 )
          else                                                             3m
            fvar( item ) = .true.
            end if                                                         3e
          goto 2
          end if                                                           2e
c         end of loop                                                      1e
c
c       event / loop counter
c
      call setvar( ivarof + Hcntr, 23104, Hminctr, Hmaxctr,
     1  fvar( Hcntr + 1 ) )
c
c       acquisition cycle length
c
      call setvar( Hcylen + ivarof, 23064, Hmincylen, imaxcl( iadid ),
     1       fvar( Hcylen + 1 ) .and. iadid .ne. Hsim )
      icylen = iacqv( ivarof + Hcylen ,iblock)
c
c       sampling period
c
      racqv( ivarof + Hsampd ,iblock) = rsampd( iadid )
      if ( iadid .eq. Hseq ) then                                          1b
        call setvar( Hsampd + ivarof, 23062, Hminspd, rmaxct(2),
     1    fvar( Hsampd + 1 ) )
        rsampd( Hseq ) = racqv( ivarof + Hsampd ,iblock)
        end if                                                             1e
c
c       cycle time
c
      if ( iadid .ne. Hsim ) then                                          1b
        rminct = rsampd( iadid ) * icylen + Rsamov( iadid )
        call setvar( ivarof + Hcytim, 23008, rminct, rmaxct( iadid ),
     1    fvar( Hcytim + 1 ) )
        end if                                                             1e
c
c       number of A/D cycles
c
      dmaxcy = dnsam(iadid) / icylen
      call setvar( ivarof + Hnocy, 23063, Hmincy, dmaxcy,
     1  fvar( Hnocy + 1 ) )
c
c       channel address list
c
      if ( iadid .eq. Hslo .or. iadid .eq. Hsan ) then                     1b
        call smgwrt( 23065 )
        write( Hvdulu, 4 )
4       format( ' ' )
        do 6 i = 1, icylen                                                 2b
          if ( .not. fquiet )
     1      write( Hvdulu, 5 ) i
5           format( '+', i2, ' ? ' )
          ichan = Jresp( Iipf1, 0, 15, Hntries )
          call sopwrt( ichan, Hint2 )
          iacqc( ichof - 1 + i ,iblock) = ichan
6         continue                                                         2e
        end if                                                             1e
c
c       unpack data option
c
      if ( iadid .ne. Hslo ) then                                          1b
        f = eask( 'Are you unpacking data in the PC ?' )
        call sopwrt( f, Hlog1 )
        gacqc(iupof,iblock) = f
        end if                                                             1e
      return
      end


      SUBROUTINE SETVAR( IARG, IMSG, RMIN, RMAX, FVAR )
c
c       determine constant or variable status
c
c Arguments
c  integer *2 iarg,    # variable array index
c             imsg,    # variable identifying message
c  real  rmin,         # minimum value of parameter
c        rmax,         # maximum value of parameter
c  logical *1 fvar,    # variable parameter enable flag
c Variables
c  real rrmin,         # minimum value of parameter increment
c       rrmax,         # maximum value of parameter increment
c       qresp          # function : real response
c  integer *4 dpmin,   # minimum value of parameter increment
c             dpmax    # maximum value of parameter increment
c             dpsetcc  # function : get a parameter value
c  integer *2 ilev,    # loop level of the variable
c             Jresp    # function : accepts & checks integer response
c  logical *1 fvar1,   # variable parameter flag
c             eask,    # function : t / f reponse
c             emgwrt   #          : write message
c  subroutine smgwrt,  # display numbered message
c             swap     # swaps 2 real values
c             sopwrt    # writes a value to primary output file
c
      implicit none
      include 'genacq.kon'
c
      real rmin, rmax, rrmin, rrmax, qresp
      integer *4 dpmin, dpmax, dpsetcc
      integer *2 iarg, imsg, ilev, Jresp
      logical *1 fvar, fvar1, emgwrt
c
      include 'genacq.cmn'
      include 'module.cmn'
c
      equivalence ( rrmin, dpmin ), ( rrmax, dpmax )
c
      fvar1 = fvar .and. nvars(iblock) .lt. Hlevel
      if ( fvar1 ) then                                                   1b
        call smgwrt( 23000 )
        call smgwrt( imsg )
c
c       determine variable index - loop level
c
        nvars(iblock) = nvars(iblock) + 1
        call smgwrt( 23001 )
        ilev = Jresp( Iipf1, 0, Hlevel, Hntries )
        if ( ilev .eq. 0 )
     1    ilev = nvars(iblock)
        call sopwrt( ilev, Hint2 )
        ilevel(nvars(iblock),iblock) = ilev
c
        jindex(nvars(iblock),iblock) = iarg
        itype(nvars(iblock),iblock) = iitype( iarg )
c
c       linear / logarithmic increment
c
        call smgwrt( 23002 )
        linlog(nvars(iblock),iblock) =
     1    Jresp( iipf1, Hlin, Hlog, Hntries )
        call sopwrt( linlog(nvars(iblock),iblock), Hint2 )
c
c       loop limits
c
        istart(nvars(iblock),iblock) =
     1    dpsetcc( iarg, 23013, imsg, rmin, rmax )
        iend(nvars(iblock),iblock) =
     1    dpsetcc( iarg, 23023, imsg, rmin, rmax )
        racqv(iarg,iblock) = rend(nvars(iblock),iblock)
c
c        determine increment limits
c
        rrmin = rstart(nvars(iblock),iblock)
        rrmax = rend(nvars(iblock),iblock)
c
c           log increment
c
        if ( linlog(nvars(iblock),iblock) .eq. Hlog ) then                 2b
          if ( itype(nvars(iblock),iblock) .eq. Hreal ) then               3b
            rrmax = rrmax / rrmin
          else if ( itype(nvars(iblock),iblock) .eq. Hint2 .or.
     1        itype(nvars(iblock),iblock) .eq. Hint4 ) then                3m
            rrmax = real( dpmax ) / real( dpmin )
          else                                                             3m
            call sfail( Htyperr )
            end if                                                         3e
          rrmin = 1.0
          if ( rrmax .lt. 1 )
     1      call swap( rrmin, rrmax )
c
          if ( .not. fquiet ) then                                         3b
            if ( .not. emgwrt( Hvdulu, 23033 ) )
     1        call sfail( Hmsgerr )
            end if                                                         3e
          call smgwrt( imsg )
          rinc(nvars(iblock),iblock) =
     1      qresp( iipf1, rrmin, rrmax, Hntries )
          call sopwrt( rinc(nvars(iblock),iblock), Hreal )
c
c           linear increment
c
        else                                                               2m
          if ( itype(nvars(iblock),iblock) .eq. Hreal ) then               3b
            rrmax = rrmax - rrmin
            rrmin = 0.0
          else if ( itype(nvars(iblock),iblock) .eq. Hint2 .or.
     1        itype(nvars(iblock),iblock) .eq. Hint4 ) then                2m
            dpmax = dpmax - dpmin
            dpmin = sign( 1, dpmax )
            end if                                                         3e
          iinc(nvars(iblock),iblock) =
     1      dpsetcc( iarg, 23033, imsg, rrmin, rrmax )
          end if                                                           2e
      else                                                                 1m
c
c        constant parameter
c
        iacqv(iarg,iblock) = dpsetcc( iarg, 23004 + Ipropt, imsg,
     1    rmin, rmax )
        end if                                                             1e
      return
      end


      INTEGER *4 FUNCTION DPSETCC( IARG, IGMSG, ICMSG, RMIN, RMAX )
c
c       Sets the value of a constant parameter or limit
c Argument
c  integer iarg,        # variable array index
c          igmsg,       # number of 1st ( generic ) message
c          icmsg,       # number of 2nd ( constant id ) message
c  real  rmin,          # minimum value for the parameter
c        rmax,          # maximum value for the parameter
c Variable
c  real  r,             # real returned value
c        qresp          # function : accepts & checks real value
c  integer *2 i,        # integer *2 returned value
c             Jresp     # function : accepts & checks integer value
c  integer *4 d         # integer *4 returned value
c             dpresp    # function : accepts & checks 32-bit integer response
c  logical *1 emgwrt    # function : writes message
c  subroutine sopwrt    # writes a value to primary output file
c
c include genacq.cmn
c include module.cmn
c
      implicit none
      include 'genacq.kon'
c
      real  rmin, rmax, r, qresp
      integer *2 iarg, igmsg, icmsg, i, Jresp
      integer *4 d, dpresp
      logical *1 emgwrt
c
      include 'genacq.cmn'
      include 'module.cmn'
      equivalence ( r, i, d )
c
      d = 0
      if ( .not. fquiet ) then                                              1b
        if ( .not. emgwrt( Hvdulu, igmsg ) )
     1    call sfail( Hmsgerr )
        end if                                                              1e
      call smgwrt( icmsg )
      if ( iitype( iarg ) .eq. Hreal ) then                                 1b
        r = Qresp( iipf1, rmin, rmax, Hntries )
      else if ( iitype( iarg ) .eq. Hint2 ) then                            1m
        i = Jresp( iipf1, rmin, rmax, Hntries )
      else if ( iitype( iarg ) .eq. Hint4 ) then                            1m
        d = dpresp( iipf1, rmin, rmax, Hntries )
        end if                                                              1e
      call sopwrt( d, iitype(iarg) )
      dpsetcc = d
      return
      end


      LOGICAL *1 FUNCTION ESTDEF( CF2KEY, CFILE )
c
c Routine to Select a DEFault entry point for the secondary input file .
c The default key CF2KEY is selected from command file CFILE if the default
c calibration is selected . The returned value ESTDEF is .true. if the default
c is selected .
c
c Arguments
c  character Cf2key*(*),        # required 8 char recognition key
c            Cfile*(*)          # Secondary input file name
c Variable
c  logical *1 Eask              # function : logical response
c  subroutine sopwrt            # writes value to output command file
c             ssipf2            # select entry point for secondary I/P file
c
      implicit none
      include 'genacq.kon'
c
      logical *1 eask
      character Cf2key*(*), Cfile*(*)
      include 'genacq.cmn'
c
      estdef = Eask( 'Default calibration ?' )
      call sopwrt( estdef, Hlog1 )
      if ( estdef .and. imode .lt. Hread ) then
        fdef2 = fipf2
        fipf2 = .true.
        call ssipf2( Cf2key, Cfile )
        fdef1 = .true.
      else
        fdef1 = .false.
        call ssipf2( Cf2key, ' ' )
        end if
      return
      end



      SUBROUTINE SRSDEF
c
c       ReSets (disables) access to the default secondary input file
c
c Variables
c  subroutine sipf2d           # disable access to secondary input file
c
      implicit none
      include 'genacq.cmn'
c
      if ( fdef1 .and. imode .lt. 4 ) then
        fdef1 = .false.
        call sipf2d
        fipf2 = fdef2
        end if
      return
      end


      SUBROUTINE SSIPF2( CF2KEY, CFILE )
c
c Subroutine to Select the entry point for the Secondary Input File .
c
c       If the secondary input file has been defined in Manual, Copy, or Write
c mode and use of the secondary input file is required , SSIPF2 searches
c through the old command file for the 8 character key CF2KEY and swaps the
c primary and  secondary input files to Iipf2 = Hkbdlu & Iipf1 = Hocflu .
c       If the secondary input file is undefined , the key in the secondary
c input file is skipped . If the key CF2KEY is not found , the default
c condition Iipf1 = Hkbdlu & Iipf2 = Htcflu is set ; no action .
c       The secondary input file name is CFILE . If CFILE is an empty string,
c then the user is interrogated for the file name . If the user supplies an
c empty string , no action is taken .
c
c Argument
c  character Cfile*(*)         # secondary input file name
c            Cf2key*(*)        # key
c Variables
c  logical *1 Existf,          # function : file exists
c             emgwrt           #          : write message
c  integer *2 jljstr           # function : left justify string
c  character Cf2buf*8          # 8 chars read from the file
c  subroutine scfopen          # open command file
c             sipf2d           # disable access to secondary input file
c             smgwrt           # display message
c             sopwrtc          # write characters to output file
c
      implicit none
      include 'genacq.kon'
c
      character Cfile*(*), Cf2key*(*), Cf2buf*8
      integer *2 jljstr
      logical*1 Existf, emgwrt
      include 'genacq.cmn'
c
      if ( .not. fdef1 .and. fipf2 ) then                                 1b
        if ( Cfile .eq. ' ' ) then                                        2b
          call scfopen( Cipf2, 3 )
        else if ( Existf( Cfile ) ) then                                  2m
          open( UNIT=Hocflu, FILE=Cfile, ACCESS='sequential',
     1      FORM='formatted', STATUS='old', ERR=6 )
          Cipf2 = Cfile
        else                                                              2m
          if ( .not. emgwrt( Hvdulu, 3013 + ipropt ) )
     1      call sfail( Hmsgerr )
          Cipf2 = ' '
          end if                                                          2e
        if ( Cipf2 .ne. ' ' ) then                                        2b
          Iipf1 = Hocflu
          Iipf2 = Hkbdlu
          fqold = fquiet
          fquiet = .true.
c
c           search for key
c
c         repeat                                                          3b
1           read( Hocflu, 2, ERR=4, END=4 ) Cf2buf
2           format( a )
            if ( jljstr( Cf2buf ) .ne. len( Cf2key ) ) goto 1
            if ( Cf2key .ne. Cf2buf( 1: len( Cf2key ) ) ) goto 1
c         until ( Cf2key .eq. Cf2buf( 1: len( Cf2key ) ) )                3e
          end if                                                          2e
c
c           skip line in old command file
c
      else if ( Iipf1 .eq. Hocflu ) then                                  1m
        read( Iipf1, 3 )
3       format( )
        end if                                                            1e
7     if ( Iopf1 .ne. Hvdulu )
     1      call sopwrtc( Cf2key )
      return
c
c           reached end of file ( or read error )
c
4     if ( emgwrt( Hvdulu, 03000 + ipropt ) )
     1      call sfail( Hmsgerr )
      write( Hvdulu, 5 ) Cf2key
5     format( 1x, a )
      call sipf2d
      goto 7
c
c           cannot open file
c
6     if ( .not. emgwrt( Hvdulu, 03003 + ipropt ) )
     1      call sfail( Hmsgerr )
      goto 7
      end


      SUBROUTINE SIPF2D
c
c       Disables access to the secondary input file
c
      implicit none
      include 'genacq.kon'
      include 'genacq.cmn'
c
      if ( .not. fdef1 .and. fipf2 .and. Iipf1 .eq. Hocflu ) then
        Iipf1 = Hkbdlu
        Iipf2 = Hocflu
        close( UNIT=Hocflu )
        fquiet = fqold
        call smgwrt( 3002 )
        end if
      return
      end



      SUBROUTINE SMMHDR( CLABEL )
c
c       Writes the MODULE header record onto data file ;
c Argument
c  character *1 Clabel*(*)     # header record label
c Variables
c  logical *1 ok,      # success / failure of data transfer
c             daput,   # function : put bytes onto data file
c             daputc,  #          : put character string onto data file
c             daflush  #          : flush data file buffer
c  integer *2 itmprec  # temporary data file record no. for writing directory
c
      implicit none
      include 'genacq.kon'
c
      logical *1 ok, daput, daputc, daflush
      integer *2 itmprec
      character Clabel*(*)
      include 'genacq.cmn'
c
c         make directory entry
c
      dirrec(nmodul) = irec
c
c           write the directory record onto data file ( again )
c
      itmprec = 1
      ok = daput( itmprec, nmodul, 2 )
      ok = ok .and. daput( itmprec, dirrec, 510 )
      ok = ok .and. daflush( itmprec )
      if ( .not. ok )
     1  call sfail( Hmoderr )
c
c The module header record consists of
c  1) an eight character label - beginning with '###'
      ok = daputc( irec, Clabel )
c
c  2) the number of remaining bytes in the record = 108
      ok = ok .and. daput( irec, 108, 2 )
c
c  3) logical unit numbers of command files, iipf1, iipf2, iopf1
      ok = ok .and. daput( irec, iipf1, 2 )
      ok = ok .and. daput( irec, iipf2, 2 )
      ok = ok .and. daput( irec, iopf1, 2 )
c
c  4) names of the command files - 32 characters each - Cipf1, Cipf2, Copf1
      ok = ok .and. daputc( irec, Cipf1 )
      ok = ok .and. daputc( irec, Cipf2 )
      ok = ok .and. daputc( irec, Copf1 )
c
c  5) module number
c  6) total number of data bytes obtained so far
      ok = ok .and. daput( irec, nmodul, 2 )
      ok = ok .and. daput( irec, dtnbyt, 4 )
      ok = ok .and. daflush( irec )
      if ( .not. ok )
     1  call sfail( Hmoderr )
      return
      end


      LOGICAL *1 FUNCTION EASK( CMSG )
c
c       Form of EQUERY which can be silenced by raising the fquiet flag .
c This is only to be used within a module . The input file is IIPF1 . If
c silenced , the input is restricted to 't'  'f' .
c
c Argument
c  character cmsg*(*)           # message string
c Variables
c  logical *1 equery            # function : logical response
c
      implicit none
      character cmsg*(*)
      logical *1 equery
      include 'genacq.cmn'
c
      if ( .not. fquiet ) then
        Eask = equery( Iipf1, Cmsg )
      else
        read (Iipf1,1) Eask
1       format( l2 )
        end if
      return
      end


      SUBROUTINE SCFOPEN( CMDNAM, IOLDNEW )
c
c     Opens a new or old command file .
c
c Argument
c  character cmdnam*(*)        # name of command file
c  integer *2 ioldnew          # 1 = new command file for output
c                              # 2 = old command file for input
c                              # 3 = secondary input command file
c Variables
c  logical *1 fexist,          # file exists
c             Equery,          # function : logical response
c             Existf           #          : file exists
c  integer *2 iostat           # error status for opening file
c             imsgp            # message number for file name prompt
c             mmsgp(3)         # possible message numbers for file name prompt
c  subroutine smgwrt
c message no.
c  01201  request for input file name
c  01301  request for output file name
c  01401  file not found
c  01501  file already exists
c
      implicit none
      include 'genacq.kon'
c
      character cmdnam*(*)
      integer *2 ioldnew, iostat, imsgp, mmsgp(3)
      logical *1 fexist, Equery, Existf
      include 'genacq.cmn'
      save mmsgp
c
      data  mmsgp / 1301, 1201, 3001 /
c
      if ( 0 .lt. ioldnew .and. ioldnew .le. 3 ) then                     1b
        imsgp = mmsgp( ioldnew )
c       repeat                                                            2b
1         call smgwrt( imsgp )
          read( Hkbdlu, 2 ) Cmdnam
2         format( a )
          if ( ioldnew .eq. 3 .and. cmdnam .eq. ' ' )
     1      return
          fexist = Existf( Cmdnam )
c
c         new command file
c
          if ( ioldnew .eq. 1 ) then                                      3b
            if ( fexist ) then                                            4b
              call smgwrt( 1501 )
              if ( .not. Equery( Hkbdlu, 'OK ?' ) )
     1          goto 1
              end if                                                      4e
            open( UNIT=Hncflu, FILE=Cmdnam, ACCESS='sequential',
     1        FORM='formatted', STATUS='unknown', IOSTAT=iostat )
c
c         old command file
c
          else                                                            3m
            if ( .not. fexist ) then                                      4b
              call smgwrt( 1401 )
              goto 1
              end if                                                      4e
            open( UNIT=Hocflu, FILE=Cmdnam, ACCESS='sequential',
     1        FORM='formatted', STATUS='old', IOSTAT=iostat )
            end if                                                        3e
          if ( 0 .lt. iostat .and. iostat .lt. 128 ) then                 3b
            write( Hvdulu, 3 ) iostat
3           format( ' WARNING : Cannot open file. IOSTAT = ', i3 )
            goto 1
            end if                                                        3e
c         until( file is successfully opened )                            2e
        end if                                                            1e
      return
      end


      SUBROUTINE SRDFIL( CSOURCE )
c
c    ReaD the default names of the FILes required by genacq
c
c Argument
c  character Csource*(*)    # file of file names
c
c The file names are :
c  \genacq\genacq.gsm  # message file
c  \genacq\genacq.log  # log file
c  \genacq\calbar.com  # baratron calibration command file
c  \genacq\calhw1.com  # normal hot wire calibration command file
c  \genacq\calxhw.com  # inclined hot wire calibration command file
c  \genacq\caltvs.com  # traverse calibration command file
c  \genacq\caltvs.dat  # traverse calibration data file
c The names of all these files must be present in this order in the
c file CSOURCE . The file names cannot be longer than 32
c characters . Only one file name can be on each line of genacq.fil .
c The first line of the file is skipped ( treated as a comment ) .
c
      implicit none
      character Csource*(*)
      include 'genacq.kon'
      include 'genacq.cmn'
c
      open( UNIT=Hfillu, FILE=Csource, ACCESS='sequential',
     1  FORM='formatted', STATUS='old', ERR=4 )
      read( Hfillu, 1, ERR=2, END=2 )
      read( Hfillu, 1, ERR=2, END=2 ) Cmsgfil
      read( Hfillu, 1, ERR=2, END=2 ) Clogfil
      read( Hfillu, 1, ERR=2, END=2 ) Cbarcmd
      read( Hfillu, 1, ERR=2, END=2 ) Chw1cmd
      read( Hfillu, 1, ERR=2, END=2 ) Cxhwcmd
      read( Hfillu, 1, ERR=2, END=2 ) Ctvscmd
      read( Hfillu, 1, ERR=2, END=2 ) Ctvsfil
1     format( a )
      return
c
c       error messages - all FATAL
c
2     write( Hvdulu, 3 )
3     format( ' GENACQ : FATAL : Can''t read default file names' )
      stop
4     write( Hvdulu, 5 )
5     format( ' GENACQ : FATAL : Can''t open default file names file' )
      stop
      end


      SUBROUTINE SOPWRT( IVAR, ITYPE )
c
c       Writes the value of IVAR onto the primary output file . The type of
c IVAR is given by ITYPE .
c
c Arguments
c  integer *4 ivar     # address of the source value
c  integer *2 itype    # the type of IVAR
c                        1 = real *4,     3 = integer *4
c                        2 = integer *2,  4 = logical *1
c Variables
c  integer *4 ivar4    # data buffer
c  integer *2 ivar2    # "         "
c  logical *1 fvar1    # "         "
c  real rvar4          # "         "
c
      implicit none
      include 'genacq.kon'
c
      integer *4 ivar, ivar4
      integer *2 ivar2, itype
      logical *1 fvar1
      real rvar4
      include 'genacq.cmn'
c
      equivalence ( ivar4, ivar2, fvar1, rvar4 )
c
      if ( ( Iopf1 .ne. Hvdulu .or. .not. fquiet ) .and.
     1    Iopf1 .ne. Hnullu ) then                                          1b
        if ( Itype .eq. Hint2 ) then                                        2b
          ivar4 = ivar
          if ( Iopf1 .eq. Hvdulu ) then                                     3b
            write( Hvdulu, 1 ) ivar2
1           format( 1x, i6 )
          else                                                              3m
            write( Iopf1, 11 ) ivar2
11          format( i6 )
            end if                                                          3e
        else if ( Itype .eq. Hint4 ) then                                   2m
          if ( Iopf1 .eq. Hvdulu ) then                                     3b
            write( Hvdulu, 2) ivar
2           format( 1x, i11 )
          else                                                              3m
            write( Iopf1, 12 ) ivar
12          format( i11 )
            end if                                                          3e
        else if ( Itype .eq. Hlog1 ) then                                   2m
          ivar4 = ivar
          if ( Iopf1 .eq. Hvdulu ) then                                     3b
            write( Hvdulu, 3 ) fvar1
3           format( 1x, l1 )
          else                                                              3m
            write( Iopf1, 13 ) fvar1
13          format( l1 )
            end if                                                          3e
        else if ( Itype .eq. Hreal ) then                                   2m
          ivar4 = ivar
          if ( Iopf1 .eq. Hvdulu ) then                                     3b
            write( Hvdulu, 4 ) rvar4
4           format( 1x, g14.7 )
          else                                                              3m
            write( Iopf1, 14 ) rvar4
14          format( g14.7 )
            end if                                                          3e
          end if                                                            2e
        end if                                                              1e
      return
      end


      SUBROUTINE SOPWRTC( CSTR )
c
c       Writes the character string CSTR onto the primary output file .
c
c Argument
c  character Cstr*(*)  # source string
c
      implicit none
      include 'genacq.kon'
c
      character Cstr*(*)
      include 'genacq.cmn'
c
      if ( ( Iopf1 .ne. Hvdulu .or. .not. fquiet ) .and.
     1    Iopf1 .ne. Hnullu ) then                                          1b
        if ( Iopf1 .eq. Hvdulu ) then                                       2b
          write( Hvdulu, 1 ) Cstr
1         format( 1x, a )
        else                                                                2m
          write( Iopf1, 11 ) Cstr
11        format( a )
          end if                                                            2e
        end if                                                              1e
      return
      end


      SUBROUTINE SMGWRT( IMSG )
c
c       Simplified call to EMGWRT which can be silenced by the fquiet flag .
c Argument
c  integer *2 imsg     # message number
c Variables
c  logical *1 emgwrt   # message write
c
      implicit none
      include 'genacq.kon'
c
      integer *2 imsg
      logical *1 emgwrt
      include 'genacq.cmn'
c
      if ( .not. fquiet ) then                                              1b
        if ( .not. emgwrt( Hvdulu, imsg + Ipropt ) )
     1    call sfail( Hmsgerr )
        end if                                                              1e
      return
      end


      SUBROUTINE SFAIL( IERROR )
c
c       write error message to screen
c       This routine does not use the messages file
c
c Argument
c  integer *2 ierror        # error identifier
c
      implicit none
      include 'genacq.kon'
c
      integer *2 ierror
c
      if ( ierror .eq. Hmoderr ) then                                       1b
        write( Hvdulu, 1 )
1       format( ' Can''t write module header to data file' )
      else if ( ierror .eq. Hblkerr ) then                                  1m
        write( Hvdulu, 2 )
2       format( ' Can''t write block header to data file' )
      else if ( ierror .eq. Hsbkerr ) then                                  1m
        write( Hvdulu, 3 )
3       format( ' Can''t write sub-block header to data file' )
      else if ( ierror .eq. Htvserr ) then                                  1m
        write( Hvdulu, 4 )
4       format( ' Can''t drive traverse' )
      else if ( ierror .eq. Hmsgerr ) then                                  1m
        write( Hvdulu, 5 )
5       format( ' Can''t write GENACQ message' )
      else if ( ierror .eq. Htyperr ) then                                  1m
        write( Hvdulu, 6 )
6       format( ' Illegal data type' )
      else                                                                  1m
        write( Hvdulu, 7 )
7       format( ' Unknown error' )
        end if                                                              1e
      return
      end


      SUBROUTINE SRDFMHD( IOPFLU, CLABEL, IRDFREC )
c
c       Raw Data File get next Module HeaDer
c
c    Reads the next module header record . IRDFREC is the record number from
c which the search starts . On exit , IRDFREC is the next record number .
c
c Arguments
c  integer *2 iopflu           # logical unit no. of O/P device
c  character Clabel *8         # required module header label
c  integer *2 irdfrec          # raw data file record number
c
c constants
c    Hvdulu                    # v.d.u. logical unit number
c    Hlabel                    # Routine name
c variables
c  integer *2 nmod             # module number
c             kipf1            # primary input command file logical unit
c             kipf2            # secondary input command file logical unit
c             kopf1            # primary output command file logical unit
c  logical *1 Bipf1(32)        # primary input command file name
c             Bipf2(32)        # secondary input command file name
c             Bopf1(32)        # primary output command file name
c             Bmhlab(8)        # actual block header label
c             daget            # function : read direct access file
c
      implicit none
      character *7 Hlabel
      parameter( Hlabel='SRDFMHD' )
      include 'genacq.kon'
c
      integer *2 irdfrec, iopflu, nbytes, nmod, kipf1, kipf2, kopf1
      logical *1 Bipf1(32), Bipf2(32), Bopf1(32), Bmhlab(8), daget
      character Clabel*8
      include 'genrdf.cmn'
      include 'genacq.cmn'
c
      equivalence ( Mhdr(1), Bmhlab(1) ), ( Mhdr(5), nbytes ),
     1  ( Mhdr(6), kipf1 ), ( Mhdr(7), kipf2 ), ( Mhdr(8), kopf1 ),
     2  ( Mhdr(9), Bipf1(1) ), ( Mhdr(25), Bipf2(1) ),
     3  ( Mhdr(41), Bopf1(1) ),( Mhdr(57), nmod )
c
c         find module
c
      call srdfind( irdfrec )
      irdfrec = dirrec( idirptr )
      idirptr = idirptr + 1
c
c         read header & check for errors
c
      call dainit
      if ( .not. daget( irdfrec, Mhdr, 114 ) )
     1  call srdferr( Hlabel, Hrdfueof )
      call Sbytchr( Bmhlab, Clabel, 8 )
      if ( Clabel .ne. '#initial' .and. Clabel .ne. '#acquire' .and.
     1    Clabel .ne. '#close  ' .and. Clabel(1:4) .ne. '#cal' )
     2  call srdferr( Hlabel, Hrdfimod )
      if ( nbytes .ne. 108 )
     1  call srdferr( Hlabel, Hrdfbcnt )
c
c         write module header information
c
      write( Iopflu, 1 ) Clabel, idirptr - 2, nmod, kipf1, Bipf1,
     1  kipf2, Bipf2, kopf1, Bopf1
1     format( ' SRDFMHD : Module header : type = ', a8 /
     1        25x, ': directory entry = ', i5 /
     2        25x, ': module number = ', i5 //
     3        11x, 'command files  logical unit   name' /
     4        11x, 'primary input',  5x, i6, 4x, 32a1 /
     5        9x, 'secondary input', 5x, i6, 4x, 32a1 /
     6        10x, 'primary output', 5x, i6, 4x, 32a1 / )
      return
      end



      SUBROUTINE SRDFIND( IRDFREC )
c
c       FIND Raw Data File module header
c
c    Finds the directory entry which points to the next module header record .
c The search is started at the record IRDFREC and the directory pointer is
c adjusted until it points at the nearest module header after IRDFREC . The
c returned value is the directory pointer IDIRPTR in common block .
c
      implicit none
      integer *2 irdfrec
      include 'genacq.cmn'
      include 'genrdf.cmn'
c
c         Check if already finished
c
c
c         Check boundary conditions
c
      irdfrec = max( dirrec(1), min( dirrec( nmodul ), irdfrec ) )
      idirptr = max( 1, min( nmodul, idirptr ) )
      if ( irdfrec .eq. dirrec( idirptr ) )
     1  return
c
c         Advance directory pointer
c
      if( irdfrec .gt. dirrec( idirptr ) ) then                            1b
1       if ( irdfrec .gt. dirrec( idirptr ) ) then                         2b
          idirptr = idirptr + 1
          goto 1
          end if                                                           2e
c
c         Retard directory pointer
c
      else if( irdfrec .lt. dirrec( idirptr ) ) then
2       if ( irdfrec .lt. dirrec( idirptr ) ) then                         2b
          idirptr = idirptr - 1
          goto 2
          end if                                                           2e
        if ( irdfrec .ne. dirrec(idirptr) )
     1    idirptr = idirptr + 1
        end if
      return
      end


      SUBROUTINE SRDFERR( CSOURCE, ISTATUS )
c
c       Display ERRor message from Raw Data File handler routine
c N.B. All errors except 5 are fatal .
c
c Arguments
c  character Csource*(*)       # name of source routine
c  integer *2 istatus          # error status & status
c
      implicit none
      include 'genacq.kon'
c
      integer *2 istatus
      character Csource*(*)
c
      if ( istatus .eq. Hrdfimod ) then
        write( Hvdulu, 1 ) Csource
1       format( 1x, a, ' : FATAL : Invalid module requested' )
      else if ( istatus .eq. Hrdfbcnt ) then
        write( Hvdulu, 2 ) Csource
2       format( 1x, a, ' : FATAL : Wrong byte count in header' )
      else if ( istatus .eq. Hrdfsblk ) then
        write( Hvdulu, 3 ) Csource
3       format( 1x, a, ' : FATAL : Invalid sub-block label' )
      else if ( istatus .eq. Hrdfiblk ) then
        write( Hvdulu, 4 ) Csource
4       format( 1x, a, ' : FATAL : Invalid block label' )
      else if ( istatus .eq. Hrdfscnt ) then
        write( Hvdulu, 5 ) Csource
5       format( 1x, a, ' : WARNING : Data byte vs.  sample count' )
      else if ( istatus .eq. Hrdfunav ) then
        write( Hvdulu, 6 ) Csource
6       format( 1x, a, ' : FATAL : Quantity unavailable' )
      else if ( istatus .eq. Hrdfnoac ) then
        write( Hvdulu, 7 ) Csource
7       format( 1x, a, ' : FATAL : No acquisition block' )
      else if ( istatus .eq. Hrdfsmal ) then
        write( Hvdulu, 8 ) Csource
8       format( 1x, a, ' : FATAL : Data array too small' )
      else if ( istatus .eq. Hrdfueof ) then
        write( Hvdulu, 9 ) Csource
9       format( 1x, a, ' : FATAL : Uexpected EOF' )
      else
        write( Hvdulu, 10 ) Csource
10      format( 1x, a, ' : FATAL : Unknown' )
        end if
      if ( istatus .ne. 5 )
     1  stop
      return
      end


      SUBROUTINE SRDFINIT( IOPFLU, RBARPRESS, RAMBTEMP, IRDFREC )
c
c       INITialize block header from Raw Data File
c   Reads an initialize block header record from an opened Raw Data File .
c The raw data file is assumed to have been opened by ERDFOPEN . IRDFREC - the
c data file record pointer , is assumed to point to the appropriate data
c record , and its value has been determined by a call to
c ERDFMHD( '#initial', irdfrec )  or SRDFMHD( Clabel, Irdfrec )
c with Clabel='#initial'
c
c Arguments
c  integer *2 iopflu           # logical unit number of output file
c  real Rbarpress,             # barometeric pressure in Pascals
c       Rambtemp               # ambient temperature in Kelvin
c  integer *2 irdfrec          # raw data file record number
c
c constants
c    Hlabel                    # Routine name
c variables
c  logical *1 Bcmt(81)         # comment string
c             Bdate(32)        # time and date of experiment
c             Bdfname(32)      # Unix data file name and path
c             Blabel(8)        # block label
c             fchr             # single comment character
c             daget            # function : read from direct access file
c  integer *2 ichr             # single comment character
c             icmt             # comment byte pointer
c             icol, icol1      # comment line character pointers
c             lencmt           # total length of comment in bytes
c             nbytes           # number of bytes remaining in record
c  real Rapbar                 # barometric pressure in Pascals
c       Raptem                 # ambient temperature in Kelvin
c  character *8  Clabel        # required module header label
c  subroutine dainit           # restart reading data file record
c             Sbytchr          # convert byte to char string
c             srdferr          # read data file message
c
      implicit none
      character *8 Hlabel
      parameter( Hlabel='SRDFINIT' )
      include 'genacq.kon'
c
      logical *1 Bcmt(81), Bdate(32), Bdfname(32), Blabel(8), fchr,
     1  daget
      integer *2 ichr, icmt, icol, icol1, iopflu, irdfrec, lencmt,
     1  nbytes
      real Rbarpress, Rapbar, Rambtemp, Raptem
      character Clabel*8
      include 'genrdf.cmn'
      equivalence ( Mhdr(1), Blabel(1) ),  ( Mhdr(5), nbytes ),
     1            ( Mhdr(6), Bdfname(1) ), ( Mhdr(22), Bdate(1) ),
     2            ( Mhdr(38), Rapbar ),    ( Mhdr(40), Raptem ),
     3            ( Mhdr(42), lencmt ),    ( ichr, fchr )
c
c           read the initialize record up to the comment and check it
c
      call dainit
      if ( .not. daget( irdfrec, Mhdr, 84 ) )
     1  call srdferr( Hlabel, Hrdfueof )
      call Sbytchr( Blabel, Clabel, 8 )
      if ( Clabel .ne. '##init  ' )
     1  call srdferr( Hlabel, Hrdfiblk )
      if ( nbytes .lt. 74 .or. nbytes .ne. lencmt + 74 )
     1  call srdferr( Hlabel, Hrdfbcnt )
c
c           extract output args
c
      Rbarpress = Rapbar
      Rambtemp = Raptem
c
c           display contents of header
c
      write( iopflu, 1 ) nbytes + 10, Bdfname, Bdate, Rapbar, Raptem
1     format( / 11x, 'Initialize block header' / 11x, 23( '=' ) /
     1  6x, 'Bytes read = ', i4 /
     2  6x, 'data file name = ', 32a1 /
     3  6x, 'Time and Date    = ', 32a1 /
     4  6x, 'Barometric pressure (Pa) = ', f9.1 /
     5  6x, 'Ambient Temperature (K)  = ', f7.2 )
c
c           read and display comment
c
      icmt = 0
      if ( lencmt .gt. 1 ) then                                            1b
        icol = 0
5       if ( icmt .lt. lencmt ) then                                       2b
          icol = icol + 1
          icmt = icmt + 1
          if ( .not. daget( irdfrec, fchr, 1 ) )
     1      call srdferr( Hlabel, Hrdfueof )
            Bcmt(icol) = fchr
          if ( ichr .eq. 0 ) then                                          3b
            write( iopflu, 4 ) ( Bcmt(icol1), icol1 = 1, icol - 1 )
4           format( 1x, 80a1 )
            icol = 0
            end if                                                         3e
          goto 5
          end if                                                           2e
        end if                                                             1e
      return
      end


      SUBROUTINE SRDFCLOS( IOPFLU, ITNBYT, IRDFREC )
c
c       Read CLOSe block from Raw Data File
c   Reads a close block header record from an opened Raw Data file .
c
c Arguments
c  integer *2 iopflu           # logical unit no. of O/P device
c  integer *4 itnbyt           # data file record pointer
c  integer  2  irdfrec          # raw data file record number
c
c constants
c    Hlabel                    # Routine name
c variables
c  logical *1 Bcmt(81)         # comment line
c             Blabel(8)        # required header label
c             daget            # function : read direct access file
c  integer *2 icol             # comment column number
c             lencmt           # total length of comment in bytes
c             nbytes           # number of bytes remaining in header record
c  integer *4 dtnbyt           # data file record pointer
c  character Clabel*8          # required header label
c  subroutine dainit           # restart reading data file record
c             Sbytchr          # convert byte to char string
c             srdferr          # read data file message
c
      implicit none
      character *8 Hlabel
      parameter( Hlabel='SRDFCLOS' )
      include 'genacq.kon'
c
      logical *1 Bcmt(81), Blabel(8), daget
      integer *2 icol, iopflu, irdfrec, lencmt, nbytes
      integer *4 itnbyt, dtnbyt
      character Clabel*8
      include 'genrdf.cmn'
      equivalence ( Mhdr(1), Blabel ), ( Mhdr(5), nbytes ),
     1  ( Mhdr(11), dtnbyt ), ( Mhdr(13), lencmt )
c
c           read the close record up to the comment and check it
c
      call dainit
      if ( .not. daget( irdfrec, Mhdr, 26 ) )
     1  call srdferr( Hlabel, Hrdfueof )
      call Sbytchr( Blabel, Clabel, 8 )
      if ( Clabel .ne. '##close ' )
     1  call srdferr( Hlabel, Hrdfiblk )
      if ( nbytes .lt. 16 .or. nbytes .ne. lencmt + 16 )
     1  call srdferr( Hlabel, Hrdfbcnt )
      itnbyt = dtnbyt
c
c           write header information
c
      write( iopflu, 1 ) ( Mhdr(icol), icol = 6, 10 ), itnbyt
1     format( 11x, 'Close block header' / 11x, 18( '=' ) /
     1  ' Master file entry : library = ', i5 /
     2  19x, ': series = ', i5, /
     3  19x, ': volume = ', i5 /
     4  19x, ': acquisition mode = ', i2 /
     5  19x, ': no. of modules = ', i4 /
     6  19x, ': total no. of data bytes = ', i10 )
      if ( lencmt .gt. 1 ) then                                            1b
        if ( .not. daget( irdfrec, Bcmt, lencmt - 1 ) )
     1    call srdferr( Hlabel, Hrdfueof )
        write( iopflu, 2 ) ( Bcmt( icol ), icol = 1, lencmt - 1 )
2       format( 19x, ': Comment : ', 40a1 : / 40a1 )
        end if                                                             1e
      return
      end



      LOGICAL *1 FUNCTION ERDFACQ( CSUBBLK, DNSAMP, MDATA, DSIZE,
     1                             IRDFREC, FWINEN )
c
c        Routine to read the header information in the block and sub-block
c header records , and if it exists , the data sub-block of the Raw Data File
c , starting at record IRDFREC .
c        If the returned value ERDFACQ = .true. , a block header and a
c sub-block header were found . If ERDFACQ = .false. , there is no more data
c in the module , and ERDFMHD should be called to get the next module header .
c        The raw data file is assumed to have been opened by a ERDFOPN .
c IRDFREC is assumed to point to the appropriate data record , and its value
c has been determined by a call to ERDFMHD( '#acquire', irdfrec ) .
c        If there is a data sub-block , the INSAMP data samples are placed
c in the array MDATA of DSIZE 16-bit words . Packed data is automatically
c unpacked before putting it into MDATA .
c        If DSIZE = 0 , no data is read into MDATA . If FWINEN = .true. , a
c WINdow reading mode is ENabled , in which a maximum of DSIZE samples are read
c from file . By using this feature , the data can be read in small lumps . In
c this case DSIZE can be less than the number of data samples available . If
c DSIZE is otherwise less than DNSAMP , a fatal error occurs .
c
c Arguments
c  character Csubblk*8  # sub block header label                  output
c  integer *4 dnsamp    # no. of samples read into MDATA          output
c  integer *2 Mdata(*)  # data array                              output
c  integer *4 dsize     # max no. of samples to be read           input
c  integer *2 irdfrec   # data file record pointer             input / output
c  logical *1 fwinen    # window enable flag                      input
c
c constants
c  Hlabel                      # routine name
c variables
c  logical *1 Blab(8)          # actual header record label
c             fbcnt            # byte count error detected in header
c             daget            # function : read direct access file
c  integer *2 iadid            # A/D converter identifier
c             icylen           # A/D acquisition cycle length
c             iunpack          # 1=data is already unpacked, 0=dat is packed
c             nbytes           # number of remaining bytes in record
c  integer *4 ddnocy           # number of data acquisition cycles
c             dnbyt            # no. of data bytes to be read
c             drdfdat          # function : copies data into MDATA
c             dupnob           # function : calculate no. of packed bytes
c  character *8 Clab           # actual header record label
c  subroutine dainit           # restart reading data file record
c             Sbytchr          # convert byte to char string
c             srdferr          # read data file message
c
      implicit none
      character *10 Hlabel
      parameter ( Hlabel='ERDFACQ : ' )
      include 'genacq.kon'
c
      logical *1 Blab(8), fbcnt, fwinen, daget
      integer *2 iadid, icylen, irdfrec, iunpack, Mdata(*), nbytes
      integer *4 ddnocy, dnbyt, dnsamp, dsize, drdfdat, dupnob
      character Clab*8, Csubblk*8
      include 'genrdf.cmn'
c
      equivalence ( Mhdr(1), Blab ), ( Mhdr(5), nbytes ),
     1  ( Mhdr(9), iadid ), ( Mhdr(10), iunpack ), ( Mhdr(17), ddnocy ),
     2  ( Mhdr(19), icylen )
c
c       if windowing data , get some more
c
      if ( fdata ) then                                                    1b
        Csubblk = Csublab
        erdfacq = .true.
        fdata = drsamp .gt. 0
        dnsamp = 0
        if ( fdata )
     1    dnsamp = drdfdat( Mdata, dsize, irdfrec, fwinen )
      else                                                                 1m
c
c       not windowing or first record .
c       read the next record and if it is a block header,
c         record the label and read the subblock header .
c
        erdfacq = .false.
        call dainit
        if ( .not. daget( irdfrec, Mhdr, 70 ) )
     1    call srdferr( Hlabel, Hrdfueof )
        call Sbytchr( Blab, Clab, 8 )
        if ( Clab(1:2) .eq. '##' ) then                                    2b
c
c       if a block header record , read block header records until a sub
c         block is encountered .
c
1         if ( Clab(3:3) .ne. '#' ) then                                   3b
c
c       If a module header record , return with false result .
c
            if ( Clab(1:1) .eq. '#' .and. Clab(2:2) .ne. '#' ) then        4b
              irdfrec = irdfrec - 1
              return
              end if                                                       4e
            if ( Clab .ne. '##prelim' .and. Clab .ne. '##main  ' .and.
     1           Clab .ne. '##extra ' )
     2        call srdferr( Hlabel, Hrdfiblk )
c
c       If the block header contains time stamp, date stamp and time delay
c       information, extract it into global variables
c
            call srdfstmp( Mhdr )
            call dainit
            if ( .not. daget( irdfrec, Mhdr, 70 ) )
     1        call srdferr( Hlabel, Hrdfueof )
            call Sbytchr( Blab, Clab, 8 )
            goto 1
            end if                                                         3e
c
c           Check that the block and sub-block headers are OK
c
          if ( Cblklab .eq. '##prelim' .or. Cblklab .eq. '##main' .or.
     1         Cblklab .eq. '##extra ' ) then                              3b
            if ( Clab .eq. '###pause' ) then                               4b
              fbcnt = nbytes .ne. 2 .and. nbytes. ne. 20 .and.
     1          nbytes .ne. 28
            else if ( Clab .eq. '###trav ' ) then                          4m
              fbcnt = nbytes .ne. 42
            else if ( Clab.eq.'###1dat1' .or. Clab.eq.'###2dat2' ) then    4m
              dnocy = ddnocy
              fbcnt = nbytes .ne. 28 + icylen * iand( iadid, 1 ) * 2
            else                                                           4m
              call srdferr( Hlabel, Hrdfsblk )                                    4
              endif                                                        4e
            if ( fbcnt )
     1        call srdferr( Hlabel // Clab, Hrdfbcnt )
          else                                                             3m
            call srdferr( Hlabel, Hrdfiblk )
            end if                                                         3e
          erdfacq = .true.
          Csublab = Clab
          Csubblk = Csublab
          dnsamp = 0
c
c         If data records follow , read the number of data bytes DNBYT
c
          if ( Clab .eq. '###1dat1' .or. Clab .eq. '###2dat2' ) then       3b
            call dainit
            if ( .not. daget( irdfrec, dnbyt, 4 ) )
     1        call srdferr( Hlabel, Hrdfueof )
            inxtrec = irdfrec + max( 0, ( dnbyt + 3 ) / 512 )
            if ( dnbyt .gt. 0 ) then                                       4b
              if ( dsize .le. 0 ) then                                     5b
                irdfrec = inxtrec
              else                                                         5m
c
c         calculate number of samples
c
                istrw = icylen
                drsamp = icylen * dnocy
                fdata = .false.
                iupodd = 0
c
c         check no. of bytes vs no. of samples
c
                if ( iadid .gt. 1 .and. iunpack .eq. 0 ) then              6b
                  if ( dnbyt .ne. dupnob( drsamp, iupodd ) ) then          7b
                    call srdferr( Hlabel, Hrdfscnt )
                    dnbyt = min( dnbyt, dupnob( drsamp, iupodd ) )
                    end if                                                 7e
                else                                                       6m
                  if ( dnbyt .ne. drsamp * 2 ) then                        7b
                    call srdferr( Hlabel, Hrdfscnt )
                    dnbyt = min( dnbyt, drsamp / 2 )
                    end if                                                 7e
                   end if                                                  6e
                dnsamp = drsamp
                dnsamp = drdfdat( Mdata, dsize, irdfrec, fwinen )
                end if                                                     5e
              end if                                                       4e
            end if                                                         3e
        else                                                               2m
c
c         if not block or sub block header
c
          irdfrec = irdfrec - 1
          end if                                                           2e
        end if                                                             1e
      return
      end


      INTEGER *4 FUNCTION DRDFDAT( MDATA, DSIZE, IRDFREC, FWINEN )
c
c   Reads all or some of the data from a data sub-block . The returned value
c JRDFDAT is the number of data samples actually read into the integer *2 data
c array MDATA . DSIZE is the size of MDATA , and is the maximum number of data
c samples that can be read in one lump .
c
c arguments
c  integer *4 dsize            # size of data array - max no. of samples
c  integer *2 irdfrec          # data file record pointer
c  logical *1 fwinen           # open window on data flag
c
c variables
c  logical *1 Blab(8)          # actual sub block header label
c             buf(400)         # input buffer for unpacking data
c             daget            # function : read direct access file
c  integer *2 iadid            # A/D converter identifier
c             iunpack          # data unpacked flag
c             dnbsam           # number of samples in chunk to be unpacked
c             dnbyt            # no. of data bytes to be read
c  integer *4 dwncnt           # sample down count from JRDFDAT
c             disamp           # sample counter
c             dupnob           # function : calculate no. of packed bytes
c  character Clab*8            # actual sub block header label
c  subroutine dainit           # restart reading data file record
c             Sbytchr          # convert byte to char string
c             srdferr          # read data file message
c             supsim           # unpack data from 'una voce' A/D converter
c             sup250           # unpack data from DAS 250A A/D converter
c
      implicit none
      integer *2 Hsamblk, Hbytblk
      parameter( Hsamblk=256, Hbytblk=400 )
      include 'genacq.kon'
c
      logical *1 Blab(8), buf(Hbytblk), fwinen, daget
      integer *2 iadid, iunpack, dnbsam, dnbyt, Mdata(*), irdfrec
      integer *4 dwncnt, disamp, dsize, dupnob
      character Clab*8
      include 'genrdf.cmn'
      equivalence ( Mhdr(1), Blab(1) ), ( Mhdr(9), iadid ),
     1  ( Mhdr(10), iunpack )
c
c           if data not found , skip to end
c
      if ( dsize .le. 0 ) then                                             1b
        irdfrec = inxtrec
        drdfdat = 0
        fdata = .false.
      else                                                                 1m
        drdfdat = drsamp
        if ( drsamp .gt. dsize ) then                                      2b
          if ( .not. fwinen )
     1      call srdferr( 'JRDFDAT', Hrdfsmal )
          drdfdat = dsize / istrw * istrw
          fdata = .true.
        else if ( .not. fwinen ) then                                      2m
          fdata = .false.
          end if                                                           2e
        dwncnt = drdfdat
        if ( drdfdat .gt. 0 ) then                                         2b
          call Sbytchr( Blab, Clab, 8 )
          if ( iadid .gt. 1 .and. iunpack .eq. 0 ) then                    3b
c
c           read packed data and unpack it into Mdata
c
            do 3 disamp = 1, drdfdat, Hsamblk                                  4b
              dnbsam = Hsamblk
              if ( dwncnt .lt. Hsamblk ) dnbsam = dwncnt
              dnbyt = dupnob( int( dnbsam ), iupodd )
              if ( .not. daget( irdfrec, buf( 1 + iupodd ), dnbyt ) )
     1          goto 1
              if ( iadid .eq. 4 ) then                                     5b
                call supsim( buf, Mdata(disamp), dnbsam, iupodd )
              else                                                         5m
                call sup250( buf, Mdata(disamp), dnbsam, iupodd )
                end if                                                     5e
              dwncnt = dwncnt - Hsamblk
3             continue                                                     4e
          else                                                             3m
c
c           or read non-packed data into Mdata
c
            if ( .not. daget( irdfrec, Mdata, drdfdat * 2 ) ) goto 1
            end if                                                         3e
          drsamp = drsamp - drdfdat
c
c           force new record & sub-block if end of data
c
          if ( drsamp .le. 0 ) then                                        3b
            if ( drdfdat .lt. dsize )
     1        fdata = .false.
            call dainit
            irdfrec = inxtrec
            end if                                                         3e
          end if                                                           2e
        end if                                                             1e
      return
c
1     write( Hvdulu, 2 ) dwncnt
2     format( ' JRDFDAT : ERROR : Not enough data ', i12 )
      drdfdat = drdfdat - dwncnt
      return
      end


c      SUBROUTINE SRDFBUG(I)
c      IMPLICIT NONE
c      INTEGER I
cc
cc         COMMON BLOCK DECLARATION
cc
c      integer *2 dirrec(256), mhdr(57), idirptr, imute, istrw, iauxop
c      integer *4 inxtrec, drsamp, iupodd, dnocy
c      character *8 Cblklab, Csublab
c      logical *2 frdfopn, fdata
cc
c      common /rdfhnd/ dirrec, mhdr, Cblklab, Csublab, idirptr, imute,
c     1   frdfopn, fdata, istrw, iauxop, inxtrec, iupodd, drsamp, dnocy
cc
c      WRITE(6,1) I,IDIRPTR,IMUTE,ISTRW,inxtrec, drsamp, iupodd,
c     1   CBLKLAB, CSUBLAB, FRDFOPN, FDATA
c      WRITE(6,2) DIRREC, MHDR
c1     FORMAT( / ' SRDFBUG : ', I5 /
c     1 ' IDIRPTR, IMUTE, ISTRW = ', 3I10 /
c     2 ' inxtrec, drsamp  iupodd = ', 3I10 /
c     3 ' CBLKLAB, CSUBLAB = ', 2A8, ' FRDFOPN, FDATA ', 2L3 )
c2     FORMAT( ' DIRREC = ' , 16( / 1X,16I4 ) / ' MHDR = ', 4A2,
c     5 6 ( / 1X,10I7))
c      RETURN
c      END
c
c


      INTEGER *4 FUNCTION DUPNOB( NSAMP, ODDEVEN )
c
c               UnPack No. Of Bytes
c   Calculates the number of bytes to be read from packed data file in order
c to unpack NSAMPLES data samples .
c Argument
c  integer *4 nsamp             # number of data samples
c  integer *2 oddeven           # odd/even = 1/0 flag for 1st sample
c
c calculation
c   dupnob = imod( nsamps, 2 ) & ! oddeven + 3* nsamp /2
c
      implicit none
      integer *2 nsamp, oddeven
c
      dupnob = iand( iand( nsamp, 1 ), not( oddeven ) ) + 3 * nsamp / 2
      return
      end


      INTEGER *4 FUNCTION DEXTNOCY
c
c       EXTract NUmber of Cycles
c   Returned value is the number of A/D data acquisition cycles done in
c a '###pause' , '###1dat1' or '###2dat2' sub-block
c
c Mhdr(5) == nbytes    # number of bytes remaining in header record
c Mhdr(9) == nocyp     # number of cycles for ###pause sub-block
c Mhdr(17)== nocyd     # number of cycles for data sub-block
c
      implicit none
      integer *4 nocyd
      include 'genacq.kon'
      include 'genrdf.cmn'
      equivalence ( Mhdr(17), nocyd )
c
      dextnocy = 0
      if ( Csublab .eq. '###pause' ) then
        if ( Mhdr(5) .ge. 20 )
     1    dextnocy = Mhdr(9)
      else if ( Csublab.eq.'###1dat1' .or. Csublab.eq.'###2dat2' ) then
        dextnocy = nocyd
      else
        call srdferr( 'JEXTNOCY : ' // Csublab,  Hrdfunav )
        end if
      return
      end



      CHARACTER *12 FUNCTION GEXTADID
c
c       EXTract A/D converter IDentity
c   Returned value is a character string representing the identity of the A/D
c converter used .
c GEXTADID =
c     'DAS 1128 slo' - Slow A/D converter in random channel addressing mode
c     'DAS 250A seq' - Fast A/D converter in sequential channel addressing mode .
c     'DAS 250A ran' - fast A/D converter in random channel addressing modem
c     'SIM ACQ fast' - fast simultaneous channel converter
c If no data is acquired in a pause sub-block , the returned value is
c GEXTADID = ' '
c
c constant
c  Cadid(4)*12                 # possible returned values
c
c Mhdr(5) == nbytes    # number of bytes remaining in header record
c Mhdr(6) == iadidp    # A/D converter identifier for ###pause sub-block
c Mhdr(9) == iadidd    # A/D converter identifier for data sub-block
c
      implicit none
      character Cadid(4)*12
      data Cadid / 'DAS 1128 slo', 'DAS 250A seq',
     1             'DAS 250A ran', 'SIM ACQ fast' /
      include 'genacq.kon'
      include 'genrdf.cmn'
c
      Gextadid = ' '
      if ( Csublab .eq. '###pause' ) then
        if ( Mhdr(5) .ge. 20 )
     1    Gextadid = Cadid( Mhdr(6) * 2 - 1 )
      else if ( Csublab.eq.'###1dat1' .or. Csublab.eq.'###2dat2' ) then
        Gextadid = Cadid( Mhdr(9) )
      else
        call srdferr( 'GEXTADID : ' // Csublab, Hrdfunav )
        end if
      return
      end



      INTEGER *2 FUNCTION JEXTCHLS( ICHAN )
c
c       EXTract a/d CHannel address LiSt element .
c   Returns the value of the Ith A/D converter channel address . The argument
c ICHAN is ignored for the '###pause' sub-block . If ICHAN is out of its range
c or no data is acquired in a '###pause' sub-block , the returned value is
c JEXTCHLS = -1 . If the A/D converter is used in sequential channel addressing
c mode , the returned value is , of course , JEXTCHLS = ICHAN - 1
c
c Argument
c  integer *2 ichan        # A/D channel pointer
c
c variables
c  integer *2 ichan(16)    # A/D channel address list - mapped into common block
c
c Mhdr(5) == nbytes    # number of bytes remaining in header record
c Mhdr(9) == iadidd    # A/D converter identifier for data sub-block
c Mhdr(11)== ihchan    # A/D channel for ###pause subblock
c Mhdr(19)== inchans   # no. of A/D channels used in a data sub-block
c
      implicit none
      integer *2 ichannel(16), ichan
      include 'genacq.kon'
      include 'genrdf.cmn'
c
      equivalence ( Mhdr(20), Ichannel(1) )
c
      Jextchls = -1
      if ( Csublab .eq. '###pause' ) then
        if ( Mhdr(5) .ge. 20 )
     1    Jextchls = Mhdr(11)
      else if ( Csublab.eq.'###1dat1' .or. Csublab.eq.'###2dat2' ) then
        if ( 0 .lt. ichan .or. ichan .le. Mhdr(19) ) then
          if ( iand( Mhdr(9), 1 ) .gt. 0 ) then
            Jextchls = ichannel( ichan )
          else
            Jextchls = ichan - 1
            end if
          end if
      else
        call srdferr( 'JEXTCHLS : ' // Csublab, Hrdfunav )
        end if
      return
      end


      INTEGER *4 FUNCTION JEXTMDLN( I )
c
c       EXTract the record Number of the Ith MoDuLe header .
c  If I <= 0 , the returned value is the total number of modules in the file .
c  If I > JEXTMDLN( 0 ) , the returned value is the record number of the last
c  module header .
c
c variables
c  integer *2 i                # module number
c
      implicit none
      integer *2 i
      include 'genacq.cmn'
c
      jextmdln = dirrec( max( 1, min( nmodul, i ) ) )
      return
      end


      INTEGER *4 FUNCTION JEXTCYLN
c
c       EXTract a/d CYcle LeNgth
c   Returned value is the length of each data acquisition cycle .
c If no data is acquired in a '###pause' sub-block , the returned value is
c JEXTCYLN = -1
c
c Mhdr(5) == nbytes    # number of bytes remaining in header record
c Mhdr(19)== inchans   # no. of A/D channels used in a data sub-block
c
      implicit none
      include 'genacq.kon'
      include 'genrdf.cmn'
c
      Jextcyln = -1 0
      if ( Csublab .eq. '###pause' ) then
        if ( Mhdr(5) .ge. 20 )
     1    Jextcyln = 1
      else if ( Csublab.eq.'###1dat1' .or. Csublab.eq.'###2dat2' ) then
        Jextcyln = Mhdr(19)
      else
        call srdferr( 'JEXTCYLN : ' // Csublab,  Hrdfunav )
        end if
      return
      end


      CHARACTER *2 FUNCTION GEXTVSID
c
c       EXTract TraVerSe IDentity
c   Returns the two traverse identifier characters .
c
c Mhdr(2) == itvsid    # travserse identifier - stored as 2 bytes
c
      implicit none
      include 'genacq.kon'
      include 'genrdf.cmn'
c
      if ( Csublab .ne. '###trav ' )
     1  call srdferr( 'GEXTVSID : ' // Csublab, Hrdfunav )
      call Sbytchr( Mhdr(6), Gextvsid, 2 )
      return
      end



      REAL FUNCTION QEXTCYTM
c
c       EXTract a/d Cycle Time
c   Returned value is the A/D converter cycle time .
c
c variables
c  real Rcytmd, Rcytmp         # cycle times for data and pause sub-blocks
c
c Mhdr(5) == nbytes    # number of bytes remaining in header record
c
      implicit none
      include 'genacq.kon'
c
      real Rcytmd, Rcytmp
      include 'genrdf.cmn'
      equivalence ( Mhdr(7), Rcytmp ), ( Mhdr(13), Rcytmd )
c
      if ( Csublab .eq. '###pause' ) then
        if ( Mhdr(5) .ge. 20 )
     1    Qextcytm = Rcytmp
      else if ( Csublab.eq.'###1dat1' .or. Csublab.eq.'###2dat2' ) then
        Qextcytm = Rcytmd
      else
        call srdferr( 'QEXTCYTM : ' // Csublab, Hrdfunav )
        end if
      return
      end



      REAL FUNCTION QEXTSAMT
c
c       EXTract a/d SAMpling Time
c   Returned value is the A/D converter sampling periods in seconds .
c Available for the '###1dat1' and '###2dat2' sub-blocks only .
c
c variables
c  real Rsamtm                 # sampling period
c
      implicit none
      include 'genacq.kon'
c
      real Rsamtm
      include 'genrdf.cmn'
      equivalence ( Mhdr(15), Rsamtm )
c
      if ( Csublab .ne. '###1dat1' .and. Csublab .ne. '###2dat2' )
     1  call srdferr( 'QEXTSAMT : ' // Csublab, Hrdfunav )
      Qextsamt = Rsamtm
      return
      end


      SUBROUTINE SRDFSTMP( HEADER )
c
c If the block header contains time stamp, date stamp and time delay
c information, extract it into global variables .
c
c Argument
c  integer *2 header(*)   # data block header array
c
      implicit none
      integer *2 header(*)
      include 'genrdf.cmn'
c
      call Sbytchr( header(1), Cblklab, 8 )
      if ( header(5) .ge. 6 ) then
          tstamp(1) = header(6)
          tstamp(2) = header(7)
          tstamp(3) = header(8)
      else
          tstamp(1) = 0
          tstamp(2) = 0
          tstamp(3) = 0
          end if
      if ( header(5) .ge. 12 ) then
          dstamp(1) = header(9)
          dstamp(2) = header(10)
          dstamp(3) = header(11)
      else
          dstamp(1) = 0
          dstamp(2) = 0
          dstamp(3) = 0
          end if
      if ( header(5) .ge. 18 ) then
          idelay(1) = header(12)
          idelay(2) = header(13)
          idelay(3) = header(14)
      else
          idelay(1) = 0
          idelay(2) = 0
          idelay(3) = 0
          end if
      return
      end


      SUBROUTINE SRDFXXX( IRDFREC )
c
c         Modify the contents of a sub-block header record
c
c constants
c  Hlabel='SRDFXXX'            # name of routine
c  integer *2 indd(0:7)        # array indices for ###?dat? sub-block
c             indp(0:7)        # array indices for ###pause sub-block
c             ityped(0:7)      # type of variables in ###?dat? sub-block
c             itypep(0:7)      # type of variables in ###pause sub-block
c variables
c  logical *1 Blab(8)          # actual header record label
c             ok               # write to file success / failure
c             daflush          # function : flush data file O/P buffer
c             daget            #          : read direct access file
c             daput            #          : write to direct access file
c  integer *2 ind              # array index of variable to be changed
c             Index            # sub-block listing reference index
c             irec             # record number of record to be changed
c             irdfrec          # initial raw data file record number
c             itype            # type of the variable to be changed
c             nbytes           # number of bytes remaining in record
c             Jresp            # function : integer response
c  integer *4 Dhdr(28)         # contents of header record
c             Dpresp           # function : integer *4 response
c  real       Rhdr(28)         # contents of header record
c             Shdr(28)         # contents of header record
c             Qresp            # function : real response
c  character Clab*8            # actual header record label
c  subroutine dainit           # initialize file input buffer pointer
c             sbytchr          # convert byte string to character string
c             sextall          # display sub-block header
c             sfail            # genacq error message
c             srdferr          # read data file error
c
      implicit none
      include 'genacq.kon'
      character *7 Hlabel
      parameter( Hlabel='SRDFXXX' )
      integer *2 indp(0:7), indd(0:7), itypep(0:7), ityped(0:7)
      data Indp   / 0, 6, 11, 9, 4, 7, 8, 9 /
      data Itypep / Hnull, 3* Hint2, Hreal, 3* Hrealb /
      data Indd   / 0, 4, 11, 9, 7, 8, 9, 19 /
      data Ityped / Hnull, Hreal, 2* Hint2, 2* Hreal, Hrealb, Hint2 /
c

      logical *1 Blab(8), ok, daflush, daget, daput
      integer *2 ind, Index, irec, irdfrec, itype, nbytes, Jresp
      integer *4 Dhdr(28), Dpresp
      real Rhdr(28), Shdr(28), Qresp
      character Clab*8
      include 'genrdf.cmn'
      equivalence ( Mhdr(1), Blab(1), Rhdr(1), Dhdr(1) ),
     1            ( Mhdr(2), Shdr(1) ), ( Mhdr(5), nbytes )
c
c           find the sub-block header record
c
      irec = irdfrec
      call dainit
      if ( .not. daget( irec, Mhdr, 70 ) )
     1  call srdferr( Hlabel, Hrdfueof )
      call Sbytchr( Blab, Clab, 8 )
      if ( Clab(1:2) .eq. '##' ) then                                      1b
c
c       if a block header record , read block header records until a sub
c         block is encountered .
c
1       if ( Clab(3:3) .ne. '#' ) then                                     2b
c
c       If a module header record , return with false result .
c
          if ( Clab(1:1) .eq. '#' .and. Clab(2:2) .ne. '#' )
     1      return
c
c       If the block header contains time stamp, date stamp and time delay
c       information, extract it into global variables
c
          call srdfstmp( Mhdr )
          call dainit
          if ( .not. daget( irec, Mhdr, 70 ) )
     1      call srdferr( Hlabel, Hrdfueof )
          call Sbytchr( Blab, Clab, 8 )
          goto 1
          end if                                                           2e
c
c       Advice
c
        call sextall
        write( Hvdulu, 2 ) nbytes, Clab, irec
2       format( / 11x, 'SUB-BLOCK HEADER RECORD MODIFIER' /
     1    11x, 32( '=' ) /
     2  12x, 'You can now modify some of the ', i3, ' bytes in the' /
     3  12x, a8, ' sub-block at record number ', i7,'. You are warned' /
     4  12x, 'that the data files constructed by GENACQ are' /
     5  12x, 'syntactically and numerically consistent . In modifying' /
     7  12x, 'the sub-block header record, you can easily destroy' /
     8  12x, 'this consistency  ; so  BE  VERY  CAREFUL , otherwise '  /
     9  12x, 'you may render the data file unreadable by RDFLIB' /
     a  12x, 'routines .' )
c
c       main loop
c
c       start of loop                                                      2b
3         write( Hvdulu, 4 )
4         format( 6x, 'What do you want to modify ?' /
     1      12x, '( enter an item number enclosed by () in the' /
     2      14x, 'above sub-block listing ; N.B. 0 = nothing   ) ' )
c
c       Determine index & type of value to be modified
c
          if ( Clab .eq. '###pause' ) then                                 3b
            Index = Jresp( Hkbdlu, 0, 7, 3 )
            ind = indp( index )
            itype = itypep( index )
          else if ( Clab .eq. '###trav ' ) then                            3m
            Index = Jresp( Hkbdlu, 0, 11, 3 )
            itype = H2chr
            ind = 6
            if ( Index .gt. 1 ) then                                       4b
              itype = Hreal
              ind = Index + 1
              end if                                                       4e
          else if ( Clab.eq.'###1dat1' .or. Clab.eq.'###2dat2' ) then      3m
            Index = Jresp( Hkbdlu, 0, 19, 3 )
            ind = Index + 12
            Itype = 1
            if ( index .le. 7 ) then                                       4b
              ind = Indd( index )
              itype = ityped( index )
              end if                                                       4e
            end if                                                         3e
c
c             assign the value
c
          if ( index .eq. 0 ) goto 10
          if ( itype .eq. Hint2 ) then                                     3b
            write( Hvdulu, 5 )
5           format( ' Enter a 16 bit integer value  ' )
            Mhdr( ind ) = Jresp( Hkbdlu, -32768, 32767, 3 )
          else if ( itype .eq. Hreal ) then                                3m
            write( Hvdulu, 6 )
6           format( ' Enter a 32 bit, single precision real value  ' )
            Rhdr( ind ) = Qresp( Hkbdlu, -1.6e-36, 1.6e36, 3 )
          else if ( itype .eq. Hrealb ) then                               3m
            write( Hvdulu, 6 )
            Shdr( ind ) = Qresp( Hkbdlu, -1.6e-36, 1.6e36, 3 )
          else if ( itype .eq. Hint4 ) then                                3m
            write( Hvdulu, 7 )
7           format( ' Enter a 32 bit integer value  ' )
            Dhdr( ind ) = Dpresp( Hkbdlu, -2147483647, 2147483647, 3 )
          else if ( itype .eq. H2chr ) then                                3m
            write( Hvdulu, 8 )
8           format( ' Enter 2 ASCII characters  ' )
            read( Hkbdlu, 9 ) Mhdr( ind )
9           format( a2 )
            end if
          call sextall
          goto 3
c         end of loop                                                      2e
c
c             re-write the sub-block header record
c
10      irec = irec - 1
        ok = daput( irec, Mhdr, 70 )
        ok = ok .and. daflush( irec )
        if ( .not. ok )
     1    call sfail( Hsbkerr )
        end if                                                             1e
      return
      end


      SUBROUTINE SEXTALL( IOPFLU )
c
c       EXTract ALL header information
c   Puts all the information in the current block header and sub-block
c header records from an '#acquire', '#calbar', or 'calhw1' raw data file
c module onto file with logical unit IAUXLU .
c
c Argument
c  integer *2 iopflu           # output file logical unit number
c
c constants
c    Hlabel                    # Routine name
c    Cadid(4)*12               # A/D converter types
c Variables
c  integer *2 i                # looping index
c             ichls(16)        # A/D channel address list
c             icid             # A/D converter identifier
c             icntr            # loop / event counter
c             icyln            # A/D cycle length
c             ihadid           # A/D converter identifier
c             ihchan           # A/D channel address
c             ihnocy           # no. of A/D acquisition cycles
c             ikbdv            # keyboard reference value used flag
c             itvsid           # traverse identifier
c             nbytes           # number of bytes remaining in record
c  integer *4 ddnocy           # no. of data acquisition cycles
c  real rcytm                  # A/D cycle time
c       rkbdv                  # keyboard reference value
c       rhcyt                  # A/D cycle time
c       rhmonav                # average monitored voltage
c       rhtarg                 # monitor target voltage
c       rhtol                  # monitor voltage tolerance
c       rsamt                  # A/D chan to chan sampling time
c       rtvxxa(5)              # actual traverse position coordinates
c       rtvxxr(5)              # required traverse position coordinates
c  subroutine srdferr          # read data file error message
c
      implicit none
      character *10 Hlabel, Cadid(4)*12
      parameter( Hlabel='SEXTALL : ' )
      data Cadid / 'DAS 1128 slo', 'DAS 250A seq', 'DAS 250A ran',
     1  'SIM ACQ fast' /
      include 'genacq.kon'
c
      integer *2 i, ichls(16), icid, icntr, icyln, ihadid, ihchan,
     1  ihnocy, ikbdv, iopflu, itvsid, nbytes
      integer *4 ddnocy
      real rcytm, rkbdv, rhcyt, rhmonav, rhtarg, rhtol, rsamt,
     1  rtvxxa(5), rtvxxr(5)
      include 'genrdf.cmn'
c
      equivalence ( Mhdr(5), nbytes ),
     1  ( Mhdr(6), ihadid, itvsid, ikbdv ),
     2  ( Mhdr(7), rhcyt, rtvxxr(1), Rkbdv ), ( Mhdr(9), ihnocy, icid ),
     3  ( Mhdr(11), ihchan, icntr ),               ( Mhdr(14), rhtarg ),
     4  ( Mhdr(13), rcytm ), ( Mhdr(15), rsamt ), ( Mhdr(16), rhtol ),
     5  ( Mhdr(17), rtvxxa(1), ddnocy ),          ( Mhdr(18), rhmonav ),
     6  ( Mhdr(19), icyln ),                     ( Mhdr(20), ichls(1) )
c
c           display block label
c
      if ( Cblklab .eq. '##main' ) then
        write( iopflu, 1 )
1       format( / 21x, 'MAIN DATA BLOCK' )
      else if ( Cblklab .eq. '##prelim' ) then
        write( iopflu, 2 )
2       format( / 21x, 'PRELIMINARY DATA BLOCK' )
      else if ( Cblklab .eq. '##extra  ' ) then                            1m
        write( iopflu, 3 )
3       format( / 21x, 'EXTRA DATA BLOCK' )
      else                                                                 1m
        call srdferr( Hlabel // Cblklab, Hrdfiblk )
        end if                                                             1e
      if ( tstamp(1) .ne. 0 .or. tstamp(2) .ne. 0 .or.
     1     tstamp(3) .ne. 0 ) then
        write( iopflu, 14 ) tstamp(1), tstamp(2), tstamp(3)
14      format( 25x, 'time   ', i2, ':', i2, ':', i2 )
        end if
      if ( dstamp(1) .ne. 0 .or. dstamp(2) .ne. 0 .or.
     1     dstamp(3) .ne. 0 ) then
        write( iopflu, 15 ) dstamp(1), dstamp(2), dstamp(3)
15      format( 25x, 'date   ', i2, '/', i2, '/', i2 )
        end if
      if ( idelay(1) .ne. 0 .or. idelay(2) .ne. 0 .or.
     1     idelay(3) .ne. 0 ) then
        write( iopflu, 16 ) idelay(1), idelay(2), idelay(3)
16      format( 25x, 'initial time delay  ', i5, ' minutes' /
     1          45x, i5, ' seconds' / 45x, i5, ' millisec' )
        end if
c
c           pause sub-block
c
      if ( Csublab .eq. '###pause' ) then                                  1b
        if ( nbytes .lt. 20 ) then                                         2b
          write( iopflu, 4 )
4         format( 11x, 'PAUSE sub-block : simple pause ' )
        else                                                               2m
          write( iopflu, 5 ) Cadid( ihadid*2-1 ), ihchan, ihnocy, rhcyt
5         format( 11x, 'PAUSE sub-block : active monitoring' /
     1      6x, '(1) A/D converter used             =   ', a13 /
     2      6x, '(2) A/D channel address            =   ', i2 /
     3      6x, '(3) No. of A/D acquisition cycles  = ', i5 /
     4      6x, '(4) A/D acquisition cycle period   = ', g14.6,
     5      ' seconds' )
          if ( nbytes .lt. 28 ) then                                       3b
            write( iopflu, 6 ) Rhtarg
6           format( 10x, 'Monitoring mode', 16x, '=    manual' /
     1        6x, '(5) Average monitored voltage      = ', f10.4,
     2         ' Volts' )
          else                                                             3m
            write( iopflu, 7 ) Rhtarg, Rhtol, Rhmonav
7           format( 10x, 'Monitoring mode', 16x, '=    automatic' /
     1 6x, '(5) Target monitor voltage         = ', f10.4, ' Volts' /
     2 6x, '(6) Monitor tolerance voltage      = ', f10.4, ' Volts' /
     3 6x, '(7) Average monitored voltage      = ', f10.4, ' Volts' )
            end if                                                         3e
          end if                                                           2e
c
c           traverse sub-block
c
      else if ( Csublab .eq. '###trav ' ) then                             1m
        write( iopflu, 8 ) itvsid, ( rtvxxr(i), Rtvxxa(i), i= 1, 5 )
8       format( 11x, 'TRAVERSE sub-block :' /
     1    6x, '(1) Traverse identifier : ', a2 /
     2    6x, 'Probe position coordinates     required     actual' /
     3    8x, '(3)(8)  Streamwise displacement   ', 2f9.4, ' mm' /
     4    8x, '(4)(9)  Normal displacement       ', 2f9.4, ' mm' /
     5    8x, '(5)(10) Spanwise displacement     ', 2f9.4, ' mm' /
     6    8x, '(6)(11) Yaw angle                 ', 2f9.3, ' degrees' /
     7    8x, '(7)(12) Pitch angle               ', 2f9.3, ' degrees' )
c
c           primary and secondary data blocks
c
      else if ( Csublab.eq.'###1dat1' .or. Csublab.eq.'###2dat2' ) then    1m
        if ( Csublab .eq. '###1dat1' ) then                                2b
          write( iopflu, 9 )
9         format( 11x, 'PRIMARY DATA sub-block :' )
        else                                                               2m
          write( iopflu, 10 )
10        format( 11x, 'SECONDARY DATA sub-block :' )
          end if                                                           2e
        if ( ikbdv .gt. 0 )
     1    write( iopflu, 11 ) rkbdv
11        format( 6x, '(1) Keyboard reference value       =', g15.6 )
        write( iopflu, 12 ) icntr, Cadid( icid ), rcytm, rsamt, ddnocy,
     1    icyln
12      format( 6x, '(2) Loop /event counter            = ', i7 /
     1    6x, '(3) A/D converter                  =   ', a12 /
     2    6x, '(4) Acquisition cycle time         = ', g14.6, ' sec' /
     3    6x, '(5) chan to chan sampling time     = ', g14.6, ' sec' /
     4    6x, '(6) Number of acquisition cycles   =   ', i10 /
     5    6x, '(7) Acquisition cycle length       =   ', i3,
     6    ' channels' )
        if ( iand( icid, 1 ) .gt. 0 ) then
          write( iopflu, 13 ) ( ichls(i), i = 1, icyln )
        else
          write( iopflu, 13 ) ( i, i = 0, icyln-1 )
          end if
13        format( 6x, '(>=8) A/D channel address list     = ', 8i3 :/
     1      39x, 8i3 )
c
c           unidentified sub-block
c
      else
        call srdferr( Hlabel // Csublab, Hrdfsblk )
        end if
      return
      end


      SUBROUTINE SRDFTVS( IOPFLU, IRDFREC )
c
c       Display the traverse calibration table
c   It is assumed that a module header record with a '#caltvs ' label has just
c been read .by a call to ERDFMHD or SRDFMHD .
c
c Arguments
c  integer *2 iopflu           # logical unit no. of O/P device
c             irdfrec          # data file record pointer
c
c constants
c    Hlabel='SRDFTVS'          # Routine label
c    Hntvch=8                  # number of traverse channels available
c    Hnopts=30                 # no. of rows in calibration table
c
c variables
c  logical *1 Blab(8)          # actual header record label
c             Ftvdone(Hntvch)  # DOFs calibrated flags
c             daget            # function : read direct access file
c  integer *2 i1, i2           # looping indices
c             Mpdsiz(Hntvch)   # number of p/d calibration points for each DOF
c             nbytes           # number of bytes remaining in record
c  real Upddgc(Hntvch)         # Pot/displ. drift gradient corrections
c       Upddoc(Hntvch)         # Pot/displ. drift offset correction
c       Uproff(5,3)            # Probe offset for each traverse
c       Utvdis(Hnopts,Hntvch)  # Traverse displacements table
c       Utvoff(Hntvch)         # Traverse displacement offsets
c       Utvpot(Hnopts,Hntvch)  # Potentiometer readings table
c  subroutine dainit           # restart file I/P buffer
c             sbytchr          # convert byte to character string
c             srdferr          # read data file error message
c
c
      implicit none
      integer *2 Hmaxpol, Hntvch, Hnopts
      character *6 Hlabel
      parameter( Hlabel='SRDFTVS', Hmaxpol=12, Hntvch=8, Hnopts=30 )
      include 'genacq.kon'
c
      logical *1 Blab(8), Ftvdone(Hntvch), daget
      integer *2 i1, i2, Mpdsiz(Hntvch), Mtvord(Hntvch), nbytes, iopflu,
     1  irdfrec
      real Upddgc(Hntvch), Upddoc(Hntvch), Uproff(5,3),
     1  Utvdis(Hnopts,Hntvch), Utvoff(Hntvch), Utvpot(Hnopts,Hntvch),
     2  Utvpol(Hmaxpol,Hntvch)
      include 'genrdf.cmn'
      equivalence ( Mhdr(1), Blab(1) ), ( Mhdr(5), nbytes ),
     1  ( Mhdr(6), Ftvdone(1) ), ( Mhdr(10), Mpdsiz(1) ),
     2  ( Utvpot(1,1), Utvdis(1,1), Utvoff(1), Upddgc(1), Upddoc(1),
     3    Uproff(1,1), Utvpol(1,1) )
c
c             get label, byte count, calibrated flags & array size
c
      call dainit
      if ( .not. daget( irdfrec, Mhdr, 34 ) )
     1  call srdferr( Hlabel, Hrdfueof )
      call sbytchr( Blab, Cblklab, 8 )
      if ( Cblklab .ne. '##caltvs' )
     1  call srdferr( Hlabel, Hrdfiblk )
c
c           This code must work for version 1 & version 2 traverse calibrations
c
c             version 1 & 2
      if ( nbytes .ne. 2100 .and. nbytes .ne. 2500 )
     1  call srdferr( Hlabel, Hrdfbcnt )
      write( iopflu, 1 ) ftvdone, Mpdsiz
1     format( 21x, 'CALIBRATE TRAVERSE block' // 11x, 'DOFs calibrated'
     1  / 5x, 7( l1, 9x ), l1 //
     2  11x, 'Number of Pot.<=>Displ. calibration points' /
     3  4x, 7( i3, 7x ), i3 // 11x, 'Potentiometer readings table' )
c
c             version 2 only
      if ( nbytes .eq. 2500 ) then
        if ( .not. daget( irdfrec, Mtvord, 16 ) )
     1    call srdferr( Hlabel, Hrdfueof )
        write( Hvdulu, 8 ) Mtvord
8       format( 11x, 'Polynomial order' / 4x, 7( i3, 7x ), i3 )
        end if
c
c             get potentiometer readings table
c
c             version 1 & 2
      if ( .not. daget( irdfrec, Utvpot, 960 ) )
     1  call srdferr( Hlabel, Hrdfueof )
      write( iopflu, 2 ) ( ( Utvpot(i1,i2), i2=1,8 ), i1=1,30 )
2     format( 1x, 8f10.3 )
c
c             get traverse displacements table
c
c             version 1 & 2
      if ( .not. daget( irdfrec, Utvdis, 960 ) )
     1  call srdferr( Hlabel, Hrdfueof )
      write( iopflu, 3 )
3     format( / 11x, 'Traverse displacements table' )
      write( iopflu, 2 ) ( ( Utvdis(i1,i2), i2=1,8 ), i1=1,30 )
c
c             get traverse displacement offsets
c
c             version 1 & 2
      if ( .not. daget( irdfrec, Utvoff, 32 ) )
     1  call srdferr( Hlabel, Hrdfueof )
      write( iopflu, 4 )
4     format( / 11x, 'Traverse displacement offsets' )
      write( iopflu, 2 ) Utvoff
c
c             get Pot. / Displ. drift gradient corrections
c
c             version 1 & 2
      if ( .not. daget( irdfrec, Upddgc, 32 ) )
     1  call srdferr( Hlabel, Hrdfueof )
      write( iopflu, 5 )
5     format( / 11x, 'Pot./Displ. drift gradient corrections' )
      write( iopflu, 2 ) Upddgc
c
c             get Pot. / Displ. drift offset corrections
c
c             version 1 & 2
      if ( .not. daget( irdfrec, Upddoc, 32 ) )
     1  call srdferr( Hlabel, Hrdfueof )
      write( iopflu, 6 )
6     format( / 11x, 'Pot./Displ. drift offset corrections' )
      write( iopflu, 2 ) Upddoc
c
c             version 2 only
      if ( nbytes .eq. 2500 ) then
        if ( .not. daget( irdfrec, Utvpol, 384 ) )
     1    call srdferr( Hlabel, Hrdfueof )
        write( Hvdulu, 9 )
9       format( / 11x, 'Coefficients of fitted polynomials' )
        write( Hvdulu, 10 ) ( ( Utvpol(i1,i2), i2 = 1, 8 ), i1 = 1, 12 )
10      format( 1x, 4g15.7 / 9x, 4g15.7 )
        end if
c
c             get probe offsets
c
c             version 1 & 2
      if ( .not. daget( irdfrec, Uproff, 60 ) )
     1  call srdferr( Hlabel, Hrdfueof )
      write( iopflu, 7 ) Uproff
7     format( / 11x, 'Probe offset coordinates for each traverse' /
     1  ( 1x, 5f12.3 ) )
      return
      end


      SUBROUTINE SBYTCHR( BSTR, CSTR, LENSTR )
c
c         Transfer the character data in the BYTE array BSTR to a character
c  variable GSTR . LENSTR is the maximum number of characters which can be
c  transferred . BSTR and GSTR must be at least L:ENSTR bytes long . A zero
c  ( null ) in BSTR is understood to be a string terminator . The remainder
c  of GSTR is filled with blanks .
c
c Arguments
c  logical *1 Bstr(*)          # byte string
c  character Cstr(*)           # character string
c  integer *2 lenstr           # maximum length of byte string
c Variable
c  integer *2 i,               # looping index
c             lb,              # length of byte string
c             ibyte            # temporary character storage
c  logical *1 fbyte            # temporary character storage
c
      implicit none
      integer * 2 lenstr, i, lb, ibyte
      logical *1 Bstr(*), fbyte
      character *(*) Cstr
      equivalence( fbyte, ibyte )
c
      lb = min( lenstr, len( Cstr ) )
      ibyte = 0
      i = 1
1     fbyte = bstr(i)
      if ( i .le. lb .and. ibyte .ne. 0 ) then
        Cstr(i:i) = char( ibyte )
        i = i + 1
        goto 1
        end if
      Cstr(i:) = ' '
      return
      end
