c
c    Copyright (C) 1997  Peter Vernon Lanspeary
c
c    This program is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    This program is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program; if not, write to the Free Software
c    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c


      PROGRAM TVSCAL
c
c       Display traverse calibration file .
c
c  synopsis :   tvscal [filename]
c     if no file name is specified , the default  /genacq/caltvs.dat
c  is assumed .
c
c  logical *1 fedit,            # file has been edited
c             Equery            # logical response
c  integer *2 i, j,             # O/P looping indices
c             ind(10),          # real ind of each item
c             item,             # item to be changed
c             ierr,             # error status
c             iargc,            # function : get program arguments
c             Jresp             #          : integer response
c  real Utvcal(525),            # traverse calibration file contents
c       Qresp                   # function : real response
c  character Ctvsfil*32         # name of calibration file
c  subroutine getarg            # get program arguments
c
      implicit none
      include 'genacq.kon'
      include 'tvstvs.cmn'
c
      logical *1 fedit, Equery
      integer *2 i, j, ind(10), item, ierr, iargc, Jresp
      real Utvcal(625), Qresp
      character Ctvsfil*32
c
      equivalence ( Mtvcal(1), Utvcal(1) )
      data ind / 0, 2, 6, 10, 250, 490, 498, 506, 514, 610 /
c
c       open and read calibration file
c
      fedit = .false.
      if ( iargc() .le. 0 ) then                                          1b
        Ctvsfil = '\genacq\com\caltvs.dat'
        write( Hvdulu, 1 ) Ctvsfil
1       format( ' TVSCAL : NOTE : Default calibration file is ', a )
      else                                                                1m
        call getarg( 1, Ctvsfil )
        end if                                                            1e
      open( UNIT=Htvslu, FILE=Ctvsfil, ACCESS='sequential',
     1      FORM='unformatted', STATUS='old', ERR=24, IOSTAT=ierr )
      read( Htvslu, END=20, ERR=20, IOSTAT=ierr ) Mtvcal
c
c           Print contents of calibration file
c
2     write( Hvdulu, 3 ) ftvpdt, Mpdsiz, Mtvord,
     1  ( ( Utvpot(i,j), j = 1, Hntvch ), i = 1, 30 )
      write( Hvdulu, 4 ) ( ( Utvdis(i,j), j = 1, Hntvch ), i = 1, 30 )
      write( Hvdulu, 5 ) Utvoff, Upddgc, Upddoc, Utvpol
      write( Hvdulu, 6 ) Uproff
3     format( / 10x, 'TRAVERSE CALIBRATION FILE' / 10x, 25( '=' ) //,
     1  5x, 'Channel calibrated flags' / 8( l5, 4x ) //,
     2  5x, 'Number of calibration points' / 8( i5, 4x ) //,
     3  5x, 'Order of fitted polynomial' / 8( i5, 4x ) //,
     4  5x, 'Potentiometer readings table' / 8( 2x, f5.0, 2x ) )
4     format( // 5x, 'Traverse displacements table' / ( 1x, 8f9.3 ) )
5     format( // 5x, 'Traverse displacement offsets' / 1x, 8f9.3 //,
     1  5x, 'Pot/displ drift gradient correction' / 1x, 8f9.6 //,
     2  5x, 'Pot/displ drift offset correction' /  1x, 8f9.4 //,
     3  5x, 'Fitted polynomials' / ( 1x, 5g14.6 / 8x, 3g14.6 ) )
6     format( 5x, 'Probe offset for each traverse' / 3( 9x, 5f11.4 / ) )
c
c           edit the file
c
      if ( equery( Hkbdlu, 'Do you want to edit the file ?' ) ) then      1b
c
c       start loop                                                        2b
7         write( Hvdulu, 8 )
8         format( ' Which item ?' / '  (0) exit' /
     1      '  (1) ftvpdt - channel calibrated' /
     2      '  (2) Mpdsiz - no of pot/dis records' /
     3      '  (3) Mtvord - order of fitted polynomial' /
     4      '  (4) Utvpot - potentiometer readings' /
     5      '  (5) Utvdis - traverse displacements' /
     6      '  (6) Utvoff - displacement offsets' /
     7      '  (7) Upddgc - drift gradient correction' /
     8      '  (8) Upddoc - drift offset correction ' /
     9      '  (9) Utvpol - fitted polynomials' /
     a      ' (10) display values ' )
          item = Jresp( Hkbdlu, 0, 10, Hntries )
          if ( item .eq. Hexit )
     1      goto 18
          if ( item .eq. 10 )
     1      goto 2
          write( Hvdulu, 9 )
9         format( ' channel number ? ' )
          ichan = Jresp( Hkbdlu, 1, Hntvch, Hntries )
c
c       channel calibrated flag
c
          if ( item .eq. 1 ) then                                         3b
            fedit = .true.
            write( Hvdulu, 10 ) ichan, ftvpdt(ichan)
10          format( 'ftvpdt : chan ', i1, ' = ', l1 )
            ftvpdt(ichan) = Equery( Hkbdlu, 'New value ? ' )
c
c       length of displacement table
c
          else if ( item .eq. 2 ) then                                    3m
            fedit = .true.
            write( Hvdulu, 12 ) ichan, Mpdsiz(ichan)
12          format( ' Mpdsiz : chan ', i1, ' = ', i2, '. New value ? ' )
            Mpdsiz(ichan) = Jresp( Hkbdlu, 0, Hnopts, Hntries )
c
c       order of fitted polynomial
c
          else if ( item .eq. 3 ) then                                    3m
            fedit = .true.
            write( Hvdulu, 13 ) ichan, Mpdsiz(ichan)
13          format( ' Mtvord : chan ', i1, ' = ', i2, '. New value ? ' )
            Mtvord(ichan) = Jresp( Hkbdlu, 0, Hnopts, Hntries )
c
c       traverse displacements or potentiometer readings
c
          else if ( item .eq. 4 .or. item .eq. 5 ) then                    3m
            if ( Mpdsiz(ichan) .gt. 0 .and. ftvpdt(ichan) ) then           4b
              fedit = .true.
              write( Hvdulu, 14 ) ichan,
     1          ( i, Utvcal( ind( item ) + Hnopts * ( ichan - 1 ) + i ),
     2          i = 1, Mpdsiz( ichan ) )
14            format( ' Utvpot/Utvdis : chan ', i1, ' = ' /,
     1          ( i2, 2x, f11.4, 4x, i2, 2x, f11.4, 4x, i2, 2x, f11.4,
     2          4x, i2, 2x, f11.4 ) )
              write( Hvdulu, 15 ) Mpdsiz( ichan )
15            format( ' Which value ( 1 to ', i2, ' ) ' )
              i = Jresp( Hkbdlu, 1, Mpdsiz(ichan), Hntries )
              write( Hvdulu, 16 )
16            format( '+New value ? ' )
              Utvcal( ind( item ) + Hnopts * ( ichan - 1 ) + i ) =
     1          Qresp( Hkbdlu, -999999., 999999., Hntries )
              end if                                                       4e
c
c       displacement offsets, drift gradient correction,
c         or drift offset correction
c
          else if ( item .gt. 5 .or. item .lt. 9 ) then                   3m
            fedit = .true.
            write( Hvdulu, 17 ) ichan, Utvcal( ind( item ) + ichan )
17          format( 'Utvoff/Upddgc/Upddoc : chan : ', i1, ' = ', f11.4,
     1        ' . New value ? ' )
            Utvcal( ind( item ) + ichan ) =
     1        Qresp( Hkbdlu, -500., 500., Hntries )
            end if                                                        3e
            goto 7
c         end of loop                                                     2e
        end if                                                            1e
18    if ( fedit ) then                                                   1b
        rewind( UNIT=Htvslu )
        write( Htvslu, ERR=22, IOSTAT=ierr ) Mtvcal
        write( Hvdulu, 19 )
19      format( ' TVSCAL : New traverse calibration file written' )
        end if                                                            1e
      stop
c
20    write( Hvdulu, 21 ) ierr
21    format( ' TVSCAL : FATAL : File read error ', i8 )
      stop
c
22    write( Hvdulu, 23 ) ierr
23    format( ' TVSCAL : FATAL : file write error ', i8 )
c
24    write( Hvdulu, 25 ) ierr
25    format( ' TVSCAL : FATAL : Can''t open file ', i8 )
      stop
      end
