c
c    Copyright (C) 1997  Peter Vernon Lanspeary
c
c    This program is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    This program is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program; if not, write to the Free Software
c    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c


      PROGRAM CRO
c
c       Simulates a crude form of CRO with the data acquisition system.
c
c   Usage :-
c       CRO
c
      include 'stdio.def'
c
      write( STD_OUT, 1 )
1     format( ' Start the data acquisition system ( i.e. SBC etc. )'
     1      / '   Then press <return>' )
      read( STD_IN, 2 )
2     format( )
      call sbinit( .FALSE., ' ' )
      call sbunpk( .TRUE. )
      call sppdis( .FALSE. )
      call HG_Erase()
      call redraw_all()
      call main_menu()
      call HG_Erase()
      call HG_Off()
      call sbstop
      stop
      end




      SUBROUTINE MAIN_MENU()
c
c          1         2         3         4         5         6         7         8
c 12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789
ccccccccccccc
c1Exit CRO  c  Exit H/W     Das 1128      Exit Ave     Exit T/Base          Auto
c2Hardware  c  A/D conv     Seq 250A      Averaging N  Cycle time  0.00150  Upper 10.240
c3Time-base c  Parallel  Y  Ran 250A      Order mom 2  Total time   20.000  Lower  0.000
c4Voltage   c  Graph                      Max/Min   Y  No. samples 20000    Range
c5Inputs    c                             Clip-data N  Samp period 0.00025  Centr
c6Averaging c  Exit I/P                                Samp freq     6000   Full
c7Sngl-sweepc  Number    8                Exit
c8Continuousc  Chan List 0 1 2 3 4 5 6 7  Plot  Y
c9Measure   c                             Scale Y
caFile      c
cbWait      c
ccccccccccccc
c
c35    File   Storage.CRO
c36    Store
c37    Recall
c38
c39    Measure  Time    Voltage
c40    prev ---g12.6e1--nnn.nnn
c41    curr ---g12.6e1--nnn.nnn
c42    diff ---g12.6e1--nnn.nnn
c 12345678901234567890123456789
c 6        7         8
c
c local variables
c  logical *1
c   terminal(9)   # specifies which menu items are terminators
c  integer *2
c   item          # specified menu item
c   get_menu      # function : select menu item
c  character
c   Menu(M_LEN)*10   # list of menu item text strings
c   dummy(M_LEN)*1   # unused menu keys and menu value strings
c
      include 'stdio.def'
      integer *2 M_LEN, M_LEFT, M_TOP, Q_LEN, Q_LEFT, Q_TOP
      character BLANK*1, BLANKS_12*12
      parameter( M_LEN=11, M_LEFT=1, M_TOP=0,
     1           Q_LEN=2,  Q_LEFT=35, Q_TOP=21,
     2           BLANK=' ', BLANKS_12 = '            ' )
c
      logical *1 terminal(M_LEN)
      integer *2 item, get_menu
      character Menu(M_LEN)*10, dummy(M_LEN)*1, quit_menu(2)*12
      include 'cro.cmn'
c
      data terminal / M_LEN * .FALSE. /
      data Menu / 'Exit CRO  ', 'Hardware  ', 'Time-base ',
     1    'Voltage   ', 'Inputs    ', 'Averaging ', 'Sngl-sweep',
     2    'Continuous', 'Measure   ', 'File      ', 'Wait      ' /
      data quit_menu / 'Exit to DOS ', 'Continue CRO' /
      data dummy / M_LEN * BLANK /
c
      if ( print_only ) then                                              1b
          call prt_menu( Menu, dummy, terminal,
     1        M_LEN, M_LEFT, M_TOP, 0 )
      else                                                                1m
c
c         start of menu loop                                              2b
1             item = get_menu( dummy, menu, dummy, terminal,
     1            M_LEN, M_LEFT, M_TOP )
              call err_menu( BLANK )
c
c       Exit
c
              if ( item .eq. 1) then                                      3b
                  item = get_menu( dummy, quit_menu, dummy, terminal,
     1                             Q_LEN, Q_LEFT, Q_TOP )
c                 erase the quit menu
                  call HG_Puts( BLANKS_12, 21, 35 )
                  call HG_Puts( BLANKS_12, 22, 35 )
                  if ( item .eq. 1 )
     1                return
c
c       Hardware
c
              else if ( item .eq. 2) then                                 3m
                  call hardware_menu()
c
c       Time-base
c
              else if ( item .eq. 3 ) then                                3m
                  call time_base_menu()
                  call ilgclos()
                  call redraw_all()
                  got_graph = .FALSE.
                  got_data  = .FALSE.
c
c       Voltage
c
              else if ( item .eq. 4 ) then                                3m
                  call voltage_menu()
                  call ilgclos()
                  call redraw_all()
                  got_graph = .FALSE.
                  got_data  = .FALSE.
c
c       Inputs
c
              else if ( item .eq. 5 ) then                                3m
                  call inputs_menu()
                  call ilgclos()
                  call redraw_all()
                  got_graph = .FALSE.
                  got_data  = .FALSE.
c
c       Averaging
c
              else if ( item .eq. 6 ) then                                3m
                  call averaging_menu()
c
c       Sngl-sweep
c
              else if ( item .eq. 7 ) then                                3m
                  call do_sngl_sweep()
                  call redraw_all()
c
c       Continuous
c
              else if ( item .eq. 8 ) then                                3m
                  call do_continuous()
                  call redraw_all()
c
c       Measure
c
              else if ( item .eq. 9 ) then                                3m
                  call make_meas()
c
c       File
c
              else if ( item .eq. 10 ) then                               3m
                  call file_menu()
c
c       Wait for the user with graphics turned off until return key is pressed
c
              else if ( item .eq. 11 ) then                               3m
                  call HG_Off()
                  write( STD_OUT, 2 )
2                 format( ' Press <return> to continue' )
                  read( STD_IN, 3 )
3                 format( a )
                  call HG_On()
                  end if                                                  3e
              goto 1
c             end of menu loop                                            2e
          end if
      end




      SUBROUTINE REDRAW_ALL()
c
c Redraw all menus
c
      include 'stdio.def'
      include 'cro.cmn'
c
      print_only = .TRUE.
      call HG_On()
      call main_menu()
      call hardware_menu()
      call time_base_menu()
      call voltage_menu()
      call inputs_menu()
      call averaging_menu()
      call file_menu()
      call AD_select_menu()
      call plot_sel_menu()
      call displ_meas()
      print_only = .FALSE.
      return
      end



      SUBROUTINE HARDWARE_MENU()
c
c          1         2         3         4         5         6         7         8
c 12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789
c             ccccccccccccc
c1Exit CRO    cExit H/W   c Das 1128      Exit Ave     Exit T/Base          Auto
c2Hardware    cA/D conv   c Seq 250A      Averaging N  Cycle time  0.00150  Upper 10.240
c3Time-base   cParallel  Yc Ran 250A      Order mom 2  Total time   20.000  Lower  0.000
c4Voltage     cGraph      c               Max/Min   Y  No. samples 20000    Range
c5Inputs      ccccccccccccc               Clip-data N  Samp period 0.00025  Centr
c6Averaging    Exit I/P                                Samp freq     6000   Full
c7Sngl-sweep   Number    8                Exit
c8Continuous   Chan List 0 1 2 3 4 5 6 7  Plot  Y
c9Measure                                 Scale Y
caFile
cbWait
c
c
c35    File   Storage.CRO
c36    Store
c37    Recall
c38
c39    Measure  Time    Voltage
c40    prev ---g12.6e1--nnn.nnn
c41    curr ---g12.6e1--nnn.nnn
c42    diff ---g12.6e1--nnn.nnn
c 12345678901234567890123456789
c 6        7         8
c
c local variables
c  logical *1
c   terminal(4)   # specifies which menu items are terminators
c  integer *2
c   item          # selected menu item
c   get_menu      # function : select menu item
c  character
c   Menu(4)*9     # list of menu item text strings
c   key(4)*1      # unused menu keys
c   value(4)*1    # menu value strings
c  subroutine
c   err_menu      # display error message on graphics screen
c
c
      include 'stdio.def'
      integer *2 M_LEN, M_LEFT, M_TOP
      parameter( M_LEN=4, M_LEFT=14, M_TOP=0 )
c
      logical *1 terminal(M_LEN)
      integer *2 item, get_menu
      character Menu(M_LEN)*9, Key(M_LEN)*1, Value(M_LEN)*1
      include 'cro.cmn'
c
      save terminal, menu, key
      data terminal / .FALSE., .FALSE., .TRUE., .FALSE. /
      data Menu / 'Exit H/W ', 'A/D conv ', 'Parallel ', 'Graph    ' /
      data Key / 4*' ' /
      data Value / ' ', ' ', 'Y', ' ' /
c
      if ( print_only ) then                                              1b
          call prt_menu( menu, value, terminal,
     1        M_LEN, M_LEFT, M_TOP, 0 )
      else                                                                1m
c
c         start of menu loop                                              2b
1             item = get_menu( key, menu, value, terminal,
     1            M_LEN, M_LEFT, M_TOP )
              call err_menu( ' ' )
c
c       Exit
c
              if ( item .eq. 1 ) then                                     3b
c
c       fix up the parallel line switch
c
                  if ( index( 'nNyYfFtT01.', value(3) ) .ne. 0 ) then     4b
                      call sppdis( index( 'yYtT1.', value(2) ) .eq. 0 )
                      got_data = .FALSE.
                      return
                  else                                                    4m
                      call err_menu( 'Use Y or N for Parallel' )
                      end if                                              4e
c
c       select A/D converter
c
              else if ( item .eq. 2 ) then                                3m
                  call AD_select_menu()
c
c       select graphics switches
c
              else if ( item .eq. 4 ) then                                3m
                  call plot_sel_menu()
                  end if                                                  3e
              goto 1
c             end of menu loop                                            2e
          end if                                                          1e
      end




      SUBROUTINE AD_SELECT_MENU()
c
c          1         2         3         4         5         6         7         8
c 12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789
c                          cccccccccccc
c1Exit CRO     Exit H/W    cDas 1128  c   Exit Ave     Exit T/Base          Auto
c2Hardware     A/D conv    cSeq 250A  c   Averaging N  Cycle time  0.00150  Upper 10.240
c3Time-base    Parallel  Y cRan 250A  c   Order mom 2  Total time   20.000  Lower  0.000
c4Voltage      Graph       cccccccccccc   Max/Min   Y  No. samples 20000    Range
c5Inputs                                  Clip-data N  Samp period 0.00025  Centr
c6Averaging    Exit I/P                                Samp freq     6000   Full
c7Sngl-sweep   Number    8                Exit
c8Continuous   Chan List 0 1 2 3 4 5 6 7  Plot  Y
c9Measure                                 Scale Y
caFile
cbWait
c
c
c35    File   Storage.CRO
c36    Store
c37    Recall
c38
c39    Measure  Time    Voltage
c40    prev ---g12.6e1--nnn.nnn
c41    curr ---g12.6e1--nnn.nnn
c42    diff ---g12.6e1--nnn.nnn
c 12345678901234567890123456789
c 6        7         8
c
c local variables
c  logical *1
c   terminal(3)   # specifies which menu items are terminators
c  integer *2
c   get_menu      # function : select menu item
c  character
c   Menu(3)*9     # list of menu item text strings
c   dummy(3)*1    # unused menu keys and value strings
c
      include 'stdio.def'
      integer *2 M_LEN, M_LEFT, M_TOP
      parameter( M_LEN=3, M_LEFT=27, M_TOP=0 )
c
      logical *1 terminal(M_LEN)
      integer *2 get_menu
      character Menu(M_LEN)*8, dummy(M_LEN)*1
      include 'cro.cmn'
c
      save terminal, menu, dummy
      data terminal / 3 * .FALSE. /
      data Menu / 'Das 1128', 'Seq 250a', 'Ran 250a' /
      data dummy / 3 * ' ' /
c
      if ( print_only ) then                                              1b
          call prt_menu( Menu, dummy, terminal,
     1        M_LEN, M_LEFT, M_TOP, 0 )
      else                                                                1m
c         start of loop                                                   2b
1             call err_menu( ' ' )
              adid = get_menu( dummy, menu, dummy, terminal,
     1            M_LEN, M_LEFT, M_TOP )
              if ( adid .lt. 1 .or. adid .gt. 3 )
     1            goto 1
c             end of loop                                                 2e
          call prt_menu( Menu, dummy, terminal,
     1        M_LEN, M_LEFT, M_TOP, adid )
          if ( adid .eq. 1 ) then                                         2b
              AD_scale = 400.0
          else                                                            2m
              AD_scale = -409.6
              end if                                                      2e
          got_data = .FALSE.
          end if                                                          1e
      return
      end




      SUBROUTINE PLOT_SEL_MENU()
c
c          1         2         3         4         5         6         7         8
c 12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789
c
c1Exit CRO     Exit H/W     Das 1128      Exit Ave     Exit T/Base          Auto
c2Hardware     A/D conv     Seq 250A      Averaging N  Cycle time  0.00150  Upper 10.240
c3Time-base    Parallel  Y  Ran 250A      Order mom 2  Total time   20.000  Lower  0.000
c4Voltage      Graph                      Max/Min   Y  No. samples 20000    Range
c5Inputs                                  Clip-data N  Samp period 0.00025  Centr
c6Averaging    Exit I/P                  ccccccccc     Samp freq     6000   Full
c7Sngl-sweep   Number    8               cExit   c
c8Continuous   Chan List 0 1 2 3 4 5 6 7 cPlot  Yc
c9Measure                                cScale Yc
caFile                                   ccccccccc
cbWait
c
c
c35    File   Storage.CRO
c36    Store
c37    Recall
c38
c39    Measure  Time    Voltage
c40    prev ---g12.6e1--nnn.nnn
c41    curr ---g12.6e1--nnn.nnn
c42    diff ---g12.6e1--nnn.nnn
c 12345678901234567890123456789
c 6        7         8
c
c local variables
c  logical *1
c   terminal(3)   # specifies which menu items are terminators
c  integer *2
c   item          # selected menu item
c   get_menu      # function : select menu item
c  character
c   Menu(3)*5     # list of menu item text strings
c   key(3)*1      # unused menu keys
c   value(3)*1    # menu value strings
c  subroutine
c   err_menu      # display error message on graphics screen
c
c
      include 'stdio.def'
      integer *2 M_LEN, M_LEFT, M_TOP, M_PRT_LEN,
     1           I_PLOT, I_SCALE
      character BLANK*1
      parameter( M_LEN=3, M_LEFT=41, M_TOP=6, M_PRT_LEN=2,
     1           I_PLOT=2, I_SCALE=3, BLANK=' ' )
c
      logical *1 terminal(M_LEN)
      integer *2 item, get_menu
      character Menu(M_LEN)*5, Key(M_LEN)*1, Value(M_LEN)*1
      include 'cro.cmn'
c
      save terminal, menu, key, value
      data terminal / .FALSE., 2 * .TRUE. /
      data Menu / 'Exit ', 'Plot ', 'Scale' /
      data Key /   3 * BLANK /
      data Value / 3 * BLANK /
c
      Value(I_PLOT) = 'n'
      if ( plotting )
     1    Value(I_PLOT) = 'y'
      Value(I_SCALE) = 'n'
      if ( scaling )
     1   Value(I_SCALE) = 'y'
      if ( print_only ) then                                              1b
          call prt_menu( menu, value, terminal,
     1        M_PRT_LEN, M_LEFT, M_TOP, 0 )
      else                                                                1m
c
c         start of menu loop                                              2b
1             item = get_menu( key, menu, value, terminal,
     1            M_LEN, M_LEFT, M_TOP )
              call err_menu( BLANK )
c
c       Exit
c
              if ( item .eq. 1 ) then                                     3b
c
c       fix up the parallel line switch
c
                  if ( index( 'nNyYfFtT01.', value(I_PLOT) ) .ne. 0
     1                    ) then                                          4b
                      plotting = index( 'yYtT1.', value(I_PLOT) ) .ne. 0
                      if ( index( 'nNyYfFtT01.', value(I_SCALE) )
     1                        .ne. 0 ) then                               5b
                          scaling = index( 'yYtT1.', value(I_SCALE) )
     1                        .ne. 0
                          return
                      else                                                5m
                          call err_menu( 'Use Y or N for Scaling' )
                      end if                                              5e
                  else                                                    4m
                      call err_menu( 'Use Y or N for Plotting' )
                      end if                                              4e
                  end if                                                  3e
              goto 1
c             end of menu loop                                            2e
          end if                                                          1e
      end




      SUBROUTINE TIME_BASE_MENU()
c
c          1         2         3         4         5         6         7         8
c 12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789
c                                                     ccccccccccccccccccccc
c1Exit CRO     Exit H/W     Das 1128      Exit Ave    cExit T/Base        c Auto
c2Hardware     A/D conv     Seq 250A      Averaging N cCycle time  0.00150c Upper 10.240
c3Time-base    Parallel  Y  Ran 250A      Order mom 2 cTotal time   20.000c Lower  0.000
c4Voltage      Graph                      Max/Min   Y cNo. samples 20000  c Range
c5Inputs                                  Clip-data N cSamp period 0.00025c Centr
c6Averaging    Exit I/P                               cSamp freq     6000 c Full
c7Sngl-sweep   Number    8                Exit        ccccccccccccccccccccc
c8Continuous   Chan List 0 1 2 3 4 5 6 7  Plot  Y
c9Measure                                 Scale Y
caFile
cbWait
c
c
c35    File   Storage.CRO
c36    Store
c37    Recall
c38
c39    Measure  Time    Voltage
c40    prev ---g12.6e1--nnn.nnn
c41    curr ---g12.6e1--nnn.nnn
c42    diff ---g12.6e1--nnn.nnn
c 12345678901234567890123456789
c 6        7         8
c
c constants
c  CYCLE_TIME = 2
c  FREQ_CYCLE = 3
c  TOTAL_TIME = 4
c  NO_SAMPLES = 5
c  PERIOD_SAMP= 6
c
c local variables
c  logical *1
c   terminal(6)   # specifies which menu items are terminators
c  integer *2
c   item            # selected menu item
c   err_index       # index into menu array for reporting errors
c   get_menu        # function : get selection from menu
c  real
c   min_period(3)   # minimum chan-to-chan sampling period
c   min_off_cy(3)   # minimum cycle time for using no A/D channels
c   max_cy_tim(3)   # maximum A/Dk cycle time
c   total_duration  # total sweep duration
c  character
c   Menu(6)*11      # list of menu item text strings
c   key(6)*1        # unused menu keys
c   value(6)*1      # menu value strings
c   err_string*28   # string for reporting errors
c  subroutine
c   err_menu        # report error message
c
      include 'stdio.def'
      integer *2 CYCLE_TIME, FREQ_CYCLE, TOTAL_TIME,
     1           NO_SAMPLES, PERIOD_SAMP
      parameter( CYCLE_TIME=2, FREQ_CYCLE=3, TOTAL_TIME=4,
     1           NO_SAMPLES=5, PERIOD_SAMP=6 )
      integer *2 M_LEN, M_LEFT, M_TOP
      parameter( M_LEN=6, M_LEFT=52, M_TOP=0 )
c
c
      logical *1 terminal(M_LEN)
      integer *2 item, err_index, get_menu
      real min_period(3), min_off_cy(3), max_cy_tim(3), total_duration
      character Menu(M_LEN)*11, Value(M_LEN)*7, Key(M_LEN)*1,
     1    err_string*28
      include 'cro.cmn'
c
      save min_period, min_off_cy, max_cy_tim,
     1     terminal, Menu, Key, Value
c                       DAS1128   Seq 250A  Ran 250A
      data min_period / 24.25e-6, 4.469e-6, 59.776e-6 /
      data min_off_cy / 32.50e-6, 1.117e-6, 20.670e-6 /
      data max_cy_tim / 4.194300, 0.036611, 0.036611  /
c
      data terminal / .FALSE., 5 * .TRUE. /
      data Menu / 'Exit T/Base', 'Cycle time ', 'Freq cycle ',
     1            'Total time ', 'No. cycles ', 'Period samp' /
      data Key, Value / 6 * ' ', 6 * '       ' /
c
c
c
c       initialise menu values
c
      write( value(CYCLE_TIME), 1, ERR=7 )  cy_time
1     format( f7.5 )
      value(FREQ_CYCLE) = ' '
      value(TOTAL_TIME) = ' '
      write( value(NO_SAMPLES), 2, ERR=7 )  n_cycles
2     format( i7 )
      write( value(PERIOD_SAMP), 3, ERR=7 )  samp_period
3     format( f7.5 )
c
      if ( print_only ) then                                              1b
          call prt_menu( Menu, value, terminal,
     1        M_LEN, M_LEFT, M_TOP, 0 )
      else                                                                1m
c         start of menu loop                                              2b
4             item = get_menu( key, menu, value, terminal,
     1            M_LEN, M_LEFT, M_TOP )
              call err_menu( ' ' )
c
c       finalise the time-base parameters
c       if cycle time is provided, it takes precedence over cycle frequency
c       if neither cycle time nor cycle frequency are provided, both total
c       sweep duration and number of samples are required
c
              if ( item .eq. 1 ) then                                     3b
                  if ( value(PERIOD_SAMP) .ne. ' ' ) then                 4b
                      err_index = PERIOD_SAMP
                      read( value(PERIOD_SAMP), *, ERR=5 ) samp_period
                      end if                                              4e
                  if ( value(CYCLE_TIME) .ne. ' ' ) then                  4b
                      err_index = CYCLE_TIME
                      read( value(CYCLE_TIME), *, ERR=5 ) cy_time
                      value(FREQ_CYCLE) = ' '
                  else if ( value(FREQ_CYCLE) .ne. ' ' ) then             4m
                      err_index = FREQ_CYCLE
                      read( value(FREQ_CYCLE), *, ERR=5 ) cy_time
                      cy_time = 1.0 / cy_time
                      value(CYCLE_TIME) = ' '
                      end if                                              4e
                  if ( value(CYCLE_TIME) .eq. ' ' .and.
     1                 value(FREQ_CYCLE) .eq. ' ' ) then                  4b
                      if ( value(TOTAL_TIME) .eq. ' ' .or.
     1                     value(NO_SAMPLES) .eq. ' ' ) then              5b
                          call err_menu( 'Insufficient data' )
                          goto 4
                          end if                                          5e
                      err_index = TOTAL_TIME
                      read( value(TOTAL_TIME), *, ERR=5 ) total_duration
                      err_index = NO_SAMPLES
                      read( value(NO_SAMPLES), *, ERR=5 ) n_cycles
                      cy_time = total_duration / real( n_cycles )
                  else if ( value(TOTAL_TIME) .ne. ' ' ) then             4m
                      err_index = TOTAL_TIME
                      read( value(TOTAL_TIME), *, ERR=5 ) total_duration
                      value(NO_SAMPLES) = ' '
                      n_cycles = real( total_duration ) / cy_time + 0.5
                  else if ( value(NO_SAMPLES) .ne. ' ' ) then             4m
                      err_index = NO_SAMPLES
                      read( value(NO_SAMPLES), *, ERR=5 ) n_cycles
                      value(TOTAL_TIME) = ' '
                  else                                                    4m
                      call err_menu( 'Insufficient data' )
                      goto 4
                      end if                                              4e
c
c           check values against permitted limits
c
                  if ( adid .eq. 2 ) then                                 4b
                      samp_period = min( max( min_period(adid),
     1                    samp_period ), max_cy_tim(adid) )
                  else                                                    4m
                      samp_period = min_period(adid)
                      end if                                              4e
                  cy_time = min( max( min_off_cy(adid) +
     1                min_period(adid) * n_chans, cy_time ),
     2                max_cy_tim(adid) )
                  n_cycles = min( n_chans * max( 8, n_cycles ),
     1                 MAX_DATA - 2 ) / n_chans
                  write( value(CYCLE_TIME), 1, ERR=7 )  cy_time
                  write( value(NO_SAMPLES), 2, ERR=7 )  n_cycles
                  write( value(PERIOD_SAMP), 3, ERR=7 )  samp_period
                  call prt_menu( Menu, value, terminal,
     1                M_LEN, M_LEFT, M_TOP, 0 )
                  got_data = .FALSE.
                  return
                  end if                                                  3e
              goto 4
c
5             write( err_string, 6 ) menu(err_index)
6             format( 'Cannot decode ', a )
              call err_menu( err_string )
              goto 4
c             end of menu loop                                            2e
          end if                                                          1e
      return
c
7     call bug_menu( 'TIME_BASE_MENU', 'Cannot encode initial data',
     1    0.0 )
      return
      end



      SUBROUTINE VOLTAGE_MENU()
c
c          1         2         3         4         5         6         7         8
c 12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789
c                                                                          cccccccccccccc
c1Exit CRO     Exit H/W     Das 1128      Exit Ave     Exit T/Base         cAuto        c
c2Hardware     A/D conv     Seq 250A      Averaging N  Cycle time  0.00150 cUpper 10.240c
c3Time-base    Parallel  Y  Ran 250A      Order mom 2  Total time   20.000 cLower  0.000c
c4Voltage      Graph                      Max/Min   Y  No. samples 20000   cRange       c
c5Inputs                                  Clip-data N  Samp period 0.00025 cCentr       c
c6Averaging    Exit I/P                                Samp freq     6000  cFull        c
c7Sngl-sweep   Number    8                Exit                             cccccccccccccc
c8Continuous   Chan List 0 1 2 3 4 5 6 7  Plot  Y
c9Measure                                 Scale Y
caFile
cbWait
c
c
c35    File   Storage.CRO
c36    Store
c37    Recall
c38
c39    Measure  Time    Voltage
c40    prev ---g12.6e1--nnn.nnn
c41    curr ---g12.6e1--nnn.nnn
c42    diff ---g12.6e1--nnn.nnn
c 12345678901234567890123456789
c 6        7         8
c
c constants
c  AUTO_SC= 2
c  UPPER  = 3
c  LOWER  = 4
c  CENTR  = 5
c  FULL   = 6
c local variables
c  logical *1
c   got_xhair     # graph coordinate was obtained from crosshairs
c   terminal(3)   # specifies which menu items are terminators
c  logical *4
c   ilgread       # function : read from graph
c  integer *2
c   item          # selected menu item
c   get_menu      # function : select item from menu
c  real
c   junk          # unused abscissa read from crosshairs
c   V_range       # Voltage range
c   V_centre      # Centre voltage on the screen
c  character
c   cjunk*1       # unused character from crosshairs
c   Menu(6)*12    # list of menu item text strings
c   dummy(6)*1    # unused menu keys and value strings
c  subroutine
c   bug_menu      # report bug in program
c   do_empty_sweep# draw graph without data
c   err_menu      # report error
c   HG_On         # switch on graphics
c
c
      include 'stdio.def'
      integer *2 AUTO_SC, UPPER, LOWER, CENTR, FULL
      parameter( AUTO_SC=2, UPPER=3, LOWER=4, CENTR=5, FULL=6 )
      integer *2 M_LEN, M_LEFT, M_TOP
      parameter( M_LEN=6, M_LEFT=73, M_TOP=0 )
c
c
      logical *1 got_xhair, terminal(6)
      logical *4 ilgread
      integer *2 item, get_menu
      real V_range, V_centre, junk
      character cjunk*1, Menu(6)*12, dummy(6)*1
      include 'cro.cmn'
c
      data terminal / 6 * .FALSE. /
      data Menu / 'Exit Voltage', 'Autoscale   ', 'Upper       ',
     1            'Lower       ', 'Centre      ', 'Full        ' /
      data dummy / 6 * ' ' /
c
      if ( print_only ) then                                              1b
          call prt_menu( Menu, dummy, terminal,
     1        M_LEN, M_LEFT, M_TOP, 0 )
      else                                                                1m
c         start of loop                                                   2b
1             if ( auto_scale ) then
                  Menu(AUTO_SC)(11:11) = 'Y'
              else
                  Menu(AUTO_SC)(11:11) = 'N'
                  end if
              write( Menu(UPPER)(6:12), 2, ERR=3 ) Vsc_max
              write( Menu(LOWER)(6:12), 2, ERR=3 ) Vsc_min
              V_centre = ( Vsc_max + Vsc_min ) / 2.0
              write( Menu(CENTR)(6:12), 2, ERR=3 ) V_centre
2             format( f7.3 )
c                              key          values         n_items, row, col
              item = get_menu( dummy, menu, dummy, terminal,
     1            M_LEN, M_LEFT, M_TOP )
              call err_menu( ' ' )
              if ( item .eq. 1 ) then                                     3b
                  got_data = .FALSE.
                  return
              else if ( item .eq. AUTO_SC ) then                          3m
                  auto_scale = .TRUE.
              else if ( item .eq. FULL ) then                             3m
                  auto_scale = .FALSE.
                  if ( adid .eq. 1 ) then                                 4b
                      Vsc_min =  0.000
                      Vsc_max = 10.240
                  else                                                    4m
                      Vsc_min = -10.000
                      Vsc_max =   0.000
                      end if                                              4e
              else                                                        3m
                  if ( .not. got_graph ) then                             4b
                      if ( got_data ) then                                5b
                          call display_signal()
                      else                                                5m
                          call do_empty_sweep()
                          end if                                          5e
                      call HG_On()
                      end if                                              4e
                  if ( item .eq. UPPER ) then                             4b
                      auto_scale = .FALSE.
                      call err_menu( 'Locate scale maximum voltage' )
                      got_xhair = ilgread( junk, Vsc_max, cjunk )
                      call HG_On()
                  else if ( item .eq. LOWER ) then                        4m
                      auto_scale = .FALSE.
                      call err_menu( 'Locate scale minimum voltage' )
                      got_xhair = ilgread( junk, Vsc_min, cjunk )
                      call HG_On()
                  else if ( item .eq. CENTR ) then                        4m
                      auto_scale = .FALSE.
                      call err_menu( 'Locate scale minimum voltage' )
                      got_xhair = ilgread( junk, V_centre, cjunk )
                      call HG_On()
                      if ( got_xhair ) then                               5b
                          V_range = Vsc_max - Vsc_min
                          Vsc_min = V_centre - V_range / 2.0
                          Vsc_max = V_centre + V_range / 2.0
                          end if                                          5e
                      end if                                              4e
                  if ( .not. got_xhair )
     1                call err_menu( 'Place crosshair on graph' )
                  end if                                                  3e
              goto 1
c             end of loop                                                 2e
          end if                                                          1e
      return
c
3     call bug_menu( 'VOLTAGE_MENU', 'Cannot encode scale voltage',
     1    0.0 )
      return
      end




      SUBROUTINE INPUTS_MENU()
c
c          1         2         3         4         5         6         7         8
c 12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789
ccccccccccccc
c1Exit CRO  c  Exit H/W     Das 1128      Exit Ave     Exit T/Base          Auto
c2Hardware  c  A/D conv     Seq 250A      Averaging N  Cycle time  0.00150  Upper 10.240
c3Time-base c  Parallel  Y  Ran 250A      Order mom 2  Total time   20.000  Lower  0.000
c4Voltage   c  Graph                      Max/Min   Y  No. samples 20000    Range
c5Inputs    c                             Clip-data N  Samp period 0.00025  Centr
c6Averaging c  Exit I/P                                Samp freq     6000   Full
c7Sngl-sweepc  Number    8                Exit
c8Continuousc  Chan List 0 1 2 3 4 5 6 7  Plot  Y
c9Measure   c                             Scale Y
caFile      c
cbWait      c
ccccccccccccc
c
c35    File   Storage.CRO
c36    Store
c37    Recall
c38
c39    Measure  Time    Voltage
c40    prev ---g12.6e1--nnn.nnn
c41    curr ---g12.6e1--nnn.nnn
c42    diff ---g12.6e1--nnn.nnn
c 12345678901234567890123456789
c 6        7         8
c
c constants
c  NUMBER    = 1
c  CHAN_LIST = 2
c local variables
c  logical *1
c   terminal(3)   # specifies which menu items are terminators
c  integer *2
c   item          # selected menu item
c   get_menu      # function : get selection from menu
c  character
c   Menu(3)*9     # list of menu item text strings
c   key(3)*1      # unused menu keys
c   value(3)*16   # menu value strings
c  subroutine
c   bug_menu      # report bug in program
c   err_menu      # report error message
c
      include 'stdio.def'
      integer NUMBER, CHAN_LIST
      parameter( NUMBER=2, CHAN_LIST=3 )
      integer *2 M_LEN, M_LEFT, M_TOP
      parameter( M_LEN=3, M_LEFT=14, M_TOP=5 )
c
c
      logical *1 terminal(M_LEN)
      integer *2 item, get_menu
      character  key(M_LEN)*1, menu(M_LEN)*9, value(M_LEN)*16
      include 'cro.cmn'
c
      data terminal / .FALSE., .TRUE., .TRUE. /
      data Menu / 'Exit I/P ', 'Number   ', 'Chan list' /
      data Key, Value / 3 * ' ', 3 * '                ' /
c
c       initialise menu values
c
      write( value(NUMBER), 1, ERR=7 )  n_chans
1     format( i2 )
      write( value(CHAN_LIST), 2, ERR=7 )
     1    ( list_chans(item), item = 1, n_chans )
2     format( 8i2 )
      if ( print_only ) then                                              1b
          call prt_menu( Menu, value, terminal,
     1        M_LEN, M_LEFT, M_TOP, 0 )
      else                                                                1m
c
c         start of menu loop                                              2b
3             item = get_menu( key, menu, value, terminal,
     1            M_LEN, M_LEFT, M_TOP )
              call err_menu( ' ' )
c
c       finalise the input channels
c
              if ( item .eq. 1 ) then                                     3b
                  if ( value(NUMBER) .eq. ' ' ) then                      4b
                      call err_menu( 'Specify number of channels' )
                      goto 3
                      end if                                              4e
                  read( value(NUMBER), *, ERR=5 ) n_chans
                  n_chans = min( max( 1, n_chans ), 8,
     1                                MAX_DATA - 2 / n_cycles )
                  read( value(CHAN_LIST), *, ERR=6 )
     1                ( list_chans(item), item = 1, n_chans )
                  do 4 item = 1, n_chans                                  4b
                      list_chans(item) = min( max( 0,
     1                    list_chans(item) ), 9 )
4                     continue                                            4e
                  write( value(NUMBER), 1, ERR=7 )  n_chans
                  write( value(CHAN_LIST), 2, ERR=7 )
     1                ( list_chans(item), item = 1, n_chans )
                  call prt_menu( menu, value, terminal,
     1                M_LEN, M_LEFT, M_TOP, 0 )
                  got_data = .FALSE.
                  return
                  end if                                                  3e
              goto 3
5             call err_menu( 'Cannot decode number of channels' )
              goto 3
6             call err_menu( 'Cannot decode list of channels' )
              goto 3
c             end of menu loop                                            2e
          end if                                                          1e
      return
c
c
7     call bug_menu( 'INPUTS_MENU', 'Cannot encode initial data', 0.0 )
      return
      end




      SUBROUTINE AVERAGING_MENU()
c
c          1         2         3         4         5         6         7         8
c 12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789
c                                        ccccccccccccc
c1Exit CRO     Exit H/W     Das 1128     cExit Ave   c Exit T/Base          Auto
c2Hardware     A/D conv     Seq 250A     cAveraging Nc Cycle time  0.00150  Upper 10.240
c3Time-base    Parallel  Y  Ran 250A     cOrder mom 2c Total time   20.000  Lower  0.000
c4Voltage      Graph                     cMax/Min   Yc No. samples 20000    Range
c5Inputs                                 cClip-data Nc Samp period 0.00025  Centr
c6Averaging    Exit I/P                  ccccccccccccc Samp freq     6000   Full
c7Sngl-sweep   Number    8                Exit
c8Continuous   Chan List 0 1 2 3 4 5 6 7  Plot  Y
c9Measure                                 Scale Y
caFile
cbWait
c
c
c35    File   Storage.CRO
c36    Store
c37    Recall
c38
c39    Measure  Time    Voltage
c40    prev ---g12.6e1--nnn.nnn
c41    curr ---g12.6e1--nnn.nnn
c42    diff ---g12.6e1--nnn.nnn
c 12345678901234567890123456789
c 6        7         8
c
c constant
c  AVERAG  = 2
c  MAX_MIN = 3
c  ORDER   = 4
c local variables
c  logical
c   terminal(5)   # specifies which menu items are terminators
c  integer *2
c   item          # selected menu item
c   get_menu      # function : select menu item
c  character
c   Menu(5)*9     # list of menu item text strings
c   key(5)*1      # unused menu keys
c   value(5)*1    # menu value strings
c  subroutine
c   bug_menu
c   err_menu
c   prt_menu
c
      include 'stdio.def'
      integer *2 AVERAG, ORDER, MAX_MINIM, CLIPPING
      parameter( AVERAG=2, ORDER=3, MAX_MINIM=4, CLIPPING=5 )
      integer *2 M_LEN, M_LEFT, M_TOP
      parameter( M_LEN=5, M_LEFT=39, M_TOP=0 )
c
c
      logical *1 terminal(M_LEN)
      integer *2 item, get_menu
      character  key(M_LEN)*1, menu(M_LEN)*9, value(M_LEN)*1
      include 'cro.cmn'
c
      save terminal, Menu, Key, Value
      data terminal / .FALSE., 4 * .TRUE. /
      data Menu / 'Exit Ave ', 'Averaging', 'Order mom', 'Max/min  ',
     1            'Clip-data' /
      data Key, Value / 10 * ' ' /
c
c       initialize values
c
      value(AVERAG) = 'N'
      if ( averaging )
     1    value(AVERAG) = 'Y'
      write( Value(ORDER), 1, ERR=4 ) mom_order
1     format( i1 )
      value(MAX_MINIM) = 'N'
      if ( max_min )
     1    value(MAX_MINIM) = 'Y'
      value(CLIPPING) = 'N'
      if ( clip_data )
     1    value(CLIPPING) = 'Y'
c
      if ( print_only ) then                                              1b
          call prt_menu( Menu, value, terminal,
     1        M_LEN, M_LEFT, M_TOP, 0 )
      else                                                                1m
c         start of menu loop                                              2b
3             item = get_menu( key, menu, value, terminal,
     1            M_LEN, M_LEFT, M_TOP )
              call err_menu( ' ' )
              if ( item .eq. 1 ) then                                     3b
c
c       fix up the averaging and max/min switches
c
                  if ( index( 'nNyYfFtT01.', value(AVERAG) ) .ne. 0 )
     1                    then                                            4b
                      if ( index( 'nNyYfFtT01.', value(MAX_MINIM) )
     1                        .ne. 0 ) then                               5b
                          if ( index( 'nNyYfFtT01.', value(CLIPPING) )
     1                            .ne. 0 ) then                           6b
                              clip_data = index(
     1                            'yYtT1.', value(CLIPPING) ) .ne. 0
                              read( value(ORDER), *, ERR=5 ) mom_order
                              mom_order = min( max( 1, mom_order ), 4 )
                              write( Value(ORDER), 1, ERR=4 ) mom_order
                              averaging = mom_order .gt. 0 .and. index(
     1                            'yYtT1.', value(AVERAG) ) .ne. 0
                              max_min = index(
     1                            'yYtT1.', value(MAX_MINIM)) .ne. 0
                              call prt_menu( menu, value, terminal,
     1                            M_LEN, M_LEFT, M_TOP, 0 )
                              return
                          else                                            6m
                              call err_menu( 'Use Y or N for Clip-data')
                              end if                                      6e
                      else                                                5m
                          call err_menu( 'Use Y or N for Max/Min' )
                          end if                                          5e
                  else                                                    4m
                      call err_menu( 'Use Y or N for Averaging' )
                      end if                                              4e
                  end if                                                  3e
              goto 3
5             call err_menu( 'Cannot decode moment order' )
              goto 3
c             end of menu loop                                            2e
          end if                                                          1e
      return
c
4     call bug_menu( 'AVERAGING_MENU', 'Cannot encode moment order',
     1    0.0 )
      return
      end




      SUBROUTINE FILE_MENU()
c
c          1         2         3         4         5         6         7         8
c 12345678901234567890123456789012345678901234567890123456789012345678901234567890123456789
ccccccccccccc
c1Exit CRO  c  Exit H/W     Das 1128      Exit Ave     Exit T/Base          Auto
c2Hardware  c  A/D conv     Seq 250A      Averaging N  Cycle time  0.00150  Upper 10.240
c3Time-base c  Parallel  Y  Ran 250A      Order mom 2  Total time   20.000  Lower  0.000
c4Voltage   c  Graph                      Max/Min   Y  No. samples 20000    Range
c5Inputs    c                             Clip-data N  Samp period 0.00025  Centr
c6Averaging c  Exit I/P                                Samp freq     6000   Full
c7Sngl-sweepc  Number    8                Exit
c8Continuousc  Chan List 0 1 2 3 4 5 6 7  Plot  Y
c9Measure   c                             Scale Y
caFile      c
cbWait      c
ccccccccccccc
c
c35    File   Storage.CRO
c36    Store
c37    Recall
c38
c39    Measure  Time    Voltage
c40    prev ---g12.6e1--nnn.nnn
c41    curr ---g12.6e1--nnn.nnn
c42    diff ---g12.6e1--nnn.nnn
c 12345678901234567890123456789
c 6        7         8
c
c  logical *1
c   terminal(3)   # specifies which menu items are terminators
c  integer *2
c   i             # array index
c   item          # selected menu item
c   get_menu      # function : select menu item
c  real
c   check_magic   # magic number read from file
c  character
c   Menu(3)*6     # list of menu item text strings
c   key(3)*1      # unused menu keys
c   value(3)*12   # menu value strings
c
c
      include 'stdio.def'
      integer MEM_LU
      real MAGIC
      parameter( MEM_LU=49, MAGIC=3.1415926 )
      integer *2 M_LEN, M_LEFT, M_TOP
      parameter( M_LEN=3, M_LEFT=66, M_TOP=35 )
c
c
      logical *1 terminal(M_LEN)
      integer *2 i, item, get_menu
      real check_magic
      character  key(M_LEN)*1, menu(M_LEN)*6, value(M_LEN)*12
      include 'cro.cmn'
c
      save terminal, Menu, Key, Value
      data terminal / .TRUE., 2 * .FALSE. /
      data Menu / 'File  ', 'Store ', 'Recall' /
      data Key, Value / 3 * ' ', 'STORAGE.CRO ', 2 * '            ' /
c
      if ( print_only ) then                                              1b
          call prt_menu( Menu, value, terminal,
     1        M_LEN, M_LEFT, M_TOP, 0 )
      else                                                                1m
c
          item = get_menu( key, menu, value, terminal,
     1        M_LEN, M_LEFT, M_TOP )
c
c       store display and setup
c
          if ( item .eq. 2 ) then                                         2b
              open( UNIT=MEM_LU, FILE=value(1), STATUS='unknown',
     1            ERR=1, FORM='unformatted', ACCESS='sequential' )
              write( MEM_LU, ERR=2 ) MAGIC
              write( MEM_LU, ERR=2 )
     1          auto_scale, averaging, clip_data, got_data, got_graph,
     2          max_min, plotting, print_only, scaling,
     3          adid, list_chans, mom_order, n_chans, n_cycles,
     4          AD_scale, curr_x, curr_y, cy_time, prev_x, prev_y,
     5          samp_period, Vsc_max, Vsc_min
              if ( got_data ) then                                        3b
                  write( MEM_LU, ERR=2 )
     1                ( ad_data(i), i = 3 ,n_chans * n_cycles + 2 )
                  call err_menu( 'Trace stored' )
              else                                                        3m
                  call err_menu( 'Setup stored' )
                  end if                                                  3e
              close( UNIT=MEM_LU )
c
c           read display and setup
c
          else if ( item .eq. 3 ) then                                    2m
              open( UNIT=MEM_LU, FILE=value(1), STATUS='old',
     1            ERR=1, FORM='unformatted', ACCESS='sequential' )
              read( MEM_LU, ERR=3 ) check_magic
              if ( check_magic .ne. MAGIC ) goto 3
              read( MEM_LU, ERR=3 )
     1          auto_scale, averaging, clip_data, got_data, got_graph,
     2          max_min, plotting, print_only, scaling,
     3          adid, list_chans, mom_order, n_chans, n_cycles,
     4          AD_scale, curr_x, curr_y, cy_time, prev_x, prev_y,
     5          samp_period, Vsc_max, Vsc_min
              if ( got_data ) then                                        3b
                  read( MEM_LU, ERR=3 )
     1                ( ad_data(i), i = 3, n_chans * n_cycles + 2 )
                  call display_signal()
                  call err_menu( 'Trace recalled' )
              else                                                        3m
                  call do_empty_sweep()
                  call err_menu( 'Setup recalled' )
                  end if                                                  3e
              close( UNIT=MEM_LU )
              end if                                                      2e
          end if                                                          1e
      return
c
1     call err_menu( 'Cannot open storage file' )
      return
c
2     call err_menu( 'Cannot write storage file' )
      return
c
3     call err_menu( 'Cannot read storage file' )
      return
      end



      SUBROUTINE DO_SNGL_SWEEP()
c
c Do a single sweep and display the trace on the screen .
c
c local variables
c  integer *4
c   dn_cycles     # number of A/D cycles
c
      include 'stdio.def'
      integer *4 dn_cycles
      include 'cro.cmn'
c
      dn_cycles = n_cycles
      call HG_On()
      if ( adid .eq. 1 ) then                                             1b
          call sloacq( cy_time, n_cycles, n_chans, list_chans,
     1                 ad_data, -1 )
      else if ( adid .eq. 2 ) then                                        1m
          call seqacq( cy_time, samp_period, dn_cycles, n_chans,
     1                 ad_data, -1 )
      else if ( adid .eq. 2 ) then                                        1m
          call sanacq( cy_time, dn_cycles, n_chans, list_chans,
     1                 ad_data, -1 )
          end if                                                          1e
      got_data = .TRUE.
      call display_signal()
      return
      end




      SUBROUTINE DO_CONTINUOUS()
c
c Acquire data and display it until an ASCII key is pressed .
c
c local variables
c  logical *1
c   key_pressed   # function : a key has been pressed
c  character
c   cjunk*1       # unused key pressed
c
      include 'stdio.def'
      logical *1 key_pressed
      character cjunk*1
c
c     start of loop                                                       1b
1         call do_sngl_sweep()
          if ( .not. key_pressed( cjunk ) )
     1        goto 1
c         end of loop                                                     1e
      return
      end




      SUBROUTINE PRT_MENU( TEXT, VALUES, TERMIN, N_ITEMS,
     1                     START_X, START_Y, SELECTED )
c
c    Print a menu on the graphics screen . Menu text items are printed
c in a single column with any values alongside .
c
c Arguments
c  character text(n_items)*(*)   # IN # text strings
c  character values(n_items)*(*) # IN # value strings
c  logical *1 termin(n_items)    # IN # menu item is terminal & has a value
c  integer *2 n_items            # IN # number of menu item
c             start_x,           # IN # starting column number (left) of menu
c             start_y            # IN # starting row number (top) of menu
c             selected           # IN # selected menu item
c
c local variables
c  integer *2
c   item          # printed item number
c   len_text      # length of menu item text string
c   len_val       # length of menu item value string
c   max_width     # maximum width of menu
c   row           # screen row number
c   start_val     # screen column number of the value string
c  character
c   blanks*24     # string of blanks
c   name*9        # 'PRT_MENU'
c   select_str    # text string in upper case to indicate selection
c  subroutine
c   bug_menu
c   HG_On
c   hg_puts
c   scase
c
      include 'stdio.def'
      integer *2 start_x, start_y, n_items, selected,
     1    item, len_text, len_val, max_width, row, start_val
      character text(n_items)*(*), values(n_items)*(*),
     1    select_str*24, blanks*24, name*8
      logical *1 termin(n_items)
      data name, select_str, blanks / 'PRT_MENU',
     1    '                        ', '                        ' /
c
c       check arguments
c
      if ( n_items .lt. 1 .or. n_items .gt. 42 ) then                     1b
          call bug_menu( name, 'Illegal arg N_ITEMS', real( n_items ) )
          return
      else if ( start_x .lt. 0 .or. start_x .gt. 87 ) then                1m
          call bug_menu( name, 'Illegal arg START_X', real( start_x ) )
          return
      else if ( start_y .lt. 0 .or. start_y + n_items .gt. 43 ) then      1m
          call bug_menu( name, 'Illegal arg START_Y', real( start_y ) )
          return
          end if                                                          1e
c
c
      row = start_y
      max_width= 90 - start_x
      len_text = max( min( max_width - 2, len( text(1) ) ), 1 )
      len_val  = max( min( max_width - len_text - 1, len( values(1) ) ),
     1    1 )
      start_val = start_x + len_text + 1
      call HG_On()
c
c       print each menu item, with the selected item in upper case
c
      do 1 item = 1, n_items                                              1b
          if ( item .eq. selected ) then                                  2b
              call scase( text(item), select_str, 'u' )
              call hg_puts( charnb( select_str ), row, start_x )
c              call hg_puts( select_str(1:len_text), row, start_x )
          else                                                            2m
              call hg_puts( charnb( text(item) ), row, start_x )
c              call hg_puts( text(item)(1:len_text), row, start_x )
              end if                                                      2e
          if ( termin(item) ) then                                        2b
              call hg_puts( values(item)(1:len_val), row, start_val )
          else                                                            2m
              call hg_puts( blanks(1:len_val), row, start_val )
              end if                                                      2e
          row = row + 1
1         continue                                                        1e
      return
      end




      SUBROUTINE BUG_MENU( SOURCE, MESSAGE, VALUE )
c
c    Turns off the graphics, print an bug message and wait for <RETURN> .
c
c Arguments
c  character source*(*)     # name of calling routine
c            message*(*)
c  real value
c
      include 'stdio.def'
      character source*(*), message*(*)
      real value
c
      call HG_Off()
      if ( abs( value ) .le. 1.0e-9 ) then                                1b
          write( STD_ERR, 1 )  source, message
1         format( 1x, a, ' : ABORT : ', a )
      else                                                                1m
          write( STD_ERR, 2 )  source, message, value
2         format( 1x, a, ' : ABORT : ', a, 1x, g14.7 )
          end if                                                          1e
      read( STD_IN, 3 )
3     format()
      return
      end




      SUBROUTINE BOX_MENU( LEFT, TOP, WIDTH, HEIGHT )
c
c  Draws a double thickness box around the outside of the menu
c
c argument
c  integer *2 left  # left character cell column
c             top   # top character cell column
c             width # width of menu in character cells
c             height# height of menu in character cells
c
c constants
c  HERC_X=720       # total width of screen in pixels
c  HERC_Y=348       # total height of screen in pixels
c  CHAR_X=8         # width of character cell in pixels
c  CHAR_Y=8         # height of character cell in pixels
c
c local variables
c  integer *2
c   x_min, y_min    # lower left corner of menu
c   x_max, y_max    # upper right corner of menu
c
      integer *2 HERC_X, HERC_Y, CHAR_X, CHAR_Y
      parameter( HERC_X=720, HERC_Y=348, CHAR_X=8, CHAR_Y=8 )
c
      integer *2 left, top, height, width,
     1    x_min, y_min, x_max, y_max
c
c       statement function
      limit(xlower,x,xupper) = max( xlower, min( x, xupper ) )
c
c       determine the limits of the inner box
c
      x_min = limit( 0, left * CHAR_X - 1, HERC_X - 1 )
      y_min = limit( 0, top  * CHAR_Y - 2, HERC_Y - 1 )
      x_max = limit( 0, ( left + width ) * CHAR_X + 9, HERC_X - 1 )
      y_max = limit( 0, ( top + height ) * CHAR_Y + 1, HERC_Y - 1 )
c
c       draw the inner box
c
      call draw_box( x_min, y_min, x_max, y_max )
c
c       determine the limits of the outer box
c
      x_min = limit( 0, x_min - 1, HERC_X - 1 )
      y_min = limit( 0, y_min - 1, HERC_Y - 1 )
      x_max = limit( 0, x_max + 1, HERC_X - 1 )
      y_max = limit( 0, y_max + 1, HERC_Y - 1 )
c
c       draw the inner box
c
      call draw_box( x_min, y_min, x_max, y_max )
      return
      end




      SUBROUTINE DRAW_BOX( X_MIN, Y_MIN, X_MAX, Y_MAX )
c
c  Draw box
c
      include 'stdio.def'
      integer *2 x_min, y_min, x_max, y_max
c
      call HG_line( x_min, y_min, x_min, y_max )
      call HG_line( x_min, y_max, x_max, y_max )
      call HG_line( x_max, y_max, x_max, y_min )
      call HG_line( x_max, y_min, x_min, y_min )
      return
      end




      INTEGER *2 FUNCTION GET_MENU( KEY, TEXT, VALUES, TERMINAL,
     1                              N_ITEMS, START_X, START_Y )
c
c    Prints a menu on the graphics screen and gets a response from the
c user . To select a menu item the character pressed must match one in
c the item's KEY string . If the KEY is blank, the first character of
c the TEXT string is used for matching . The selection is not case
c sensitive . If the selected item is a TERMINAL, the menu is displayed
c again and another item is selected, otherwise GET_MENU returns . At
c least one menu item must be non-terminal (i.e. at least the EXIT item
c ) so that GET_MENU can return .
c
c Arguments
c  character key(n_items)*(*)    # IN # Selection keys
c            text(n_items)*(*)   # IN # text strings
c            values(n_items)*(*) # IN # value strings
c  logical *1 terminal(n_items)  # IN # menu item is terminal & has a value
c  integer *2 n_items            # IN # number of menu item
c             start_x,           # IN # starting column number (left) of menu
c             start_y            # IN # starting row number (top) of menu
c
c local variables
c  integer *2
c   char_no             # character index of value
c   item                # menu item number tested
c   len_values          # length of values string
c   max_width           # IN # maximum number of columns permitted
c   new_x, new_y        # current crosshair location
c   old_x, old_y        # previous crosshair location
c  logical *1
c   found               # menu item was found
c   found_exit          # It is possible to exit from the menu
c  character
c   name*8              # 'GET_MENU'
c   lower*1, upper*1    # lower & upper case versions of
c  subroutine
c   box_menu            # draw box around menu
c   bug_menu            # print error message
c   prt_menu            # print menu
c   HG_xhair            # read crosshairs
c   HG_Colour           # select colour - foreground or backgroun
c   scase               # change case of string
c
      include 'stdio.def'
c
      integer *2 n_items, start_x, start_y, max_width,
     1    char_no, item, len_values, new_x, new_y, old_x, old_y
      logical *1 terminal(n_items), found_exit, found
      character key(n_items)*(*), text(n_items)*(*),
     1    values(n_items)*(*), name*8, lower*1, upper*1
c
      save name
      data name / 'GET_MENU' /
c
c       check arguments
c
      if ( n_items .lt. 1 .or. n_items .gt. 42 ) then                     1b
          call bug_menu( name, 'Illegal arg N_ITEMS', real( n_items ) )
          return
      else if ( start_x .lt. 0 .or. start_x .gt. 89 ) then                1m
          call bug_menu( name, 'Illegal arg START_X', real( start_x ) )
          return
      else if ( start_y .lt. 0 .or. start_y + n_items .gt. 43 ) then      1m
          call bug_menu( name, 'Illegal arg START_Y', real( start_y ) )
          return
          end if                                                          1e
      found_exit = .not. terminal(1)
      do 1 item = 2, n_items
          found_exit = found_exit .or. .not. terminal(item)
1         continue
      if ( .not. found_exit ) then                                        1b
          call bug_menu( name, 'Cannot exit menu loop', 0.0 )
          return
          end if                                                          1e
c
c       draw box around the menu to mark it
c
      get_menu  = -1
      max_width = 90 - start_x
      call box_menu( start_x, start_y,
     1    min( max_width, len( text(1) ) + len( values(1) ) ), n_items )
c
      old_x    = -1
      old_y    = -1
      char_no  = 0
      get_menu = 0
      len_values = len( values(1) )
c
c     start of loop                                                       1b
c
c       print the menu
c
2         call prt_menu( text, values, terminal, n_items,
     1                   start_x, start_y, get_menu )
c
c       get character from crosshairs
c
          call hg_xhair( new_x, new_y, lower )
          call scase( lower, upper, 'u' )
          call scase( lower, lower, 'l' )
c
c       If the item is already selected, the following characters are
c       accumulated into the values string until the crosshairs are
c       moved . When the crosshairs are moved, a new item is selected .
c
          if ( char_no .gt. 0 ) then                                      2b
              if ( terminal(get_menu) ) then                              3b
                  if ( old_x .eq. new_x .and. old_y .eq. new_y ) then     4b
                      if ( char_no .le. len_values ) then                 5b
                          values(get_menu)(char_no:char_no) = lower
                          char_no = char_no + 1
                          if ( char_no .le. len_values )
     1                        values(get_menu)(char_no:char_no) = '_'
                      else
                          char_no = 0
                          end if                                          5e
                  else                                                    4m
                      if ( char_no .le. len_values )
     1                    values(get_menu)(char_no:char_no) = ' '
                      char_no = 0
                      end if                                              4e
                  call HG_puts( values, start_y + get_menu - 1,
     1                          start_x + len( text(1) ) + 1 )
              else                                                        3m
                  char_no = 0
                  end if                                                  3e
              end if                                                      2e
c
c       Select the menu item . The character pressed is in the item's KEY
c       string, the item is selected . If the KEY is blank, the first
c       character of the TEXT string is used . The selection is not case
c       sensitive . If the selected item is a TERMINAL, the menu is
c       displayed again and another item is selected .
c
          if ( char_no .eq. 0 ) then                                      2b
              do 3 item = 1, n_items                                      3b
                  found = .FALSE.
                  if ( key(item) .eq. ' ' ) then                          4b
                      found = lower .eq. text(item)(1:1) .or.
     1                        upper .eq. text(item)(1:1)
                  else                                                    4m
                      found = index( key(item), lower ) .ne. 0 .or.
     1                        index( key(item), upper ) .ne. 0
                      end if                                              4e
                  if ( found ) then                                       4b
                      get_menu = item
                      char_no = 1
                      old_x = new_x
                      old_y = new_y
                      if ( .not. terminal(item) ) then                    5b
c
c       remove box surrounding menu
c
                          call HG_Colour( 0 )
                          call box_menu( start_x, start_y, min(
     1                        max_width, len(text(1)) + len(values(1))
     2                         ), n_items )
                          call HG_Colour( 1 )
                          return
                          end if                                          5e
                      values(item) = '_'
                      call HG_puts( values, start_y + get_menu - 1,
     1                    start_x + len( text(1) ) + 1 )
                      end if                                              4e
3                 continue                                                3e
              end if                                                      2e
          goto 2
c         end of loop                                                     1e
      end




      SUBROUTINE DISPLAY_SIGNAL()
c
c Display the data from the A/D converter
c
c local variables
c  integer *2
c   i
c   ichan
c   index
c   max_ad
c   min_ad
c  real
c   denom
c   sweep_duration
c   sw_time(MAX_DATA)
c   voltage(MAX_DATA)
c  character
c   chan_str*2
c  subroutine
c   bug_menu
c   HG_On, HG_Puts
c   ilgdata, ilgimit, ilgopen, ilgraph, ilgylab
c   smeang
c
c
      include 'stdio.def'
c
      integer *2 dash_y, i, ichan, index, max_ad, min_ad
      real sweep_duration
      character chan_str*2
c
      include 'cro.cmn'
c
      sweep_duration = cy_time * ( n_cycles - 1 ) +
     1                 samp_period * ( n_chans - 1 )
      if ( plotting ) then                                                1b
          call ilgopen( ' ' )
          if ( scaling ) then                                             2b
              call ilgraph( 1, 1, 11, 11, 1 )
          else                                                            2m
              call ilgraph( 1, 1, 0, 0, 1 )
              end if                                                      2e
c
c       set the scaling
c
          if ( auto_scale ) then                                          2b
              max_ad = ad_data(3)
              min_ad = ad_data(3)
              do 1 i = 4, n_chans * n_cycles + 2                          3b
                  if ( ad_data(i) .gt. max_ad ) then                      4b
                      max_ad = ad_data(i)
                  else if ( ad_data(i) .lt. min_ad ) then                 4m
                      min_ad = ad_data(i)
                      end if                                              4e
1                 continue                                                3e
              call ilgwild( 'uu', 0.0, real( min_ad ) / AD_scale,
     1                      sweep_duration, real( max_ad ) / AD_scale )
          else                                                            2m
              call ilgwild( 'uu', 0.0, Vsc_min, sweep_duration, Vsc_max)
              end if                                                      2e
          call ilgimit( 0.0, Vsc_min, sweep_duration, Vsc_max )
          end if                                                          1e
c
      call label_statistics()
c
c       one loop for each channel
c
      dash_y = 284
      do 7 ichan = 1, n_chans                                             1b
          if ( averaging .or. plotting ) then                             2b
c
c       generate the time and voltage data
c
              sw_time(1) = samp_period * ( ichan - 1 )
              index   = ichan + 2
              voltage(1) = real( ad_data(index) ) / AD_scale
              do 2 i = 2, n_cycles                                        3b
                  index = index + n_chans
                  sw_time(i)    = sw_time(i-1) + cy_time
                  voltage(i) = real( ad_data(index) ) / AD_scale
2                 continue                                                3e
c
c       display channel number
c
              write( chan_str, 5, ERR=8 ) list_chans(ichan)
5             format( i2 )
              call HG_Puts( chan_str, 34 + ichan, 5 )
              end if                                                      2e
          call calc_statistics( ichan )
          if ( plotting ) then                                            2b
c
c       display line style
c
              call lintyp( ichan - 1 )
              call HG_Line( 68, dash_y, 112, dash_y )
              call lintyp( 0 )
              dash_y = dash_y + 8
              got_graph = .TRUE.
              call HG_On()
c
c       plot the data
c
              call ilgline( 0, ichan, 1 )
              call ilgdata( sw_time, voltage, 1, n_cycles, 0 )
c
c       plot cursor location
c
              call ilgline( 1, 0, 1 )
              call ilgdata( prev_x, prev_y, 1, 1, 0 )
              call ilgline( 3, 0, 1 )
              call ilgdata( curr_x, curr_y, 1, 1, 0 )
              end if                                                      2e
7         continue                                                        1e
      return
c
8     call bug_menu( 'DISPLAY_SIGNAL', 'Cannot encode channel number',
     1    real( list_chans(ichan) ) )
      return
      end




      SUBROUTINE LABEL_STATISTICS()
c
c       print labels for statistics
c
c           1         2         3         4         5         6         7
c  1234567890123456789012345678901234567890123456789012345678901234567890
c33               max     min     mean    rms    skew      flat
c34nn     ----- nnn.nnn nnn.nnn nnn.nnn nnn.nnn123456789a123456789a
c
      include 'stdio.def'
      include 'cro.cmn'
c
      if ( averaging ) then                                               1b
          if ( mom_order .gt. 0 )
     1        call HG_Puts( 'mean', 32, 32 )
          if ( mom_order .gt. 1 )
     1        call HG_Puts( 'rms', 32, 40 )
          if ( mom_order .gt. 2 )
     1        call HG_Puts( 'skew', 32, 47 )
          if ( mom_order .gt. 3 )
     1        call HG_Puts( 'flat', 32, 57 )
          end if                                                          1e
      if ( max_min ) then                                                 1b
          call HG_Puts( 'max     min', 32, 16 )
          end if                                                          1e
      return
      end




      SUBROUTINE CALC_STATISTICS( ICHAN )
c
c       calculate and print averages and voltage limits
c   denom
c  character
c   stats_str*35
c
      include 'stdio.def'
      integer *2 RES_STATS_LU
      parameter( RES_STATS_LU=50 )
c
      real denom, min_clip, max_clip, moment(4)
      integer *2 i, ichan, index, first, max_ad, min_ad, stats_lu,
     1           wind_len
      character stats_str*35, limit_str*15, stamp_str*20
      include 'cro.cmn'
      save stats_lu
      data stats_lu / 0 /
c
c       determine the conditional averaging limits
c
      if ( clip_data ) then                                               1b
          first = max( int( min( prev_x, curr_x ) / cy_time +
     1                 0.99999 ), 1 )
          wind_len = max( int( max( prev_x, curr_x ) /
     1                         cy_time + 0.00001 ) - first + 1, 0 )
          min_clip = min( prev_y, curr_y )
          max_clip = max( prev_y, curr_y )
      else                                                                1m
          first = 1
          wind_len = n_cycles
          min_clip = -1.0e9
          max_clip =  1.0e9
          end if                                                          1e
c
c       calculate the statistical moments
c
      if ( averaging ) then                                               1b
          mom_order = min( mom_order, 4 )
          if ( wind_len .gt. 0 ) then                                     2b
              call smeang( voltage(first), 1, wind_len, moment,
     1            mom_order, min_clip, max_clip )
              if ( mom_order .gt. 1 ) then                                3b
                  denom = max( moment(2), 0.0 )
                  moment(2) = sqrt( denom )
                  if ( denom .gt. 0 ) then                                4b
                      if ( mom_order .gt. 2 )
     1                    moment(3) = moment(3) / denom / moment(2)
                      if ( mom_order .gt. 3 )
     1                    moment(4) = moment(4) / denom **2
                  else                                                    4m
                      moment(3) = 0.0
                      moment(4) = 0.0
                      end if                                              4e
                  end if                                                  3e
          else                                                            2m
              do 1 i = 1, 4                                               3b
                  moment(i) = 0.0
1                 continue                                                3e
              end if                                                      2e
          write( stats_str, 2, ERR=4 )
     1        ( moment(i), i = 1, mom_order )
2         format( f7.3, 1x, f7.3, 2g10.4e1 )
          call HG_Puts( stats_str, 34 + ichan, 30 )
      else                                                                1m
          stats_str = ' '
          end if                                                          1e
c
c       calculate and print data limits
c
      if ( max_min ) then                                                 1b
          if ( wind_len .gt. 0 ) then                                     2b
              index  = 2 + ichan + ( first - 1 ) * n_chans
              max_ad = ad_data(index)
              min_ad = ad_data(index)
              do 3 i = index + n_chans,
     1                 index + n_chans * ( wind_len - 1 ), n_chans        3b
                  if ( ad_data(i) .gt. max_ad ) then                      4b
                      max_ad = ad_data(i)
                  else if ( ad_data(i) .lt. min_ad ) then                 4m
                      min_ad = ad_data(i)
                      end if                                              4e
3                 continue                                                3e
          else                                                            2m
              max_ad = 0
              min_ad = 0
              end if                                                      2e
          write( limit_str, 2, ERR=5 )
     1        real( max_ad ) / AD_scale, real( min_ad ) / AD_scale
          call HG_Puts( limit_str, 34 + ichan, 14 )
      else                                                                1m
          limit_str = ' '
          end if                                                          1e
c
      if ( ( averaging .or. max_min ) .and.
     1      stats_lu .ne. RES_STATS_LU ) then                              1b
          open( UNIT=RES_STATS_LU, FILE='crostats.log',
     1          STATUS='unknown', ACCESS='append', ERR=12 )
          stats_lu = RES_STATS_LU
          stamp_str(1:2) = ' '
          call time( stamp_str(3:10) )
          stamp_str(11:12) = ' '
          call date( stamp_str(13:20) )
          write( stats_lu, 10, ERR=13 ) stamp_str
10        format( ' statistics log file for cro' /
     1            ' time & date : ', a /
     2            ' max     min     mean    rms    skew      flat' )
         end if                                                           1e
      if ( max_min .or. averaging )
     1    write( stats_lu, 11 ) limit_str, charnb( stats_str )
11        format( a, 1x, a )
      return
12    call err_menu( 'Cannot open statistics log file' )
      return
13    call err_menu( 'Cannot write to statistics log file' )
c
4     call bug_menu( 'CALC_STATISTICS', 'Cannot encode Averages', 0.0 )
      return
5     call bug_menu( 'CALC_STATISTICS', 'Cannot encode Max/Min', 0.0 )
      return
      end




      SUBROUTINE MAKE_MEAS()
c
c Measure the cross-hair location and compute signal statistics between
c the previous and current measurement points
c
c39    Measure  Time    Voltage
c40    prev ---g12.6e1--nnn.nnn
c41    curr ---g12.6e1--nnn.nnn
c42    diff ---g12.6e1--nnn.nnn
c 12345678901234567890123456789
c 6        7         8
c
c
c local variables
c  logical *1
c   got_xhairs
c  logical *4
c   ilgread
c  integer
c   i
c   ichan
c   index
c  real
c   curs_x, curs_y    # cursor/measurement-point location
c  character
c   which*1
c  subroutine
c   calc_statistics
c   do_empty_sweep
c   err_menu
c   HG_Puts
c   ilgline, ilginvs, ilgdata
c   label_statistics
c
      include 'stdio.def'
      character CURSOR_PROMPT*53
      parameter( CURSOR_PROMPT =
     1    'Specify 1st or 2nd cursor position [1 or 2]. E = Exit' )
c
      logical *1 got_xhairs
      logical *4 ilgread
      integer *2 i, ichan, index
      real curs_x, curs_y
      character which*1
c
      include 'cro.cmn'
c
c       display measurements and highlight with box
c
      call displ_meas
      call box_menu( 66, 39, 23, 4 )
      if ( plotting ) then                                                1b
          if ( .not. got_graph )
     1        call do_empty_sweep()
c
c       get the new cursor location
c
          call err_menu( CURSOR_PROMPT )
c
c         start of loop                                                   2b
1             got_xhairs = ilgread( curs_x, curs_y, which )
              if ( .not. got_xhairs ) then                                3b
                  call err_menu(
     1                'Place crosshair on graph. Do not use X' )
                  goto 1
                  end if                                                  3e
c
c       erase previous cursor & redraw previous or current cursor
c
              if ( which .eq. '1' .or. which .eq. '2' ) then              3b
                  call ilginvs()
                  if ( which .eq. '1' ) then                              4b
                      call ilgline( 1, 0, 1 )
                      call ilgdata( prev_x, prev_y, 1, 1, 0 )
                      prev_x = curs_x
                      prev_y = curs_y
                  else if ( which .eq. '2' ) then                         4m
                      call ilgline( 3, 0, 1 )
                      call ilgdata( curr_x, curr_y, 1, 1, 0 )
                      curr_x = curs_x
                      curr_y = curs_y
                      end if                                              4e
                  call ilgdata( curs_x, curs_y, 1, 1, 0 )
c
c       display measurement-limits / cursor-locations
c
                  call displ_meas()
c
c       generate the voltage data
c
                  if ( averaging .or. max_min ) then                      4b
                      call label_statistics()
                      do 4 ichan = 1, n_chans                             5b
                          index = ichan + 2
                          voltage(1) = real( ad_data(index) ) / AD_scale
                          do 3 i = 2, n_cycles                            6b
                              index = index + n_chans
                              voltage(i) = real( ad_data(index) ) /
     1                            AD_scale
3                             continue                                    6e
                          call calc_statistics( ichan )
4                         continue                                        5e
                      end if                                              4e
              else if ( which .eq. 'E' .or. which .eq. 'e' ) then         3m
c
c       remove highlighting box
c
                  call HG_Colour( 0 )
                  call box_menu( 66, 39, 23, 4 )
                  call HG_Colour( 1 )
                  call err_menu( ' ' )
                  return
              else                                                        3m
                  call err_menu( CURSOR_PROMPT )
              end if                                                      3e
          goto 1
c         end of loop                                                     2e
      else                                                                1m
          call err_menu( 'Switch on plotting to make measurement' )
          end if                                                          1e
      end




      SUBROUTINE DISPL_MEAS()
c
c       display measurement-limits / cursor-locations
c
c local variables
c  character
c   meas_str*24
c
      include 'stdio.def'
      character meas_str*24
      include 'cro.cmn'
c
      call HG_Puts( 'Measure  Time   Voltage', 39, 66 )
      write( meas_str, 2, ERR=5 ) '1st', prev_x, prev_y
2     format( a3, 1x, g12.6e1, f7.3 )
      call HG_Puts( meas_str, 40, 66 )
      write( meas_str, 2, ERR=5 ) '2nd', curr_x, curr_y
      call HG_Puts( meas_str, 41, 66 )
      write( meas_str, 2, ERR=5 )
     1    'dif', curr_x - prev_x, curr_y - prev_y
      call HG_Puts( meas_str, 42, 66 )
      return
c
5     call bug_menu( 'DISPL_MEAS', 'Cannot encode cursor location',
     1    0.0 )
      return
      end




      SUBROUTINE ERR_MENU( ERR_MSG )
c
c Display error message on the bottom of the graphics screen .
c
c Argument
c  character err_msg*(*)  # error message text
c local variables
c  integer *2
c   column                # starting column of text
c
      include 'stdio.def'
      integer *2 column
      character err_msg*(*)
c
c       clear the message
c
      do 1 column = 0, 60, 5                                              1b
          call HG_Puts( '     ', 42, column )
1         continue                                                        1e
c
c       print new message if it is not blank
c
      if ( err_msg .ne. ' ' ) then                                        1b
          column = ( 65 - nblank( err_msg ) ) / 2
          call HG_Puts( charnb( err_msg ), 42, column )
          end if                                                          1e
      return
      end




      SUBROUTINE DO_EMPTY_SWEEP()
c
c Draw the graph without getting data
c
c local variables
c  real
c   sweep_duration  # total duration of a sweep
c   dummy_time(2)   # dummy time trace data
c   dummy_volts(2)  # dummy voltage data
c
      include 'stdio.def'
      integer *2 ZERO, ONE, TWO, THREE
      parameter( ZERO=0, ONE=1, TWO=2, THREE=3 )
c
c
      real sweep_duration, dummy_volts(2), dummy_time(2)
      include 'cro.cmn'
c
      save dummy_volts, dummy_time
      data dummy_volts, dummy_time / -20.0, -30.0, -2.0e6, -1.0e6 /
c
      sweep_duration = cy_time * ( n_cycles - 1 ) +
     1                 samp_period * ( n_chans - 1 )
      call ilgopen( ' ' )
      call ilgraph( 1, 1, 11, 11, 1 )
c
c       set the scaling -- for autoscale, use full range
c
      if ( auto_scale ) then                                              1b
          if ( adid .eq. 1 ) then                                         2b
              call ilgwild( 'uu', 0.0, 0.0, sweep_duration, 10.24 )
          else                                                            2m
              call ilgwild( 'uu', 0.0, -10.0, sweep_duration, 0.0 )
              end if                                                      2e
      else                                                                1m
          call ilgwild( 'uu', 0.0, Vsc_min, sweep_duration, Vsc_max )
          end if                                                          1e
      call ilgimit( 0.0, 0.0, sweep_duration, 0.0 )
c
c       plot dummy data
c
      call ilgline( 0, 0, 1 )
      call ilgdata( dummy_time, dummy_volts, 1, 2, 0 )
c
c       plot cursor location
c
      call ilgline( 1, 0, 1 )
      call ilgdata( prev_x, prev_y, 1, 1, 0 )
      call ilgline( 3, 0, 1 )
      call ilgdata( curr_x, curr_y, 1, 1, 0 )
      got_graph = .TRUE.
      return
      end



      LOGICAL *1 FUNCTION KEY_PRESSED( CHAR_PRESSED )
c
c Returns .TRUE. if a key is pressed . If a key has been pressed, the
c CHAR_PRESSED argument returns the character
c
c CPU registers
      include 'stdio.def'
      integer *2 AX, BX, CX, DX, DS, ES, DI, SI, FL
      parameter( AX=1, BX=2, CX=3, DX=4, DS=5, ES=6, DI=7, SI=8, FL=9 )
c
c Flags register description
c 15 14 13 12 11 10  9  8  7  6  5  4  3  2  1  0
c uu uu uu uu OF DF IF TF SF ZF uu AC uu PF uu CF
c
      integer *2 ZERO_FLAG
      parameter( ZERO_FLAG=64 )
c
c Using BIOS 16H
      integer BIOS_16H
      parameter( BIOS_16H=22 )
c
c BIOS 16 functions
      integer *2 READ_KBD, TEST_KBD, HIGH_BYTE
      parameter( READ_KBD=0,TEST_KBD=1, HIGH_BYTE=256 )
c
      character char_pressed*1
      integer *2 registers(9)
c
      registers(AX) = HIGH_BYTE * TEST_KBD
      call INTRUP( registers, BIOS_16H )
      key_pressed = iand( registers(FL), ZERO_FLAG ) .eq. 0
      if ( key_pressed ) then
          registers(AX) = HIGH_BYTE * READ_KBD
          call INTRUP( registers, BIOS_16H )
c         ASCII code of key pressed is in AL -- filter out AH
          char_pressed = char( mod( HIGH_BYTE, registers(AX) ) )
          end if
      return
      end




      SUBROUTINE SMEANG( X, NINCR, NPTS, MOMENTS, ORDER,
     1                   MIN_LIM, MAX_LIM )
c
c  Conditionally calculates the 1st ( mean ) to ORDERth moments of NPTS samples
c  in the array X, taking every NINCRth value. All but the 1st moment ( mean )
c  are centred about the sample mean . The maximum and minimum values of ORDER
c  are 14 and 1 . Each data point is used only if it is between MIN_LIM and
c  MAX_LIM .
c
c
c  N.B. There are two one passes of the data
c
c    Arguments
c real x(*),            # data array
c      moments(*),      # array of moment results
c integer *2 nincr,     # data array indexing increment
c            npts,      # number of data values used
c            order      # maximum moment required
c real min_lim,         # minimum clipping voltage
c      max_lim,         # maximum clipping voltage
c
c    Variables
c real r, rk            # temporay products
c integer *2 i,j        # looping indices
c double precision total(2:14)
c
      include 'stdio.def'
c
      real x(*), moments(*), min_lim, max_lim, r, rk
      double precision total(14)
      integer *2 count, i, j, nincr, npts, order
c
c               Check parameters
c
      if ( npts  .le. 0  .or.  nincr .le. 0  .or.
     1     order .lt. 1  .or.  order .gt. 14 ) then                       1b
          write( STD_OUT, 1 )
1         format( ' SMEANG : ABORT : Illegal argument' )
          return
          end if                                                          1e
c
c               Calculate mean
c
      count = 0
      total(1) = 0.0d0
      do 2 i = 1, ( npts - 1 ) * nincr + 1, nincr                         1b
          if ( min_lim .le. x(i) .and. x(i) .le. max_lim ) then           2b
              total(1) = total(1) + x(i)
              count = count + 1
              end if                                                      2e
2         continue                                                        1e
      do 3 i = 1, order                                                   1b
          moments(i) = 0.0
3         continue                                                        1e
      if ( count .gt. 0 )
     1    moments(1) = total(1) / real( count )
c
c               Calculate sums of (x-mean)**i : i=1..k
c
      if ( order .gt. 1 .and. count .gt. 1 ) then                         1b
          do 4 i = 2, order                                               2b
              total(i) = 0.0d0
4             continue                                                    2e
          do 6 i = 1, ( npts - 1 ) * nincr + 1, nincr                     2b
              if ( min_lim .le. x(i) .and. x(i) .le. max_lim ) then       3b
                  r = ( x(i) - moments(1) )
                  rk = r
                  do 5 j = 2, order                                       4b
                      rk = rk * r
                      total(j) = total(j) + rk
5                     continue                                            4e
                  end if                                                  3e
6            continue                                                     2e
c
c               Calculate moments
c
          if ( order .gt. 1 ) then                                        2b
              moments(2) = real( total(2) ) / real( count - 1 )
              do 7 j = 3, order                                           3b
                  moments(j) = real( total(j) ) / real( count )
7                 continue                                                3e
              end if                                                      2e
          end if                                                          1e
      return
      end



      BLOCK DATA CRO_BLOCK
c
      include 'stdio.def'
      include 'cro.cmn'
c
      data auto_scale, averaging, clip_data, got_data, got_graph,
     1     max_min, plotting, print_only, scaling /
     2     .TRUE.,     .FALSE.,   .FALSE.,   .FALSE.,  .FALSE.,
     3     .FALSE., .TRUE.,   .FALSE.,    .TRUE. /
      data adid, mom_order, n_chans, n_cycles, list_chans  /
     1     1,    1,         1,       256,      8*0  /
      data AD_scale, curr_x, curr_y, cy_time, prev_x, prev_y,
     1     samp_period, Vsc_max, Vsc_min /
     2     400.0,    0.0,    0.0,    0.001,   0.0,    0.0,
     3     24.25e-6,    0.0,     0.0 /
c
      end


