c
c    Copyright (C) 1997  Peter Vernon Lanspeary
c
c    This program is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    This program is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program; if not, write to the Free Software
c    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c

      PROGRAM HGR
c
c Replays a capture file of HPPREV calls . Obtain help by typing   hgr /h
c
c Constants
c  Hkbdlu=5         # logical unit number of keyboard
c  Hvdulu=6         # logical unit number of VDU
c  Hcaplu=4         # logical unit number of capture file
c  Hlen  =100       # length of SYMBOL character string
c Variables
c  logical *1 fshow,                # show graph as it is being drawn
c             fcont,                # don't wait for <RETURN>
c             fprint,               # dump screen onto printable file
c             fdisplay,             # display graph on screen
c             laray(Hlen),          # SYMBOL character string
c             existf                # function : file exists ?
c  integer *2 i1, i2, i3, i4, i5,   # data from capture file
c             irout,                # subroutine name
c             ifile,                # capture file number
c             iqstrt,               # starting index of qualifier string
c             nchars,               # number of characters in argument
c             iargc                 # function : no. of program arguments
c             jljstr,               #          : left justify string
c  real *4 r1, r2, r3, r4, r5       # data from capture file
c  character Capfile*64             # name of current capture file
c            Carg*64                # one program argument
c            Cdump*64               # name of printable dump file
c  subroutine getarg                # get a program argument
c             scase                 # case change
c             ilgwait               # graphics wait
c             -- HPPREV ROUTINES --
c
      implicit none
      integer *4 Hkbdlu, Hvdulu, Hcaplu, Hlen
      parameter( Hkbdlu=5, Hvdulu=6, Hcaplu=4, Hlen=100 )
c
      logical *1 fshow, fcont, fprint, fdisplay, laray(Hlen), existf
      integer *2 i1, i2, i3, i4, i5, irout, ifile, iqstrt, nchars,
     1  iargc, jljstr
      real *4 r1, r2, r3, r4, r5
      character Capfile*64, Carg*64, Cdump*64
      include 'hpprev.cmn'
c
c           one loop for each argument
c
      do 7 ifile = 1, iargc()                                               1b
c
c           get IFILEth argument
c
        call getarg( ifile, Carg )
        call scase( Carg, Carg, 'l' )
        nchars = jljstr( Carg )
        iqstrt = index( Carg, '/' )
c
c           INTERPRET THE ARGUMENT
c           **********************
c
c           give help
c
        if ( iqstrt .eq. 1 .and. Carg(2:2) .eq. 'h' ) then                  2b
          write( Hvdulu, 1 )
1         format( ' HGR - Program to replay a capture of HPISPP calls' /
     1 '  Capture files are specified as program arguments .' /
     2 '  Qualifiers can be appended to capture file names .' /
     3 '  The allowed qualifiers are :-' /
     4 '    /h - Help .' /
     5 '    /p - Dump the screen to a printable file . The dump file' /
     6 '          name is formed by replacing the capture file name' /
     7 '          extension with .PRN .' /
     8 '    /d - Display on the screen .' /
     9 '    /c - Continue when finished - do not wait for a <RETURN> .')
          write( Hvdulu, 2 )
2         format( '    /s - Show the graph as it is being drawn .' /
     1 '  Rules :-' /
     2 '    1) a qualifier can be negated by placing an N between the' /
     3 '        / and the qualifier letter . E.g. /nd .' /
     4 '    2) the default qualifiers are /d/nh/np/nc/ns .' /
     5 '    3) order of qualifiers is unimportant .' /
     6 '    4) if both /X and /NX are used, /X takes precedence' /
     7 '    5) /h can only appear by itself in an argument' /
     8 '         ( i.e. without a capture file ) .'  /
     9 '    6) /p implies /nd/c . ( can be overridden )' /
     a '    7) /c/d implies /s . ( can be overridden )' )
          call ilgwait( .false. )
c
c           no capture file - no action
c
        else if ( iqstrt .eq. 1 ) then                                      2m
          write( Hvdulu, 3 )
3         format( ' HGR : WARNING : Argument contains no capture file.')
c
c           we have a capture file, set default qualifiers
c
        else                                                                2m
          fshow = .false.
          fcont = .false.
          fprint = .false.
          fdisplay = .true.
c
c           there are no qualifiers
c
          if ( iqstrt .eq. 0 ) then                                         3b
            if ( nchars .eq. 0 ) then                                       4b
              write( Hvdulu, 3 )
              goto 7
            else                                                            4m
              Capfile = Carg
              end if                                                        4e
c
c           there are qualifiers
c
          else                                                              3m
            Capfile = Carg( 1: iqstrt-1 )
c
c               /p - print qualifier & make dump file name
c
            if ( index( Carg(iqstrt:), '/p' ) .gt. 0 ) then                 4b
              fprint = .true.
              fcont  = .true.
              fdisplay = .false.
              nchars = index( Capfile, '.' ) - 1
              if ( nchars .lt. 0 )
     1          nchars = len( Capfile )
              if ( nchars .gt. 0 ) then                                     5b
                cdump = capfile(1:nchars) // '.prn'
              else                                                          5m
                cdump = '.prn'
                end if                                                      5e
              end if                                                        4e
c
c               /d - display qualifier
c
            if ( index( Carg(iqstrt:), '/d' ) .gt. 0 ) then                 4b
              fdisplay = .false.
            else if ( index( Carg(iqstrt:), '/nd' ) .gt. 0 ) then           4m
              fdisplay = .true.
              end if                                                        4e
c
c               /c - continue qualifier
c
            if ( index( Carg(iqstrt:), '/c' ) .gt. 0 ) then                 4b
              fshow = .true.
            else if ( index( Carg(iqstrt:), '/nc' ) .gt. 0 ) then           4m
              fshow = .false.
              end if                                                        4e
c
c               /s - show qualifier
c
            if ( index( Carg(iqstrt:), '/s' ) .gt. 0 ) then                 4b
              fshow = .true.
            else if ( index( Carg(iqstrt:), '/ns' ) .gt. 0 ) then           4m
              fshow = .false.
              end if                                                        4e
            end if                                                          3e
c
c           READ & DISPLAY THE CAPTURE FILE
c           *******************************
c
          if ( existf( Capfile ) ) then                                     3b
            open( UNIT=Hcaplu, FILE=Capfile, ACCESS='sequential',
     1        STATUS='old', FORM='unformatted' )
            call grstrt( 100, 0 )
            if ( fshow )
     1        call vecmod
c           start of loop                                                   4b
4             read( Hcaplu, END=5, ERR=8 ) irout, r1, r2, i1, i2
c
c          -------- hpprev routines ----------
c
              if ( irout .lt. axscap ) then                                 5b
                if ( irout .lt. movcap ) then                               6b
                  read( Hcaplu, END=10, ERR=8  ) r3, r4
                  if ( irout .eq. vwpcap ) then                             7b
                    call vwport( r1, r2, r3, r4 )
                  else if ( irout .eq. wincap ) then                        7m
                    call window( r1, r2, r3, r4 )
                    end if                                                  7e
c
                else if ( irout .lt. arccap ) then                          6m
                  if ( irout .eq. dracap ) then                             7b
                    call draw( r1, r2 )
                  else if ( irout .eq. movcap ) then                        7m
                    call move( r1, r2 )
                  else if ( irout .eq. drrcap ) then                        7m
                    call drwrel( r1, r2 )
                  else if ( irout .eq. mvrcap ) then                        7m
                    call movrel( r1, r2 )
                    end if                                                  7e
c
                else if ( irout .lt. npgcap ) then                          6m
                  if ( irout .eq. lincap ) then                             7b
                    call lintyp( i1 )
                  else if ( irout .eq. arccap ) then                        7m
                    read( Hcaplu, END=10, ERR=8  ) r3
                    call arc( r1, r2, r3 )
                  else if ( irout .eq. actcap ) then                        7m
                    call arctol( r1 )
                  else if ( irout .eq. tszcap ) then                        7m
                    call txtsiz( r1 )
                  else if ( irout .eq. tancap ) then                        7m
                    call txtang( r1 )
                    end if                                                  7e
c
                else                                                        6m
                  if ( irout .eq. npgcap ) then                             7b
                    call newpag
                  else if ( irout .eq. nsccap ) then                        7m
                    call newscr
                  else if ( irout .eq. invcap ) then                        7m
                    call invis
                  else if ( irout .eq. viscap ) then                        7m
                    call visibl
                    end if                                                  7e
                  end if                                                    6e
c
c         ----------- HPISPP routines ------------
c
              else                                                          5m
                if ( irout .lt. ptscap ) then                               6b
                  if ( irout .eq. pltcap ) then                             7b
                    call plot( r1, r2, i1 )
                  else if ( irout .eq. hpicap ) then                        7m
                    read( Hcaplu, END=10, ERR=8  ) i3, i4, i5
                    call hpinit( i1, i2, i3, i4, i5 )
                  else if ( irout .eq. nwpcap ) then                        7m
                    call newpen( i1 )
                  else if ( irout .eq. numcap ) then                        7m
                    read( Hcaplu ) r3, r4, r5
                    call number( r1, r2, r3, r4, r5, i1 )
                    endif                                                   7e
                else                                                        6m
                  if ( irout .eq. symcap ) then                             7b
                    read( Hcaplu, END=10, ERR=8  ) r3, r4,
     1                ( laray(i5), i5 = 1, min(i1,100) )
                    call symbol( r1, r2, r3, laray, r4, i2 )
                  else if ( irout .eq. ptscap ) then                        7m
                    read( Hcaplu, END=10, ERR=8  ) i3
                    call plots( i1, i2, i3 )
                  else if ( irout .eq. whrcap ) then                        7m
                    call where( r1, r2, r3 )
                    end if                                                  7e
                  end if                                                    6e
                end if                                                      5e
                goto 4
c             end of loop                                                   4e
5           close( UNIT=Hcaplu )
c
c               GRAPH IS ON SCREEN - ACT ON QUALIFIERS
c               **************************************
c
            if ( fprint )
     1        call scr_dump( Cdump )
            if ( .not. fcont .or. fdisplay .and. .not. fshow )
     1        call ilgwait( .true. )
            if ( fshow )
     1        call anmode
            call newpag
c
c               CAN'T FIND CAPTURE FILE - SKIPPED PLOTTING
C               ******************************************
C
          else                                                              3m
            write( Hvdulu, 6 ) Capfile
6           format( ' HGR : Can''t find file ', a )
            end if                                                          3e
          end if                                                            2e
7       continue                                                            1e
      stop
c
8     call anmode
      write( Hvdulu, 9 ) capfile
9     format( ' HGR : Error in capture file ', a )
      stop
c
10    call anmode
      write( Hvdulu, 11 ) capfile
11    format( ' HGR : Unexpected EOF in ', a )
      stop
      end


      SUBROUTINE ILGWAIT( GRAPHICS )
c
c       Prompt and Wait for <carriage return> from the keyboard .
c Argument
c  logical *1 graphics      # wait in graphics mode ( else test mode )
c
c Constants
c  Hkbdlu=5         # keyboard logical unit number
c  Hvdulu=6         # vdu logical unit number
c
      implicit none
      integer *2 Hkbdlu, Hvdulu, Hrow, Hcol
      parameter( Hkbdlu=5, Hvdulu=6, Hrow=42, Hcol=27 )
      character Creturn*26, Cblank*26
      data Creturn / 'Press <RETURN> to continue' /
      data Cblank  / '                          ' /
c
      logical *1 graphics
c
      if ( graphics ) then                                                  1b
        call vecmod
        call HG_puts( Creturn, Hrow, Hcol )
        read( Hkbdlu, 1 )
1       format( )
        call HG_puts( Cblank, Hrow, Hcol )
        call anmode
      else                                                                  1m
        write( Hvdulu, 2 ) Creturn
2       format( ' ', a )
        read( Hkbdlu, 1 )
        end if                                                              1e
      return
      end
