c
c    Copyright (C) 1997  Peter Vernon Lanspeary
c
c    This program is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    This program is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program; if not, write to the Free Software
c    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c


      PROGRAM SBCLOAD
c
c       Downloads a SBC command queue from ASCII file to the SBC ( ie. it
c  writes the command queue ) and then hands control over to the SBC console .
c       Invocation :    sbclod [filename]
c  Filename is the name of the source file containing the SBC command queue .
c  The default value for filename is "sbclod.dat" . The command queue file
c  consists of a series of hexadecimal coded commands .
c  Each of these commands is :
c    1) a header line  - containing at least one colon ':' - and anything else
c    2) one or more lines of hexadecimal digit pairs . Characters which are
c       not hexadecimal digits ( except : which marks the header of the next
c       command , and so will cause an error ) are ignored .
c
c constant
c  Hvdulu=6                 # vdu logical unit number
c variables
c  character Cfilnam*32     # source file name
c  integer *2 n,            # number of program arguments
c             iargc         # function : number of program arguments
c  subroutine getarg        # get a program argument
c             sbinit,       # start the SBC
c             sbclod,       # download a command queue to the SBC
c             sbswap        # transfer control to the SBC console
c
      implicit none
      integer *2 Hvdulu
      parameter( Hvdulu=6 )
c
      character Cfilnam*32
      integer *2 n, iargc
c
      n = iargc()
      if ( n .gt. 0 ) then
        call getarg( 1, Cfilnam )
        if ( Cfilnam(1:1) .eq. '-' ) then
          write( Hvdulu, 1 )
1         format( ' SBCLOD : Stupid filename - using sbclod.dat' )
          n = 0
          end if
        end if
      call sbinit( .false., ' ' )
      if ( n .eq. 0 ) then
        call sbclod( 'sbclod.dat' )
      else
        call sbclod( Cfilnam )
        end if
      call sbswap
      stop
      end
