c
c    Copyright (C) 1997  Peter Vernon Lanspeary
c
c    This program is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    This program is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program; if not, write to the Free Software
c    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c


      PROGRAM TEST
c
c Tests the linearity of potentiometers in the probe-traverse mehanisms
c
      implicit none
      integer *2 file_lu, i, item, npts, order,
     1     jljstr, Jresp
      real berror(30), bpoly(15), displ(30), err, ferror(30), fpoly(15),
     1     work(64), volts(30), qpoly
      character Cline*80
      data order / 3 /
c
c       read data file
c
      file_lu = 12
      open( UNIT=file_lu, FILE='junk.aux', STATUS='old' )
      npts = 1
c     start of loop
1         read( file_lu, 2, END=3 ) Cline
          if ( jljstr( cline ) .lt. 3 .or. Cline(1:1) .eq. ';' ) goto 1
2         format( a )
          read( Cline, *, ERR=1 ) volts(npts), displ(npts)
          npts = npts + 1
          goto 1
c         end of loop
3     npts = npts - 1
      close( file_lu )
c
c     start of loop
4         write( 6, 5 ) order
5         format( ' Select' / '   0) exit' /
     1    '   1) Polynomial order ', i2 /
     2    '   2) Calculate polynomials' /
     3    '   3) Write polynomials' /
     4    '   4) Write errors' /
     5    '   5) Plot forward error' /
     6    '   6) Plot backward error' )
          item = Jresp( 5, 0, 6, 4 )
          if ( item .eq. 0 ) then
              stop
c
c           get polynomial order
c
          else if ( item .eq. 1 ) then
              order = Jresp( 5, 1, 15, 4 )
c
c           calculate polynomials
c
          else if ( item .eq. 2 ) then
              call spyorth( volts, displ, npts, fpoly, order, err,
     1                      work )
              write( 6, 6 ) err
6             format( ' Forward error (volts->displ) = ', g12.5 )
              call spyorth( displ, volts, npts, bpoly, order, err,
     2                      work )
              write( 6, 7 ) err
7             format( ' Backward error (displ-volts) = ', g12.5 )
              do 8 i = 1, npts
                  ferror(i) = displ(i) - qpoly( volts(i), fpoly, order )
                  berror(i) = volts(i) - qpoly( displ(i), bpoly, order )
8                 continue
c
c           write polynomials
c
          else if ( item. eq. 3 ) then
              write( 6, 9 )
9             format( ' Conversion polynomials ' /
     1            '       forward      backward' /
     2            '     Volt->disp    displ->volt' )
              do 11 i = 0, order
                  write( 6, 10 ) i, fpoly(i+1), bpoly(i+1)
10                format( 1x, i2, 3x, 2g13.5 )
11                continue
c
c           write errors etc
c
          else if ( item .eq. 4 ) then
              write( 6, 12 )
12            format( 7x, 'Data', 10x, 'Conversions', 10x, 'Error' /
     1                3( '  Volts    Displ  ' ) )
              do 14 i = 1, npts
                  write( 6, 13 ) volts(i), displ(i),
     1                qpoly( displ(i), bpoly, order ),
     2                qpoly( volts(i), fpoly, order ),
     3                berror(i), ferror(i)
13                format( 3(f9.3, f9.4) )
14                continue
c
c           plot errors
c
          else if ( item .eq. 5 ) then
              call ilgline( 1, 1, 1 )
              call ilgdata( volts, ferror, 1, npts, 1 )
              call ilgwait()
              call ilgclos()
          else if ( item .eq. 6 ) then
              call ilgline( 1, 1, 1 )
              call ilgdata( displ, berror, 1, npts, 1 )
              call ilgwait()
              call ilgclos()
              end if
          goto 4
      end


