c
c    Copyright (C) 1997  Peter Vernon Lanspeary
c
c    This program is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    This program is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program; if not, write to the Free Software
c    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c


c  Code portability :
c   This code has been compiled on
c     SunOS unix f77 v1.3.1,
c     VMS/VAX    FORTRAN V4
c     DOS        MICROSOFT FORTRAN V4.10
c     Linux      Linux f77
c     Silicon Graphics  IRIX f77
c
c The lines following the lines
c  'CC--VAX-SunOS-DEC-FORTRAN'
c  'CC--MISCROSOFT-FORTRAN-V4:'
c is by default commented out with an initial 'CC'
c
c The initial "CC" of the line which follows the line
c  'CC--VAX-SunOS-DEC-FORTRAN'
c must be removed if the machine is SunOS unix, VMS/VAX or DECstation 5000.
c
c The initial "CC" of the line which follows the line
c  'CC--MISCROSOFT-FORTRAN-V4:'
c must be removed if the machine is an IBM PC (or compatible) running DOS.
c




CC--MISCROSOFT-FORTRAN-V4:
CC$notruncate

      SUBROUTINE FACTOR( FACT )
c
c change the size of the entire plot
c
c Argument
c   real fact   # the current plotting factor
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      real ffact, fact
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
c           check for a valid plot size factor
c
      if ( device_open ) then
          if ( fact .le. 0.0 .or. fact .gt. 32767.0 ) then
              ffact = 1.0
          else
              ffact = fact
              end if
c
c           compute plotter units/inch if unit system is inches
c
          if ( munit .eq. 0 ) then
              xyunit = ffact * 25.4 / pixel_size
c
c           compute plotter units/centimeter if unit system is metric
c
          else if ( munit .eq. 1 ) then
               xyunit = ffact * 10.0 / pixel_size
c
c           trap for bugs
c
          else
               call anmode()
               write( STD_ERR, 1 ) munit
1              format( ' BUG : illegal munit ', i12 )
               end if
          end if
      return
      end




      SUBROUTINE HPINIT( REQD_DEV, UNITS, OUT_FILE, OPTIONS )
c
c Initialize the graphics device driver
c
c Arguments
c   integer reqd_dev       # defines the device type; specifies device driver
c   integer units          # unit system desired : 0 = inches
c                          #                       1 = centimetres
c   character out_file*(*) # name of output file, ' ' = screen = STD_OUT
c             options*(*)  # list of options for the graphics device
c
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'f77_g.con'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'f77_g.con'
      integer    PLOTTER,   SCREEN,   WINDOW
      parameter( PLOTTER=0, SCREEN=1, WINDOW=2 )
c
      integer curr_dev, reqd_dev, units, is_screen, category, ijunk,
     1        tf_begin, tf_device
      logical tf_status, tf_end
      real    junk_x, junk_y
      character junk_str*1, out_file*(*), options*(*)
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
      save curr_dev
      data curr_dev / -9999 /
c
      if ( units .ne. 0 .and. units .ne. 1 ) then                         1b
          call anmode()
          write( STD_ERR, 1 ) units
1         format( ' HPINIT : ABORT : Illegal UNITS argument ', i12 )
      else                                                                1m
          if ( reqd_dev .ne. curr_dev .or. .not. device_open ) then       2b
              if ( reqd_dev .ne. curr_dev ) then                          3b
                  if ( device_open ) device_open = .not. tf_end()
                  device_open = tf_device( reqd_dev, out_file, options )
     1                .ne. 0
                  if ( device_open ) curr_dev = reqd_dev
              else                                                        3m
                  device_open = tf_begin( out_file, options ) .ne. 0
                  end if                                                  3e
              end if                                                      2e
          if ( .not. device_open ) then                                   2b
              call anmode()
              write( STD_ERR, 2 )
2             format( ' HPINIT: ABORT: Could not open graphics device' )
c
c               get device resolution
c
          else if ( .not. tf_status( T_ST_PIXSIZ, ijunk, pixel_size,
     1                               pixel_size, junk_str ) ) then        2m
              call anmode()
              write( STD_ERR, 3 )
3             format( ' HPINIT: ABORT: Cannot get device resolution' )
c
c           compute plotter units/inch  or units/centimetre
c
          else if ( .not. tf_status( T_ST_SCREEN, is_screen,
     1                               junk_x, junk_y, junk_str ) ) then    2m
              call anmode()
              write( STD_ERR, 4 )
4             format( ' HPINIT : ABORT : Cannot get device type' )
          else if ( .not. tf_status( T_ST_CATEG, category,
     1                               junk_x, junk_y, junk_str ) ) then    2m
              call anmode()
              write( STD_ERR, 4 )
          else                                                            2m
c
c          set coordinate origin to leave a margin if a hardcopy device
c
              if ( is_screen .ne. 0 ) then                                3b
                  device_type = SCREEN
                  if ( category / 128 .gt. 0 ) device_type = WINDOW
              else                                                        3m
                  device_type = PLOTTER
                  end if                                                  3e
c
c          set inches or cm coordinate system for hpispp
c
              munit = units
              if ( munit .eq. 0 ) then                                    3b
                  xyunit = 25.4 / pixel_size
              else                                                        3m
                  xyunit = 10.0 / pixel_size
                  end if                                                  3e
              end if                                                      2e
          end if                                                          1e
      return
      end



      SUBROUTINE NEWPEN(IPEN)
c
c selects the specified pen or dashed line style
c
c Argument
c  integer ipen # > 0 ; = pen number to be selected
c               # = 0 ; = put pen back in stall
c               # =-1 ; = continuous line;
c               # <-1 ; = dashed line style
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
      integer ipen
      logical tf_colour, tf_dashed
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
c               select pen
c
      if ( device_open ) then
          if ( ipen .ge. 0 ) then
              if ( .not. tf_colour( ipen ) ) then
                  call anmode()
                  write( STD_ERR, 1 )
1                 format( ' NEWPEN : Cannot select pen' )
                  end if
c
c               dashed line styles
c
          else
              if ( .not. tf_dashed( -ipen ) ) then
                  call anmode()
                  write( STD_ERR, 2 )
2                 format( ' NEWPEN : Cannot select dash style' )
                  end if
              end if
          end if
      return
      end



      SUBROUTINE NUMBER( X, Y, HEIGHT, VALUE, THETA, PRECISION )
c
c Displays a floating point number in fortran g-type format .
c The STANDARD number uses f-type format -- too bad .
c
c  Arguments
c   real x, y       # coordinates of the first character to be produced
c        height     # height of the character to be plotted
c        value      # floating point number to be converted and plotted
c        theta      # angle at which the number is to be plotted
c        precision  # precision of the number conversion
c
c Local variables
c   integer sig_figs    # number of significant figures ( = PRECISION )
c           str_len     # number of chars in string
c           clean_str   # function : remove leading blanks & then find length
c                       #            of a string
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
      integer sig_figs, precision, clean_str, str_len
      real x, y, height, value, theta
      character format_str*8, string*16
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
c               convert VALUE to a string, first decide the format
c
      if ( device_open ) then
          if ( value .eq. 0.0 ) then
              string = '0.0'
          else
              sig_figs = min( 8, precision )
              write( format_str, 1 ) sig_figs+7, sig_figs
1             format( '(g', i2, '.', i1, ')' )
              write( string, format_str ) value
              end if
c
c               clean up leading and trailing blanks
c
          str_len = clean_str( string )
c
c               use SYMBOL to do the hard work
c
          if ( str_len .gt. 0 ) then
              call symbol( x, y, height, string, theta, str_len )
              end if
          end if
      return
      end



      INTEGER FUNCTION CLEAN_STR( STRING )
c
c         Left justify the character string STRING ; ie eliminate leading blanks
c and return the number of characters in it after trailing blanks have also
c been removed .
c
c    Argument
c character *(*) string   # operand
c
c    Variables
c integer length,       # length of operand
c         i,            # count up index
c         j,            # count down index
c         n,            # justified result index
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
      character *(*) string
      integer length, i, j, n
c
      length = len( string )
c
c       find first non blank char
c
      i = 1
1     if ( string(i:i) .eq. ' ' .and. i .lt. length ) then
          i = i + 1
          goto 1
          end if
c
c       find last non blank char
c
      j = length
2     if ( string(j:j) .eq. ' ' .and. j . gt. i ) then
          j = j - 1
          goto 2
          end if
      clean_str = j - i + 1
      if ( string(j:j) .eq. ' ' ) clean_str = 0
c
c       left justify
c
      do 3 n = 1, clean_str
          string(n:n) = string(i:i)
          i = i + 1
3         continue
c
c       fill up with blanks
c
      do 4 n = clean_str + 1, j
          string(n:n) = ' '
4         continue
      return
      end



      SUBROUTINE OFFSET( XSET, XFCT, YSET, YFCT )
c
c sets special offsets and scale factors
c
c Arguments :
c   real xset   # x offset factor
c        xfct   # x scale factor
c        yset   # y offset factor
c        yfct   # y scale factor
c
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
      real xset, xfct, yset, yfct
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
c     transfer arguments to common block
c
      xoff  = xset
      xfact = xfct
      yoff  = yset
      yfact = yfct
      return
      end



      SUBROUTINE PLOT( X, Y, IPEN )
c
c moves with the pen up or down to a new position
c
c Arguments :
c  real x, y    # coordinates of the position to which the pen is to be moved.
c  integer ipen # 2    draw
c               # 3    move
c               # 12   draw with special x/y offset and scale factors
c               # 13   move with special x/y offset and scale factors
c               # 999  same as negative 3, but terminate i/o
c
c     note : if ipen 2 or 3 negative, then reset origin after command execution
c
c   Local variables
c logical
c   end,        # required to terminate graphics
c   neworg,     # move relative to current position & reset origin
c   tf_end,     # driver function
c   tf_vecdrw,  # driver function
c   tf_vecmov   # driver function
c integer
c   ip          # abs(ipen)
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'win_view.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'win_view.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'f77_g.con'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'f77_g.con'
c
      integer    PLOTTER,   SCREEN,   WINDOW
      parameter( PLOTTER=0, SCREEN=1, WINDOW=2 )
c
      logical end_graphics, neworg,
     1        tf_end, tf_vecdrw, tf_vecmov, tf_newpag
      integer ip, ipen
      real x, y, xb, yb
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
c               check for valid ipen
c
      if ( device_open ) then
          xp = x
          xb = xp
          yp = y
          yb = yp
          end_graphics = .FALSE.
          neworg = .FALSE.
          if ( ipen .lt. 0 ) neworg = .TRUE.
          ip = abs( ipen )
          if ( ip .ne. 2  .and. ip .ne. 3  .and.
     1         ip .ne. 12 .and. ip .ne. 13 .and.
     2         ip .ne. 999 ) then
              ip = 13
c
c                ipen is 999 - same as ipen = -3 but signal end of process
c
          else if ( ip .eq. 999 ) then
              ip = 3
              neworg = .TRUE.
              end_graphics = .TRUE.
              end if
c
c               required to use shifted origin
c
          if ( neworg ) then
              xb = xb + xorg
              yb = yb + yorg
              end if
c
c               use special offset and factor values - if required
c
          if ( ip .eq. 12 .or. ip .eq. 13 ) then
              xb = ( xb - xoff ) / xfact
              yb = ( yb - yoff ) / yfact
              end if
c
c               apply the window-viewport transformation if a screen device
c               of convert to basic plotter units if a hardcopy device
c
          call win_port( WV_CONVERT, xb, yb, xb, yb )
c
c               do the move or draw
c
          if ( ip .eq. 2 .or. ip .eq. 12  ) then
              if ( .not. tf_vecdrw( xb, yb ) ) then
                  call anmode()
                  write( STD_ERR, 2 )
2                 format( ' PLOT : Cannot draw' )
                  end if
          else if ( ip .eq. 3 .or. ip .eq. 13 ) then
              if ( .not. tf_vecmov(  xb, yb ) ) then
                  call anmode()
                  write( STD_ERR, 3 )
3                 format( ' PLOT : Cannot move' )
                  end if
          else
              call anmode()
              write( STD_ERR, 1 ) ip
1             format( ' BUG in PLOT : illegal ip ', i12 )
              end if
c
c               reset origin if necessary
c
          if ( neworg ) then
              xorg = xp
              yorg = yp
              end if
c
c               terminate graphics if ipen=999
c
          if ( end_graphics ) then
              if ( device_type .eq. SCREEN ) then
                  if ( .not. tf_newpag() ) then
                      call anmode()
                      write( STD_ERR, 5 )
5                     format( ' PLOT : Cannot clear page' )
                      end if
                  end if
              call anmode()
              if ( tf_end() ) then
                  device_open = .FALSE.
              else
                  write( STD_ERR, 4 )
4                 format( ' PLOT : Cannot end graphics' )
                  end if
              end if
          end if
      return
      end



      SUBROUTINE VWPORT( X_MIN, X_MAX, Y_MIN, Y_MAX )
c
c    Set viewport limits
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'win_view.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'win_view.def'
c
      real x_min, y_min, x_max, y_max
c
      call win_port( WV_VIEWPORT, x_min, y_min, x_max, y_max )
      return
      end



      SUBROUTINE WINDOW( X_MIN, X_MAX, Y_MIN, Y_MAX )
c
c set user space limits
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'win_view.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'win_view.def'
c
      real x_min, y_min, x_max, y_max
c
      call win_port( WV_WINDOW, x_min, y_min, x_max, y_max )
      return
      end



      SUBROUTINE WIN_PORT( ACTION, X1, Y1, X2, Y2 )
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'win_view.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'win_view.def'
c
      integer    PLOTTER,        SCREEN,          WINDOW
      real       A4_WIDTH,       A4_HEIGHT,
     1           A3_WIDTH,       A3_HEIGHT
      parameter( PLOTTER=0,      SCREEN=1,        WINDOW=2 )
      parameter( A4_WIDTH=210.0, A4_HEIGHT=297.0,
     1           A3_WIDTH=297.0, A3_HEIGHT=410.0 )
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'f77_g.con'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'f77_g.con'
c
      integer action
      logical hard_rotate, win_vp_changed
      real    hard_angle, hard_x, x_temp, y_temp,
     1        win_xlo, win_ylo, win_xhi, win_yhi,
     2        vp_xlo, vp_ylo, vp_xhi, vp_yhi,
     3        xoffset, yoffset, xscale, yscale, x1, y1, y2, x2
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
      save hard_rotate, win_vp_changed
      save hard_angle, hard_x,
     1     win_xlo, win_ylo, win_xhi, win_yhi,
     2     vp_xlo, vp_ylo, vp_xhi, vp_yhi,
     3     xoffset, yoffset, xscale, yscale
      data hard_rotate, win_vp_changed      / .FALSE., .TRUE. /
      data hard_angle, hard_x               / 0.0, 0.0 /
      data win_xlo,win_ylo, win_xhi,win_yhi / 0.0, 0.0, 10.0, 10.0 /
      data vp_xlo, vp_ylo,  vp_xhi, vp_yhi  / 0.0, 0.0, 1023.0, 779.0 /
      data xoffset, yoffset, xscale, yscale / 0.0, 0.0, 102.3, 7.79 /
c
c
c         define the viewport
c
      if ( action .eq. WV_VIEWPORT ) then                                 1b
          vp_xlo = min( x1, x2 )
          vp_ylo = min( y1, y2 )
          vp_xhi = max( x1, x2 )
          vp_yhi = max( y1, y2 )
          win_vp_changed = .TRUE.
c
c         define the window
c
      else if ( action .eq. WV_WINDOW ) then                              1m
          win_xlo = min( x1, x2 )
          win_ylo = min( y1, y2 )
          win_xhi = max( x1, x2 )
          win_yhi = max( y1, y2 )
          win_vp_changed = .TRUE.
      else                                                                1m
c
c         first update the conversion factors
c
          if ( win_vp_changed ) then                                      2b
              if ( device_type .ne. PLOTTER ) then                        3b
                  xscale = ( vp_xhi - vp_xlo ) /
     1                     ( win_xhi - win_xlo )
                  yscale = ( vp_yhi - vp_ylo ) /
     1                     ( win_yhi - win_ylo )
                  xoffset = vp_xlo - xscale * win_xlo
                  yoffset = vp_ylo - yscale * win_ylo
                  hard_angle = 0.0
              else                                                        3m
                  hard_rotate = win_xhi .lt. win_yhi
                  if ( hard_rotate ) then                                 4b
                      if ( win_xhi * xyunit * pixel_size .gt.
     1                        A4_HEIGHT + 0.3 ) then                      5b
                          hard_x = A3_WIDTH / xyunit / pixel_size
                      else                                                5m
                          hard_x = A4_WIDTH / xyunit / pixel_size
                          end if                                          5e
                      hard_angle = -90.0
                  else                                                    4m
                      hard_x = 0.0
                      hard_angle = 0.0
                      end if                                              4e
                  end if                                                  3e
              win_vp_changed = .FALSE.
              end if                                                      2e
c
c
c         convert (x1,y1) to (x2,y2) using
c           a) the window-viewport transformation for screen devices
c           b) hardcopy rotation for hardcopy devices
c
c         forward transformation
c
          if ( action .eq. WV_CONVERT ) then                              2b
              if ( device_type .ne. PLOTTER ) then                        3b
                  x_temp = xscale * x1 + xoffset
                  y_temp = yscale * y1 + yoffset
              else if ( hard_rotate ) then                                3m
                  x_temp = y1 * xyunit
                  y_temp = ( hard_x - x1 ) * xyunit
              else                                                        3m
                  x_temp = x1 * xyunit
                  y_temp = y1 * xyunit
                  end if                                                  3e
              x2 = x_temp
              y2 = y_temp
c
c         reverse transformation
c
          else if ( action .eq. WV_REVERSE ) then                         2m
              if ( device_type .ne. PLOTTER ) then                        3b
                  x_temp = ( x1 - xoffset ) / xscale
                  y_temp = ( y1 - yoffset ) / yscale
              else if ( hard_rotate ) then                                3m
                  x_temp = hard_x - y1 / xyunit
                  y_temp = x1 / xyunit
              else                                                        3m
                  x_temp = x1 / xyunit
                  y_temp = y1 / xyunit
                  end if                                                  3e
              x2 = x_temp
              y2 = y_temp
c
c         scale (x1,y1) to (x2,y2)
c
          else if ( action .eq. WV_SCALE ) then                           2m
              if ( device_type .ne. PLOTTER ) then                        3b
                  x2 = x1 * xscale
                  y2 = y2 * yscale
              else                                                        3m
                  x2 = x1 * xyunit
                  y2 = y1 * xyunit
                  end if                                                  3e
c
c         add the hardcopy rotation angle
c
          else if ( action .eq. WV_ANGLE ) then                           2m
              x2 = x1 + hard_angle
              y2 = y1 + hard_angle
              end if                                                      2e
          end if                                                          1e
      return
      end




      SUBROUTINE SYMBOL( X, Y, HEIGHT, STRING, ANGLE, ICTL )
c
c draws a label character string or special centered symbol at
c a specified location, size and angle.
c
c   Arguments:
c real
c   x,y     # coordinates of the first character to be produced
c   height  # height of the character to be plotted
c   angle   # angle at which the characters are to be plotted
c character
c   string*(*) # the string containing characters to be produced
c integer
c   ictl    # control code
c---------------------------------------------------------------------
c   ictl > 0   the number of characters in 'string' to be drawn
c
c   ictl = 0   draw only the single character which is in string(4:4)
c              this is the only way to reference some of the characters when
c              the host computer stores characters internally in fewer than
c              eight bits.
c
c   ictl =-1   draw special symbol represented by the integer in string(1:1).
c              Plot the x,y point with the pen up. The special symbols are
c              drawn with no connecting lines.
c
c   ictl =-2   draw special symbol represented by the integer in string(1:1).
c              Plot the x,y point with the pen down. The special symbols are
c              drawn with connecting lines.
c
c   ictl =-3   draw the Greek character stored in string(1:1)
c-----------------------------------------------------------------------
c
c   Global Variables
c real
c   xyunit       # number of plotter units per inch or centimeter
c   xp, yp       # current pen position - plotter units
c
c   Local variables
c logical
c   tf_txtdrw    # driver function
c   tf_txtset    # driver function
c   tf_symdrw    # driver function
c   tf_txtmov    # driver function
c integer i      # array index
c real size      # clipped character height
c      dummy
c      direction
c character
c   junk_str*1   # discarded result from tf_txtset
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'f77_g.con'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'f77_g.con'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'win_view.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'win_view.def'
c
      integer font, finish, ictl, start
      logical tf_symdrw, tf_txtdrw, tf_txtmov, tf_txtset, tf_vecdrw
      real    height, size, dummy, angle, direction, x, y, xb, yb
      character junk_str*1, string*(*)
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
c
      if ( .not. device_open ) then                                       1b
          continue
      else if ( ictl .lt. -3 ) then                                       1m
          call anmode()
          write( STD_ERR, 1 )
1         format( ' SYMBOL : ABORT : Illegal ICTL argument' )
      else                                                                1m
          if ( x .ne. 999.0 ) xp = x
          if ( y .ne. 999.0 ) yp = y
c
c               apply the window-viewport transformation to location
c
          call win_port( WV_CONVERT, xp, yp, xb, yb )
c
c               scale and set the character height and direction
c
          call win_port( WV_SCALE, height, 0.0, size, dummy )
          call win_port( WV_ANGLE, angle, 0.0, direction, dummy )
c
          if ( .not. tf_txtset( T_CH_HEIGHT, size, junk_str ) ) then      2b
              call anmode()
              write( STD_ERR, 2 )
2             format( ' SYMBOL : Cannot set character height' )
          else if ( .not. tf_txtset( T_CH_ANGLE, direction, junk_str ) )
     1            then                                                    2m
              call anmode()
              write( STD_ERR, 3 )
3             format( ' SYMBOL : Cannot set writing direction' )
          else                                                            2m
c
c           select font
c
              font = T_SYMBOL
              if ( ictl .ge. 0 ) font = T_ASCII
              if ( .not. tf_txtset( font, 0.0, junk_str ) ) then           3b
                  call anmode()
                  write( STD_ERR, 4 )
4                 format( ' SYMBOL : Cannot set font' )
c
c           do string, single character or Greek character
c
              else if ( ictl .ge. 0 .or. ictl .eq. -3 ) then              3m
                  start = 1
                  if ( ictl .eq. 0 ) start = 4
                  finish = start
                  if ( ictl .gt. 0 )
     1                finish = start + min( len( string ), ictl ) - 1
                  if ( .not. tf_txtmov( xb, yb ) )
     1                    then                                            4b
                      call anmode()
                      write( STD_ERR, 5 )
5                     format( ' SYMBOL : Cannot move to start of text' )
                  else if ( .not. tf_txtdrw( string(start:finish) ) )
     1                     then                                           4m
                      call anmode()
                      write( STD_ERR, 6 )
6                     format( ' SYMBOL : Cannot draw text' )
                      end if                                              4e
              else                                                        3m
                  if ( ictl .eq. -2 ) then                                4b
                      if ( .not. tf_vecdrw( xb, yb ) ) then                5b
                          call anmode()
                          write( STD_ERR, 5)
                          end if                                          5e
                      end if                                              4e
                  if ( .not. tf_symdrw( xb, yb,
     1                    char( ichar( string(1:1) ) + ichar( '0' ) )
     2                    ) ) then                                        4b
                      call anmode()
                      write( STD_ERR, 7 )
7                     format( ' SYMBOL : Cannot draw symbol' )
                      end if                                              4e
                  end if                                                  3e
              end if                                                      2e
          end if                                                          1e
      return
      end



      SUBROUTINE WHERE( X, Y, FCT )
c
c obtains the current x,y pen location and scale factor
c
c   Arguments :
c real
c   x, y    # location
c   fct     # current scale factor
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      real x, y, fct
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
c               where are you ?
c
      if ( device_open ) then
          x = xp
          y = yp
c
c               obtain the current scale factor
c
          fct = xyunit * pixel_size * 10.0
          if ( munit .eq. 0)
     1        fct = fct / 2.54
          end if
      return
      end



      BLOCK DATA HP_BLOCK
c
c   initialization of common block variables for HPISPP binding functions
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      integer    PLOTTER,   SCREEN,   WINDOW
      parameter( PLOTTER=0, SCREEN=1, WINDOW=2 )
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
      data device_open / .FALSE. /
      data munit, device_type / 1, SCREEN /
      data pixel_size, costh, sinth, tolarc, xorg, yorg, xoff, yoff,
     1     xfact, yfact, xyunit, xp, yp /
     2     0.025,      1.0,   0.0,   10.0,   4*0.0,
     3     2*1.0,        400.0,  2*0.0 /
      end



      SUBROUTINE VECTOR( DEL_X, DEL_Y, ARROW_LENGTH, ARROW_ASPECT )
c
c       VECTOR
c   Draws a vector (arrow) bar in the direction (DELX,DELY) from the current
c pen position . The length and aspect ratio of the arrowhead are ARROW_LENGTH
c and ARROW_ASPECT respectively.
c   The error bar is rotated by the angle specified by TXTANG .
c If DELX >= DELMIN and DELY >= DELMIN, the error bar is drawn as a rectangle .
c If DELX = 0, the error bar is drawn as an `I' . If DELY = 0, the error bar is
c drawn as an `I' lying on its side . With DELX < DELMIN or DELY < DELMIN, the
c error bar is in transition between a rectangle and an `I' .
c
c Arguments
c  real del_x, del_y    # length & direction of vector from current pen postion
c       arrow_length    # length of arrowhead
c       arrow_aspect    # aspect ratio of arrowhead
c
c Local Variables
c  real rx,ry,          # initial and final pen location
c       vect_len        # length of arrow stem
c       head_len        # nondimensional length of arrow head
c       head_width      # nondimensional width of arrow head
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      real del_x, del_y, arrow_length, arrow_aspect,
     1     rx, ry, vect_len, head_len, head_width
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
c       draw the stem of the arrow
c
      rx = xp
      ry = yp
      call plot( rx + del_x, ry + del_y, 2 )
c
c       calculate size of arrowhead
c
      vect_len = sqrt( del_x **2 + del_y **2 )
      head_len = max( 0.0, min( arrow_length, vect_len / 2.0 ) )
      if ( head_len .gt. 0.0 .and. vect_len .gt. 0.0 ) then
          head_width = max( 0.25, min( arrow_aspect, 2.0 ) ) * head_len
     1                 / vect_len / 2.0
          head_len   = ( 1.0 - head_len / vect_len )
c
c       draw arrowhead
c
          call plot( rx + del_x * head_len + del_y * head_width,
     1               ry + del_y * head_len - del_x * head_width, 2 )
          call plot( rx + del_x, ry + del_y, 3 )
          call plot( rx + del_x * head_len - del_y * head_width,
     1               ry + del_y * head_len + del_x * head_width, 2 )
          end if
      call plot( rx, ry, 3 )
      return
      end



      SUBROUTINE ERRBAR( DELX, DELY, DELMIN, ANGLE )
c
c       ERRor BAR
c   Draws an error bar at the current pen position .
c   The error bar is rotated by the angle specified by TXTANG .
c If DELX >= DELMIN and DELY >= DELMIN, the error bar is drawn as a rectangle .
c If DELX = 0, the error bar is drawn as an `I' . If DELY = 0, the error bar is
c drawn as an `I' lying on its side . With DELX < DELMIN or DELY < DELMIN, the
c error bar is in transition between a rectangle and an `I' .
c
c Arguments
c  real delx,           # width of the error bar
c       dely,           # height of the error bar
c       delmin,         # minimum width of the bar terminator
c       angle           # angle of error bar
c
c Variables
c  real delHx, delHy,   # unrotated 1st quadrant position of width bar
c       delVx, delVy,   # unrotated 1st quadrant position of height bar
c       rx,ry,          # centre of the error bar
c       Ax,Ay, Bx,By,   # rotated end points of the height bar
c       Cx,Cy, Dx,Dy    # rotated end points of the width bar
c  logical * rectangle  # the error bar forms a rectangle
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      real delX, delY, delmin, angle, delHx, delHy, delVx, delVy,
     1  rx, ry, Ax, Ay, Bx, By, Cx, Cy, Dx, Dy
      logical rectangle
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
c           decide unrotated positions and lengths of the height & width bars
c
      call sincos( angle )
      rx    = xp
      ry    = yp
      delHx = abs( delX ) / 2.0
      delVy = abs( delY ) / 2.0
      delVx = max( delHx, delMin / 2.0 )
      delHy = max( delVy, delMin / 2.0 )
      rectangle = delHx .eq. delVx .and. delHy .eq. delVy
c
c           left end of top height bar
c
      Ax = -delVX
      Ay = delVy
      call rotate( Ax, Ay )
      call plot( rx + Ax, ry + Ay, 3 )
c
c           right end of top height bar
c
      Bx = delVx
      By = delVy
      call rotate( Bx, By )
      call plot( rx + Bx, ry + By, 2 )
c
c           top end of right width bar
c
      if ( .not. rectangle ) then
        Cx = delHx
        Cy = delHy
        call rotate( Cx, Cy )
        call plot( rx + Cx, ry + Cy, 3 )
        end if
c
c           bottom end of right width bar
c
      Dx = delHx
      Dy = - delHy
      call rotate( Dx, Dy )
      call plot( rx + Dx, ry + Dy, 2 )
c
c           right & left ends of bottom height bar
c
      if ( delVy .gt. 0.0 ) then
        if ( .not. rectangle )
     1    call plot( rx - Ax, ry - Ay, 3 )
        call plot( rx - Bx, ry - By, 2 )
c
c           bottom and top ends of left width height bar
c
        if ( delVx .gt. 0.0 ) then
          if ( .not. rectangle )
     1      call plot( rx - Cx, ry - Cy, 3 )
          call plot( rx - Dx, ry - Dy, 2 )
          end if
      else if ( delVx .gt. 0 ) then
        if ( .not. rectangle )
     1    call plot( rx - Cx, ry - Cy, 3 )
        call plot( rx - Dx, ry - Dy, 2 )
        end if
      call plot( rx, ry, 3 )
      return
      end



      SUBROUTINE SINCOS( ANG )
c
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      real DEG_TO_RAD
      parameter ( DEG_TO_RAD=0.017453293 )
c
      real ang, angl
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
      angl = mod( ang, 360.0 )
      if ( angl .eq. 0.0 ) then
        costh = 1.0
        sinth = 0.0
      else if ( angl .eq. 90.0 ) then
        costh = 0.0
        sinth = 1.0
      else if ( angl .eq. 180.0 ) then
        costh = -1.0
        sinth = 0.0
      else if ( angl .eq. 270.0 ) then
        costh = 0.0
        sinth = -1.0
      else
        angl = angl * DEG_TO_RAD
        costh = cos( angl )
        sinth = sin( angl )
      end if
      return
      end


      SUBROUTINE ROTATE( RX, RY )
c
c  rotate the coordinate (RX,RY) by the angle specified by a call to
c  SINCOS
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      real rx, ry, tx, ty
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
      tx = rx
      ty = ry
      rx = tx * costh - ty * sinth
      ry = tx * sinth + ty * costh
      return
      end



      SUBROUTINE ARC( RADIUS, START, FIN )
c
c subroutine to draw arc of RADIUS from START angle to FIN angle (deg
c anticlock ) using algorithm for parametric circle
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      real radius, start, fin, x, y, thstrt, thfin, tmptht, arclen,
     1  tmptol, xrel, yrel
      integer narcs, i
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
      x = xp
      y = yp
      thstrt = start
      thfin = fin
c
c set angles modulo 360.
c
      if ( abs(thstrt) .gt. 360.0 ) thstrt = mod( start, 360.0 )
      if ( abs(thfin)  .gt. 360.0 ) thfin  = mod( fin,   360.0 )
c
c make both positive angles & thfin bigger than thstart for correct length
c
      if ( thstrt .lt. 0.0 ) thstrt = 360.0 + thstrt
      if ( thfin  .lt. 0.0 ) thfin  = 360.0 + thfin
      tmptht = thfin
      if ( thfin .lt. thstrt ) tmptht = thfin + 360.0
      arclen = tmptht - thstrt
c
c chord tol set to give tol closest to tolarc but with integral
c number of chords
c
      if ( arclen .le. tolarc ) then
          narcs = 1
          tmptol = arclen
      else
          narcs = int( arclen / tolarc + 0.5 )
          tmptol = arclen/narcs
          end if
c
c         move to start position
c
      call sincos( thstrt)
      xrel = radius
      yrel = 0
      call rotate( xrel, yrel )
      call plot( x + xrel, y + yrel, 3 )
c
c         draw arc segments
c
      call sincos( tmptol )
      do 1 i = 1,narcs
          call rotate( xrel, yrel )
          call plot( x + xrel, y + yrel, 2 )
1         continue
c
      return
      end



      SUBROUTINE ARCTOL(TOL)
c
c   set arc tolerance ( ie. resolution ) to TOL degrees
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      real  tol
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
      tolarc = tol
      return
      end



      SUBROUTINE VECMOD()
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      integer    PLOTTER,   SCREEN,   WINDOW
      parameter( PLOTTER=0, SCREEN=1, WINDOW=2 )
c
      logical tf_gr_on
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
      if ( device_open .and. device_type .ne. WINDOW ) then
          if ( .not. tf_gr_on() ) then
              call anmode()
              write( STD_ERR, 1 )
              end if
          end if
1     format( ' VECMOD : ABORT : Cannot switch to graphics mode' )
      return
      end



      SUBROUTINE ANMODE()
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      integer    PLOTTER,   SCREEN,   WINDOW
      parameter( PLOTTER=0, SCREEN=1, WINDOW=2 )
c
      logical tf_gr_off
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
      if ( device_open .and. device_type .ne. WINDOW ) then
          if ( .not. tf_gr_off() ) write( STD_ERR, 1 )
          end if
1     format( ' ANMODE : ABORT : Cannot switch to alphanumeric mode' )
      return
      end



      SUBROUTINE VISIBL()
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      logical tf_visib
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
      if ( device_open ) then
          if ( .not. tf_visib() ) then
              call anmode()
              write( STD_ERR, 1 )
              end if
          end if
1     format( ' VISIB : ABORT : Cannot select dots_on mode' )
      return
      end



      SUBROUTINE INVIS()
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      logical tf_invis
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
      if ( device_open ) then
          if ( .not. tf_invis() ) then
              call anmode()
              write( STD_ERR, 1 )
              end if
          end if
1     format( ' INVIS : ABORT : Cannot select dots_off mode' )
      return
      end



      SUBROUTINE BELL()
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      logical tf_bell
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
      if ( device_open ) then
          if ( .not. tf_bell() ) then
              call anmode()
              write( STD_ERR, 1 )
              end if
          end if
1     format( ' BELL : ABORT : Cannot ring bell' )
      return
      end



      SUBROUTINE NEWSCR()
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      logical tf_newscr
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
      if ( device_open ) then
          if ( .not. tf_newscr() ) then
              call anmode()
              write( STD_ERR, 1 )
              end if
          end if
1     format( ' NEWSCR : ABORT : Cannot clear alphanumeric screen' )
      return
      end



      SUBROUTINE NEWPAG()
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      logical tf_newpag
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
      if ( device_open ) then
          if ( .not. tf_newpag() ) then
              call anmode()
              write( STD_ERR, 1 )
              end if
          end if
1     format( ' NEWPAG : ABORT : Cannot clear graphics screen' )
      return
      end



      SUBROUTINE WAIT_CR()
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      logical tf_wait
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
      if ( device_open ) then
          if ( .not. tf_wait() ) then
              call anmode()
              write( STD_ERR, 1 )
              end if
          end if
1     format( ' WAIT : ABORT : Cannot wait for <CR>' )
      return
      end



      SUBROUTINE LOCATE( MAX_PTS, X_ARRAY, Y_ARRAY, PRESSED, NPTS )
c
c Returns array of coordinates in window units of cross-hair positions
c Parameters :
c  integer MAX_PTS     = max posns is imaxpt  - input
c  real    X_ARRAY(*)   = array of x values
c          Y_ARRAY(*)   = array of corresponding y values
c  character PRESSED*) = array of characters used to transmit x-hair positions
c  integer NPTS        = actual number positions returned
c sequence is terminated when 'x' is typed or IGOT is equal to IMAXPT or an end
c of file is encountered .
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'win_view.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'win_view.def'
c
      integer max_pts, npts
      logical tf_xhrget
      real    xhair, yhair, x_array(*), y_array(*)
      character pressed(*)*1, chr*1
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'hpispp.cmn'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'hpispp.cmn'
c
      if ( device_open ) then
          npts = 0
c         repeat
1         if ( npts .lt. max_pts ) then
              if ( tf_xhrget( xhair, yhair, chr ) ) then
                  if ( chr .ne. 'X' .and. chr .ne. 'x' ) then
                      npts = npts + 1
                      call win_port( WV_REVERSE, xhair, yhair,
     1                               x_array(npts), y_array(npts) )
                      pressed(npts) = chr
                      goto 1
                      end if
              else
                  call anmode()
                  write( STD_ERR, 2 )
2                 format( ' LOCATE : ABORT : Cannot read crosshairs' )
                  end if
              end if
          end if
      call vecmod()
      return
      end



