c
c    Copyright (C) 1997  Peter Vernon Lanspeary
c
c    This program is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    This program is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program; if not, write to the Free Software
c    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c


c  Code portability :
c   This code has been compiled on
c     SunOS unix f77 v1.3.1,
c     VMS/VAX    FORTRAN V4
c     DOS        MICROSOFT FORTRAN V4.10
c     Linux      Linux f77
c     Silicon Graphics  IRIX f77
c     Digital Alpha     UNIX f77
c
c The lines following the lines
c  'CC--VAX-SunOS-DEC-FORTRAN'
c  'CC--MISCROSOFT-FORTRAN-V4:'
c is by default commented out with an initial 'CC'
c
c The initial "CC" of the line which follows the line
c  'CC--VAX-SunOS-DEC-FORTRAN'
c must be removed if the machine is SunOS unix, VMS/VAX or DECstation 5000.
c
c The initial "CC" of the line which follows the line
c  'CC--MISCROSOFT-FORTRAN-V4:'
c must be removed if the machine is an IBM PC (or compatible) running DOS.


CC--MISCROSOFT-FORTRAN-V4:
CC$notruncate


      PROGRAM ILGPLOT
c
c         GENERAL PLOTTING PROGRAM
c         using ILGLIB routines
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
c       ALL system dependent code is in one of the following source files
c
c
c               ILGPLOT SYSTEM DEPENDENT CODE 
c               *****************************
c Include just one of the following files:
c  ilglinux.f    for Linux
c  ilglinux.f    for IRIX on Silicon Graphics workstation
c  ilglinux.f    for UNIX on Digital Alpha workstation
c  ilgsunos.f    for SunOS on Sun 3 or SPARC workstation
c  ilg_vms.for   for VMS on a Digital VAX
c  ilg_dos.for   for MISCROSOFT-FORTRAN-V4 on a PC running MS-DOS (MS-dog)
c
       include 'ilglinux.f'
c       include 'ilg_sunos.f'
c       include 'ilg_vms.for/list'
c$INCLUDE:'ilg_dos.for'
c
      stop
      end



      LOGICAL FUNCTION GET_REAL( STREAM_LU, VALUE,
     1                           MINIMUM, MAXIMUM, ECHO )
c
c       reads a real number from the command stream
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      integer stream_lu, ntries
      logical echo, eqabbr, next_token
      real    value, maximum, minimum
      character string*32
c
c           read from command stream
c
      get_real = .TRUE.
      do 3 ntries = 1, MAX_TRIES                                          1b
          if ( .not. next_token( stream_lu,
     1                           string, TOK_NOBLANK, echo ) ) then       2b
c             end of file detected
              goto 7
          else                                                            2m
              call casech( string, 'l' )
c             user abort
              if ( string .eq. 'end' ) then                               3b
                  get_real = .FALSE.
c           selected  maximum
              else if ( eqabbr( string, 'maximum', 3 ) ) then             3m
                  value = maximum
c           selected  minimum
              else if ( eqabbr( string, 'minimum', 3 ) ) then             3m
                  value = minimum
c
c           decode & check numeric value
              else                                                        3m
                  read( string, 10, ERR=3 ) value
10                format( bn, f32.0 )
                  if ( value .lt. min( minimum, maximum ) .or.
     1                 value .gt. max( minimum, maximum ) ) then          4b
                      write ( STD_ERR, 1 ) minimum, maximum
1                     format(' GET_REAL : ERROR ; real outside limits ',
     1                    g15.7, ' & ', g15.7 )
                      if ( stream_lu .ne. STD_IN ) goto 7
                      write ( STD_OUT, 2 )
2                     format( ' Try again' )
c                     skip to end of loop
                      goto 3                                              4e
                      end if                                              3e
                  end if                                                  2e
              end if
          return
c
c           error detected
c
3         write( STD_OUT, 4 )
4         format( ' GET_REAL : Can''t decode that . Try again .' )
5         continue                                                        1e
      write( STD_OUT, 6 )
6     format( 8x, 'Get Help' )
c
c     end of file
7     get_real = .FALSE.
      return
      end



      LOGICAL FUNCTION GET_INT( STREAM_LU, VALUE,
     1                          MINIMUM, MAXIMUM, ECHO )
c
c       reads integer from the command stream
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      integer stream_lu, ntries, value, maximum, minimum
      logical echo, eqabbr, next_token
      character string*32
c
c           read from command stream
c
      get_int = .TRUE.
      do 3 ntries = 1, MAX_TRIES                                         1b
          if ( .not. next_token( stream_lu,
     1                           string, TOK_NOBLANK, echo ) ) then       2b
c             end of file detected
              goto 7
          else                                                            2m
              call casech( string, 'l' )
c             user abort
              if ( string .eq. 'end' ) then                               3b
                  get_int = .FALSE.
c           selected  maximum
              else if ( eqabbr( string, 'maximum', 3 ) ) then             3m
                  value = maximum
c           selected  minimum
              else if ( eqabbr( string, 'minimum', 3 ) ) then             3m
                  value = minimum
c
c           decode & check numeric value
              else                                                        3m
                  read( string, 10, ERR=3 ) value
10                format( bn, i32 )
                  if ( value .lt. min( minimum, maximum ) .or.
     1                 value .gt. max( minimum, maximum ) ) then          4b
                      write ( STD_ERR, 1 ) minimum, maximum
1                     format(' GET_INT : ERROR ; integer outside ',
     1                    'limits ', i12, ' & ', i12 )
                      if ( stream_lu .ne. STD_IN ) goto 7
                      write ( STD_OUT, 2 )
2                     format( ' Try again ' )
c                     skip to end of loop
                      goto 3                                              4e
                      end if                                              3e
                  end if                                                  2e
              end if
          return
c
c           error detected
c
3         write( STD_OUT, 4 )
4         format( ' GET_INT : Can''t decode that . Try again .' )
5         continue                                                        1e
      write( STD_OUT, 6 )
6     format( 8x, 'Get Help' )
c
c
c     end of file
7     get_int = .FALSE.
      return
      end



      INTEGER FUNCTION STR_LENGTH( STRING )
c
c    Find the location of the last non-blank character in the character
c string STRING . If the whole string is blank, the returned value is 0 .
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      character string*(*)
c
      str_length = len( string )
1     if ( str_length .ge. 1 ) then
          if ( string(str_length:str_length) .eq. ' ' ) then
              str_length = str_length - 1
          else
              return
              end if
          goto 1
          end if
      return
      end



      LOGICAL FUNCTION GET_BOOL( PROMPT_ENABLE, STREAM_LU,
     1                           BOOLEAN, MESSAGE )
c
c       Displays a query on the vdu and receives a logical response with
c  logical unit number IPLUN .
c
c    Arguments
c logical prompt_enable      # INPUT  # prompts to screen enabled
c integer stream_lu          # INPUT  # input device logical unit number
c logical boolean            # INPUT  # returned value
c character messge*(*)       # INPUT  # message string
c
c integer is_ok,      # index of response in legal response list
c         index,      # lexical function
c character response*1     # received character
c           allowed_list*8 # legal responses
c
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      integer is_ok, index, stream_lu
      logical boolean, next_token, prompt_enable, echo
      character allowed_list*10, message*(*), response*1
c
      save allowed_list
      data allowed_list / 'tT1yYfF0nN' /
c
      echo = prompt_enable .and. stream_lu .ne. STD_IN
      if ( prompt_enable ) write( STD_OUT, 1 ) message
1     format( 1x, a )
c
c     start of loop
2     if ( next_token( stream_lu, response, TOK_NOBLANK, echo ) ) then
          is_ok = index( allowed_list, response )
          if ( is_ok .gt. 0 ) then
              boolean = is_ok .le. 5
              get_bool = .TRUE.
              return
              end if
          write( STD_OUT, 3 ) allowed_list
3         format( ' Expecting one of ', a )
          goto 2
          end if
c         end of loop
      get_bool = .FALSE.
      return
      end



      SUBROUTINE READ_DATA( INPUT_LU, ARRAY, ARRAY_SIZE, ROWS, COLUMNS,
     1                      ECHO )
c
c  Reads the data from the file with logical unit number INPUT_LU file into
c  the array ARRAY . ARRAY_SIZE is the maximum possible number of data values .
c  The data file is an array with ROWS rows and COLUMNS columns . A ';' in the
c  data file begins a comment field . Comment fields are terminated by an end
c  of the line . Input format is list directed ( ie. free ) . This routine
c  reads any number ( > 0 ) of columns of data in the 1st row and the same
c  number of columns from succeeding rows .
c
c   Arguments
c integer input_lu      # data file logical unit number
c real    array(*)      # data array
c integer array_size    # maximum number of data items
c         columns       # number of columns of data
c         rows          # number of rows of data
c logical echo          # echo lines which generate an error
c
c constants
c  MAX_LINE = 128 # maximum line length
c
c local variables
c  integer
c   count
c   error               # returned value from decode_line
c   i                   # data array index for zero padding
c   index               # array index for start of each row
c   line_len            # no. of values decoded from a line
c   decode_line         # decode numeric values in a string
c  character
c   line*128            # line read from file
c
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      integer    DECODE_SUCCESS,   DECODE_EMPTY,     DECODE_COMMENT,
     1           DECODE_ENDFILE,   DECODE_OVRFLOW,   DECODE_DECODE,
     2           MAX_LINE
      parameter( DECODE_SUCCESS=0, DECODE_EMPTY=1,   DECODE_COMMENT=2,
     1           DECODE_ENDFILE=4, DECODE_OVRFLOW=8, DECODE_DECODE=16,
     2           MAX_LINE=128 )
c
      real    array(*)
      logical echo
      integer input_lu, array_size, columns, rows, count, error, i,
     1        index, line_len, decode_line
      character line*128
c
c
c         read the first line of data
c
      index = 1
c     repeat                                                              1b
1         read( input_lu, 2, END=8, ERR=10 ) line
2         format( a )
          count = count + 1
          error = decode_line( line, array(index), columns, array_size )
          if ( echo ) then                                                2b
              if ( error .ne. DECODE_SUCCESS .and.
     1             error .ne. DECODE_COMMENT .and.
     2             error .ne. DECODE_EMPTY ) write( STD_ERR, 3 ) line
3             format( 1x, a )
              end if                                                      2e
          if ( error .eq. DECODE_EMPTY .or.
     1         error .eq. DECODE_COMMENT .or.
     2         ( error .eq. DECODE_OVRFLOW .or.
     3           error .eq. DECODE_DECODE ) .and. columns .le. 0 .or.
     4         columns .le. 0 )
     5        goto 1
c         until( got some values )                                        1e
c
c       read second and subsequent lines from data file
c       Truncate lines which are too long. Pad lines which are too short
c       with zeros.
c
      index = index + columns
      if ( columns .gt. 0 ) then                                          1b
          rows = 1
4         if ( index + columns - 1 .le. array_size .and.
     1         error .ne. DECODE_ENDFILE ) then                           2b
              read( input_lu, 2, END=8, ERR=10 ) line
              error = decode_line( line, array(index), line_len,
     1            columns )
              if ( echo ) then                                            3b
                  if ( error .ne. DECODE_SUCCESS .and.
     1                 error .ne. DECODE_COMMENT .and.
     2                 error .ne. DECODE_EMPTY ) write( STD_ERR, 3) line
              end if                                                      3e
              if ( line_len .gt. 0 .and. error .ne. DECODE_ENDFILE )then  3b
                  if ( line_len .lt. columns ) then                       4b
                      write( STD_ERR, 5 ) count, line_len, columns
5                     format( ' READ_DATA : Padding : Line ', i5,
     1                    ' :', i4, ' values available. ', i4,
     2                    ' required' )
                      do 6 i = index + line_len, index + columns - 1      5b
                          array(i) = 0
6                         continue                                        5e
                      end if                                              4e
                  index = index + columns
                  rows = rows + 1
                  end if                                                  3e
              count = count + 1
              goto 4
              end if                                                      2e
          end if                                                          1e
c
      if ( index + columns - 1 .gt. array_size )
     1    write( STD_ERR, 7 ) array_size
7         format( ' READ_DATA : WARNING : Array space ', i7, ' full' )
c
8     write( STD_OUT, 9 ) rows, columns
9     format( ' READ_DATA : NOTE : ',
     1    i6, ' rows, ', i6, ' columns read' )
      call flush_token()
      return
c
10    write( STD_ERR, 11 ) count
11    format( ' READ_DATA : ABORT : Cannot read line ', i5,
     1        ' from file' )
      write( STD_ERR, 3 ) line
      call flush_token()
      return
      end



      INTEGER FUNCTION DECODE_LINE(
     1    STRING, ARRAY, N_VALUES, MAX_VALUES )
c
c Decodes up to MAX_VALUES numeric values in the character string STRING and
c places them in the array ARRAY. The number of values decoded is returned in
c N_VALUES. The returned value of the function is an error flag.
c indicator if N_VALUES=0 .
c   A ';' begins a comment field and anything after it is ignored.
c   The token 'end' indicates end-of-data-in-the-file
c
c Arguments
c   character string*(*)  # INPUT  # character string to be decoded
c   real      array(*)    # OUTPUT # array of decoded values
c   integer   n_values    # OUTPUT # number of values decoded
c             max_values  # INPUT  # max no. of values to be placed in ARRAY
c
c
c Returned error flags
c   0  DECODE_SUCCESS     no errors encountered
c   1  DECODE_COMMENT     the first token in the string began with a ';'
c   2  DECODE_ENDFILE     end of data
c   4  DECODE_EMPTY       empty (blank) string
c   8  DECODE_OVRFLOW     too many numeric tokens in the string
c  16  DECODE_DECODE      could not decode token to numeric value
c
c local variables
c  real
c   value         # decoded value
c  character
c   token*32      # token extracted from string
c subroutine
c  get_token      # extract token
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      integer    DECODE_SUCCESS,   DECODE_EMPTY,     DECODE_COMMENT,
     1           DECODE_ENDFILE,   DECODE_OVRFLOW,   DECODE_DECODE
      parameter( DECODE_SUCCESS=0, DECODE_EMPTY=1,   DECODE_COMMENT=2,
     1           DECODE_ENDFILE=4, DECODE_OVRFLOW=8, DECODE_DECODE=16 )
c
      integer   n_values, max_values
      real      value, array(*)
      character token*32, string*(*)
c
      n_values = 0
      decode_line = DECODE_SUCCESS
c
c       get first token
c
      call get_token( string, token )
c
c     start of loop                                                       1b
c
c       finished if empty line, comment or end of file
c
1         if ( token(1:1) .eq. ' ' ) then                                 2b
              if ( n_values .eq. 0 )
     1            decode_line = DECODE_EMPTY
          else if ( token(1:1) .eq. ';' ) then                            2m
              if ( n_values .eq. 0 )
     1            decode_line = DECODE_COMMENT
          else if ( token(1:3) .eq. 'end' ) then                          2m
              decode_line = DECODE_ENDFILE
          else                                                            2m
c
c       decode the token; finished if data array is full
c
              read( token, 5, ERR=3 ) value
5             format( bn, f32.0 )
              if ( n_values .ge. max_values ) then                        3b
                  decode_line = DECODE_OVRFLOW
                  write( STD_ERR, 2 ) max_values
2                 format( ' DECODE_LINE : ABORT : Too many values on ',
     1                'line ( max = ', i5, ' )' )
              else                                                         3m
                  n_values = n_values + 1
                  array(n_values) = value
                  call get_token( ' ', token )
                  goto 1
                  end if                                                  3e
              end if                                                      2e
c         end of loop                                                     1e
      return
c
c       could not decode value
c
3     if ( n_values .ge. max_values ) then                                1b
          decode_line = DECODE_OVRFLOW + DECODE_DECODE
          write( STD_ERR, 2 ) max_values
      else                                                                1m
          decode_line = DECODE_DECODE
          end if                                                          1e
      write( STD_ERR, 4 ) n_values + 1
4     format( ' DECODE_LINE : ABORT : Cannot decode value no. ', i5 )
      return
      end



      SUBROUTINE GET_TOKEN( STRING, TOKEN )
c
c Extract the next token from STRING and place it in TOKEN . On the
c any call where STRING is not blank and only one character in length,
c STRING is saved and the search for a token starts at the beginning of
c the string . In a call where STRING = ' ' (and is one character long),
c the next token is extracted from the previously saved STRING . The
c maximum length of a saved string is 128 characters . If there are no more
c tokens in the string the returned value of TOKEN is ' '.
c
c Arguments
c  character string*(*)   # INPUT  # string containing tokens
c            token*(*)    # OUTPUT # returned token
c
c local variables
c  integer
c   len_saved         # non blamk length of the saved string
c   start, finish     # start & finish indices in the saved string of the token
c   str_length        # function : non-blank length of string
c  character
c   saved*128         # saved string
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      integer len_saved, start, finish, str_length
      character saved*128, string*(*), token*(*)
c
      save len_saved, saved, start
      data saved / ' ' /
      data len_saved, start / 0, 1 /
c
      if ( string .eq. char( TOK_TO_EOL ) ) then
          if ( start .lt. len_saved .and. len_saved .gt. 0 ) then
              token = saved(start+1:len_saved)
              start = len_saved + 1
          else
              token = ' '
              end if
      else
          if ( len(string) .ne. 1 .or. string(1:1) .ne. ' ' ) then
              saved = string
              len_saved = str_length( string )
              start = 1
              end if
          if ( len_saved .le. 0 ) then
              token = ' '
          else
c
1             if ( start .le. len_saved ) then
                  if ( saved(start:start) .eq. ' ' ) then
                      start = start + 1
                      goto 1
                      end if
                  finish = start
2                 if ( finish .lt. len_saved ) then
                      if ( saved(finish+1:finish+1) .ne. ' ' ) then
                          finish = finish + 1
                          goto 2
                          end if
                      end if
                  token = saved(start:finish)
                  start = finish + 1
              else
                  token = ' '
                  end if
              end if
          end if
      return
      end



      INTEGER FUNCTION OPEN_FILE( LUN, FILE_NAME, NEW_OLD )
c
c     Opens a text file for reading ( NEW_OLD = 'old' ) or writing
c ( NEW_OLD = 'new' ). If FILE_NAME is '?', the name of the file is obtained
c from the user. If the file is for reading, the file name cannot be blank.
c If the file is for writing a blank filename is interpreted as the vdu screen.
c The logical unit used for the file is LUN. If the file is successfully opened,
c LUN is the returned result . If a file could not be opened, the returned value
c is OPEN_FILE = 0 .
c
c Arguments
c  integer   lun          # logical unit no. of file to be opened
c  character file_name*(*)# file name
c            new_old*(*)  # file status : 'old'=read, 'new'=write, or 'unknown'
c
c Local Variables
c  integer length         # length of file name string
c          str_length     # function : length of string
c character user_resp*64  # name of file - obtained from user
c
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      integer lun, length, str_length
      logical next_token
      character file_name*(*), new_old*(*), user_resp*64
c
c             check argument
c
      if ( new_old .ne. 'old' .and. new_old .ne. 'new' .and.
     1     new_old .ne. 'unknown' ) then
          write( STD_OUT, 1 ) new_old
1         format( ' OPEN_FILE : ABORT : Illegal status ', a /
     1            21x, 'Need ''old'', ''new'' or ''unknown''' )
          open_file = 0
      else if ( lun .lt. 0 .or. lun .ge. 100 ) then
          write( STD_OUT, 2 ) lun
2         format( ' OPEN_FILE : ABORT : Illegal logical unit number ',
     1            i12, '. Must be 0 to 99.' )
          open_file = 0
      else
          open_file = 0
c
c             get file name
c
3         if ( file_name .eq. '?' ) then
              length = 1
              write( STD_OUT, 4 )
4             format( ' Name of file ? ' )
              if ( .not. next_token( STD_IN, user_resp, TOK_EMPTYOK,
     1                               .FALSE. ) ) goto 6
          else
              user_resp = file_name
              end if
          length = str_length( user_resp )
          if ( length .gt. 0 ) then
              open( UNIT=lun, FILE=user_resp, STATUS=new_old,
     1              ACCESS='sequential', FORM='formatted', ERR=6 )
              open_file = lun
          else if ( new_old .ne. 'old' ) then
              open_file = STD_OUT
              end if
          end if
      return
c
c             TRAPS
c
6     write( STD_OUT, 7 ) user_resp(1:length)
7     format( ' OPEN_FILE : ABORT : Cannot open file ', a )
      open_file = 0
      return
      end



      LOGICAL FUNCTION EQABBR( CSTR, CTEST, MINLEN )
c
c       EQual ABBReviation
c     Tests if the character string CSTR is a legal abbreviation of the
c character string CTEST .
c
c Arguments
c  character cstr*(*),         # operand character string               INPUT
c            ctest*(*)         # test string                            INPUT
c  integer minlen              # minimum number of characters allowed   INPUT
c                              # in the abbreviation
c Variables
c  integer i,       # indexing counter
c          iend     # first letter in a word
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      integer i, iend, minlen
      character cstr*(*), ctest*(*)
c
c         find end of the operand string
c
      iend = len( cstr )
1     if ( iend .gt. 1 .and. cstr(iend:iend) .eq. ' ' ) then
          iend = iend - 1
          goto 1
          end if
c
c         test
c
      if ( iend .gt. len( ctest ) ) then
          eqabbr = .false.
      else
          eqabbr = .true.
          i = 1
2         if ( i .le. iend .and. eqabbr ) then
              eqabbr = eqabbr .and. cstr(i:i) .eq. ctest(i:i)
              i = i + 1
              goto 2
              end if
          eqabbr = eqabbr .and. i .gt. minlen
          end if
      return
      end



c
c         ILGPLOT actions
c

      LOGICAL FUNCTION PLOT_DATA( PROMPT_ENABLE, STREAM_LU,
     1                            COMMAND, MANUAL_SCALE, DATA_ARRAY )
c
c         handles plotting for 'Data' commands
c
c Arguments
c  character command*1        # command character 'd', '>' or '<'
c  integer stream_lu          # logical unit of command stream
c  logical prompt_enable      # INPUT  # prompts to screen enabled
c          manual_scale       # IN/OUT # no explicit scaling by ilgdata
c  real    data_array(*)
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      integer icolx, icoly, irowinc, irowstrt, stream_lu, ncols, New,
     2        Npts, nrows, open_file
      logical done_plot, got_data, manual_scale, prompt_enable, rescale,
     1        echo, get_bool, get_int, next_token, plot_wild
      real    data_array(*)
      character command*1, data_file*64
c
      save ncols, nrows, done_plot, got_data
      data ncols, nrows / 0, 0 /
      data done_plot, got_data / .FALSE., .FALSE. /
c
c
      echo = prompt_enable .and. stream_lu .ne. STD_IN
      if ( command .eq. 'd' ) then                                        1b
          if ( prompt_enable ) write( STD_OUT, 1 )
1         format( ' Data file name ? ' )
          if ( .not. next_token( stream_lu, data_file, TOK_EMPTYOK,
     1        echo ) ) goto 20
c
c                Open data file
c
          if ( data_file .ne. ' ' .and. data_file .ne. '.' .and.
     1         data_file .ne. 'vdu' ) then                                2b
c
c                Open & read formatted data file
c
              if ( open_file( DATA_LU, data_file, 'old' ) .gt. 0 ) then   3b
                  call flush_token()
                  call read_data( DATA_LU, data_array, MAX_DATA,
     1                            nrows, ncols, echo )
                  close( DATA_LU )
              else                                                        3m
                  nrows = 0
                  call ilgwait()
                  end if                                                  3e
          else if ( .not. got_data .or. data_file .eq. 'vdu' ) then       2m
              if ( prompt_enable ) write( STD_OUT, 3 )
3             format( ' Enter the (x,y) coordinates ',
     1                '- terminate with ''end''' )
c
c                Read data from keyboard
c
              call flush_token()
              call read_data( stream_lu, data_array, MAX_DATA,
     1                        nrows, ncols, echo )
              end if                                                      2e
          got_data = nrows .gt. 0 .and. ncols .ge. 2
          if ( got_data ) then                                            2b
c
c                 Get plotting parameters
c
              if ( ncols .eq. 2 ) then                                    3b
                  icolx = 1
                  icoly = 2
              else                                                        3m
                  if ( prompt_enable ) write( STD_OUT, 4 )
4                 format( ' Which column is the abscissa ? ' )
                  if ( .not. get_int( stream_lu, icolx,
     1                                1, ncols, echo ) ) goto 20
                  if ( prompt_enable ) write( STD_OUT, 5 )
5                 format( ' Which column is the ordinate ? ' )
                  if ( .not. get_int( stream_lu, icoly,
     1                                1, ncols, echo ) ) goto 20
                  end if                                                  3e
c
              if ( prompt_enable ) write( STD_OUT, 6 )
6             format( ' Starting point index ? ' )
              if ( .not. get_int( stream_lu, irowstrt,
     1                            1, nrows, echo ) ) goto 20
              if ( prompt_enable ) write( STD_OUT, 7 )
7             format( ' Index increment ? ' )
              if ( .not. get_int( stream_lu, irowinc, irowstrt - nrows,
     1                            nrows - irowstrt, echo ) ) goto 20
              if ( irowinc .eq. 0 )
     1            irowinc = 1
              if ( prompt_enable ) write( STD_OUT, 8 )
8             format( ' Number of points to plot ? ' )
              if ( .not. get_int( stream_lu, Npts, 1,
     1                ( nrows - irowstrt ) / abs( irowinc ) + 1,
     2                echo ) ) goto 20
              if ( .not. get_bool( prompt_enable, stream_lu,
     1                rescale, 'Rescale & New graph (y/n) ' ) ) goto 20
              New = 0
              if ( rescale ) New = 1
c
c                 Plot line
c
              if ( irowinc .gt. 0 .or.  ( icolx .lt. ncols .and.          3b
     1             icoly .lt. ncols .and. ncols .ge. 4 .and.
     2             abs( icoly - icolx ) .gt. 1 ) ) then
                  call ilgdata(
     1                data_array( icolx + ( irowstrt - 1 ) * ncols ),
     2                data_array( icoly + ( irowstrt -1 ) * ncols ),
     3                irowinc * ncols, npts, new )
                  done_plot = .true.
                  if ( new .ne. 0 )
     1                manual_scale = .false.
              else                                                        3m
                  write( STD_ERR, 9 )
9                 format( ' Constraints for error bars' /
     1                '  1) need 4 or more columns' /
     2                '  2) cannot plot last column' /
     3                '  3) abscissa & ordinate columns are separated' /
     4                '     by at least one other column' )
                  call ilgwait
                  end if                                                  3e
              end if                                                      2e
c*
c*                redraw
c*
      else if ( command .eq. '<' ) then                                   1m
          if ( done_plot ) then                                           2b
              new = 1
              if ( manual_scale ) new = 0
              call ilgdata(
     1            data_array( icolx + ( irowstrt - 1 ) * ncols ),
     2            data_array( icoly + ( irowstrt - 1 ) * ncols ),
     3            irowinc * ncols, npts, new )
              end if                                                      2e
c*
c*                zoom
c*
      else if ( command .eq. '>' ) then                                   1m
          if ( done_plot ) then                                           2b
              if ( .not. plot_wild( prompt_enable, stream_lu ) ) goto 20
              call ilgimit( 0.0, 0.0, 0.0, 0.0 )
              call ilgdata(
     1            data_array( icolx + ( irowstrt - 1 ) * ncols ),
     2            data_array( icoly + ( irowstrt - 1 ) * ncols ),
     3            irowinc * ncols, npts, 0 )
              end if                                                      2e
          end if                                                          1e
c
c         normal return
c
      plot_data = .TRUE.
      return
c
c         signal end of command file
c
20    plot_data = .FALSE.
      return
      end



      LOGICAL FUNCTION PLOT_WILD( PROMPT_ENABLE, STREAM_LU )
c
c         handles 'Wild' commands
c
c Arguments
c  integer stream_lu          # logical unit of command stream
c  logical prompt_enable      # INPUT  # prompts to screen enabled
c
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      integer stream_lu
      logical prompt_enable, echo, get_real, next_token
      character units*2
      real xmin, xmax, ymin, ymax
c
      echo = prompt_enable .and. stream_lu .ne. STD_IN
      plot_wild = .FALSE.
      if ( prompt_enable ) write( STD_OUT, 1 )
1     format( ' Units ? ' )
      if ( next_token( stream_lu, units, TOK_NOBLANK, echo ) ) then       1b
        if ( units .ne. 'xx' .and. units .ne. 'XX' .and.
     1       units .ne. 'zz' .and. units .ne. 'ZZ' ) then                 2b
          if ( prompt_enable ) write( STD_OUT, 3 )
3         format( ' Lower Left coordinate (X,Y)min ? ' )
          if ( get_real( stream_lu,
     1          xmin, -R_INFTY, R_INFTY, echo ) ) then                    3b
            if ( get_real( stream_lu,
     1            ymin, -R_INFTY, R_INFTY, echo ) ) then                  4b
              if ( prompt_enable ) write( STD_OUT, 4 )
4             format( ' Upper Right coordinate (X,Y)max ? ' )
              if ( get_real( stream_lu,
     1                       xmax, -R_INFTY, R_INFTY, echo ) ) then       5b
                if ( get_real( stream_lu,
     1                         ymax, -R_INFTY, R_INFTY, echo )  ) then    6b
                  call ilgwild( units, xmin, ymin, xmax, ymax )
                  plot_wild = .TRUE.
                  end if                                                  6e
                end if                                                    5e
              end if                                                      4e
            end if                                                        3e
        else                                                              2m
          call ilgwild( units, xmin, ymin, xmax,ymax )
          plot_wild = .TRUE.
          if ( units .eq. 'zz' .or. units .eq. 'ZZ' ) then                3b
            write( STD_OUT, 5 ) xmin, ymin, xmax, ymax
5           format( ' Lower left  ( ', g13.5, ', ', g13.6, ' )' /
     1              ' Upper right ( ', g13.6, ', ', g13.6, ' )' )
            call ilgwait
            end if                                                        3e
          end if                                                          2e
        end if                                                            1e
      return
      end



      LOGICAL FUNCTION PLOT_VECTOR( PROMPT_ENABLE, STREAM_LU )
c
c         handles 'Vector' commands
c
c Arguments
c  logical prompt_enable     # INPUT  # prompts to screen enabled
c  integer stream_lu         # logical unit of command stream
c
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      integer stream_lu
      logical prompt_enable, echo, get_real
      real xscale, yscale, arrow_head, arrow_aspect
c
      echo = prompt_enable .and. stream_lu .ne. STD_IN
      plot_vector = .FALSE.
      if ( prompt_enable ) write( STD_OUT, 1 )
1     format( ' (x,y) Vector scale factors ? ' )
      if ( get_real( stream_lu, xscale, -R_INFTY, R_INFTY, echo ) ) then  1b
        if ( get_real( stream_lu,
     1                 yscale, -R_INFTY, R_INFTY, echo ) ) then           2b
          if ( prompt_enable ) write( STD_OUT, 2 )
2         format( ' Arrowhead length & aspect ratio ? ' )
          if ( get_real( stream_lu,
     1                   arrow_head, -R_INFTY, R_INFTY, echo ) ) then     3b
            if ( get_real( stream_lu, arrow_aspect,
     1                     -R_INFTY, R_INFTY, echo ) ) then               4b
              call ilgvect( xscale, yscale, arrow_head, arrow_aspect )
              plot_vector = .TRUE.
              end if                                                      4e
            end if                                                        3e
          end if                                                          2e
        end if                                                            1e
      return
      end



      LOGICAL FUNCTION PLOT_LABEL( PROMPT_ENABLE, STREAM_LU,
     1                             PROMPT_STRING, ILGLABEL )
c
c         handles Note, Title, X-axis-label and Y-axis-label commands
c
c Arguments
c  integer stream_lu         # logical unit of command stream
c  logical prompt_enable      # INPUT  # prompts to screen enabled
c  character prompt_string*(*)# INPUT  # label to be written
c  subroutine ilglabel        # INPUT  # name of ilglib label routine
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      integer stream_lu
      logical prompt_enable, next_token
      character prompt_string*(*), label*128
      external ilglabel
c
      plot_label = .FALSE.
      if ( prompt_enable ) write( STD_OUT, 1 ) prompt_string
1     format( 1x, a )
      if ( next_token( stream_lu, label, TOK_TO_EOL,
     1        prompt_enable .and. stream_lu .ne. STD_IN ) ) then
          plot_label = .TRUE.
          call ilglabel( label )
          end if
      return
      end



      LOGICAL FUNCTION PLOT_OPEN( PROMPT_ENABLE, STREAM_LU, DEVICE )
c
c         handles Open command
c
c Arguments
c  integer stream_lu          # INPUT  # logical unit of command stream
c  logical prompt_enable      # INPUT  # prompts to screen enabled
c  integer device             # INPUT  # specifies graphics device
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'f77_g.con'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'f77_g.con'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
      logical prompt_enable, next_token
      integer device, stream_lu, file_len, str_length
      character output_file*32
c
      plot_open = .FALSE.
      if ( prompt_enable ) write( STD_OUT, 1 )
1     format( ' Graphics output file name ? ' )
      if ( next_token( stream_lu, output_file, TOK_EMPTYOK,
     1        prompt_enable .and. stream_lu .ne. STD_IN  ) ) then
          if ( output_file .eq. 'vdu' .or.
     1         device .eq. VISUAL500_TERMINAL .or.
     2         device .eq. VISUAL550_TERMINAL .or.
     3         device .eq. HERCULES_GRAPHICS  .or.
     4         device .eq. SUN_3_WORKSTATION  .or.
     5         device .eq. XTERM_VT100TEK4014 ) output_file = ' '
          file_len = max( str_length( output_file ), 1 )
          call ilgopen( output_file(1:file_len) )
          plot_open = .TRUE.
          end if
      return
      end



      LOGICAL FUNCTION PLOT_SCALE( PROMPT_ENABLE, STREAM_LU )
c
c         handles Scale command
c
c Arguments
c  integer stream_lu         # logical unit of command stream
c  logical prompt_enable      # INPUT  # prompts to screen enabled
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      integer stream_lu
      logical prompt_enable, echo, next_token
      character x_scale*3, y_scale*3
c
      plot_scale = .FALSE.
      echo = prompt_enable .and. stream_lu .ne. STD_IN
      if ( prompt_enable ) write( STD_OUT, 1 )
1     format( ' X scaling law ? ' )
      if ( next_token( stream_lu, x_scale, TOK_NOBLANK, echo ) ) then
          if ( prompt_enable ) write( STD_OUT, 2 )
2         format( ' Y scaling law ? ' )
          if ( next_token( stream_lu, y_scale, TOK_NOBLANK, echo )) then
              call ilgslaw( x_scale, y_scale )
              plot_scale = .TRUE.
              end if
          end if
      return
      end



      LOGICAL FUNCTION PLOT_READ( PROMPT_ENABLE, STREAM_LU )
c
c         handles "Read" command
c
c  integer stream_lu         # logical unit of command stream
c  logical prompt_enable      # INPUT  # prompts to screen enabled
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      logical close_op, prompt_enable, get_bool, ilgread, next_token
      integer count, ncurve, out_lu, start_index, stream_lu, open_file
      real    xx, yy
      character char*1, out_file*64
c
      save out_lu
      data out_lu / STD_OUT /
c
c           open file
c
      plot_read = .FALSE.
      if ( out_lu .eq. STD_OUT ) then                                     1b
          ncurve  = 0
          start_index = 1
          if ( prompt_enable) write( STD_OUT, 1 )
1         format( ' Output file name ? ' )
          if ( .not. next_token( stream_lu, out_file, TOK_EMPTYOK,
     1            prompt_enable .and. stream_lu .ne. STD_IN ) ) return
          if ( out_file .eq. 'vdu' ) out_file = ' '
          out_lu = open_file( DATA_LU, out_file, 'new' )
          end if                                                          1e
c
c           read data
c
      if ( out_lu .gt. 0 ) then                                           1b
          write( STD_OUT, 2 )
2         format( ' Terminate with ''X''' )
          count = 0
3         if ( ilgread( xx, yy, char ) ) then                             2b
              write( out_lu, 4 ) xx, yy, char
4             format( 1x, 2g15.7, 1x, a1 )
              count = count + 1
              goto 3
              end if                                                      2e
c
c           documentation
c
          if ( count .gt. 0 ) then                                        2b
              ncurve  = ncurve + 1
              if ( out_lu .eq. DATA_LU )
     1            write( out_lu, 5 ) ncurve, start_index, count
5                 format( / ' ; curve number ', i3 /
     1              ' ; starting point = ', i5 /
     2              ' ; ', i5, ' points' )
              write( STD_OUT, 5 ) ncurve, start_index, count
              write( STD_OUT, 6 )
6             format( ' Press <RETURN> to continue' )
              read( STD_IN, 7 )
7             format()
              start_index = start_index + count
              end if                                                      2e
c
c           close file
c
          if ( out_lu .ne. STD_OUT ) then                                 2b
              if ( .not. get_bool( prompt_enable, stream_lu,
     1                close_op , 'Close output file ? ' ) ) return
              if ( close_op ) then                                        3b
                  close( UNIT=out_lu )
                  out_lu = 0
                  end if                                                  3e
              end if                                                      2e
          end if                                                          1e
      plot_read = .TRUE.
      return
      end



      LOGICAL FUNCTION PLOT_2_PARAMS( PROMPT_ENABLE, STREAM_LU,
     1                            PROMPT_STRING, ILG_ROUTINE )
c
c         handles 'oFfset', 'Zsize' commands with 2 real parameters
c
c Arguments
c  logical prompt_enable      # INPUT  # prompts to screen enabled
c  integer stream_lu         # INPUT  # logical unit of command stream
c  character prompt_string*(*)# INPUT  # prompt string
c  subroutine ilg_routine     # INPUT  # routine to be executed
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      integer stream_lu
      logical prompt_enable, echo, get_real
      real param1, param2
      character prompt_string*(*)
      external ilg_routine
c
      plot_2_params = .FALSE.
      echo = prompt_enable .and. stream_lu .ne. STD_IN
      if ( prompt_enable ) write( STD_OUT, 1 ) prompt_string
1     format( ' ', a, ' ' )
      if ( get_real( stream_lu, param1, -R_INFTY, R_INFTY, echo ) ) then  1b
          if ( get_real( stream_lu, param2, -R_INFTY, R_INFTY,
     1                   echo )  ) then                                   2b
          call ilg_routine( param1, param2 )
          plot_2_params = .TRUE.
          end if                                                          2e
        end if                                                            1e
      return
      end



      LOGICAL FUNCTION PLOT_GRAPH( PROMPT_ENABLE, STREAM_LU )
c
c         handles 'Graph' commands
c
c Arguments
c  logical prompt_enable      # INPUT  # prompts to screen enabled
c  integer stream_lu         # INPUT  # logical unit of command stream
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      integer stream_lu, x_locn, y_locn, x_axis, y_axis, border
      logical echo, prompt_enable, get_int
c
      plot_graph = .FALSE.
      echo = prompt_enable .and. stream_lu .ne. STD_IN
      if ( prompt_enable ) write( STD_OUT, 1 )
1     format( ' X & Y cell position ( from top left ) ? ' )
      if ( get_int( stream_lu, x_locn, -I_INFTY, I_INFTY, echo ) ) then   1b
        if ( get_int( stream_lu,
     1                y_locn, -I_INFTY, I_INFTY, echo ) ) then            2b
          if ( prompt_enable ) write( STD_OUT, 2 )
2         format( ' X & Y axis type ? ' )
          if ( get_int( stream_lu,
     1                  x_axis, -I_INFTY, I_INFTY, echo ) ) then          3b
            if ( get_int( stream_lu,
     1                    y_axis, -I_INFTY, I_INFTY, echo ) ) then        4b
              if ( prompt_enable ) write( STD_OUT, 3 )
3             format( ' Border type ? ' )
              if ( get_int( stream_lu,
     1                      border, -I_INFTY, I_INFTY, echo ) ) then      5b
                call ilgraph( x_locn, y_locn, x_axis, y_axis, border )
                plot_graph = .TRUE.
                end if                                                    5e
              end if                                                      4e
            end if                                                        3e
          end if                                                          2e
        end if                                                            1e
      return
      end



      LOGICAL FUNCTION PLOT_HELP( HELP_FILE )
c
c     Implementation of help facility . The information is read from
c     the help file ILG.HLP . ILG.HLP is a sequential access ASCII file
c     with the items arranged in alphabetical order . Each item begins
c     with ##? where ? is the key letter . Each item ends with $$ .
c     A line containing only #wait calls the ILGWAIT routine .
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      integer cmd_index, open_file, prev_index, str_length
      logical file_open, plot_command
      character help_file*(*), command*1, reqd_label*3, label*3,
     1          string*128
c
      save prev_index, file_open
      data prev_index / 9999   /
      data file_open / .FALSE. /
c
      plot_help = .TRUE.
1     continue                                                            1b
          write( STD_OUT, 2 )
2         format( / '   ILGPLOT HELP --- Press "q <RET>" to escape. ' )
          if ( .not. plot_command( .TRUE., STD_IN, command ) )  then      2b
              plot_help = .FALSE.
              return
              end if                                                      2e
          if ( command .eq. 'q' ) return
          cmd_index = index( 'bcdefghiklmnoprstvwxyz<>', command )
          if ( cmd_index .gt. 0 ) then                                    2b
c
c                   open or rewind file
c
              if ( .not. file_open ) then                                 3b
                  if ( open_file( HELP_LU, help_file, 'old' ) .le. 0 )
     1                    then                                            4b
                      call ilgwait()
                      return
                      end if                                              4e
                  file_open = .TRUE.
              else if ( cmd_index .le. prev_index ) then                  3m
                  rewind( HELP_LU )
                  end if                                                  3e
c
c                 search for required label
c
              reqd_label = '##' // command
c             read labels until a match occurs                            3b
3                 read( HELP_LU, 4, END=7 ) label
4                 format( a )
                  if ( label .ne. reqd_label ) goto 3
c                 end of loop                                             3e
c
c                 display message
c
c             read and print file records until a $$ terminator is found  3b
5                 read( HELP_LU, 4, END=7) string
                  if ( string(1:5) .eq. '#wait' ) then                    4b
                      call ilgwait
                      goto 5
                  else if ( string(1:2) .ne. '$$' ) then                  4m
                      write( STD_OUT, 6 )
     1                    string( 1 : max( 1, str_length( string ) ) )
6                     format( 1x, a )
                      goto 5
                      end if                                              4e
c                 end of loop                                             3e
              prev_index = cmd_index
              end if                                                      2e
          goto 1
c         end of loop                                                     1e
c
c             End of help file
c
7     write( STD_OUT, 8 )
8     format( ' ILGPLOT : Bug : End of help file' /
     1        ' Press <RETURN> to continue' )
      read( STD_IN, 9 )
9     format()
      return
      end


      LOGICAL FUNCTION PLOT_COMMAND( PROMPT_ENABLE, COMMAND_LU,
     1                               COMMAND )
c
c         plot command menu
c
c Arguments
c  logical prompt_enable      # INPUT  # prompts to screen enabled
c  integer command_lu         # INPUT  # logical unit of command stream
c  character command*1        # OUTPUT # received command
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      logical echo, prompt_enable, next_token
      integer command_lu, extend_menu
      character command*1
c
      plot_command = .FALSE.
      echo = prompt_enable .and. command_lu .ne. STD_IN
      if ( prompt_enable ) then                                           1b
          write( STD_OUT, 1 )
1         format( ' Select routine : ',
     1           'Help Data liMit Exit +more' /
     2      18x, 'Open Page Graph Line Close' /
     3      18x, 'Xlab Ylab Title Note Scale ' )
          if ( extend_menu .gt. 1 ) then                                  2b
              write( STD_OUT, 2 )
2             format( 18x, 'Wild Read Zsize oFfset' /
     1                18x, 'Back Klip Invis Vector' /
     2                18x, '*see      >zoom <redraw ')
              extend_menu = extend_menu - 1
              end if                                                      2e
          end if                                                          1e
      if ( next_token( command_lu, command, TOK_EMPTYOK, echo ) ) then    1b
3         format( a )
          if ( command .eq. '+' .or.
     1         command .eq. ' ' .and. extend_menu .eq. 0 ) then           2b
              if ( prompt_enable )
     1            write( STD_OUT, 2 )
              if ( .not. next_token( command_lu, command, TOK_NOBLANK,
     1                               echo ) ) goto 4
              extend_menu = 3
              end if                                                      2e
          call Casech( command, 'l' )
          if ( index( 'abfikrwvz<>*', command ) .gt. 0 )
     1        extend_menu = 3
          plot_command = .TRUE.
          end if                                                          1e
c
4     return
      end



      LOGICAL FUNCTION PLOT_LINE( PROMPT_ENABLE, STREAM_LU )
c
c         handles 'Line' commands
c
c Arguments
c  logical prompt_enable      # INPUT  # prompts to screen enabled
c  integer stream_lu         # INPUT  # logical unit of command stream
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      integer stream_lu, symbol, style, colour
      logical echo, prompt_enable, get_int
c
      plot_line = .FALSE.
      echo = prompt_enable .and. stream_lu .ne. STD_IN
      if ( prompt_enable ) write( STD_OUT, 1 )
1     format( ' Symbol type, Dashed line type, Pen number ? ' )
      if ( get_int( stream_lu, symbol, -I_INFTY, I_INFTY, echo )  ) then  1b
        if ( get_int( stream_lu, style, -I_INFTY, I_INFTY,
     1                echo )  ) then                                      2b
          if ( get_int( stream_lu, colour, -I_INFTY, I_INFTY,
     1                  echo )  ) then                                    3b
            call ilgline( symbol, style, colour )
            plot_line = .TRUE.
            end if                                                        3e
          end if                                                          2e
        end if                                                            1e
      return
      end



      LOGICAL FUNCTION PLOT_LIMIT( PROMPT_ENABLE, STREAM_LU,
     1                             USE_PREVIOUS )
c
c         handles 'Mlimit' commands
c
c Arguments
c  logical prompt_enable      # INPUT  # prompts to screen enabled
c  integer stream_lu          # INPUT  # logical unit of command stream
c  logical use_previous       # INPUT  # use previous limits, not new ones
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      integer stream_lu
      logical echo, prompt_enable, use_previous, get_real
      real xmin, ymin, xmax, ymax
c
      save xmin, ymin, xmax, ymax
c
      plot_limit = .TRUE.
      if ( use_previous ) then                                            1b
              call ilgimit( xmin, ymin, xmax, ymax )
      else                                                                1m
          plot_limit = .FALSE.
          echo = prompt_enable .and. stream_lu .ne. STD_IN
          if ( prompt_enable ) write( STD_OUT, 1 )
1         format( ' Lower Left coordinate (X,Y)min ? ' )
          if ( get_real( stream_lu,
     1           xmin, -R_INFTY, R_INFTY, echo ) ) then                   2b
            if ( get_real( stream_lu,
     1                     ymin, -R_INFTY, R_INFTY, echo ) ) then         3b
              if ( prompt_enable ) write( STD_OUT, 2 )
2             format( ' Upper Right coordinate (X,Y)max ? ' )
              if ( get_real( stream_lu,
     1                       xmax, -R_INFTY, R_INFTY, echo ) ) then       4b
                if ( get_real( stream_lu,
     1                         ymax, -R_INFTY, R_INFTY, echo ) ) then     5b
                  call ilgimit( xmin, ymin, xmax, ymax )
                  plot_limit = .TRUE.
                  end if                                                  5e
                end if                                                    4e
              end if                                                      3e
            end if                                                        2e
          end if                                                          1e
      return
      end



      LOGICAL FUNCTION PLOT_PAGE( PROMPT_ENABLE, STREAM_LU )
c
c         handles 'Page' commands
c
c Arguments
c  logical prompt_enable     # INPUT  # prompts to screen enabled
c  integer stream_lu         # INPUT  # logical unit of command stream
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      integer stream_lu, x_cells, y_cells
      logical echo, prompt_enable, get_int, next_token
      character paper*2, orientation*4
c
      plot_page = .FALSE.
      echo = prompt_enable .and. stream_lu .ne. STD_IN
      if ( prompt_enable ) write( STD_OUT, 1 )
1     format( ' Paper size ? ' )
      if ( next_token( stream_lu, paper, TOK_NOBLANK, echo ) ) then       1b
        if ( prompt_enable ) write( STD_OUT, 3 )
3       format( ' Orientation ? ' )
        if ( next_token( stream_lu,
     1                   orientation, TOK_NOBLANK, echo ) ) then          2b
          if ( prompt_enable )  write( STD_OUT, 4 )
4         format( ' Number of plot cells on page -width & height ?' )
          if ( get_int( stream_lu,
     1                  x_cells, -I_INFTY, I_INFTY, echo ) ) then         3b
            if ( get_int( stream_lu,
     1                    y_cells, -I_INFTY, I_INFTY, echo ) ) then       4b
              call ilgpage( paper, orientation, x_cells, y_cells )
              plot_page = .TRUE.
              end if                                                      4e
            end if                                                        3e
          end if                                                          2e
        end if                                                            1e
      return
      end



      INTEGER FUNCTION ILG_ROUTINES( PROMPT_ENABLE, COMMAND_LU,
     1    DATA_ARRAY, HELP_FILE, DEVICE, BOLDFACE, CR_WAIT )
c
c         Reads commands from command stream and calls the appropriate
c         'PLOT_****' routines which read the required parameters and
c         call the ilglib routines
c
c Arguments
c  logical   prompt_enable    # INPUT  # prompts to screen enabled
c  integer   command_lu       # INPUT  # logical unit of command stream
c  real      data_array(*)    # INPUT  # (address) of data array
c  character help_file*(*)    # INPUT  # name of help file
c  integer   device           # INPUT  # specifies graphics device
c  logical   boldface         # INPUT  # .TRUE. for boldface
c  integer   cr_wait          # INPUT  # wait for <CR> after each routine
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'f77_g.con'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'f77_g.con'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      logical boldface, clipping, manual_scale, not_eof, page_empty,
     1        prompt_enable, ok, no_command,
     2        get_bool, plot_command, plot_data, plot_graph, plot_help,
     3        plot_label, plot_limit, plot_line, plot_page, plot_read,
     4        plot_scale, plot_vector, plot_wild, plot_2_params,
     5        plot_open, tf_txtset
      integer command_lu, device, cr_wait
      real    data_array(*)
      character command*1, help_file*(*)
      external ilgchar, ilgfset, ilgnote, ilgtitl, ilgxlab, ilgylab
c
c
      not_eof = .TRUE.
      if ( prompt_enable ) call new_scr( 0 )
c
c               Main get / execute routine loop
c
1     if ( not_eof ) then                                                 1b
          not_eof = plot_command( prompt_enable, command_lu, command )
          if ( not_eof ) then                                             2b
c
c             return to command level -- not end of command file
              no_command = .FALSE.
              if ( command .eq. 'b' ) then                                3b
                  ilg_routines = YES
                  return
c
c             Close
              else if ( command .eq. 'c' ) then                           3m
                  call ilgclos
c
c             Plot data
              else if ( command .eq. 'd' ) then                           3m
                  not_eof = plot_data( prompt_enable, command_lu,
     1                command, manual_scale, data_array )
c
c             oFfset
              else if ( command .eq. 'f' ) then                           3m
                  not_eof = plot_2_params( prompt_enable, command_lu,
     1                '(x,y) offset (user units) ?', ilgfset )
c
c             Graph
              else if ( command .eq. 'g' ) then                           3m
                  not_eof = plot_graph( prompt_enable, command_lu )
c
c             Help
              else if ( ( command .eq. 'h' .or. command .eq. '?' ) .and.
     1                  prompt_enable ) then                              3m
                  not_eof = plot_help( help_file )
c
c             Invisible
              else if ( command .eq. 'i' ) then                           3m
                  call ilginvs
c
c             Klip
              else if ( command .eq. 'k' ) then                           3m
                  not_eof = get_bool( prompt_enable, command_lu,
     1                                clipping, 'clip on ? ' )
                  if ( not_eof ) call ilgclip( clipping )
c
c             Line
              else if ( command .eq. 'l' ) then                           3m
                  not_eof = plot_line( prompt_enable, command_lu )
c
c             Coordinate limits
              else if ( command .eq. 'm' ) then                           3m
                  not_eof = plot_limit( prompt_enable, command_lu,
     1                .FALSE. )
                  manual_scale = not_eof
c
c             Notes
              else if ( command .eq. 'n' )  then                          3m
                  not_eof = plot_label( prompt_enable, command_lu,
     1               'Note string ?', ilgnote )
c
c             Open
              else if ( command .eq. 'o' ) then                           3m
                  not_eof = plot_open( prompt_enable, command_lu,
     1                                 device )
                  if ( boldface ) then
                      ok = tf_txtset( T_CH_BOLD, 0.0, ' ' )
                  else
                      ok = tf_txtset( T_CH_NOBOLD, 0.0, ' ' )
                      end if
                  page_empty = not_eof
                  call ilgerrr( -STD_OUT )
c
c             Page
              else if ( command .eq. 'p' ) then                           3m
                  not_eof = plot_page( prompt_enable, command_lu )
                  page_empty = not_eof
c
c             Read
              else if ( command .eq. 'r' .and. prompt_enable ) then       3m
                  not_eof = plot_read( prompt_enable, command_lu )
c
c             Scaling law
              else if ( command .eq. 's' ) then                           3m
                  not_eof = plot_scale( prompt_enable, command_lu )
c
c             Title
              else if ( command .eq. 't' ) then                           3m
                  not_eof = plot_label( prompt_enable, command_lu,
     1                'Title ?', ilgtitl )
c
c             Vector Enable
              else if ( command .eq. 'v' )  then                          3m
                  not_eof = plot_vector( prompt_enable, command_lu )
c
c             Wild card
              else if ( command .eq. 'w' ) then                           3m
                  not_eof = plot_wild( prompt_enable, command_lu )
c
c             X axis label
              else if ( command .eq. 'x' ) then                           3m
                  not_eof = plot_label( prompt_enable, command_lu,
     1               'X axis label ?', ilgxlab )
c
c             Y axis label
              else if ( command .eq. 'y' ) then                           3m
                  not_eof = plot_label( prompt_enable, command_lu,
     1                'Y axis label ?', ilgylab )
c
c             change character size
              else if ( command .eq. 'z' ) then                           3m
                  not_eof = plot_2_params( prompt_enable, command_lu,
     1                'Character and symbol size factors ?', ilgchar )
c
c             redraw
              else if ( command .eq. '<' ) then                           3m
                  if ( .not. page_empty ) then                            4b
                      if ( manual_scale )
     1                    not_eof = plot_limit( prompt_enable,
     2                        command_lu, .TRUE. )
                      not_eof = plot_data( prompt_enable, command_lu,
     1                    command, manual_scale, data_array )
                      end if                                              4e
c
c             zoom
              else if ( command .eq. '>' ) then                           3m
                  if ( .not. page_empty ) then                            4b
                      not_eof = plot_data( prompt_enable, command_lu,
     1                    command, manual_scale, data_array )
                      end if                                              3e
              else if ( command .eq. '*' ) then                           3m
                  call ilgwait()
c
c             Exit
              else if ( command .eq. 'e' .or. command .eq. 'q' ) then     3m
                  call ilgclos
                  ilg_routines = -1
                  return
c
              else                                                        2m
                  no_command = .TRUE.
                  end if                                                  3e
              end if                                                      2e
c
          if ( .not. no_command ) then                                    2b
              if ( cr_wait .eq. CR_TERM ) then                            3b
                  write( STD_OUT, 2 )
2                 format( ' Press <RETURN> to continue' )
                  read( STD_IN, 3 )
3                 format()
              else if ( cr_wait .eq. CR_GRAF ) then                       3m
                  call ilgwait()
              else if ( cr_wait .eq. CR_BOTH ) then                       3m
                  write( STD_OUT, 2 )
                  read( STD_IN, 3 )
                  call ilgwait()
                  end if                                                  3e
              end if                                                      2e
          if ( prompt_enable ) call new_scr( 0 )
          goto 1
          end if                                                          1e
      ilg_routines = NO
      return
      end



      CHARACTER *8 FUNCTION CENABLED( BOOLEAN )
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      logical boolean
c
      if ( boolean ) then
          cenabled = 'enabled '
      else
          cenabled = 'disabled'
          end if
      return
      end



      SUBROUTINE PLOT_SWITCH( PROG_ARGS, DATA_ARRAY, HELP_FILE )
c
c Control program I/O through switch commands.
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'f77_g.con'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'f77_g.con'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      integer cr_wait, command_lu, device, new_lu, status, terminal,
     1        ilg_routines, lun_stack, open_file, str_length
      logical boldface, execute, first_arg, prompt_enable,
     1        device_args, eqabbr, next_token
      real    data_array(*)
      character prog_args*(*), switch*32, command_file*32,
     1          help_file*(*), old_cmd_file*32, Cenabled*8
c
      save boldface, prompt_enable, execute
      data boldface, prompt_enable, execute /
     1     .FALSE.,  .TRUE.,        .FALSE. /
c
      first_arg  = prog_args .ne.  ' '
      command_lu = STD_IN
      old_cmd_file = ' '
CC--VAX-SunOS-DEC-FORTRAN
      device   = XTERM_VT100TEK4014
CC--MISCROSOFT-FORTRAN-V4:
CC      device = HERCULES_GRAPHICS
      terminal = ANSI_TERMINAL
      cr_wait  = CR_NONE
      call ilgdevi( device, ' ' )
c
c
c       start of main loop
c
1     continue                                                            1b
c
c       exhaust the program arguments before reading the command stream
c
          if ( first_arg ) then                                           2b
              call get_token( prog_args, switch )
              first_arg  = .FALSE.
          else                                                            2m
              if( prompt_enable ) write( STD_OUT, 2 )
2             format( ' Command ? ' )
              if ( .not. next_token( command_lu, switch, TOK_EMPTYOK,
     1            prompt_enable .and. command_lu .ne. STD_IN ) ) goto 10
              end if                                                      2e
          call casech( switch, 'l' )
c
c       STOP / EXIT / QUIT
c
          if ( eqabbr( switch, 'stop', 3 ) .or.
     1         eqabbr( switch, 'exit', 3 ) .or.
     2         eqabbr( switch, 'quit', 1 ) ) then                         2b
              call ilgclos()
              return
c
c       PROMPTS / NOPROMPTS / INTERACTIVE
c
          else if ( eqabbr( switch, 'prompts', 1 ) ) then                 2m
              prompt_enable = .TRUE.
          else if ( eqabbr( switch, 'noprompts', 3 ) ) then               2m
              prompt_enable = .FALSE.
          else if ( eqabbr( switch, 'interactive', 1 ) ) then             2m
              prompt_enable = .TRUE.
              execute = .FALSE.
              if ( command_lu .ne. STD_IN ) then                          3b
                  if ( lun_stack( LUN_PUSH, command_lu ) .gt. 0 )
     1                command_lu = STD_IN
                  end if                                                  3e
              command_file = ' '
c
c       HELP
c
          else if ( eqabbr( switch, 'help', 1 ) ) then                    2m
              write( STD_OUT, 3 )
3             format( / ' Available commands (optional chars in []):' /
     1 '   d[evice]  <device-spec>  -- define graphics device'  /
     2 '   v[t52]  a[nsi]           -- alphanumeric terminal'   /
     3 '   p[rompts]  nop[rompts]   -- (not) prompt for input'  /
     4 '   exe[cute] <command-file> -- take commands from file' /
     5 '   i[nteractive]            -- take commands from user' /
     6 '   re[turn]                 -- to previous input file'  /
     7 '   ro[utine] gr[aphics] go  -- begin plot functions'    /
     8 '   sta[tus]  h[elp]         -- switch status & help'    /
     9 '   b[old]    nob[old]       -- (no) boldface characters'/
     a '   tw[ait] gw[ait] now[ait] -- (tty/gfx/no) wait for CR'/
     b '   exi[t]  q[uit]  sto[p]   -- stop the program'        /
     c '   w[arranty]               -- print warranty'          /
     d '   l[icense]                -- print license'           /
     e '   g[uide]                  -- brief introduction' /
     f ' Commands can be abbreviated.' )
c
c       WAIT FOR <RETURN>
c
          else if ( eqabbr( switch, 'twait', 2 ) ) then                   2m
              if ( cr_wait.eq.CR_NONE .or. cr_wait.eq.CR_TERM ) then      3b
                  cr_wait = CR_TERM
              else                                                        3m
                  cr_wait = CR_BOTH
                  end if                                                  3e
          else if ( eqabbr( switch, 'gwait', 2 ) ) then                   2m
              if ( cr_wait.eq.CR_NONE .or. cr_wait.eq.CR_GRAF ) then      3b
                  cr_wait = CR_GRAF
              else                                                        3m
                  cr_wait = CR_BOTH
                  end if                                                  3e
          else if ( eqabbr( switch, 'nowait', 3 ) ) then                  2m
              cr_wait = CR_NONE
c
c       STATUS
c
          else if ( eqabbr( switch, 'status', 3 ) ) then                  2m
              write( STD_OUT, 4 ) Cenabled( prompt_enable ),
     1            Cenabled( execute ), Cenabled( boldface ),
     2            lun_stack( LUN_INDEX, 0 )
4             format( ' Prompts        ', a /
     1                ' File execution ', a /
     2                ' Boldface       ', a /
     3                ' File stack index  ', i3 )
c
c       EXECUTE new command stream
c
          else if ( eqabbr( switch, 'execute', 3 ) ) then                 2m
              if ( prompt_enable ) write( STD_OUT, 5 )
5             format( ' Command file name ? ' )
              if ( .not. next_token( command_lu, command_file,
     1                TOK_EMPTYOK, prompt_enable .and.
     2                command_lu .ne. STD_IN ) ) goto 10
              if ( command_file .eq. '.' )
     1            command_file = old_cmd_file
              if ( str_length( command_file ) .gt. 0 ) then               3b
                  new_lu = lun_stack( LUN_PUSH, command_lu )
                  if ( new_lu .gt. 0 ) new_lu =
     1                    open_file( new_lu, command_file, 'old' )
                  if ( new_lu .gt. 0 ) then                               4b
                      command_lu = new_lu
                      old_cmd_file = command_file
                      execute = .TRUE.
                      prompt_enable = .FALSE.
                  else                                                    4m
                      call ilgwait()
                      end if                                              4e
                  end if                                                  3e
          else if ( eqabbr( switch, 'return', 2 ) ) then                  2m
              goto 10
          else if ( eqabbr( switch, 'routine', 2 ) .or.
     1              eqabbr( switch, 'graphics', 2 ) .or.
     2              switch .eq. 'go' .or. switch .eq. ' ' ) then          2m
              call ilgerrr( -STD_OUT )
              call new_scr( terminal )
              status = ilg_routines( prompt_enable, command_lu,
     1            data_array, help_file, device, boldface, cr_wait )
              if ( status .eq. NO ) goto 10
              if ( status .eq. -1 ) return
c
          else if ( eqabbr( switch, 'device', 1 ) ) then                  2m
              if ( .not. device_args( command_lu,
     1            command_lu .ne. STD_IN .and. prompt_enable,
     2            device, terminal ) ) goto 10
c
c       boldface/non-boldface character font
c
          else if ( eqabbr( switch, 'bold', 1 ) ) then                    2m
              boldface = .TRUE.
          else if ( eqabbr( switch, 'nobold', 3 ) ) then                  2m
              boldface = .FALSE.
          else if ( eqabbr( switch, 'vt52', 1 ) ) then                    2m
              terminal = VISUAL500_TERMINAL
          else if ( eqabbr( switch, 'ansi', 1 ) ) then                    2m
              terminal = ANSI_TERMINAL
c
c       PRINT WARRANTY
c
          else if ( eqabbr( switch, 'warranty', 1 ) ) then                2m
              write( STD_OUT, 7 )
7             format(
     1 'This program is distributed in the hope that it will be' /
     2 'useful, but WITHOUT ANY WARRANTY; without even the implied' /
     3 'warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR' /
     4 'PURPOSE.  See the GNU General Public License for more details.')
c
c       PRINT LICENSE
c
          else if ( eqabbr( switch, 'license', 1 ) ) then                 2m
              write( STD_OUT, 8 )
8             format(
     1 'This program is free software; you can redistribute it and/or' /
     2 'modify it under the terms of the GNU General Public License' /
     3 'as published by the Free Software Foundation; either' /
     4 'version 1, or (at your option) any later version.' //
     5 'You should have received a copy of the GNU General Public' /
     6 'License along with this program; if not, write to the Free' /
     7 'Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,',
     8 'USA.' )
c
c       INTRODUCTORY GUIDE
c
          else if ( eqabbr( switch, 'guide', 2 ) ) then                   2m
              write( STD_OUT, 9 )
9             format(
     1 'ILGPLOT plots data as rectangular, two-dimensional coordinates'/
     2 'A variety of switches is available at the top-level "command"' /
     3 'prompt.  Plotting functions are available from a menu via the' /
     4 '"routine", "graphics", "go" or <RETURN> command.  Plotting'    /
     5 'functions are selected by typing the CAPITAL letter in the'    /
     6 'corresponding menu item.  Words and numbers entered as input'  /
     7 'must be separated by a <SPACE> or <RETURN>.  Anything which'  /
     8 'follows and is on the same line as a file name is ignored.' /
     9 'Command-line arguments are exhausted before waiting for input.'/
     a 'Try "ilgplot device ps execute example.ilg".' )
c
          else if ( switch .ne. ';' ) then                                2m
              write( STD_OUT, 6 )
     1            switch( 1 : max( 1, str_length( switch ) ) )
6             format( ' ILGPLOT : illegal command ', a )
              write( STD_OUT, 3 )
              end if                                                      2e
          goto 1
c
c             End of file trap
c
10    write( STD_OUT, 11 )
11    format( ' ILGPLOT : Return / End of file' )
      if ( command_lu .eq. STD_IN .and.
     1        lun_stack( LUN_INDEX, 0 ) .le. 0 ) then                     1b
          call ilgclos()
          return
          end if                                                          1e
      if ( command_lu .ne. STD_IN )
     1    close( UNIT=command_lu )
      command_lu = lun_stack( LUN_POP, 0 )
      if ( command_lu .eq. STD_IN ) then                                  1b
          prompt_enable = .TRUE.
          execute = .FALSE.
      else                                                                1m
          prompt_enable = .FALSE.
          execute = .TRUE.
          end if                                                          1e
      goto 1
      end



      SUBROUTINE NEW_SCR( DEVICE )
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'f77_g.con'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'f77_g.con'
c
      integer    ESCAPE
      parameter( ESCAPE=27 )
      integer device, alph_num_term
      save alph_num_term
      data alph_num_term / -1 /
c
      if ( alph_num_term .eq. -1 ) alph_num_term = device
      if ( alph_num_term .eq. VISUAL500_TERMINAL ) then
          write( STD_OUT, 1 ) char( ESCAPE )
1         format( 1x, a1, 'w' )
      else
          write( STD_OUT, 2 ) char( ESCAPE ), char( ESCAPE )
2         format( 1x, a1, '[2J', a1, '[H' )
          end if
      return
      end



      LOGICAL FUNCTION DEVICE_ARGS( STREAM_LU, ECHO,
     1                              DEVICE, TERMINAL )
c
c Determines from the input stream the graphics device to be used, whether or
c not boldface characters are drawn and the nonstandard options for the device
c driver. If the first token in the input stream is a (, [, { or " delimiter
c the input stream is consumed until a ), ], } or " delimiter is found. Any
c non-delimiter token which is not listed below is copied directly into the
c OPTIONS string for the device driver.
c
c Arguments
c  integer   stream_lu      # INPUT  # logical unit no. of input stream
c  logical   echo           # INPUT  # .TRUE. if echo is required
c  integer   device         # OUTPUT # specifies the graphics device
c            terminal       # OUTPUT # type of alphanumeric terminal
c
c Program arguments parsed by this routine
c
c    help
c    vt52 ansi
c    v500 v550 xterm sun3 ps dummy hpgl hp7440 hp7470 hp7475 hp7550
c    hp7580 hp7585
c
c    Alphanumeric terminal
c  vt52           VT52 (i.e. visual 500)
c  ansi [default] uses ANSI clear screen sequence
c                    (visual 550, vt100, sun, personal computer)
c                 selection of a screen graphics device automatically
c                 implies an alphanumeric terminal type
c
c    Graphics device
c  v500           Visual 500 terminal
c  v550 [default] Visual 550 terminal
c  xterm          xterm - tektronics 4014 emulation
c  sun3           Sun 3 workstation running suntools
c  ps             standard PostScript (for LaserWriter)
c  dummy          dummy graphics device
c  hpgl           Hewlett-Packard 7470A plotter
c  hpNNNN         Hewlett-Packard plotter. NNNN is 7470, 7475, 7550 or 7580
c                 representing the various types of plotter .
c
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'f77_g.con'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'f77_g.con'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      integer device, stream_lu, str_len, terminal, str_length
      logical appended, delimiter, echo, next_token, str_append
      character token*32, options*128
c
      options  = ' '
      device_args = .TRUE.
      appended = .TRUE.
      delimiter = .FALSE.
c
c
c     start of loop
1     if ( next_token( stream_lu, token, TOK_NOBLANK, echo ) ) then       1b
          call casech( token, 'l' )
c
c       opening delimiter
c
          if ( token .eq. '(' .or. token .eq. '[' .or.
     1         token .eq. '{' .or. token .eq. '"' ) then                  2b
              delimiter = .TRUE.
c
c       closing delimiter
c
          else if ( token .eq. ')' .or. token .eq. ']' .or.
     1              token .eq. '}' .or. token .eq. '"' ) then             2m
              delimiter = .FALSE.
c
c       alphanumeric terminal
c
          else if ( token .eq. 'vt52' ) then                              2m
              terminal = VISUAL500_TERMINAL
          else if ( token .eq. 'ansi' ) then                              2m
              terminal = ANSI_TERMINAL
c
c       various graphics devices
c
          else if ( token .eq. 'v500' ) then                              2m
              device = VISUAL500_TERMINAL
              terminal = device
          else if ( token .eq. 'v550' ) then                              2m
              device = VISUAL550_TERMINAL
              terminal = ANSI_TERMINAL
          else if ( token .eq. 'xterm' ) then                             2m
              device = XTERM_VT100TEK4014
              terminal = ANSI_TERMINAL
c          else if ( token .eq. 'herc' ) then                              2m
c              device = HERCULES_GRAPHICS
c              terminal = ANSI_TERMINAL
          else if ( token .eq. 'sun3' ) then                              2m
              device = SUN_3_WORKSTATION
              terminal = ANSI_TERMINAL
          else if ( token .eq. 'hpgl' ) then                              2m
              device = HEWLETT_GL_PLOTTER
          else if ( token .eq. 'hp7585' ) then                            2m
              device = HEWLETT_GL_PLOTTER
              appended = str_append( options, '7585B' )
          else if ( token .eq. 'hp7580' ) then                            2m
              device = HEWLETT_GL_PLOTTER
              appended = str_append( options, '7580B' )
          else if ( token .eq. 'hp7550' ) then                            2m
              device = HEWLETT_GL_PLOTTER
              appended = str_append( options, '7550B' )
          else if ( token .eq. 'hp7475' ) then                            2m
              device = HEWLETT_GL_PLOTTER
              appended = str_append( options, '7475A' )
          else if ( token .eq. 'hp7470' ) then                            2m
              device = HEWLETT_GL_PLOTTER
              appended = str_append( options, '7470A' )
          else if ( token .eq. 'hp7440' ) then                            2m
              device = HEWLETT_GL_PLOTTER
              appended = str_append( options, '7440A' )
          else if ( token .eq. 'ps' ) then                                2m
              device = POSTSCRIPT_PRINTER
          else if ( token .eq. 'dummy' ) then                             2m
              device = DUMMY_GRAPHICS_DEV
c
          else if ( token .eq. 'help' ) then                              2m
              write( STD_OUT, 2 )
2             format( ' Help for device selection' /
     1    '   ( [ { "     opening delimiters' /
     2    '   ) ] } "     closing delimiters' /
     3    ' Alphanumeric terminals - for clear screen sequence' /
     3    '   vt52        VT52 (i.e. Visual 500)' /
     4    '   ansi [def]  ANSI (Vis550, vt100, sun, PC)' /
     5    ' Graphics devices' /
     6    '   v500        Visual 500 terminal' /
     7    '   v550 [def]  Visual 550 terminal' /
     8    '   xterm       xterm - tektronics 4014 emulation' /
     9    '   sun3        Sun 3 workstation running suntools' /
     a    '   ps          PostScript (for LaserWriter)' /
     b    '   hpgl        Hewlett-Packard 7470A plotter' /
     c    '   hpNNNN      Hewlett-Packard plotter. NNNN is 7470, 7475,'/
     d    '               7550, 7580, 7585 or 7440 (ColorPro)' /
     e    '               representing the various types of plotter' /
     f    '   Anything not listed above is given as an option' /
     g    '   to the device driver.' )
c
c
c       the argument is an appended option
c
          else if ( token .ne. ' ' ) then                                 2m
              appended = str_append( options, token )
              end if                                                      2e
          if ( delimiter .and. appended ) goto 1
      else                                                                1m
          device_args = .FALSE.
          end if                                                          1b
c         until( end of delimited string )
c
CC--MISCROSOFT-FORTRAN-V4:
CC      if ( device .eq. VISUAL500_TERMINAL .or.
CC--MISCROSOFT-FORTRAN-V4:
CC     1     device .eq. VISUAL550_TERMINAL .or.
CC--MISCROSOFT-FORTRAN-V4:
CC     2     device .eq. SUN_3_WORKSTATION ) device = HERCULES_GRAPHICS
CC--MISCROSOFT-FORTRAN-V4:
CC      terminal = ANSI_TERMINAL
c
      str_len = max( 1, str_length( token ) )
      if ( .not. appended )
     1    write( STD_ERR, 3 ) token( 1 : str_len )
3     format( ' ILGPLOT : Options string full. Token ', a,
     1        ' et seq. ignored.' )
      str_len = str_length( options )
      if ( str_len .gt. 0 ) write( STD_ERR, 4 ) options(1:str_len)
4     format( ' WARNING : Device options string = ', a )
      call ilgdevi( device, options )
      return
      end




      LOGICAL FUNCTION STR_APPEND( STRING, APPENDED )
c
c    Appends APPENDED to STRING with space between
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      integer str_len, str_length
      character string*(*), appended*(*)
c
      str_append = .FALSE.
      str_len = str_length( string ) + 1
      if ( str_len + str_length( appended ) .le.
     1     len(string) ) then
          if ( str_len .gt. 1 ) then
              string(str_len:str_len) = ' '
              str_len = str_len + 1
              end if
          string(str_len:) = appended
          str_append = .TRUE.
          end if
      return
      end



      LOGICAL FUNCTION NEXT_TOKEN( STREAM_LU, TOKEN, TYPE, ECHO )
c
c     Get next token from command stream
c
c Arguments
c  integer   stream_lu
c  character token*(*)
c  integer   type
c  logical   echo
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      integer stream_lu, previous_lu, type, str_length
      logical echo
      character token*(*), line*128
c
      save previous_lu
      data previous_lu / STD_IN /
c
      if ( stream_lu .ne. previous_lu ) call flush_token()
      previous_lu = stream_lu
      next_token = .FALSE.
c
      if ( type .eq. TOK_TO_EOL ) then
          call get_token( char( TOK_TO_EOL ), token )
          if ( token .eq. ' ' ) read( stream_lu, 2, END=3 ) token
      else  if ( type .eq. TOK_NOBLANK .or.
     1           type .eq. TOK_EMPTYOK ) then
          call get_token( ' ', token )
1         if ( token .eq. ' ' .or. token(1:1) .eq. ';' ) then
              read( stream_lu, 2, END=3 ) line
2             format( a )
              call get_token( line, token )
              if ( type .eq. TOK_NOBLANK .or. token(1:1) .eq. ';' )
     1            goto 1
              end if
          end if
      next_token = .TRUE.
      if ( echo ) write( STD_OUT, 4 )
     1    token( 1 : max( str_length(token), 1 ) )
4     format( 1x, a )
3     return
      end


      SUBROUTINE FLUSH_TOKEN()
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      character flushed_token*1
c
1     call get_token( ' ', flushed_token )
      if ( flushed_token .ne. ' ' ) goto 1
      return
      end



      INTEGER FUNCTION LUN_STACK( ACTION, NEW_LU )
c
c    logical unit number stack control
c
c Arguments
c  integer action     # LUN_PUSH   push NEW_LU onto stack and return new value
c                     # LUN_INDEX  return location of top of stack
c                     # LUN_POP    pop value from stack and return it
c          new_lun    # new logical unit pushed onto stack
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'ilgplot.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'ilgplot.def'
c
      integer stack(STACK_LEN), top, action, new_lu
      save stack, top
      data stack, top / STACK_LEN*0, 1 /
c
      lun_stack = 0
      top = max( 1, min( top, STACK_LEN + 1 ) )
      if ( action .eq. LUN_PUSH ) then                                    1b
          if ( top .le. STACK_LEN ) then                                  2b
              stack(top) = new_lu
              lun_stack = top + LUN_BASE
              top = min( top, STACK_LEN ) + 1
          else
              write( STD_ERR, 1 )
1             format( ' LUN_STACK : Stack is full' )
              end if                                                      2e
      else if ( action .eq. LUN_INDEX ) then                              1m
          lun_stack = top - 1
      else if ( action .eq. LUN_POP ) then                                1m
          top = max( 1, top - 1 )
          lun_stack = stack(top)                                          1e
      else
          write( STD_ERR, 2 )
2         format( ' LUN_STACK : Unknown ACTION' )
          end if
      return
      end



      SUBROUTINE CASECH( STRING, CASE )
c
c       CASE CHange
c     Change the case of character string CSTR to upper, lower of edit case .
c
c Arguments
c  character string*(*),  # IN/OUT # operand character string
c            case*1       # INPUT  # 'l' or 'L' - change to lower case
c                                  # 'u' or 'U' - change to upper case
c                                  # 'e' or 'E' - change to edit case
c                                  # anyting else - no change
c local variables
c  integer i        # indexing counter
c  logical first    # first letter in a word
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      integer i, str_length
      logical first
      character string*(*), case*1
c
c
c         change to lower case
c
      if ( case .eq. 'l' .or. case .eq. 'L' ) then                        1b
          do 1 i = 1, str_length( string )                                2b
              if ( 'A' .le. string(i:i) .and. string(i:i) .le. 'Z' )
     1            string(i:i) = char(
     2                ichar( string(i:i) ) + ichar('a') - ichar('A') )
1             continue                                                    2e
c
c         change to upper case
c
      else if ( case .eq. 'u' .or. case .eq. 'U' ) then                   1m
          do 2 i = 1, str_length( string )                                2b
              if ( 'a' .le. string(i:i) .and. string(i:i) .le. 'z' )
     1            string(i:i) = char(
     2                ichar( string(i:i) ) + ichar('A') - ichar('a') )
2             continue                                                    2e
c
c         change to edit case
c
      else if ( case .eq. 'e' .or. case .eq. 'E' ) then                   1m
          first = .TRUE.
          do 3 i = 1, str_length( string )                                2b
              if ( 'A' .le. string(i:i) .and.
     1                      string(i:i) .le. 'Z' ) then                   3b
                  if ( .not. first )
     1                string(i:i) = char( ichar( string(i:i) ) +
     2                    ichar('a') - ichar('A') )
                  first = .FALSE.
              else if ( 'a'.le. string(i:i) .and.
     1                          string(i:i) .le.'z' ) then                3m
                  if ( first )
     1                string(i:i) = char( ichar( string(i:i) ) +
     2                    ichar('A') - ichar('a') )
                  first = .FALSE.
              else                                                        3m
                  first = .TRUE.
                  end if                                                  3e
3             continue                                                    2e
          end if                                                          1e
      return
      end



