/*
    Copyright (C) 1997  Peter Vernon Lanspeary

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
 *                      clip.h
*/
#ifndef CLIP_DEFINED

#ifndef POINTER_DEFINED
#include POINTER_HEADER
#endif

#ifndef STD_TYPE_DEFINED
#include STD_TYPE_HEADER
#endif

#ifndef ERROR_DEFINED
#include ERROR_HEADER
#endif

/*
 *                 Type declarations
*/
typedef struct              /* CLIPPING results and parameters              */
  {
    int          id_struct; /* identifies the structure as a clipping area  */
    coord_triple cl_out1;   /* first end of clipped line segment            */
    coord_triple cl_out2;   /* other end of clipped line segment            */
    coord_triple cl_min;    /* lower left clipping limit                    */
    coord_triple cl_max;    /* upper right clipping limit                   */
    coord_triple cl_prev;   /* previous position                            */
    boolean      cl_on;     /* clipping is switched on                      */
  }
    clip_area;

/*
 *                 Access Macros
*/

#define FIRST_clip(clip_ptr)  ((coord_triple VAR_PTR) &( (clip_ptr)->cl_out1 ))
#define LAST_clip(clip_ptr)   ((coord_triple VAR_PTR) &( (clip_ptr)->cl_out2 ))
#define MIN_clip(clip_ptr)    ((coord_triple VAR_PTR) &( (clip_ptr)->cl_min ) )
#define MAX_clip(clip_ptr)    ((coord_triple VAR_PTR) &( (clip_ptr)->cl_max ) )

#define first_clip(clip_ptr,component)  ( (clip_ptr)->cl_out1.component )
#define last_clip(clip_ptr,component)   ( (clip_ptr)->cl_out2.component )
#define min_clip(clip_ptr,component)    ( (clip_ptr)->cl_min.component  )
#define max_clip(clip_ptr,component)    ( (clip_ptr)->cl_max.component  )

/*
 *                  Functions in clip.c
*/
clip_area VAR_PTR def_2rclip(), VAR_PTR def_3rclip();
boolean clip(), move_clip(), clear_clip(), off_clip(), on_clip(), what_clip();

#define CLIP_DEFINED 1
#endif
