c! <d ya sl
c! m >j sd'f' >r$f$g$ @a a
c! a m -a >sw @a
c! >j i', ' a =d


      PROGRAM HEAT_XFER_MODEL
c
c This routine is for evaluating the heat transfer model for a hot wire
c in wall proximity.
c
      include 'stdio.def'
      include 'xfer.def/list'
c
      integer item, in_len, n_streams, out_len,
     1        Jresp, str_length, xfer_read_params
      real    params(STREAM_LENGTH,MAX_STREAMS), corr_law(MAX_LAW)
      logical got_law, Equery, prox_read
      character in_file*32, out_file*32
c
      data in_file, out_file / ' ', ' ' /
c     subroutine Cresp,            newscr,          prox_write
c                Xfer_calc_law,    Xfer_calc_Nuss,  Xfer_edit_law,
c                Xfer_edit_params, Xfer_mask,       xfer_make_law,
c                Xfer_plot_params, Xfer_write_params
c
c
c     start of loop                                                       1b
1         in_len  = max( 1, str_length( in_file ) )
          out_len = max( 1, str_length( out_file ) )
          call newscr()
          write( STD_OUT, 2 ) in_file(1:in_len), out_file(1:out_len)
2         format( ' Heat transfer model' / '  0) Exit' /
     1        '  1) Input file name', 11x, a /
     2        '  2) Read parameters and data' /
     3        '  3) Read correction law' /
     4        '  4) Edit parameters and data' /
     5        '  5) Edit correction law' /
     6        '  6) Output file name', 10x, a /
     7        '  7) Write parameters and data' /
     8        '  8) Write correction law' /
     9        '  9) Plot data and/or correction law' /
     a        ' 10) Data stream mask' /
     b        ' 11) Calculate Nusselt numbers etc' /
     c        ' 12) Calculate correction law  ' )
          item = Jresp( STD_IN, 0, 12, MAX_TRIES )
c
c           EXIT
c           ****
c
          if ( item .eq. 0 ) then                                         2b
              if ( Equery( STD_IN, ' EXIT : Are you sure ? ' ) )
     1            stop
c
c           INPUT FILE NAME
c           ***************
c
          else if ( item .eq. 1 ) then                                    2m
              write( STD_OUT, 3 )
3             format( ' File name ? ', $ )
              call Cresp( STD_IN, in_file, MAX_TRIES )
c
c           READ PARAMETERS AND DATA
c           ************************
c
          else if ( item .eq. 2 ) then                                    2m
              if ( str_length( in_file ) .gt. 0 ) then                    3b
                  n_streams = xfer_read_params( in_file, params )
              else                                                        3m
                  write( STD_OUT, 4 )
4                 format( ' WARNING : Input file not specified' )
                  call wait_for_CR()
                  end if                                                  3e
c
c           READ CORRECTION LAW
c           *******************
c
          else if ( item .eq. 3 ) then                                    2m
              if ( str_length( in_file ) .gt. 0 ) then                    3b
                  if ( got_law ) then                                     4b
                      if ( Equery( STD_IN,
     1                        'Overwrite existing correction ?' ) )
     2                    got_law = prox_read( corr_law, MAX_LAW,
     3                                         in_file )
                  else                                                    4m
                      got_law = prox_read( corr_law, MAX_LAW, in_file )
                      end if                                              4e
              else                                                        3m
                  write( STD_OUT, 4 )
                  call wait_for_CR()
                  end if                                                  3e
c
c           EDIT PARAMETERS AND DATA
c           ************************
c
          else if ( item .eq. 4 ) then                                    2m
              if ( n_streams .gt. 0 ) then                                3b
                  call xfer_edit_params( params, n_streams,
     1                                   corr_law, got_law )
                  end if                                                  3e
c
c           EDIT CORRECTION LAW
c           *******************
c
          else if ( item .eq. 5 ) then                                    2m
              call Xfer_edit_law( corr_law )
c
c           OUTPUT FILE NAME
c           ****************
c
          else if ( item .eq. 6 ) then                                    2m
              write( STD_OUT, 3 )
              call Cresp( STD_IN, out_file, MAX_TRIES )
c
c           WRITE PARAMETERS AND DATA
c           *************************
c
          else if ( item .eq. 7 ) then                                    2m
              if ( n_streams .gt. 0 ) then                                3b
                  call Xfer_write_params( out_file, params, n_streams,
     1                                    got_law )
                  end if                                                  3e
c
c           WRITE CORRECTION LAW
c           ********************
c
          else if ( item .eq. 8 ) then                                    2m
              if ( got_law ) then                                         3b
                  call prox_write( corr_law, out_file )
                  if ( out_file .eq. ' ' )
     1                call wait_for_CR()
              else                                                        3m
                  write( STD_OUT, 6 )
6                 format( ' WARNING : No correction law available' )
                  call wait_for_CR()
                  end if                                                  3e
c
c           PLOT DATA
c           *********
c
          else if ( item .eq. 9 ) then                                    2m
              if ( n_streams .gt. 0 ) then                                3b
                  call Xfer_plot_params( params, n_streams,
     1                                   corr_law, got_law )
                  end if                                                  3e
c
c           DATA STREAM MASK
c           ****************
c
          else if ( item .eq. 10 ) then                                   2m
              call Xfer_mask( params, n_streams )
c
c           CALCULATE NUSSELT NUMBERS ETC
c           *****************************
c
          else if ( item .eq. 11 ) then                                   2m
              if ( n_streams .gt. 0 ) then                                3b
                  call Xfer_calc_Nuss( params, n_streams )
                  if ( got_law ) then                                     4b
                      call Xfer_calc_law( params, n_streams, corr_law )
                      end if                                              4e
                  end if                                                  3e
c
c           CALCULATE CORRECTION LAW
c           ************************
c
          else if ( item .eq. 12 ) then                                   2m
              call Xfer_make_law( params, n_streams, corr_law, got_law )
              end if                                                      2e
c
c           recalculate data if changed parameters
c
          if ( n_streams .gt. 0 .and.
     1         ( 2 .le. item .and. item .le. 5 .or.
     2           item .eq. 10 .or. item .eq. 12 )) then                   2b
              call Xfer_calc_Nuss( params, n_streams )
              if ( got_law )
     1            call Xfer_calc_law( params, n_streams, corr_law )
              end if                                                      2e
          goto 1
c         end of loop                                                     1e
      end



      SUBROUTINE XFER_EDIT_LAW( CORR_LAW )
      include 'stdio.def'
      include 'xfer.def'
      include 'wallprox.def'
c
      integer    item, Jresp
      real       corr_law(MAX_LAW), Qresp
c     subroutine newscr
c
c     start of loop                                                       1b
1         call newscr()
          write( STD_OUT, 2 ) int( corr_law(Htype) + 0.5 ),
     1        int( corr_law(Horder) + 0.5 ), corr_law(Hv_fact),
     2        corr_law(Hy_fact), corr_law(Hexpon), corr_law(Hp_slope),
     3        corr_law(Hdom_min), corr_law(Hdom_max)
2         format( ' Edit correction law ' / '   0) Exit'   /
     1            '   1) Correction law type   ', i4  /
     2            '   2) Order of polynomial   ', i4 /
     3            '   3) Velocity scale factor  ', g12.5 /
     4            '   4) Y (horiz) scale factor ', g12.5 /
     5            '   5) Y_plus exponent        ', g12.5 /
     6            '   6) Inferred profile slope ', g12.5 /
     7            '   7) Minimum fitted y_plus  ', g12.5 /
     8            '   8) Maximum fitted y_plus  ', g12.5 /
     9            '   9) Defaults for velocity correction' /
     a            '  10) Defaults for Nusselt number correction' )
          item = Jresp( STD_IN, 0, 10, MAX_TRIES )
c
c           EXIT
c           ****
c
          if ( item .eq. 0 ) then                                         2b
              return
c
c               correction law type
c               *******************
c
          else if ( item .eq. 1 ) then                                    2m
c
              write( STD_OUT, 3 )
3             format( ' What value ? ', $ )
              corr_law(Htype) = Jresp( STD_IN, 1, 5, MAX_TRIES )
c
c               order of the polynomial
c               ***********************
c
          else if ( item .eq. 2 ) then                                    2m
              write( STD_OUT, 3 )
              corr_law(Horder) = Jresp( STD_IN, 1, MAX_LAW - Hpoly,
     1            MAX_TRIES )
c
c               velocity scale factor
c               *********************
c
          else if ( item .eq. 3 ) then                                    2m
              write( STD_OUT, 3 )
              corr_law(Hv_fact) = Qresp( STD_IN, 1.0e-5, 1.0e5,
     1            MAX_TRIES )
c
c               set the value of the y scale factor
c               ***********************************
c
          else if ( item .eq. 4 ) then                                    2m
              write( STD_OUT, 3 )
              corr_law(Hy_fact) = Qresp( STD_IN, 1.0e-5, 1.0e5,
     1            MAX_TRIES )
c
c               set the value of the exponent
c               *****************************
c
          else if ( item .eq. 5 ) then                                    2m
              write( STD_OUT, 3 )
              corr_law(Hexpon) = Qresp( STD_IN, -20.0, 20.0, MAX_TRIES )
c
c               Inferred profile slope
c               **********************
c
          else if ( item .eq. 6 ) then                                    2m
              write( STD_OUT, 3 )
              corr_law(Hp_slope) = Qresp( STD_IN, 0.3, 3.0, MAX_TRIES )
c
c               Minimum fitted y_plus
c               *********************
c
          else if ( item .eq. 7 ) then                                    2m
              write( STD_OUT, 3 )
              corr_law(Hdom_min) = Qresp( STD_IN, 0.0, 15.0, MAX_TRIES )
c
c               Maximum fitted y_plus
c               *********************
c
          else if ( item .eq. 8 ) then                                    2m
              write( STD_OUT, 3 )
              corr_law(Hdom_max) = Qresp( STD_IN, 0.0, 15.0, MAX_TRIES )
c
c               VELOCITY CORRECTION DEFAULT VALUES
c               **********************************
c
          else if ( item .eq. 9 ) then                                    2m
              corr_law(Htype)    = 4
              corr_law(Horder)   = 2
              corr_law(Hv_fact)  = 1.0
              corr_law(Hy_fact)  = 1.0
              corr_law(Hexpon)   = -1.0
              corr_law(Hp_slope) = 1.0
c
c               NUSSELT CORRECTION DEFAULT VALUES
c               *********************************
c
          else if ( item .eq. 10 ) then                                   2m
              corr_law(Htype)    = 5
              corr_law(Horder)   = 3
              corr_law(Hv_fact)  = 1.0
              corr_law(Hy_fact)  = 1.0
              corr_law(Hexpon)   = 1.0
              corr_law(Hp_slope) = 1.0
              end if                                                      2e
          goto 1
c         end of loop                                                     1e
      end



      INTEGER FUNCTION XFER_READ_PARAMS( FILE_NAME, PARAMS )
c
c  Read the heat transfer model parameters and velocity profile data from
c  file. The returned value is the number of data streams.
c
c  character file_name*(*)
c  real      params(STREAM_LENGTH,*)
c
c local variables
c  logical
c   decode_prf    # decodes mean velocity profile coordinate
c   get_real      # get real value from input file
c  integer
c   i
c   index
c   nom_points
c   res_xfer_lu
c   stream
c   xfer_lu
c   new_lun
c   open_file
c  character
c   line*128
c  subroutine
c   flush_token
c
c
      include 'stdio.def'
      include 'xfer.def'
c
c
      logical decode_prf, get_real
      integer i, index, nom_points, res_xfer_lu, stream, xfer_lu,
     1        new_lun, open_file
      real    params(STREAM_LENGTH,*)
      character file_name*(*), line*128
c
      xfer_read_params = 0
      stream = 1
      if ( file_name .ne. ' ' ) then                                      1b
c
c       open the data file
c
          if ( res_xfer_lu .eq. 0 ) then                                  2b
              res_xfer_lu = new_lun()
              end if                                                      2e
          xfer_lu = open_file( res_xfer_lu, file_name, 'old' )
          if ( xfer_lu .gt. 0 ) then                                      2b
c
c       read each stream from data file until end of file or space is full
c
1             if ( stream .le. MAX_STREAMS ) then                         3b
                  params(BAS_MASK,stream) = NO
                  do 2 i = BAS_HWC_A, BAS_FRIC_VEL                        4b
                      if ( .not. get_real( xfer_lu, params(i,stream),
     1                               -1.0e38, 1.0e38, .FALSE. ) ) goto 7
2                     continue                                            4e
                  if ( .not. get_real( xfer_lu,
     1                           params(LAW_N_POINTS,stream),
     2                           -1.0e38, 1.0e38, .FALSE. ) ) goto 7
                  params(LAW_N_POINTS,stream) = max( 0, min( MAX_DATA,
     1                int( params(LAW_N_POINTS,stream) + 0.5 ) ) )
                  if ( .not. get_real( xfer_lu,
     1                           params(PRF_N_POINTS,stream),
     2                           -1.0e38, 1.0e38, .FALSE. ) ) goto 7
                  nom_points = max( 0, min( MAX_DATA,
     1                int( params(PRF_N_POINTS,stream) + 0.5 ) ) )
c
c       Read experimental mean velocity profile data
c
                  index = PRF_EXPT_Y_PL
                  do 5 i = 1, nom_points                                  4b
c                     repeat                                              5b
3                         read( xfer_lu, 4, END=6, ERR=6 ) line
4                         format( a )
                          if ( .not. decode_prf( line,
     1                           params(index,stream) ) ) goto 3
c                         until( got some values )                        5e
                      index = index + PRF_LAW_INCREM
5                     continue                                            4e
c
6                 params(PRF_N_POINTS,stream) = i - 1
                  xfer_read_params = stream
                  params(BAS_MASK,stream) = YES
                  stream = stream + 1
                  call flush_token()
                  goto 1
                  end if                                                  3e
c
c       Close the data file
c
7                 close( UNIT=xfer_lu )
                  xfer_lu = 0
              end if                                                      2e
          call flush_token()
          end if                                                          1e
      return
      end



      LOGICAL FUNCTION DECODE_PRF( STRING, ARRAY )
c
c Decodes a (y^+,U^+) coordinate in the character string STRING, place it
c at the start of the array ARRAY, and pad the remainder of ARRAY with zeros.
c The returned values indicates success or failure.
c   A ';' begins a comment field and anything after it is ignored.
c   The token 'end' indicates end-of-data-in-the-file
c
c Arguments
c   character string*(*)  # INPUT  # character string to be decoded
c   real      array(*)    # OUTPUT # array of decoded values
c
c  integer
c   i
c   first_pad     # index of first array value to be zero padded
c  character
c   token*32      # token extracted from string
c subroutine
c  get_token      # extract token
c
      include 'stdio.def'
      include 'xfer.def'
c
      integer    first_pad, i
      real       array(*)
      character  string*(*), token*32
c     subroutine get_token
c
c
c       get y^+ value
c
      first_pad = 1
      call get_token( string, token )
      decode_prf = token(1:1) .ne. ' ' .and. token(1:1) .ne. ';' .and.
     1             token(1:3) .ne. 'end'
      if ( decode_prf ) then                                              1b
          read( token, 1, ERR=3 ) array(1)
1         format( bn, f32.0 )
c
c       get U^+ value
c
          first_pad = 2
          call get_token( ' ', token )
          decode_prf = token(1:1) .ne. ' ' .and.
     1                 token(1:1) .ne. ';' .and. token(1:3) .ne. 'end'
          if ( decode_prf ) then                                          2b
              read( token, 1, ERR=3 ) array(2)
              first_pad = 3
              end if                                                      2e
          end if                                                          1e
c
c       pad remaining variables with zeros
c
      do 2 i = first_pad, PRF_CORR_FUNC - PRF_EXPT_Y_PL + 1               1b
          array(i) = 0.0
2         continue                                                        1e
      return
c
c       could not decode value
c
3     decode_prf = .FALSE.
      write( STD_ERR, 4 )
4     format( ' DECODE_PRF : ABORT : Cannot decode value' )
      return
      end



      SUBROUTINE XFER_EDIT_PARAMS( PARAMS, N_STREAMS, CORR_LAW, GOT_LAW)
      include 'stdio.def'
      include 'xfer.def'
c
      integer item, n_points, n_streams, stream, Jresp
      logical got_law
      real    params(STREAM_LENGTH,*), corr_law(MAX_LAW)
c     subroutine newscr, sfudge, xfer_edit_basic
c
      save stream
      data stream / 1 /
c
      if ( 1 .le. n_streams .and. n_streams .le. MAX_STREAMS ) then       1b
c         start of loop                                                   2b
1             call newscr()
              write( STD_OUT, 2 ) n_streams, stream
2             format( ' Edit Parameters' / '  0) Exit' /
     1                '  1) Selected stream (1-',i2,')  ', i3 /
     2                '  2) Basic parameters' /
     3                '  3) Mean velocity profile' /
     4                '  4) Stream mask ' )
              item = Jresp( STD_IN, 0, 4, MAX_TRIES )
              if ( item .eq. 0 ) then                                     3b
                  return
              else if ( item .eq. 1 ) then                                3m
                  write( STD_OUT, 3 )
3     format( ' What is the selected data stream ? (0=all) ' )
                  stream = Jresp( STD_IN, 0, n_streams, MAX_TRIES )
              else if ( item .eq. 2 ) then                                3m
                  call xfer_edit_basic( params, n_streams, stream )
              else if ( item .eq. 3 ) then                                3m
                  if ( stream .eq. 0 ) then                               4b
                      write( STD_ERR, 4 )
4     format( ' Can specify only a single stream for editing data.' )
                      call wait_for_CR()
                  else                                                    4m
                      n_points = params(PRF_N_POINTS,stream) + 0.5
                      call ilgopen( ' ' )
                      call ilgxlab( 'y|t+' )
                      call ilgylab( 'U|t+' )
                      call sfudge( params(PRF_EXPT_Y_PL,stream),
     1                    params(PRF_EXPT_U_PL,stream), PRF_LAW_INCREM,
     2                    n_points, n_points, MAX_DATA )
                      params(PRF_N_POINTS,stream) = n_points
                      call ilgclos()
                      end if                                              4e
              else if ( item .eq. 4 ) then                                3m
                  call xfer_mask( params, n_streams )
                  call Xfer_calc_Nuss( params, n_streams )
                  if ( got_law )
     1                call Xfer_calc_law( params, n_streams, corr_law )
                  end if                                                  3e
              goto 1
c             end of loop                                                 2e
          end if                                                          1e
      return
      end



      SUBROUTINE XFER_EDIT_BASIC( PARAMS, N_STREAMS, STREAMS )
      include 'stdio.def'
      include 'xfer.def'
c
      integer item, n_streams, param_index(20), stream, streams, Jresp
      real    params(STREAM_LENGTH,*), Qresp
      data param_index /
     1    BAS_HWC_A,     BAS_HWC_B,     BAS_HWC_N,     BAS_HWC_C,
     2    BAS_HWC_D,     BAS_HWC_E,     BAS_HWC_F,     BAS_HWC_G,
     3    BAS_HWC_H,     BAS_HWC_I,     BAS_HWC_J,     BAS_HWC_K,
     4    BAS_PROF_SLOP, BAS_FRIC_CORR, BAS_TEMP_WGHT, BAS_ALPHA,
     5    BAS_OVERHEAT,  BAS_WIRE_DIAM, BAS_FRIC_VEL,  LAW_N_POINTS /
c
c     subroutine newscr
c
      stream = max( streams, 1 )
c     start of loop                                                       1b
1         call newscr()
          if ( streams .eq. 0 ) write( STD_OUT, 2 )
2         format( ' WARNING : Editing **ALL** data streams' )
          write( STD_OUT, 3 )
     1        ( params(item,stream), item = BAS_HWC_A, BAS_HWC_K )
3         format( ' Edit basic parameters' / '  0) Exit' /
     1        '     Hot-wire calibration Nu=A+B.Re^n' /
     2        '  1)   A = ', f9.4 /
     3        '  2)   B = ', f9.4 /
     4        '  3)   n = ', f9.4 /
     5        44x, 'n         n  +E  F      +G' / '     Calibration ',
     6        'in proximity Nu_fl = A+B.Re - (C+D.Re )d. Re.exp(-y  )' /
     7        '  4)   C = ', f9.4 / '  5)   D = ', f9.4 /
     8        '  6)   E = ', f9.4 / '  7)   F = ', f9.4 /
     9        '  8)   G = ', f9.4 /
     a        52x, '+H  I +J   +', 11x, 'K' / '     Wall proximity ',
     b      'effect Nu_y = (Nu-Nu_fl).y/d = d .Re.y. f(y ).(v_i/v_f)' /
     c        '  9)   H = ', f9.4 / ' 10)   I = ', f9.4 /
     d        ' 11)   J = ', f9.4 / ' 12)   K = ', f9.4 )
          write( STD_OUT, 4 ) ( params(item,stream),
     1                          item = BAS_PROF_SLOP, BAS_FRIC_VEL ),
     2                        int( params(LAW_N_POINTS,stream) + 0.5 )
4         format( '     Empirical corrections' /
     1        ' 13) sublayer profile slope m                ', f7.5 /
     2        ' 14) correction factor for friction velocity ', f7.5 /
     3        ' 15) weighting factor for film temperature   ', f7.5 / /
     4        '     Operating conditions' /
     5        ' 16) temperature coefficient of resisitivity ', f7.5 /
     6        ' 17) nominal overheat ratio of the hot-wire ', f6.3 /
     7        ' 18) nominal hot-wire diameter', 13x, f6.2, ' microns' /
     8        ' 19) friction velocity', 21x, f9.5, ' m/s' /
     9        ' 20) length of correction law table         ', i3 )
          item = Jresp( STD_IN, 0, 20, MAX_TRIES )
          if ( item .ne. 0 ) then
              write( STD_OUT, 5 )
5             format( ' What is the value ? ' )
              params(param_index(item),stream) =
     1            Qresp( STD_IN, -100.0, 100.0, MAX_TRIES )
              if ( streams .eq. 0 ) then                                  2b
                  do 6 stream = 2, n_streams                              3b
                      params(param_index(item),stream) =
     1                    params(param_index(item),1)
6                     continue                                            3e
                  stream = 1
                  end if                                                  2e
              goto 1
              end if
c             end of loop                                                 1e
          return
          end



      SUBROUTINE XFER_WRITE_PARAMS( OUT_FILE, PARAMS, N_STREAMS,
     1                              GOT_LAW )
c
      include 'stdio.def'
      include 'xfer.def'
c
      logical got_law, Equery
      integer n_streams, res_xfer_lu, stream, xfer_lu,
     1        new_lun, open_file
      real    params(STREAM_LENGTH,*)
      character out_file*(*), query_stream*20
c     subroutine xfer_write_stream
c
      save res_xfer_lu
      data res_xfer_lu / 0 /
c
      if ( res_xfer_lu .le. 0 ) then                                      1b
          res_xfer_lu = new_lun()
          end if                                                          1e
      if ( out_file .ne. ' ' ) then                                       1b
          xfer_lu = open_file( res_xfer_lu, out_file, 'new' )
      else                                                                1m
          xfer_lu = STD_OUT
          end if                                                          1e
c
      if ( xfer_lu .gt. 0 ) then                                          1b
          do 7 stream = 1, n_streams                                      2b
              if ( int( params(BAS_MASK,stream) + 0.5 ) .eq. YES ) then   3b
                  if ( xfer_lu .eq. STD_OUT ) then                        4b
                      write( query_stream, 1 ) stream
1                     format( 'Display stream ', i3, ' ?' )
                      if ( Equery( STD_IN, query_stream ) ) then          5b
                          call xfer_write_stream( xfer_lu, stream,
     1                             params(1,stream), got_law )
                          end if                                          5e
                  else                                                    4m
                      call xfer_write_stream( xfer_lu, stream,
     1                         params(1,stream), got_law )
                      end if                                              4e
                  end if                                                  3e
7             continue                                                    2e
          if ( xfer_lu .eq. STD_OUT ) then                                2b
              call wait_for_CR()
          else                                                            2m
              close( UNIT=xfer_lu )
              end if                                                      2e
          end if                                                          1e
      return
      end



      SUBROUTINE XFER_WRITE_STREAM( XFER_LU, N_STREAM, STREAM, GOT_LAW )
      include 'stdio.def'
      include 'xfer.def'
c
      integer first, i, last, n_expt, n_law, n_stream, row, xfer_lu
      logical got_law
      real    stream(*)
      real format_min(PRF_LAW_INCREM), format_max(PRF_LAW_INCREM)
c
c     subroutine wait_for_CR
      data format_min / 5*-9.999, 2*0.0000, 4*-9.9999,
     1                  5*-9.999, 2*0.0000, 4*-9.9999 /
      data format_max / 5*99.999, 2*9.9999, 4*99.9999,
     1                  5*99.999, 2*9.9999, 4*99.9999 /
c
c       Basic parameters
c
      write( xfer_lu, 1 )
     1    n_stream, ( stream(i), i = BAS_HWC_A, BAS_HWC_K )
1     format( ' ; Wall proximity effect' /
     1    ' ; Data for parametric study, stream ', i2 /
     2    ' ;   Hot-wire calibration Nu=A+B.Re^n' /
     3    f9.4, ' ; = A' / f9.4, ' ; = B' / f9.4, ' ; = n' /
     4    ' ;', 41x, 'n         n  +E  F      +G' / ' ;  Calibration ',
     5        'in proximity Nu_fl = A+B.Re - (C+D.Re )d. Re.exp(-y  )' /
     6    1x, f9.4, ' ; = C' / 1x, f9.4, ' ; = D' /
     7    1x, f9.4, ' ; = E' / 1x, f9.4, ' ; = F' / 1x, f9.4, ' ; = G' /
     8    ' ;', 49x, '+H  I  +J  +', 11x, 'K' / ' ;  Wall proximity ',
     9    'effect  Nu_w = (Nu-Nu_fl).y/d = d .Re.y .f(y ).(v_i/v_f)' /
     a    1x, f9.4, ' ; = H' / 1x, f9.4, ' ; = I' /
     b    1x, f9.4, ' ; = J' / 1x, f9.4, ' ; = K' )
      if ( xfer_lu .eq. STD_OUT )
     1    call wait_for_CR()
      write( xfer_lu, 2 )
     1    ( stream(i), i = BAS_PROF_SLOP, BAS_FRIC_VEL )
2     format( ' ;  Empirical corrections' /
     1    1x, f9.5, ' ; sublayer profile slope m' /
     2    1x, f9.5, ' ; friction velocity correction factor' /
     3    1x, f9.5, ' ; film temperature weighting factor ' / /
     4    ' ; Operating conditions' /
     5    1x, f9.5, ' ; resisitivity temperature coefficient'/
     6    1x, f9.3, ' ; nominal overheat ratio of hot-wire' /
     7    1x, f9.2, ' ; nominal hot-wire diameter (microns)' /
     8    1x, f9.5, ' ; friction velocity (m/s)' )
c      if ( xfer_lu .eq. STD_OUT )
c     1    call wait_for_CR()
c
c       Derived parameters
c
      write( xfer_lu, 3 )
     1    ( stream(i), i = DER_WIRE_TEMP, DER_FILM_VISC )
3     format( ' ;  Derived Parameters' /
     1    ' ;', f9.3, ' hot-wire operating temperature (K)' /
     2    ' ;', f9.5, ' non-dimensional hot-wire diameter' /
     3    ' ;', f9.3, ' film temperature (Kelvin)' /
     4    ' ;', f9.5, ' fluid film density (kg/cub.m)' /
     5    ' ;', g12.5, ' fluid film kinematic viscosity (sq.m/s)' )
      if ( xfer_lu .eq. STD_OUT )
     1    call wait_for_CR()
c
c       experimental Profile data
c
      n_expt = int( stream(PRF_N_POINTS) + 0.5 )
      n_law = int( stream(LAW_N_POINTS) + 0.5 )
c
      if ( n_expt .gt. 0 ) then                                           1b
          write( xfer_lu, 4 ) n_law, n_expt
4         format( 1x, i3, ' ; length of correction law table' /
     1        ' ; Experimental profile data' /
     2        1x, i3, ' ; number of profile points' /
     3        ' ;Experimental  -Corrected-  Veloc   Reynolds no.  ',
     4            '---Nusselt number---   corr''n' /
     5        ' ; y+     U+     y+     U+   error   meas  actual  ',
     6            'total  fluid   wall   funct' )
          first = PRF_EXPT_Y_PL - 1
          do 6 row = 1, n_expt                                            2b
              write( xfer_lu, 5 )
     1            ( max( format_min(i), min( format_max(i),
     2              stream(i+first) ) ), i = 1, PRF_LAW_INCREM / 2 )
5             format( 5(1x,f6.3), 4(1x,f6.4), 2(1x,f7.4) )
              first = first + PRF_LAW_INCREM
6             continue                                                    2e
          end if                                                          1e
c
c       correction law Profile data
c
      if ( n_law .gt. 0 .and. got_law ) then                              1b
          if ( xfer_lu .eq. STD_OUT )
     1        call wait_for_CR()
          write( xfer_lu, 7 ) n_law
7         format( ' ; Correction law profile data' /
     1        ' ; ', i3, ' number of profile points' /
     2        ' ; Experimental  -Corrected-  Veloc   Reynolds no.  ',
     3            '---Nusselt number---   corr''n' /
     4        ' ;   y+     U+     y+     U+   error   meas  actual  ',
     5            'total  fluid   wall   funct' )
          first = LAW_EXPT_Y_PL - 1
          do 9 row = 1, n_law                                             2b
              write( xfer_lu, 8 )
     1            ( max( format_min(i), min( format_max(i),
     2              stream(i+first) ) ), i = 1, PRF_LAW_INCREM / 2 )
8             format( ' ;', 5(1x,f6.3), 4(1x,f6.4), 2(1x,f7.4) )
              first = first + PRF_LAW_INCREM
9             continue                                                    2e
          end if                                                          1e
      return
      end



      SUBROUTINE WAIT_FOR_CR()
      include 'stdio.def'
      write( STD_OUT, 1 )
1     format( ' Press <Return> to continue' )
      read( STD_IN, 2, ERR=3, END=3 )
2     format()
      return
3     stop
      end




      SUBROUTINE XFER_PLOT_PARAMS( PARAMS, N_STREAMS, CORR_LAW, GOT_LAW)
c
      include 'stdio.def'
      include 'xfer.def'
c
      integer    abscissa, ordinate, capt_len, i, item, mask, n_plot,
     1           x_plots, y_plots, n_points, n_streams, plot_expt,
     2           plot_law, stream, use_manual,
     3           Ceiling, Jresp, str_length
      logical    got_law
      real       x_min, x_max, y_min, y_max, params(STREAM_LENGTH,*),
     1           corr_law(MAX_LAW)
      character  Capt_file*64, Xfer_prf_name*16, Cyes*5
c     subroutine Cresp, ilgclos, ilgdata, ilgimit, ilgline, ilgopen,
c    1           ilgpage, ilgraph
c
      save abscissa, ordinate, n_plot, use_manual, plot_expt, plot_law
      save capt_file
      data abscissa, ordinate / PRF_CORR_Y_PL, PRF_CORR_U_PL /
      data n_plot, x_plots, y_plots / 0, 2, 1 /
      data use_manual, plot_expt, plot_law / NO, YES, NO /
      data capt_file / ' ' /
c
      n_plot = 0
c
c     start of loop                                                       1b
c
c       display plotting menu
c
1        call newscr()
          capt_len = max( 1, str_length( capt_file ) )
          write( STD_OUT, 2 )
     1        xfer_prf_name( abscissa ), xfer_prf_name( ordinate ),
     2        x_plots * y_plots, Cyes( plot_expt ), Cyes( plot_law ),
     3        Cyes( use_manual ), Capt_file(1:capt_len)
2         format( ' Plot data menu' / '  0) Exit' /
     1        '  1) Edit basic parameters (all streams)' /
     2        '  2) Abscissa           ', a /
     3        '  3) Ordinate           ', a /
     4        '  4) No. of graphs per page  ', i2 /
     5        '  5) Plot experimental data   ', a /
     6        '  6) Plot correction law      ', a /
     7        '  7) Edit stream mask' /
     8        '  8) Manual plotting limits   ', a /
     9        '  9) Do plot' /
     a        ' 10) Capture file name  ', a )
          item = Jresp( STD_IN, 0, 10, MAX_TRIES )
c
c       EXIT
c
          if ( item .eq. 0 ) then                                         2b
              call ilgclos()
              return
c
c       EDIT BASIC PARAMETERS (ALL STREAMS)
c
          else if ( item .eq. 1 ) then                                    2m
              call xfer_edit_basic( params, n_streams, 0 )
              if ( n_streams .gt. 0 ) then                                3b
                  call Xfer_calc_Nuss( params, n_streams )
                  if ( got_law ) then                                     4b
                      call Xfer_calc_law( params, n_streams, corr_law )
                      end if                                              4e
                  end if                                                  3e
c
c       ABSCISSA
c
          else if ( item .eq. 2 ) then                                    2m
              write( STD_OUT, 3 ) ( i - PRF_EXPT_Y_PL + 1,
     1               Xfer_prf_name(i), i = PRF_EXPT_Y_PL, PRF_CORR_FUNC)
3             format( ' Select' / ( 1x, i2, ') ', a ) )
              abscissa = Jresp( STD_IN, 1,
     1            PRF_CORR_FUNC - PRF_EXPT_Y_PL + 1, MAX_TRIES ) +
     2            PRF_EXPT_Y_PL - 1
c
c       ORDINATE
c
          else if ( item .eq. 3 ) then                                    2m
              write( STD_OUT, 3 ) ( i - PRF_EXPT_Y_PL + 1,
     1               Xfer_prf_name(i), i = PRF_EXPT_Y_PL, PRF_CORR_FUNC)
              ordinate = Jresp( STD_IN, 1,
     1            PRF_CORR_FUNC - PRF_EXPT_Y_PL + 1, MAX_TRIES ) +
     2            PRF_EXPT_Y_PL - 1
c
c       NUMBER OF GRAPHS PER PAGE
c
          else if ( item .eq. 4 ) then                                    2m
              write( STD_OUT, 4 )
4             format( ' Number of graphs per page ? ' )
              y_plots = Jresp( STD_IN, 1, 16, MAX_TRIES )
              x_plots = max( ceiling( sqrt( real( y_plots ) ) ), 1 )
              y_plots = max( ceiling( real( y_plots ) / x_plots ), 1 )
              n_plot  = 0
c
c       PLOT EXPERIMENTAL DATA
c
          else if ( item .eq. 5 ) then                                    2m
              plot_expt = mod( plot_expt + 1, 2 )
c
c       PLOT CORRECTION LAW DATA
c
          else if ( item .eq. 6 ) then                                    2m
              plot_law = mod( plot_law + 1, 2 )
c
c       EDIT STREAM MASK
c
          else if ( item .eq. 7 ) then                                    2m
              call Xfer_mask( params, n_streams )
              call Xfer_calc_Nuss( params, n_streams )
              if ( got_law )
     1            call Xfer_calc_law( params, n_streams, corr_law )
c
c       MANUAL LIMITS
c
          else if ( item .eq. 8 ) then                                    2m
              if ( Use_manual .ne. YES ) then                             3b
                  call xfer_auto_limit(
     1                params, n_streams, plot_expt, plot_law,
     2                abscissa, ordinate, x_min, y_min, x_max, y_max )
                  end if                                                  3e
              call xfer_plot_limit( params, n_streams, Use_manual,
     1            abscissa, ordinate, x_min, y_min, x_max, y_max )
c
c       PLOT
c
          else if ( item .eq. 9 ) then                                    2m
              if ( n_plot .eq. 0 ) then                                   3b
                  call ilgopen( Capt_file )
                  call ilgpage( 'a4', 'wide', x_plots, y_plots )
                  end if                                                  3e
              call ilgraph( mod( n_plot, x_plots ) + 1,
     1                      n_plot / x_plots + 1, 27, 27, 1 )
              n_plot = mod( n_plot + 1, x_plots * y_plots )
              if ( Use_manual .eq. YES ) then                             3b
                  call ilgwild( 'UU', x_min, y_min, x_max, y_max )
              else                                                        3m
                  call xfer_auto_limit( params, n_streams,
     1                plot_expt, plot_law, abscissa, ordinate,
     2                x_min, y_min, x_max, y_max )
                  end if                                                  3e
              call ilgimit( x_min, y_min, x_max, y_max )
              if ( plot_expt .eq. YES ) then                              3b
                  do 5 stream = 1, n_streams                              4b
                      mask = params(BAS_MASK,stream) + 0.5
                      if ( mask .eq. YES ) then                           5b
                          n_points = params(PRF_N_POINTS,stream) + 0.5
                          call ilgline( mod( stream - 1, 14 ) + 1, 0, 1)
                          call ilgdata( params(abscissa,stream),
     1                                 params(ordinate,stream),
     2                                 PRF_LAW_INCREM, n_points, 0 )
                          end if                                          5e
5                     continue                                            4e
                  end if                                                  3e
              if ( plot_law .eq. YES .and. got_law ) then                 3b
                  do 6 stream = 1, n_streams                              4b
                      mask = params(BAS_MASK,stream) + 0.5
                      if ( mask .eq. YES ) then                           5b
                          n_points = params(LAW_N_POINTS,stream) + 0.5
                          call ilgline( 0, mod( stream - 1, 6 ) + 1, 1)
                          call ilgdata(
     1                        params( abscissa + PRF_LAW_DIFF, stream ),
     2                        params( ordinate + PRF_LAW_DIFF, stream ),
     3                        PRF_LAW_INCREM, n_points, 0 )
                          end if                                          5e
6                     continue                                            4e
                  end if                                                  3e
c
c       CAPTURE FILE NAME
c
          else if ( item .eq. 10 ) then                                   2m
              write( STD_OUT, 7 )
7             format( ' Capture file name ? ' )
              call Cresp( STD_IN, capt_file, MAX_TRIES )
              end if                                                      2e
              goto 1
c         end of loop                                                     1e
      end



      INTEGER FUNCTION CEILING( X )
      include 'stdio.def'
      integer MAX_INT
      parameter( MAX_INT=2147483647 )
      real x
c
      if ( x .lt. real( - MAX_INT ) ) then                                1b
          ceiling = - MAX_INT
      else if ( x .gt. real( MAX_INT ) ) then                             1m
          ceiling = MAX_INT
      else
          ceiling = x
          if ( real( ceiling ) .lt. x ) ceiling = x + 1
          end if                                                          1e
      return
      end



      SUBROUTINE XFER_AUTO_LIMIT(
     1    PARAMS, N_STREAMS, PLOT_EXPT, PLOT_LAW,
     2    ABSCISSA, ORDINATE, X_MIN, Y_MIN, X_MAX, Y_MAX )
      include 'stdio.def'
      include 'xfer.def'
c
      integer absc, abscissa, i, n_points, n_streams, ordin, ordinate,
     1        stream, mask, plot_expt, plot_law
      real    x_min, x_max, y_min, y_max, params(STREAM_LENGTH,*)
c
c       Automatic calculation of limits
c
      x_min =  1.0e38
      x_max = -1.0e38
      y_min =  1.0e38
      y_max = -1.0e38
      do 3 stream = 1, n_streams                                         1b
          mask = params(BAS_MASK,stream) + 0.5
          if ( mask .eq. YES ) then                                      2b
              if ( plot_expt .eq. YES ) then                             3b
                  n_points = params(PRF_N_POINTS,stream) + 0.5
                  absc  = abscissa
                  ordin = ordinate
                  do 1 i = 1, n_points                                   4b
                      x_min = min( x_min, params(absc,stream) )
                      x_max = max( x_max, params(absc,stream) )
                      y_min = min( y_min, params(ordin,stream) )
                      y_max = max( y_max, params(ordin,stream) )
                      absc  = absc  + PRF_LAW_INCREM
                      ordin = ordin + PRF_LAW_INCREM
1                     continue                                           3e
                      end if                                             4e
              if ( plot_law .eq. YES ) then                              3b
                  n_points = params(LAW_N_POINTS,stream) + 0.5
                  absc  = abscissa + PRF_LAW_DIFF
                  ordin = ordinate + PRF_LAW_DIFF
                  do 2 i = 1, n_points                                   4b
                      x_min = min( x_min, params(absc,stream) )
                      x_max = max( x_max, params(absc,stream) )
                      y_min = min( y_min, params(ordin,stream) )
                      y_max = max( y_max, params(ordin,stream) )
                      absc  = absc  + PRF_LAW_INCREM
                      ordin = ordin + PRF_LAW_INCREM
2                     continue                                           4e
                  end if                                                 3e
              end if                                                     2e
3         continue                                                       1e
      return
      end



      SUBROUTINE XFER_PLOT_LIMIT( PARAMS, N_STREAMS, USE_MANUAL,
     1            ABSCISSA, ORDINATE, X_MIN, Y_MIN, X_MAX, Y_MAX )
c
c
      include 'stdio.def'
      include 'xfer.def'
c
      integer abscissa, item, n_streams, ordinate, Use_manual, Jresp
      real    params(STREAM_LENGTH,*), x_min, x_max, y_min, y_max,
     1        Qresp
      character Cyes*5
c     subroutine newscr, ilgimit
c
c
c     start of loop                                                       1b
1         call newscr()
c
c       display menu
c
          write( STD_OUT, 4 ) Cyes( Use_manual ),
     1         x_min, y_min, x_max, y_max
4         format( ' Plotting limits' / '  0) Exit' /
     1        '  1) Use manual plotting limits  ', a /
     2        '  2) Left limit    ', g13.6 /
     3        '  3) Bottom limit  ', g13.6 /
     4        '  4) Right limit   ', g13.6 /
     5        '  5) Upper limit   ', g13.6 )
          item = Jresp( STD_IN, 0, 5, MAX_TRIES )
c
c       exit
c
          if ( item .eq. 0 ) then                                         2b
              return
          else if ( item .eq. 1 ) then                                    2m
              Use_manual = mod( Use_manual + 1, 2 )
c
c       change limits manually
c
          else if ( item .eq. 2 ) then                                    2m
              write( STD_OUT, 5 )
5             format( ' What value ? ' )
              x_min = Qresp( STD_IN, -1.0e38, 1.0e38, MAX_TRIES )
          else if ( item .eq. 3 ) then                                    2m
              write( STD_OUT, 5 )
              y_min = Qresp( STD_IN, -1.0e38, 1.0e38, MAX_TRIES )
          else if ( item .eq. 4 ) then                                    2m
              write( STD_OUT, 5 )
              x_max = Qresp( STD_IN, -1.0e38, 1.0e38, MAX_TRIES )
          else if ( item .eq. 5 ) then                                    2m
              write( STD_OUT, 5 )
              y_max = Qresp( STD_IN, -1.0e38, 1.0e38, MAX_TRIES )
              end if
          goto 1
c         end of loop
      end



      CHARACTER *16 FUNCTION XFER_PRF_NAME( ITEM )
      include 'stdio.def'
      include 'xfer.def'
      integer item
c
      if ( item .eq. PRF_EXPT_Y_PL .or.
     1     item .eq. LAW_EXPT_Y_PL ) then                                 1b
          xfer_prf_name = 'Experimental y^+'
      else if ( item .eq. PRF_EXPT_U_PL .or.
     1          item .eq. LAW_EXPT_U_PL ) then                            1m
          xfer_prf_name = 'Experimental U^+'
      else if ( item .eq. PRF_CORR_Y_PL .or.
     1          item .eq. LAW_CORR_Y_PL ) then                            1m
          xfer_prf_name = 'Corrected    y^+'
      else if ( item .eq. PRF_CORR_U_PL .or.
     1          item .eq. LAW_CORR_U_PL ) then                            1m
          xfer_prf_name = 'Corrected    U^+'
      else if ( item .eq. PRF_VEL_ERROR .or.
     1          item .eq. LAW_VEL_ERROR ) then                            1m
          xfer_prf_name = 'Velocity error^+'
      else if ( item .eq. PRF_RE_MEASUR .or.
     1          item .eq. LAW_RE_MEASUR ) then                            1m
          xfer_prf_name = 'Measured     Re '
      else if ( item .eq. PRF_RE_ACTUAL .or.
     1          item .eq. LAW_RE_ACTUAL ) then                            1m
          xfer_prf_name = 'Actual       Re '
      else if ( item .eq. PRF_NUS_TOTAL .or.
     1          item .eq. LAW_NUS_TOTAL ) then                            1m
          xfer_prf_name = 'Total        Nu '
      else if ( item .eq. PRF_NUS_FLUID .or.
     1          item .eq. LAW_NUS_FLUID ) then                            1m
          xfer_prf_name = 'Net fluid    Nu '
      else if ( item .eq. PRF_NUS_WALL  .or.
     1          item .eq. LAW_NUS_WALL  ) then                            1m
          xfer_prf_name = 'Wall         Nu '
      else if ( item .eq. PRF_CORR_FUNC .or.
     1          item .eq. LAW_CORR_FUNC ) then                            1m
          xfer_prf_name = 'Correction funct'
      else                                                                1m
          xfer_prf_name = 'unknown variable'
          end if                                                          1e
      return
      end



      SUBROUTINE XFER_CALC_NUSS( PARAMS, N_STREAMS )
      include 'stdio.def'
      include 'xfer.def'
c
      real AMBIENT_TEMP, ATMOS_PRESS, GAS_CONSTANT, ATMOS_DENSITY
      parameter( AMBIENT_TEMP =293.15,
     1    ATMOS_PRESS  = 101325.0,
     2    GAS_CONSTANT = 287.0,
     3    ATMOS_DENSITY= ATMOS_PRESS / AMBIENT_TEMP / GAS_CONSTANT )
c
      integer i, last_index, n_streams, stream
      real    params(STREAM_LENGTH,*), amb_kinem_visc, Qmuair
c
c
      amb_kinem_visc = Qmuair( AMBIENT_TEMP ) / ATMOS_DENSITY
c
      do 2 stream = 1, n_streams                                          1b
          if ( int( params(BAS_MASK,stream) + 0.5 ) .eq. YES ) then       2b
c
c       hot-wire operating temperature
c
              params(DER_WIRE_TEMP,stream) =
     1            params(BAS_OVERHEAT,stream) /
     2            params(BAS_ALPHA,stream) + AMBIENT_TEMP
c
c       film temperature
c
              params(DER_FILM_TEMP,stream) =
     1            params(DER_WIRE_TEMP,stream) *
     2            params(BAS_TEMP_WGHT,stream) +
     3            AMBIENT_TEMP * ( 1.0 - params(BAS_TEMP_WGHT,stream) )
c
c       non-dimensional hot-wire diameter
c
              params(DER_D_PLUS,stream) = params(BAS_WIRE_DIAM,stream) *
     1            1.0e-6 * params(BAS_FRIC_VEL,stream) / amb_kinem_visc
c
c       fluid film density
c
              params(DER_FILM_DENS,stream) = ATMOS_PRESS /
     1            GAS_CONSTANT / params(DER_FILM_TEMP,stream)
c
c       fluid film kinematic viscosity
c
              params(DER_FILM_VISC,stream) =
     1            Qmuair( params(DER_FILM_TEMP,stream) ) /
     2            params(DER_FILM_DENS,stream)
c
              last_index = ( int( params(PRF_N_POINTS,stream) + 0.5 )
     2                       - 1 ) * PRF_LAW_INCREM
              do 1 i = 0, last_index, PRF_LAW_INCREM                      3b
c
c       Corrected values of y^+
                  params(PRF_CORR_Y_PL+i,stream) =
     1                params(PRF_EXPT_Y_PL+i,stream) *
     2                params(BAS_FRIC_CORR,stream)
c
c       Corrected values of U^+
                  params(PRF_CORR_U_PL+i,stream) =
     1                params(PRF_EXPT_U_PL+i,stream) /
     2                params(BAS_FRIC_CORR,stream)
c
c       Non-dimensional velocity error
                  params(PRF_VEL_ERROR+i,stream) =
     1                params(PRF_CORR_U_PL+i,stream) -
     2                params(PRF_CORR_Y_PL+i,stream)
c
c       Measured Reynolds number
                  params(PRF_RE_MEASUR+i,stream) =
     1                params(PRF_CORR_U_PL+i,stream) *
     2                params(DER_D_PLUS,stream) * amb_kinem_visc /
     3                params(DER_FILM_VISC,stream)
c
c       Actual Reynolds number
                  params(PRF_RE_ACTUAL+i,stream) =
     1                params(PRF_CORR_Y_PL+i,stream) *
     2                params(DER_D_PLUS,stream) * amb_kinem_visc /
     3                params(DER_FILM_VISC,stream)
c
c       Nusselt number of the total heat transfer
                  params(PRF_NUS_TOTAL+i,stream) =
     1    ( params(DER_FILM_TEMP,stream) / AMBIENT_TEMP ) ** 0.17 *
     2    ( params(BAS_HWC_A,stream) + params(BAS_HWC_B,stream) *
     3      params(PRF_RE_MEASUR+i,stream) ** params(BAS_HWC_N,stream) )
c
c       Nusselt number of heat transfer to the fluid
                  params(PRF_NUS_FLUID+i,stream) =
     1    ( params(DER_FILM_TEMP,stream) / AMBIENT_TEMP ) ** 0.17 *
     2    ( params(BAS_HWC_A,stream) + params(BAS_HWC_B,stream) *
     3      params(PRF_RE_ACTUAL+i,stream)**params(BAS_HWC_N,stream) ) -
     4    ( params(BAS_HWC_C,stream) + params(BAS_HWC_D,stream) *
     5      params(PRF_RE_ACTUAL+i,stream)**params(BAS_HWC_N,stream) ) *
     6      params(DER_D_PLUS,stream) ** params(BAS_HWC_E,stream) *
     7      ( params(PRF_RE_ACTUAL+i,stream) /
     8        params(PRF_CORR_Y_PL+i,stream) )
     9      ** params(BAS_HWC_F,stream) *
     a      exp( - min( 80.0, params(PRF_CORR_Y_PL+i,stream) **
     b                  params(BAS_HWC_G,stream) ) )
c
c       Nusselt number of heat transfer to the wall
                  params(PRF_NUS_WALL+i,stream) =
     1                ( params(PRF_NUS_TOTAL+i,stream) -
     2                  params(PRF_NUS_FLUID+i,stream) ) *
     3                params(PRF_CORR_Y_PL+i,stream) /
     4                params(DER_D_PLUS,stream)
c
c       Correction function - y^+ dependent part of PRF_NUS_WALL
                  params(PRF_CORR_FUNC+i,stream) =
     1    params(PRF_NUS_WALL+i,stream) /
     2    params(DER_D_PLUS,stream) ** params(BAS_HWC_H,stream) /
     3    params(PRF_RE_ACTUAL+i,stream) ** params(BAS_HWC_I,stream) /
     4    params(PRF_CORR_Y_PL+i,stream) ** params(BAS_HWC_J,stream) /
     5    ( amb_kinem_visc / params(DER_FILM_VISC,stream) ) **
     6        params(BAS_HWC_K,stream)
1                 continue                                                3e
              end if                                                      2e
2         continue                                                        1e
      return
      end



      SUBROUTINE XFER_CALC_LAW( PARAMS, N_STREAMS, CORR_LAW )
      include 'stdio.def'
      include 'wallprox.def'
      include 'xfer.def'
c
      real AMBIENT_TEMP, ATMOS_PRESS, GAS_CONSTANT, ATMOS_DENSITY
      parameter( AMBIENT_TEMP =293.15,
     1    ATMOS_PRESS  = 101325.0,
     2    GAS_CONSTANT = 287.0,
     3    ATMOS_DENSITY= ATMOS_PRESS / AMBIENT_TEMP / GAS_CONSTANT )
c
      integer i, last_index, n_streams, stream
      real    params(STREAM_LENGTH,*), corr_law(MAX_LAW),
     1        amb_kinem_visc, y_plus, y_pl_step, prox_law, Qmuair
c
c
      amb_kinem_visc = Qmuair( AMBIENT_TEMP ) / ATMOS_DENSITY
c
      do 2 stream = 1, n_streams                                          1b
          if ( int( params(BAS_MASK,stream) + 0.5 ) .eq. YES ) then       2b
c
c       hot-wire operating temperature
c
              params(DER_WIRE_TEMP,stream) =
     1            params(BAS_OVERHEAT,stream) /
     2            params(BAS_ALPHA,stream) + AMBIENT_TEMP
c
c       film temperature
c
              params(DER_FILM_TEMP,stream) =
     1            params(DER_WIRE_TEMP,stream) *
     2            params(BAS_TEMP_WGHT,stream) +
     3            AMBIENT_TEMP * ( 1.0 - params(BAS_TEMP_WGHT,stream) )
c
c       non-dimensional hot-wire diameter
c
              params(DER_D_PLUS,stream) = params(BAS_WIRE_DIAM,stream) *
     1            1.0e-6 * params(BAS_FRIC_VEL,stream) / amb_kinem_visc
c
c       fluid film density
c
              params(DER_FILM_DENS,stream) = ATMOS_PRESS /
     1            GAS_CONSTANT / params(DER_FILM_TEMP,stream)
c
c       fluid film kinematic viscosity
c
              params(DER_FILM_VISC,stream) =
     1            Qmuair( params(DER_FILM_TEMP,stream) ) /
     2            params(DER_FILM_DENS,stream)
c
              y_plus = corr_law(Hdom_min)
              y_pl_step = ( corr_law(Hdom_max) - corr_law(Hdom_min) ) /
     1            ( int( params(LAW_N_POINTS,stream) + 0.5 ) - 1 )
              last_index = ( int( params(LAW_N_POINTS,stream) + 0.5 )
     2                       - 1 ) * PRF_LAW_INCREM
              do 1 i = 0, last_index, PRF_LAW_INCREM                      3b
c
c       (Corrected) distance from the wall
                  params(LAW_CORR_Y_PL+i,stream) = y_plus
c
c       Actual Reynolds number
                  params(LAW_RE_ACTUAL+i,stream) =
     1                params(LAW_CORR_Y_PL+i,stream) *
     2                params(DER_D_PLUS,stream) * amb_kinem_visc /
     3                params(DER_FILM_VISC,stream)
c
c       Wall proximity effect correction function
                  params(LAW_CORR_FUNC+i,stream) = prox_law( y_plus,
     1                corr_law )
c
c       Nusselt number of heat transfer to the wall
c         ( from correction function and from Reynolds number)
                  params(LAW_NUS_WALL+i,stream) =
     1    params(DER_D_PLUS,stream) ** params(BAS_HWC_H,stream) *
     2    params(LAW_RE_ACTUAL+i,stream) ** params(BAS_HWC_I,stream) *
     3    y_plus ** params(BAS_HWC_J,stream) *
     4    ( amb_kinem_visc / params(DER_FILM_VISC,stream) ) **
     6    params(BAS_HWC_K,stream) * params(LAW_CORR_FUNC+i,stream)
c
c       Nusselt number of heat transfer to the fluid
                  params(LAW_NUS_FLUID+i,stream) =
     1    ( params(DER_FILM_TEMP,stream) / AMBIENT_TEMP ) ** 0.17 *
     2    ( params(BAS_HWC_A,stream) + params(BAS_HWC_B,stream) *
     3      params(LAW_RE_ACTUAL+i,stream)**params(BAS_HWC_N,stream) ) -
     4    ( params(BAS_HWC_C,stream) + params(BAS_HWC_D,stream) *
     5      params(LAW_RE_ACTUAL+i,stream)**params(BAS_HWC_N,stream) ) *
     6      params(DER_D_PLUS,stream) ** params(BAS_HWC_E,stream) *
     7      ( params(LAW_RE_ACTUAL+i,stream) / y_plus ) **
     8          params(BAS_HWC_F,stream) *
     9      exp( - min( 80.0, params(LAW_CORR_Y_PL+i,stream) **
     a                  params(BAS_HWC_G,stream) ) )
c
c       Nusselt number of the total heat transfer
c           ( from Nusselt number of heat transfer to the fluid
c             and from Nusselt number of heat transfer to the wall )
                  params(LAW_NUS_TOTAL+i,stream) =
     1                params(LAW_NUS_FLUID+i,stream) +
     2                params(LAW_NUS_WALL+i,stream) *
     3                    params(DER_D_PLUS,stream) /
     4                    params(LAW_CORR_Y_PL+i,stream)
c
c       Measured Reynolds number
c           (from Nusselt number of the total heat transfer)
CC      IF ( STREAM .EQ. 8 ) THEN
CC      WRITE(6,999) STREAM, I, ( params(LAW_NUS_TOTAL+i,stream) *
CC     1        ( params(DER_FILM_TEMP,stream) / AMBIENT_TEMP ) ** -0.17 -
CC     2        params(BAS_HWC_A,stream) ) / params(BAS_HWC_B,stream),
CC     4        1.0 / params(BAS_HWC_N,stream)
CC999   FORMAT( ' STREAM,I ', 2I4, 2G15.7 )
CC      END IF
                  params(LAW_RE_MEASUR+i,stream) =
     1    max( 1.0e-6, ( ( params(LAW_NUS_TOTAL+i,stream) *
     2        ( params(DER_FILM_TEMP,stream) / AMBIENT_TEMP ) ** -0.17 -
     3      params(BAS_HWC_A,stream) ) / params(BAS_HWC_B,stream) ) ) **
     4    ( 1.0 / params(BAS_HWC_N,stream) )
c
c       Measured (corrected) U^+ (from measured Reynolds number)
                  params(LAW_CORR_U_PL+i,stream) =
     1                params(LAW_RE_MEASUR+i,stream) /
     2                params(DER_D_PLUS,stream) / amb_kinem_visc *
     3                params(DER_FILM_VISC,stream)
c
c       Non-dimensional velocity error
                  params(LAW_VEL_ERROR+i,stream) =
     1                params(LAW_CORR_U_PL+i,stream) -
     2                params(LAW_CORR_Y_PL+i,stream)
c
c       Experimental (uncorrected) values of y^+
                  params(LAW_EXPT_Y_PL+i,stream) =
     1                params(LAW_CORR_Y_PL+i,stream) /
     2                params(BAS_FRIC_CORR,stream)
c
c       Experimental (corrected) values of U^+
                  params(LAW_EXPT_U_PL+i,stream) =
     1                params(LAW_CORR_U_PL+i,stream) *
     2                params(BAS_FRIC_CORR,stream)
                  y_plus = y_plus + y_pl_step
1                 continue                                                3e
              end if                                                      2e
2         continue                                                        1e
      return
      end

cc      INTEGER II
cc      CHARACTER XFER_PRF_NAME*16
cc
cc      WRITE( STD_OUT, 999 ) ( STREAM, I, II, XFER_PRF_NAME(II),
cc     1    PARAMS(II,STREAM), II = LAW_EXPT_Y_PL, LAW_CORR_FUNC )
cc999   FORMAT( 1X, I2, 1X, I4, 1X, I3, 2X, A, 2X, G13.6 )
cc      CALL WAIT_FOR_CR()


      SUBROUTINE XFER_MASK( PARAMS, N_STREAMS )
c
c Edit the data stream selection mask
c
      include 'stdio.def'
      include 'xfer.def'
      integer i, item, group(MAX_STREAMS,MAX_GROUPS), n_group,
     1        n_streams, Jresp
      real    params(STREAM_LENGTH,*)
      character Cyes*3
c
      save group, n_group
      data n_group / 1 /
      data group / GROUP_LENGTH * NO /
c
      if ( n_streams .gt. 0 ) then                                        1b
c         start of loop                                                   2b
1             call newscr()
              write( STD_OUT, 2 ) ( n_group, i = 1, 4 ),
     1            ( i, Cyes( int( params(BAS_MASK,i) + 0.5 ) ),
     2              i = 1, n_streams )
2             format( ' Edit data stream mask' /
     7            '  -7) Select group number' /
     6            '  -6) Redefine group ', i2 /
     5            '  -5) Display group ', i2 /
     4            '  -4) Set group ', i2, ' masks' /
     3            '  -3) Clear group ', i2, ' masks' /
     2            '  -2) Clear all masks' /
     1            '  -1) Set all masks' /
     Z            '   0) Exit' /
     1            ( 2x, i2, ') ', a ) )
              item = Jresp( STD_IN, -7, n_streams, MAX_TRIES )
              if ( item .eq. 0 ) then                                     3b
                  return
c
c           SELECT GROUP NUMBER
c
              else if ( item .eq. -7 ) then                               3m
                  write( STD_OUT, 3 )
3                 format( ' Group number ? ' )
                  n_group = Jresp( STD_IN, 1, MAX_GROUPS, MAX_TRIES )
c
c           REDEFINE GROUP #
c
              else if ( item .eq. -6 ) then                               3m
                  do 4 i = 1, n_streams                                   4b
                      group(i,n_group) = params(BAS_MASK,i)
4                     continue                                            4e
c
c           DISPLAY GROUP #
c
              else if ( item .eq. -5 ) then                               3m
                  write( STD_OUT, 5 ) n_group,
     1                ( i, Cyes( group(i,n_group) ), i = 1, n_streams )
5                 format( ' Group ', i2 / ( 1x, i2, ') ', a ) )
                  call wait_for_CR()
c
c           SET GROUP # MASKS
c
              else if ( item .eq. -4 ) then                               3m
                  do 6 i = 1, n_streams
                      if ( group(i,n_group) .eq. YES ) then               4b
                          params(BAS_MASK,i) = YES
                          end if                                          4e
6                     continue                                            3e
c
c           CLEAR GROUP # MASKS
c
              else if ( item .eq. -3 ) then                               3m
                  do 7 i = 1, n_streams
                      if ( group(i,n_group) .eq. YES ) then               4b
                          params(BAS_MASK,i) = NO
                          end if                                          4e
7                     continue                                            3e
c
c           CLEAR ALL MASKS
c
              else if ( item .eq. -2 ) then                               3m
                  do 8 i = 1, n_streams                                   4b
                      params(BAS_MASK,i) = NO
8                     continue                                            4e
c
c           SET ALL MASKS
c
              else if ( item .eq. -1 ) then                               3m
                  do 9 i = 1, n_streams                                   4b
                      params(BAS_MASK,i) = YES
9                     continue                                            4e
c
c           SET ONE MASK
c
              else if ( 1 .le. item .and. item .le. n_streams ) then      3m
                  params(BAS_MASK,item) =
     1                int( YES + 0.5 - params(BAS_MASK,item) )
                  end if                                                  3e
              goto 1
c             end of loop                                                 2e
          end if                                                          1e
      end



      SUBROUTINE XFER_LAW_FIT_COORDS( PARAMS, N_STREAMS, CORR_LAW,
     1    ERR_ORDIN, X_FIT, Y_FIT, N_FIT )
      include 'stdio.def'
      include 'wallprox.def'
      include 'xfer.def'
c
      integer err_ordin, i, last_index, n_fit, n_streams, order,
     1        stream, type
      real    corr_law(MAX_LAW), error, exponent,
     1        params(STREAM_LENGTH,MAX_STREAMS), temp, vel_factor,
     2        x_fit(MAX_FIT), y_factor, y_fit(MAX_FIT), y_plus
c
c
      type       = corr_law(Htype) + 0.5
      order      = corr_law(Horder) + 0.5
      vel_factor = corr_law(Hv_fact)
      y_factor   = corr_law(Hy_fact)
      exponent   = corr_law(Hexpon)
c
c       calculate the fitting coordinates
c
      n_fit =  0
c
c
      do 3 stream = 1, n_streams                                          1b
          if ( int( params(BAS_MASK,stream) + 0.5 ) .eq. YES ) then       2b
              last_index = ( int( params(PRF_N_POINTS,stream) + 0.5 )
     1                       - 1 ) * PRF_LAW_INCREM
              do 2 i = 0, last_index, PRF_LAW_INCREM                      3b
                  y_plus = params(PRF_CORR_Y_PL+i,stream)
                  if ( corr_law(Hdom_min) .le. y_plus .and.
     1                 corr_law(Hdom_max) .ge. y_plus ) then              4b
                      n_fit  = n_fit + 1
                      error  = params(err_ordin+i,stream)
c
c               TYPE 1 - depends of formula for the law
c
                      if ( type .eq. 1 ) then                             5b
                          y_fit(n_fit) = error /
     1                         vel_factor / y_plus ** exponent
                          x_fit(n_fit) = y_plus / y_factor
c
c               TYPE 2 - depends of formula for the law
c
                      else if ( type .eq. 2 ) then                        5m
                          y_fit(n_fit) = error /
     1                        vel_factor / y_plus ** exponent
                          x_fit(n_fit) = y_factor / y_plus
c
c               TYPE 3 - depends of formula for the law
c
                      else if ( type .eq. 3 ) then                        5m
                          y_fit(n_fit) = error / vel_factor
                          x_fit(n_fit) = ( y_plus/y_factor ) ** exponent
c
c               TYPE 4 - depends of formula for the law
c
                      else if ( type .eq. 4 ) then                        5m
                          temp = error * y_plus / exponent / vel_factor
                          if ( temp .gt. 0.0 ) then                       6b
                              y_fit(n_fit) = - log( temp )
                              x_fit(n_fit) = ( y_plus / y_factor ) ** 2
                          else                                            6m
                              write( STD_ERR, 1 ) temp
1     format( ' WARNING : Skip data - Cannot evaluate log(',g12.5,')' )
                              n_fit = n_fit - 1
                              end if                                      6e
c
c               TYPE 5 - depends of formula for the law
c
                      else if ( type .eq. 5 ) then                        5m
                          temp = error / exponent / vel_factor
                          if ( temp .gt. 0.0 ) then                       6b
                              y_fit(n_fit) = - log( temp )
                              x_fit(n_fit) = y_plus / y_factor
                          else                                            6m
                              write( STD_ERR, 1 ) temp
                              n_fit = n_fit - 1
                              end if                                      6e
c
c               TYPE 6 - depends of formula for the law
c
                      else if ( type .eq. 5 ) then                        5m
                          temp = error / vel_factor /
     1                        ( y_plus/ y_factor ) ** exponent
                          if ( temp .gt. 0.0 ) then                       6b
                              y_fit(n_fit) = - log( temp )
                              x_fit(n_fit) = y_plus / y_factor
                          else                                            6m
                              write( STD_ERR, 1 ) temp
                              n_fit = n_fit - 1
                              end if                                      6e
                          end if                                          5e
                      end if                                              4e
2                 continue                                                3e
              end if                                                      2e
3         continue                                                        1e
      return
      end



      LOGICAL FUNCTION XFER_MAKE_LAW( PARAMS, N_STREAMS, CORR_LAW,
     1                                GOT_LAW )
c
      include 'stdio.def'
      include 'wallprox.def'
      include 'xfer.def'
c
      integer capture_len, err_ordin, i, item, n_fit, n_streams,
     1        Jresp, str_length
      logical got_law, new_data
      real    corr_law(MAX_LAW), params(STREAM_LENGTH,MAX_STREAMS),
     1        weight(MAX_FIT), x_fit(MAX_FIT), y_fit(MAX_FIT)
      double precision work(2,2*(MAX_LAW-Hpoly)+1)
      character  Capture_file*32, Xfer_prf_name*16
c     subroutine Cresp, ilgclos, newscr, prox_write, spyorth,
c    1           xfer_edit_law, Xfer_law_fit_coords, Xfer_law_plot,
c    2           xfer_make_law
c
      save err_ordin, capture_len, capture_file
      data err_ordin, capture_len / PRF_CORR_FUNC, 1 /
      data capture_file / ' ' /
c
      new_data = .TRUE.
c     start of loop                                                       1b
1         call newscr()
          capture_len = max( 1, str_length( capture_file ) )
          write( STD_OUT, 2 ) Xfer_prf_name(err_ordin),
     1        Capture_file(1:capture_len)
2         format( ' What to do ?' / '  0) Exit'   /
     1            '  1) Edit correction law parameters' /
     2            '  2) Error source            ', a /
     3            '  3) Capture file name          ', a /
     4            '  4) Calculate Correction law' /
     5            '  5) Edit/plot fitting data' /
     6            '  6) Refresh data' /
     7            '  7) Edit stream mask ' )
          item = Jresp( STD_IN, 0, 7, MAX_TRIES )
c
          if ( item .eq. 0 ) then                                         2b
              call ilgclos()
              return
c
c               EDIT CORRECTION LAW PARAMETERS
c               ******************************
c
          else if ( item .eq. 1 ) then                                    2m
              call xfer_edit_law( corr_law )
              new_data = .TRUE.
c
c               ERROR SOURCE
c               ************
c
          else if ( item .eq. 2 ) then                                    2m
              if ( err_ordin .eq. PRF_VEL_ERROR ) then                    3b
                  err_ordin = PRF_CORR_FUNC
              else                                                        3m
                  err_ordin = PRF_VEL_ERROR
                  end if                                                  3e
              new_data = .TRUE.
c
c               CAPTURE FILE NAME
c               *****************
c
          else if ( item .eq. 3 ) then                                    2m
              write( STD_OUT, 3 )
3             format( ' Enter capture file name ' )
              call Cresp( STD_IN, capture_file, MAX_TRIES )
c
c               CALCULATE THE FITTING COORDINATES
c               *********************************
c
          else if ( item .eq. 4 .or. item .eq. 5 ) then                   2m
              if ( new_data ) then                                        3b
                  call Xfer_law_fit_coords( params, n_streams,
     1                corr_law, err_ordin, x_fit, y_fit, n_fit )
                  new_data = .FALSE.
                  end if                                                  3e
c
c               CALCULATE CORRECTION LAW
c               ************************
c
              if ( n_fit .gt. 0 ) then                                    3b
                  if ( item .eq. 4 ) then                                 4b
                      do 4 i = 1, n_fit                                   5b
                          weight(i) = 1.0
4                         continue                                        5e
                      call spyorth( x_fit, y_fit, weight, n_fit,
     1                    corr_law(Hpoly), int( corr_law(Horder) +0.5 ),
     2                    corr_law(Hpol_err), work )
                      got_law = .TRUE.
                      call prox_write( corr_law, ' ' )
                      call wait_for_CR()
c
c               EDIT/PLOT FITTING DATA
c               **********************
c
                  else if ( item .eq. 5 ) then                            4m
                      call Xfer_law_plot( capture_file, corr_law,
     1                    x_fit, y_fit, n_fit, got_law )
                      end if                                              4e
              else                                                        3m
                  write( STD_ERR, 5 )
5                 format( ' WARNING : No data points inside domain' )
                  call wait_for_CR()
                  end if                                                  3e
c
c               REFRESH DATA - allow recalculation of fitting data
c               ************
c
          else if ( item .eq. 6 ) then                                    2m
              new_data = .TRUE.
c
c               EDIT STREAM MASK
c
          else if ( item .eq. 7 ) then                                    2e
              call xfer_mask( params, n_streams )
              call Xfer_calc_Nuss( params, n_streams )
              if ( got_law )
     1            call Xfer_calc_law( params, n_streams, corr_law )
              new_data = .TRUE.
              end if                                                      2e
          goto 1
c         end of loop                                                     1e
c
      end



      SUBROUTINE XFER_LAW_PLOT( CAPTURE_FILE, CORR_LAW,
     1    X_FIT, Y_FIT, N_FIT, PLOT_LAW )
      include 'stdio.def'
      include 'wallprox.def'
      include 'xfer.def'
c
      integer i, n_fit, type
      logical plot_law
      real    corr_law(MAX_LAW), curv_x(MAX_CURVE), curv_y(MAX_CURVE),
     1        exponent, max_domain, min_domain, px_del, px_max, px_min,
     2        py_max, py_min, x_fit(MAX_FIT), x_max, x_min,
     3        y_fit(MAX_FIT), y_max, y_min, qpoly
      character capture_file*(*)
c     subroutine ilgdata, ilgimit, ilgline, ilgopen, sfudge
c
      type       = int( corr_law(Htype) + 0.5 )
      exponent   = corr_law(Hexpon)
      min_domain = corr_law(Hdom_min)
      max_domain = corr_law(Hdom_max)
c
      call ilgopen( capture_file )
c
c               limits of the fitting data
c
      x_min =  1.0e37
      y_min =  1.0e37
      x_max = -1.0e37
      y_max = -1.0e37
      do 1 i = 1, n_fit                                                   1b
          x_min = min( x_min, x_fit(i) )
          y_min = min( y_min, y_fit(i) )
          x_max = max( x_max, x_fit(i) )
          y_max = max( y_max, y_fit(i) )
1         continue                                                        1e
      call ilgimit( x_min, y_min, x_max, y_max )
c
c               determine the domain of the fitted polynomial
c               this depends on the form of the fitting laws
c
      if ( plot_law ) then                                                1b
          if ( type .eq. 1 .or. type .eq. 5 .or. type .eq. 6 ) then       2b
              px_min = min_domain
              px_max = max_domain
          else if ( type .eq. 2 ) then                                    2m
              px_min = 1.0 / max_domain
              px_max = 1.0 / min_domain
          else if ( type .eq. 3 ) then                                    2m
              if ( exponent .gt. 0.0 ) then                               3b
                  px_min = min_domain ** exponent
                  px_max = max_domain ** exponent
              else                                                        3m
                  px_min = max_domain ** exponent
                  px_max = min_domain ** exponent
                  end if                                                  3e
          else if ( type .eq. 4 ) then                                    2m
              px_min = min_domain **2
              px_max = max_domain **2
              end if                                                      2e
c
c               generate the data points & then plot the polynomial
c
          px_del = ( px_max - px_min ) / ( MAX_CURVE - 1 )
          do 2 i = 1, MAX_CURVE                                           2b
              curv_x(i) = px_min + px_del * ( i - 1 )
              curv_y(i) = qpoly( curv_x(i), corr_law(Hpoly),
     1                        int( corr_law(Horder) + 0.5 ) )
2             continue                                                    2e
          call ilgline( 0, 1, 1 )
          call ilgdata( curv_x, curv_y, 1, MAX_CURVE, 0 )
          end if                                                          1e
      if ( n_fit .gt. 0 ) then                                            1b
          call sfudge( x_fit, y_fit, 1, n_fit, n_fit, MAX_FIT )
          call ilgline( 0, 1, 1 )
      else                                                                1m
          write( STD_ERR, 3 )
3         format( ' WARNING : No data points inside domain' )
          end if                                                          1e
      call ilgclos()
      return
      end



      SUBROUTINE GET_TOKEN( STRING, TOKEN )
c
c Extract the next token from STRING and place it in TOKEN . On the
c any call where STRING is not blank and only one character in length,
c STRING is saved and the search for a token starts at the beginning of
c the string . In a call where STRING = ' ' (and is one character long),
c the next token is extracted from the previously saved STRING . The
c maximum length of a saved string is 128 characters . If there are no more
c tokens in the string the returned value of TOKEN is ' '.
c
c Arguments
c  character string*(*)   # INPUT  # string containing tokens
c            token*(*)    # OUTPUT # returned token
c
c local variables
c  integer
c   len_saved         # non blamk length of the saved string
c   start, finish     # start & finish indices in the saved string of the token
c   str_length        # function : non-blank length of string
c  character
c   saved*128         # saved string
c
      include 'stdio.def'
      include 'token.def'
c
      integer len_saved, start, finish, str_length
      character saved*128, string*(*), token*(*)
c
      save saved, start
      data saved / ' ' /
      data start / 1 /
c
      if ( string .eq. char( TOK_TO_EOL ) ) then
          if ( start .lt. len_saved .and. len_saved .gt. 0 ) then
              token = saved(start+1:len_saved)
              start = len_saved + 1
          else
              token = ' '
              end if
      else
          if ( len(string) .ne. 1 .or. string(1:1) .ne. ' ' ) then
              saved = string
              len_saved = str_length( string )
              start = 1
              end if
          if ( len_saved .le. 0 ) then
              token = ' '
          else
c
1             if ( start .le. len_saved ) then
                  if ( saved(start:start) .eq. ' ' ) then
                      start = start + 1
                      goto 1
                      end if
                  finish = start
2                 if ( finish .lt. len_saved ) then
                      if ( saved(finish+1:finish+1) .ne. ' ' ) then
                          finish = finish + 1
                          goto 2
                          end if
                      end if
                  token = saved(start:finish)
                  start = finish + 1
              else
                  token = ' '
                  end if
              end if
          end if
      return
      end



      LOGICAL FUNCTION NEXT_TOKEN( STREAM_LU, TOKEN, TYPE, ECHO )
c
c     Get next token from command stream
c
c Arguments
c  integer   stream_lu
c  character token*(*)
c  integer   type
c  logical   echo
c
      include 'stdio.def'
      include 'token.def'
c
      integer stream_lu, previous_lu, type, str_length
      logical echo
      character token*(*), line*128
c
      save previous_lu
      data previous_lu / STD_IN /
c
      if ( stream_lu .ne. previous_lu ) call flush_token()
      previous_lu = stream_lu
      next_token = .FALSE.
c
      if ( type .eq. TOK_TO_EOL ) then
          call get_token( char( TOK_TO_EOL ), token )
          if ( token .eq. ' ' ) read( stream_lu, 2, END=3 ) token
      else  if ( type .eq. TOK_NOBLANK .or.
     1           type .eq. TOK_EMPTYOK ) then
          call get_token( ' ', token )
1         if ( token .eq. ' ' .or. token(1:1) .eq. ';' ) then
              read( stream_lu, 2, END=3 ) line
2             format( a )
              call get_token( line, token )
              if ( type .eq. TOK_NOBLANK .or. token(1:1) .eq. ';' )
     1            goto 1
              end if
          end if
      next_token = .TRUE.
      if ( echo ) write( STD_OUT, 4 )
     1    token( 1 : max( str_length(token), 1 ) )
4     format( 1x, a )
3     return
      end



      SUBROUTINE FLUSH_TOKEN()
c
      include 'stdio.def'
c
      character flushed_token*1
c
1     call get_token( ' ', flushed_token )
      if ( flushed_token .ne. ' ' ) goto 1
      return
      end



      LOGICAL FUNCTION GET_REAL( STREAM_LU, VALUE,
     1                           MINIMUM, MAXIMUM, ECHO )
c
c       reads a real number from the command stream
c
      include 'stdio.def'
      include 'token.def'
      integer    MAX_TRIES
      parameter( MAX_TRIES=4 )
c
      integer stream_lu, ntries
      logical echo, eqabbr, next_token
      real    value, maximum, minimum
      character string*32
c
c           read from command stream
c
      get_real = .TRUE.
      do 3 ntries = 1, MAX_TRIES                                          1b
          if ( .not. next_token( stream_lu,
     1                           string, TOK_NOBLANK, echo ) ) then       2b
c             end of file detected
              goto 7
          else                                                            2m
              call casech( string, 'l' )
c             user abort
              if ( string .eq. 'end' ) then                               3b
                  get_real = .FALSE.
c           selected  maximum
              else if ( eqabbr( string, 'maximum', 3 ) ) then             3m
                  value = maximum
c           selected  minimum
              else if ( eqabbr( string, 'minimum', 3 ) ) then             3m
                  value = minimum
c
c           decode & check numeric value
              else                                                        3m
                  read( string, 10, ERR=3 ) value
10                format( bn, f32.0 )
                  if ( value .lt. min( minimum, maximum ) .or.
     1                 value .gt. max( minimum, maximum ) ) then          4b
                      write ( STD_ERR, 1 ) minimum, maximum
1                     format(' GET_REAL : ERROR ; real outside limits ',
     1                    g15.7, ' & ', g15.7 )
                      if ( stream_lu .ne. STD_IN ) goto 7
                      write ( STD_OUT, 2 )
2                     format( ' Try again' )
c                     skip to end of loop
                      goto 3                                              4e
                      end if                                              3e
                  end if                                                  2e
              end if
          return
c
c           error detected
c
3         write( STD_OUT, 4 )
4         format( ' GET_REAL : Can''t decode that . Try again .' )
5         continue                                                        1e
      write( STD_OUT, 6 )
6     format( 8x, 'Get Help' )
c
c     end of file
7     get_real = .FALSE.
      return
      end



      LOGICAL FUNCTION GET_INT( STREAM_LU, VALUE,
     1                          MINIMUM, MAXIMUM, ECHO )
c
c       reads integer from the command stream
c
      include 'stdio.def'
      include 'token.def'
      integer    MAX_TRIES
      parameter( MAX_TRIES=4 )
c
      integer stream_lu, ntries, value, maximum, minimum
      logical echo, eqabbr, next_token
      character string*32
c
c           read from command stream
c
      get_int = .TRUE.
      do 3 ntries = 1, MAX_TRIES                                         1b
          if ( .not. next_token( stream_lu,
     1                           string, TOK_NOBLANK, echo ) ) then       2b
c             end of file detected
              goto 7
          else                                                            2m
              call casech( string, 'l' )
c             user abort
              if ( string .eq. 'end' ) then                               3b
                  get_int = .FALSE.
c           selected  maximum
              else if ( eqabbr( string, 'maximum', 3 ) ) then             3m
                  value = maximum
c           selected  minimum
              else if ( eqabbr( string, 'minimum', 3 ) ) then             3m
                  value = minimum
c
c           decode & check numeric value
              else                                                        3m
                  read( string, 10, ERR=3 ) value
10                format( bn, i32 )
                  if ( value .lt. min( minimum, maximum ) .or.
     1                 value .gt. max( minimum, maximum ) ) then          4b
                      write ( STD_ERR, 1 ) minimum, maximum
1                     format(' GET_INT : ERROR ; integer outside ',
     1                    'limits ', i12, ' & ', i12 )
                      if ( stream_lu .ne. STD_IN ) goto 7
                      write ( STD_OUT, 2 )
2                     format( ' Try again ' )
c                     skip to end of loop
                      goto 3                                              4e
                      end if                                              3e
                  end if                                                  2e
              end if
          return
c
c           error detected
c
3         write( STD_OUT, 4 )
4         format( ' GET_INT : Can''t decode that . Try again .' )
5         continue                                                        1e
      write( STD_OUT, 6 )
6     format( 8x, 'Get Help' )
c
c
c     end of file
7     get_int = .FALSE.
      return
      end



      SUBROUTINE CASECH( STRING, CASE )
c
c       CASE CHange
c     Change the case of character string CSTR to upper, lower of edit case .
c
c Arguments
c  character string*(*),  # IN/OUT # operand character string
c            case*1       # INPUT  # 'l' or 'L' - change to lower case
c                                  # 'u' or 'U' - change to upper case
c                                  # 'e' or 'E' - change to edit case
c                                  # anyting else - no change
c local variables
c  integer i        # indexing counter
c  logical first    # first letter in a word
c
      include 'stdio.def'
c
      integer i, str_length
      logical first
      character string*(*), case*1
c
c
c         change to lower case
c
      if ( case .eq. 'l' .or. case .eq. 'L' ) then                        1b
          do 1 i = 1, str_length( string )                                2b
              if ( 'A' .le. string(i:i) .and. string(i:i) .le. 'Z' )
     1            string(i:i) = char(
     2                ichar( string(i:i) ) + ichar('a') - ichar('A') )
1             continue                                                    2e
c
c         change to upper case
c
      else if ( case .eq. 'u' .or. case .eq. 'U' ) then                   1m
          do 2 i = 1, str_length( string )                                2b
              if ( 'a' .le. string(i:i) .and. string(i:i) .le. 'z' )
     1            string(i:i) = char(
     2                ichar( string(i:i) ) + ichar('A') - ichar('a') )
2             continue                                                    2e
c
c         change to edit case
c
      else if ( case .eq. 'e' .or. case .eq. 'E' ) then                   1m
          first = .TRUE.
          do 3 i = 1, str_length( string )                                2b
              if ( 'A' .le. string(i:i) .and.
     1                      string(i:i) .le. 'Z' ) then                   3b
                  if ( .not. first )
     1                string(i:i) = char( ichar( string(i:i) ) +
     2                    ichar('a') - ichar('A') )
                  first = .FALSE.
              else if ( 'a'.le. string(i:i) .and.
     1                          string(i:i) .le.'z' ) then                3m
                  if ( first )
     1                string(i:i) = char( ichar( string(i:i) ) +
     2                    ichar('A') - ichar('a') )
                  first = .FALSE.
              else                                                        3m
                  first = .TRUE.
                  end if                                                  3e
3             continue                                                    2e
          end if                                                          1e
      return
      end



      INTEGER FUNCTION STR_LENGTH( STRING )
c
c    Find the location of the last non-blank character in the character
c string STRING . If the whole string is blank, the returned value is 0 .
c
      include 'stdio.def'
      include 'token.def'
c
      character string*(*)
c
      str_length = len( string )
1     if ( str_length .ge. 1 ) then
          if ( string(str_length:str_length) .eq. ' ' ) then
              str_length = str_length - 1
          else
              return
              end if
          goto 1
          end if
      return
      end



      LOGICAL FUNCTION GET_BOOL( PROMPT_ENABLE, STREAM_LU,
     1                           BOOLEAN, MESSAGE )
c
c       Displays a query on the vdu and receives a logical response with
c  logical unit number IPLUN .
c
c    Arguments
c logical prompt_enable      # INPUT  # prompts to screen enabled
c integer stream_lu          # INPUT  # input device logical unit number
c logical boolean            # INPUT  # returned value
c character messge*(*)       # INPUT  # message string
c
c integer is_ok,      # index of response in legal response list
c         index,      # lexical function
c character response*1     # received character
c           allowed_list*8 # legal responses
c
c
      include 'stdio.def'
      include 'token.def'
c
      integer is_ok, index, stream_lu
      logical boolean, next_token, prompt_enable, echo
      character allowed_list*10, message*(*), response*1
c
      save allowed_list
      data allowed_list / 'tT1yYfF0nN' /
c
      echo = prompt_enable .and. stream_lu .ne. STD_IN
      if ( prompt_enable ) write( STD_OUT, 1 ) message
1     format( 1x, a )
c
c     start of loop
2     if ( next_token( stream_lu, response, TOK_NOBLANK, echo ) ) then
          is_ok = index( allowed_list, response )
          if ( is_ok .gt. 0 ) then
              boolean = is_ok .le. 5
              get_bool = .TRUE.
              return
              end if
          write( STD_OUT, 3 ) allowed_list
3         format( ' Expecting one of ', a )
          goto 2
          end if
c         end of loop
      get_bool = .FALSE.
      return
      end



      SUBROUTINE READ_DATA( INPUT_LU, ARRAY, ARRAY_SIZE, ROWS, COLUMNS,
     1                      ECHO )
c
c  Reads the data from the file with logical unit number INPUT_LU file into
c  the array ARRAY . ARRAY_SIZE is the maximum possible number of data values .
c  The data file is an array with ROWS rows and COLUMNS columns . A ';' in the
c  data file begins a comment field . Comment fields are terminated by an end
c  of the line . Input format is list directed ( ie. free ) . This routine
c  reads any number ( > 0 ) of columns of data in the 1st row and the same
c  number of columns from succeeding rows .
c
c   Arguments
c integer input_lu      # data file logical unit number
c real    array(*)      # data array
c integer array_size    # maximum number of data items
c         columns       # number of columns of data
c         rows          # number of rows of data
c logical echo          # echo lines which generate an error
c
c constants
c  MAX_LINE = 128 # maximum line length
c
c local variables
c  integer
c   count
c   error               # returned value from decode_line
c   i                   # data array index for zero padding
c   index               # array index for start of each row
c   line_len            # no. of values decoded from a line
c   decode_line         # decode numeric values in a string
c  character
c   line*128            # line read from file
c
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      integer    DECODE_SUCCESS,   DECODE_EMPTY,     DECODE_COMMENT,
     1           DECODE_ENDFILE,   DECODE_OVRFLOW,   DECODE_DECODE,
     2           MAX_LINE
      parameter( DECODE_SUCCESS=0, DECODE_EMPTY=1,   DECODE_COMMENT=2,
     1           DECODE_ENDFILE=4, DECODE_OVRFLOW=8, DECODE_DECODE=16,
     2           MAX_LINE=128 )
c
      real    array(*)
      logical echo
      integer input_lu, array_size, columns, rows, count, error, i,
     1        index, line_len, decode_line
      character line*128
c
c
c         read the first line of data
c
      index = 1
c     repeat                                                              1b
1         read( input_lu, 2, END=8, ERR=10 ) line
2         format( a )
          count = count + 1
          error = decode_line( line, array(index), columns, array_size )
          if ( echo ) then                                                2b
              if ( error .ne. DECODE_SUCCESS .and.
     1             error .ne. DECODE_COMMENT .and.
     2             error .ne. DECODE_EMPTY ) write( STD_ERR, 3 ) line
3             format( 1x, a )
              end if                                                      2e
          if ( error .eq. DECODE_EMPTY .or.
     1         error .eq. DECODE_COMMENT .or.
     2         ( error .eq. DECODE_OVRFLOW .or.
     3           error .eq. DECODE_DECODE ) .and. columns .le. 0 .or.
     4         columns .le. 0 )
     5        goto 1
c         until( got some values )                                        1e
c
c       read second and subsequent lines from data file
c       Truncate lines which are too long. Pad lines which are too short
c       with zeros.
c
      index = index + columns
      if ( columns .gt. 0 ) then                                          1b
          rows = 1
4         if ( index + columns - 1 .le. array_size .and.
     1         error .ne. DECODE_ENDFILE ) then                           2b
              read( input_lu, 2, END=8, ERR=10 ) line
              error = decode_line( line, array(index), line_len,
     1            columns )
              if ( echo ) then                                            3b
                  if ( error .ne. DECODE_SUCCESS .and.
     1                 error .ne. DECODE_COMMENT .and.
     2                 error .ne. DECODE_EMPTY ) write( STD_ERR, 3) line
              end if                                                      3e
              if ( line_len .gt. 0 .and. error .ne. DECODE_ENDFILE )then  3b
                  if ( line_len .lt. columns ) then                       4b
                      write( STD_ERR, 5 ) count, line_len, columns
5                     format( ' READ_DATA : Padding : Line ', i5,
     1                    ' :', i4, ' values available. ', i4,
     2                    ' required' )
                      do 6 i = index + line_len, index + columns - 1      5b
                          array(i) = 0
6                         continue                                        5e
                      end if                                              4e
                  index = index + columns
                  rows = rows + 1
                  end if                                                  3e
              count = count + 1
              goto 4
              end if                                                      2e
          end if                                                          1e
c
      if ( index + columns - 1 .gt. array_size )
     1    write( STD_ERR, 7 ) array_size
7         format( ' READ_DATA : WARNING : Array space ', i7, ' full' )
c
8     write( STD_OUT, 9 ) rows, columns
9     format( ' READ_DATA : NOTE : ',
     1    i6, ' rows, ', i6, ' columns read' )
      call flush_token()
      return
c
10    write( STD_ERR, 11 ) count
11    format( ' READ_DATA : ABORT : Cannot read line ', i5,
     1        ' from file' )
      write( STD_ERR, 3 ) line
      call flush_token()
      return
      end



      INTEGER FUNCTION DECODE_LINE(
     1    STRING, ARRAY, N_VALUES, MAX_VALUES )
c
c Decodes up to MAX_VALUES numeric values in the character string STRING and
c places them in the array ARRAY. The number of values decoded is returned in
c N_VALUES. The returned value of the function is an error flag.
c indicator if N_VALUES=0 .
c   A ';' begins a comment field and anything after it is ignored.
c   The token 'end' indicates end-of-data-in-the-file
c
c Arguments
c   character string*(*)  # INPUT  # character string to be decoded
c   real      array(*)    # OUTPUT # array of decoded values
c   integer   n_values    # OUTPUT # number of values decoded
c             max_values  # INPUT  # max no. of values to be placed in ARRAY
c
c
c Returned error flags
c   0  DECODE_SUCCESS     no errors encountered
c   1  DECODE_COMMENT     the first token in the string began with a ';'
c   2  DECODE_ENDFILE     end of data
c   4  DECODE_EMPTY       empty (blank) string
c   8  DECODE_OVRFLOW     too many numeric tokens in the string
c  16  DECODE_DECODE      could not decode token to numeric value
c
c local variables
c  real
c   value         # decoded value
c  character
c   token*32      # token extracted from string
c subroutine
c  get_token      # extract token
c
CC--VAX-SunOS-DEC-FORTRAN
      include 'stdio.def'
CC--MISCROSOFT-FORTRAN-V4:
CC$INCLUDE:'stdio.def'
c
      integer    DECODE_SUCCESS,   DECODE_EMPTY,     DECODE_COMMENT,
     1           DECODE_ENDFILE,   DECODE_OVRFLOW,   DECODE_DECODE
      parameter( DECODE_SUCCESS=0, DECODE_EMPTY=1,   DECODE_COMMENT=2,
     1           DECODE_ENDFILE=4, DECODE_OVRFLOW=8, DECODE_DECODE=16 )
c
      integer   n_values, max_values
      real      value, array(*)
      character token*32, string*(*)
c
      n_values = 0
      decode_line = DECODE_SUCCESS
c
c       get first token
c
      call get_token( string, token )
c
c     start of loop                                                       1b
c
c       finished if empty line, comment or end of file
c
1         if ( token(1:1) .eq. ' ' ) then                                 2b
              if ( n_values .eq. 0 )
     1            decode_line = DECODE_EMPTY
          else if ( token(1:1) .eq. ';' ) then                            2m
              if ( n_values .eq. 0 )
     1            decode_line = DECODE_COMMENT
          else if ( token(1:3) .eq. 'end' ) then                          2m
              decode_line = DECODE_ENDFILE
          else                                                            2m
c
c       decode the token; finished if data array is full
c
              read( token, 5, ERR=3 ) value
5             format( bn, f32.0 )
              if ( n_values .ge. max_values ) then                        3b
                  decode_line = DECODE_OVRFLOW
                  write( STD_ERR, 2 ) max_values
2                 format( ' DECODE_LINE : ABORT : Too many values on ',
     1                'line ( max = ', i5, ' )' )
              else                                                         3m
                  n_values = n_values + 1
                  array(n_values) = value
                  call get_token( ' ', token )
                  goto 1
                  end if                                                  3e
              end if                                                      2e
c         end of loop                                                     1e
      return
c
c       could not decode value
c
3     if ( n_values .ge. max_values ) then                                1b
          decode_line = DECODE_OVRFLOW + DECODE_DECODE
          write( STD_ERR, 2 ) max_values
      else                                                                1m
          decode_line = DECODE_DECODE
          end if                                                          1e
      write( STD_ERR, 4 ) n_values + 1
4     format( ' DECODE_LINE : ABORT : Cannot decode value no. ', i5 )
      return
      end



      INTEGER FUNCTION OPEN_FILE( LUN, FILE_NAME, NEW_OLD )
c
c     Opens a text file for reading ( NEW_OLD = 'old' ) or writing
c ( NEW_OLD = 'new' ). If FILE_NAME is '?', the name of the file is obtained
c from the user. If the file is for reading, the file name cannot be blank.
c If the file is for writing a blank filename is interpreted as the vdu screen.
c The logical unit used for the file is LUN. If the file is successfully opened,
c LUN is the returned result . If a file could not be opened, the returned value
c is OPEN_FILE = 0 .
c
c Arguments
c  integer   lun          # logical unit no. of file to be opened
c  character file_name*(*)# file name
c            new_old*(*)  # file status : 'old'=read, 'new'=write, or 'unknown'
c
c Local Variables
c  integer length         # length of file name string
c          str_length     # function : length of string
c character user_resp*64  # name of file - obtained from user
c
c
      include 'stdio.def'
      include 'token.def'
c
      integer lun, length, str_length
      logical next_token
      character file_name*(*), new_old*(*), user_resp*64
c
c             check argument
c
      if ( new_old .ne. 'old' .and. new_old .ne. 'new' .and.
     1     new_old .ne. 'unknown' ) then
          write( STD_OUT, 1 ) new_old
1         format( ' OPEN_FILE : ABORT : Illegal status ', a /
     1            21x, 'Need ''old'', ''new'' or ''unknown''' )
          open_file = 0
      else if ( lun .lt. 0 .or. lun .ge. 100 ) then
          write( STD_OUT, 2 ) lun
2         format( ' OPEN_FILE : ABORT : Illegal logical unit number ',
     1            i12, '. Must be 0 to 99.' )
          open_file = 0
      else
          open_file = 0
c
c             get file name
c
3         if ( file_name .eq. '?' ) then
              length = 1
              write( STD_OUT, 4 )
4             format( ' Name of file ? ' )
              if ( .not. next_token( STD_IN, user_resp, TOK_EMPTYOK,
     1                               .FALSE. ) ) goto 6
          else
              user_resp = file_name
              end if
          length = str_length( user_resp )
          if ( length .gt. 0 ) then
              open( UNIT=lun, FILE=user_resp, STATUS=new_old,
     1              ACCESS='sequential', FORM='formatted', ERR=6 )
              open_file = lun
          else if ( new_old .ne. 'old' ) then
              open_file = STD_OUT
              end if
          end if
      return
c
c             TRAPS
c
6     write( STD_OUT, 7 ) user_resp(1:length)
7     format( ' OPEN_FILE : ABORT : Cannot open file ', a )
      open_file = 0
      return
      end






