/*
    Copyright (C) 1997  Peter Vernon Lanspeary

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* *********************************************************************** */
/*                                                                         */
/*                               pointer.h                                 */
/*                                                                         */
/* *********************************************************************** */

/*
 *      Code written for PCs may use different kinds of pointer -- depending on
 * the memory model. This file defines a value VAR_PTR which can be used in
 * place of the redirection operator (*) in a variable declaration.
 *      The purpose of this file is to ensure portability of code. Use of
 * VAR_PTR will ensure that you can do proper pointer arithmetic. If you wish
 * to do arithmetic on function pointers, the function pointers can also be
 * defined using VAR_PTR.
*/

#ifndef POINTER_DEFINED
/*
 *      Borland Turbo C
*/
#ifdef  _TURBOC_        /* 1 */
#ifdef  _HUGE_          /* 2 */ /* if the memory model is              */
#define VAR_PTR huge *          /* huge, large, compact or medium,     */
#else                   /* 2 */ /* all variable pointers must be huge, */
#ifdef  _LARGE_         /* 3 */ /* otherwise they are the default      */
#define VAR_PTR huge *          /*   ( i.e. near )                     */
#else                   /* 3 */
#ifdef _COMPACT_        /* 4 */
#define VAR_PTR huge *
#else                   /* 4 */
#define VAR_PTR *
#endif                  /* 4 */
#endif                  /* 3 */
#endif                  /* 2 */
/*
 *      Power C (MIX)
*/
#else                   /* 1 */
#ifdef _POWERC_         /* 2 */
#ifdef  _LARGE_         /* 3 */
#define VAR_PTR huge *
#else                   /* 3 */
#ifdef _MEDIUM_         /* 4 */
#define VAR_PTR huge *
#else                   /* 4 */
#define VAR_PTR *
#endif                  /* 4 */
#endif                  /* 3 */
/*
 *      put other brands of C here -- e.g. MicroSoft C
*/
/*
 *      `normal' C -- no special memory fudging
*/
#else                   /* 2 */
#define VAR_PTR *
#endif                  /* 2 */
#endif                  /* 1 */

#define POINTER_DEFINED 1
#endif
