c
c    Copyright (C) 1997  Peter Vernon Lanspeary
c
c    This program is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    This program is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program; if not, write to the Free Software
c    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c


      PROGRAM DIGZCV
c
c       DIGitize CurVes from graphs
c               - using the HIPAD digitizer
c
c constants
c  Hvdulu=6                 # vdu
c  Hkbdlu=5                 # keyboard
c  Hdatlu=3                 # data file
c  Hnpts=16384              # maximum number of data points in a curve
c  Hntries=4                # maximum number of input attempts
c variables
c  integer *2 ncurve,       # curve number
c             npts,         # number of points in a line
c             istart,       # starting index in the file
c             i,            # point counter - loop index
c             item,         # menu item selected
c             Jresp         # function : integer response
c  real x(Hnpts),           # abicissa array
c       y(Hnpts)            # ordinate array
c  logical *1 equery,       # function : logical response
c             fopen,        # data file open
c             fpage         # page defined
c  character Cfile*32       # data file name
c            Com*90         # Comment string
c
      implicit none
      integer *2 Hvdulu, Hkbdlu, Hdatlu, Hnpts, Hntries
      parameter( Hvdulu=6, Hkbdlu=5, Hdatlu=3, Hnpts=16384,
     1            Hntries=4 )
c
      integer *2 ncurve, npts, istart, i, item, Jresp
      real x(Hnpts), y(Hnpts)
      logical *1 equery, fopen, fpage
      character Cfile*32, Com*90
      data fopen, fpage / 2* .false. /
c
c
      write( Hvdulu, 1 )
1     format( 21x, 'DIGITIZING GRAPHS' / 21x, 17( '#' ) / )
c     repeat
2       call dthard( Equery( Hkbdlu, 'Default Hardware settings ?' ) )
        if ( .not. Equery( Hkbdlu, ' OK ? ' ) ) goto 2
c       until( ok )
c
c     start loop
c
c       main menu                                                           1b
c
3       call dtend
        write( Hvdulu, 4 )
4       format( ' What to do ?  0) exit           1) open file    ',
     1    '2) close file' /
     2          '               3) write comment  4) define page  ',
     3    '5) define coord system' /
     4          '               6) digitize curve 7) help        ' )
        item = Jresp( Hkbdlu, 0, 7, Hntries )
        if ( item .eq. 0 ) then                                             2b
          goto 14
c
c       open data file
c
        else if ( item .eq. 1 ) then                                        2m
5         call DTMSSG( 'What is the data file name ? ' )
          read( Hkbdlu, 6 ) Cfile
6         format( a )
          if ( fopen ) then                                                 3b
            call DTMSSG( 'Close the data file ? ' )
            if ( Equery( Hkbdlu, ' ' ) ) then                               4b
              close( Hdatlu )
              fopen = .false.
              end if                                                        4e
            end if                                                          3e
          if ( .not. fopen ) then                                           3b
            open( UNIT=Hdatlu, FILE=Cfile, STATUS='unknown',
     1            FORM='formatted', ACCESS='sequential' )
            fopen = .true.
            fpage = .false.
            ncurve = 0
            istart = 1
            end if                                                          3e
c
c       close data file
c
        else if ( item .eq. 2 .and. fopen ) then                            2m
          call dtend
          close( Hdatlu )
          write( Hvdulu, 7 ) istart, ncurve
7         format( ' DIGZCV : ', i6, 'points : ', i4,
     1      ' curves digitized' )
          fopen = .false.
          fpage = .false.
c
c       write comment to data file
c
        else if ( item .eq. 3 ) then                                        2m
          if ( .not. fopen ) then                                           3b
            call DTMSSG( ' WARNING: Data file not open .' )
          else                                                              3m
            call dtend
            write( Hvdulu, 8 )
8           format( ' Enter comment . End with "."' / )
c           start loop                                                      4b
9             read( Hkbdlu, 6 ) Com
              if ( Com .eq. '.' ) goto 10
              write( Hdatlu, 15 ) charnb( Com )
15            format( ' ; ', a )
              goto 9
c             end loop                                                      4e
10          end if                                                          3e
c
c           define page
c
        else if ( item .eq. 4 ) then                                        2m
          if ( .not. fopen ) then                                           3b
            call DTMSSG( ' WARNING: Data file not open .' )
          else                                                              3m
            call dtpage
            call dtmssg( 'Press <RETURN> to continue' )
            call wait
            fpage = .true.
            end if                                                          3e
c
c           define coordinate system
c
        else if ( item .eq. 5 ) then                                        2m
          if ( .not. fopen ) then                                           3b
            call DTMSSG( ' WARNING: Data file not open .' )
          else if ( .not. fpage ) then                                      3m
            call DTMSSG( ' WARNING : Page not defined' )
          else                                                              3m
            call dtaxes
            call dtmssg( 'Press <RETURN> to continue' )
            call wait
            end if                                                          3e
c
c           digitize curve
c
        else if ( item .eq. 6 ) then                                        2m
          if ( .not. fopen ) then                                           3b
            call DTMSSG( ' WARNING: Data file not open .' )
          else if ( .not. fpage ) then                                      3m
            call DTMSSG( ' WARNING : Page not defined' )
          else                                                              3m
            call digzln( x, y, npts, Hnpts, 5 )
            if ( npts .gt. 0 ) then                                         4b
              ncurve = ncurve + 1
              write( Hdatlu, 11 ) ncurve, istart, npts,
     1                           ( x(i), y(i), i=1,npts )
11            format( ' ; curve number ', i4 /
     1          ' ; starting index = ', i5, 5x, i5, ' points' /
     2          ( 1x, 2g13.6 ) )
              write( Com, 12 ) npts, charnb( Cfile )
12            format( 'Curve with ', i4, ' data points written to ', a,
     1          '. Press <RETURN>' )
              call DTMSSG( charnb( Com ) )
              call wait
              istart = istart + npts
              end if                                                        4e
            end if                                                          3e
c
c               help
c
        else if ( item .eq. 7 ) then                                        2m
          call dtend
          write( Hvdulu, 13 )
13        format(
     1 '   DIGZCV is a program for digitizing 2 dimensional Cartesian' /
     2 ' curves  from  graphs, and  storing the  coordinates of these' /
     3 ' curves on data files .' /
     4 '   The  data  files  are  formatted  ( ASCII : as 1x,2g13.6 )' /
     5 ' sequential access  . The data files  consist of 2 columns of' /
     6 ' numbers .  Each line represents one digitized point with the' /
     7 ' first  number  being the x or horizontal  ordinate , and the' /
     8 ' second being the y or vertical ordinate .' /
     9 '   A data file must be opened and a page must be defined .' / )
          end if                                                            2e
          goto 3
c       end of loop                                                         1e
c
14    if ( fopen ) then                                                     1b
        call dtend
        close( Hdatlu )
        write( Hvdulu, 16 ) istart, ncurve
16      format( 1x, i6, ' data points' / 1x, i6, ' curves' )
        end if                                                              1e
      stop
      end
