c
c    Copyright (C) 1997  Peter Vernon Lanspeary
c
c    This program is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    This program is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program; if not, write to the Free Software
c    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c


      PROGRAM DIRCVT
c
c Drop the first record in a GENACQ direct access data file so
c the file can be processed on VMS systems.
c
      implicit none
      integer *2 Hdatlu, Hkbdlu, Hvdulu, Hscrlu
      parameter( Hdatlu=4, Hkbdlu=5, Hvdulu=6, Hscrlu=7 )
c
      logical *1 fdata(512)
      integer *2 irec, jrec, ifile, nchars, idot, ipar, imodule, i
      integer *4 iargc, jljstr
      logical *4 Existf
      character Cfile*64, cscr*64, Clabel*8
c
c         Grab the data file names
c
      do ifile = 1, iargc()                                                1b
        call getarg( ifile, Cfile )
c
c       Parse out one data file name
c
        if ( Existf( Cfile ) ) then                                        2b
c
c       Open scratch file
c
          nchars = jljstr( Cfile )
          ipar = index( Cfile, ']' )
          idot = index( Cfile, '.' )
          if ( idot .eq. 0 .or. ipar .ge. idot )
     1      idot = nchars + 1
          cscr = cfile(1:idot-1) // '.scr'
          open( UNIT=Hscrlu, FILE=Cscr, STATUS='new',
     1      ACCESS='sequential', FORM='formatted' )
          write( Hscrlu, 6 )
6         format( ' module directory' / ' module record' )
          imodule = 0
c
c           open data file
c
          open( UNIT=Hdatlu, FILE=Cfile, ACCESS='direct',
     1      FORM='unformatted', STATUS='old', RECL=128 )
          irec = 2
          jrec = 1
c         start loop                                                       3b
c
c           read and write data record
c
3           read( Hdatlu, REC=irec, ERR=4 ) fdata
            write( Hdatlu, REC=jrec ) fdata
c
c           write to scratch file
c
            if ( fdata(1) .eq. '#' .and. fdata(2) .ne. '#' ) then          4b
              call sbytchr( fdata, Clabel, 8 )
              if (   Clabel .eq. '#initial' .or. Clabel .eq. '#close  '
     1            .or. Clabel .eq. '#acquire' .or.
     2            Clabel(1:4) .eq. '#cal' ) then                           5b
                imodule = imodule + 1
                write( Hscrlu, 9 ) imodule, jrec, Clabel
9               format( 1x, 2i8, 7x, a )
                end if                                                     5e
              end if                                                       4e
c
c           update record pointers
c
            jrec = irec
            irec = irec + 1
            goto 3
c           end of loop                                                    3e
4         close( UNIT=Hdatlu )
        else                                                               2m
          write( Hvdulu, 5 ) Cfile
5         format( ' DIRCVT : Can''t find file ', a )
          end if                                                           2e
        end do                                                             1e
      stop
c
7     write( Hvdulu, 8 ) Cfile
8     format( ' DIRCVT : Can''t open data file ', a )
      stop
      end
