c
c    Copyright (C) 1997  Peter Vernon Lanspeary
c
c    This program is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    This program is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program; if not, write to the Free Software
c    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c


      PROGRAM RAWLOOK
c
c         Examine the raw data file .
c
c Only one program argument is used . If present, it is the name of the first
c data file to be examined . The data file otherwise remains blank.
c
c Local variables
c  integer
c    item             # selected item from main menu
c    len_df_name      # non-blank length of data file name
c    iargc            # function : number of program arguments
c    jljstr           #          : left justify & non-blank length of string
c    Jresp            #          : integer response
c    new_lun          #          : get new logical unit number
c  logical
c    edit_mode        # edit mode
c    erdfopn          # function : open raw data file
c  character
c    Cdata_file *64   # name of data file
c  subroutine
c    getarg           # get program arguments
c    raw_anal_menu    # set analysis parameters
c    raw_examine      # examine data
c    raw_module_sel   # module selection parameters
c    raw_setup        # setup parameters
c
      include 'stdio.def'
      integer iargc, item, jljstr, Jresp, len_df_name, new_lun
      logical edit_mode
      character Cdata_file*64
      include 'rawlook.cmn'
c
c
c         Get program argument .
c
      if ( iargc() .gt. 0 ) then                                          1b
          call getarg( 1, Cdata_file )
      else                                                                1m
          Cdata_file = ' '
          end if                                                          1e
      len_df_name = max( jljstr( Cdata_file ), 1 )
c
c         main menu
c
c     start of loop                                                       1b
2         call newscr()
          write( STD_OUT, 3 ) Cdata_file(1:len_df_name)
3         format( ' a) Main menu' / '  0) Exit' /
     1        '  1) Name of data file  ', a /
     2        '  2) Examine data file' /
     3        '  3) Setup menu' /
     4        '  4) Module selection menu' /
     5        '  5) Analysis parameters    ' )
          item = Jresp( STD_IN, 0, 5, MAX_TRIES )
c
c           EXIT
c           close files first
c
          if ( item .eq. 0 ) then                                         2b
              if ( open_data )
     1            call srdfcls()
              if ( hist_lu .ne. 0 )
     1            close( UNIT=hist_lu )
              if ( mean_lu .ne. 0 )
     1            close( UNIT=mean_lu )
              if ( spec_lu .ne. 0 )
     1            close( UNIT=spec_lu )
              stop
c
c           NAME OF DATA FILE
c
          else if ( item .eq. 1 ) then                                    2m
              write( STD_OUT, 4 )
4             format( ' Enter name of data file ', $ )
              call Cresp( STD_IN, Cdata_file, MAX_TRIES )
              len_df_name = max( jljstr( Cdata_file ), 1 )
c
c           EXAMINE THE DATA FILE
c           first check that the data file is not blank
c
          else if ( item .eq. 2 ) then                                    2m
              if ( Cdata_file .ne. ' ' ) then                             3b
                  call raw_examine( Cdata_file, edit_mode )
              else
                  write( STD_OUT, 5 )
5                 format( ' RAWLOOK : Data file not specified' )
                  call ilgwait()
                  end if                                                  3e
c
c           SETUP MENU
c
          else if ( item .eq. 3 ) then                                    2m
              call raw_setup( edit_mode )
c
c           MODULE SELECTION MENU
c
          else if ( item .eq. 4 ) then                                    2m
              call raw_module_sel()
c
c           ANALYSIS PARAMETERS MENU
c
          else if ( item .eq. 5 ) then                                    2m
              if ( .not. edit_mode ) then                                 3b
                  call raw_anal_menu()
                  end if                                                  3e
              end if                                                      2e
          goto 2
c         end of loop                                                     1e
      end



      SUBROUTINE RAW_SETUP( EDIT_MODE )
c
c         Menu for the setup parameters
c
c Setup menu
c   0) Exit
c   1) verbosity               1
c   2) host machine            IBM PC
c   3) graphics lettering size 1.0
c   4) auxillary data file     rawlook.aux
c   5) read mode
c   6) max data record length  65536
c
c Argument
c  logical edit_mode  # edit the data file headers
c
c local variables
c  integer
c    aux_len          # length of auxillary file name
c    item             # item selected from menu
c    mode             # 1=read / 2=edit mode
c    Jresp            # function : integer response
c    jljstr           #          : left justify a string
c  real
c    qresp            # function : real response
c  character
c    Caux_file *64    # name of auxillary file
c    Chost(0:2)*8     # list of available hosts
c    Cmode(2)*4       # list of available modes
c
      include 'stdio.def'
      logical edit_mode
      integer aux_len, item, mode, Jresp, jljstr
      real qresp
      character Caux_file*64, Chost(0:2)*8, Cmode(2)*4
      save Caux_file, Chost, Cmode
      include 'rawlook.cmn'
c
      data Caux_file, Cmode, Chost /
     1    ' ', 'read', 'edit', 'VAX-VMS ', 'PDP11/34', 'IBM PC  ' /
      data aux_len / 1 /
c
      if ( edit_mode ) then                                               1b
          mode = 2
      else                                                                1m
          mode = 1
          end if                                                          1e
c
c     start of loop                                                       1b
1         call newscr()
          write( STD_OUT, 2 ) verbosity, Chost(host), chrsiz,
     1        Caux_file(1:aux_len), Cmode(mode),
     2        max_rec_len
2         format( ' b) Setup menu' / '  0) Exit' /
     1        '  1) verbosity', 15x, i2 /
     2        '  2) host machine', 12x, a /
     3        '  3) graphics lettering size ', f5.2 /
     4        '  4) auxillary data file     ', a /
     5        '  5) ', a, ' mode' /
     6        '  6) max data record length  ', i7, '  ', $ )
          item = Jresp( STD_IN, 0, 6, MAX_TRIES )
c
c             EXIT
c             open or close the auxillary file as necessary
c
          if ( item .eq. 0 ) then                                         2b
              call raw_open_dump( AUXILLARY, aux_lu, Caux_file )
              edit_mode = mode .eq. 2
              return                                                      3b
c
c             VERBOSITY
c
          else if ( item .eq. 1 ) then                                    2m
              write( STD_OUT, 3 )
3             format( ' What is the verbosity ? ', $ )
              verbosity = Jresp( STD_IN, 0, 2, MAX_TRIES )
c
c             HOST MACHINE
c
          else if ( item .eq. 2 ) then                                    2m
              write( STD_OUT, 4 )
4             format( ' What is the host machine ? 0) VAX - VMS' /
     1          28x, '1) PDP11/34 - unix' /
     2          28x, '2) IBM XT/AT - MS-DOS ', $ )
              host = Jresp( STD_IN, 0, 2, MAX_TRIES )
          else if ( item .eq. 3 ) then                                    2m
c
c             LETTERING SIZE ON GRAPHS
c
              write( STD_OUT, 5 )
5             format( ' What is the size factor for graphics ',
     1            'lettering ? ', $ )
              chrsiz = qresp( STD_IN, 0.2, 5.0, MAX_TRIES )
c
c             NAME OF AUXILLARY FILE
c
          else if ( item .eq. 4 ) then                                    2m
              write( STD_OUT, 6 )
6             format( ' Name of auxillary file ?', $ )
              call Cresp( STD_IN, Caux_file, MAX_TRIES )
              aux_len = max( 1, jljstr( Caux_file ) )
c
c             TOGGLE MODE (READ or EDIT)
c
          else if ( item .eq. 5 ) then                                    2m
              mode = 3 - mode
c
c             MAXIMUM RECORD LENGTH
c
          else if ( item .eq. 6 ) then                                    2m
              write( STD_OUT, 7 )
7             format( ' What is the maximum data record length ? ', $ )
              max_rec_len = Jresp( STD_IN, 16, MAX_DATA, MAX_TRIES )
              end if                                                      2e
          goto 1
c         end of loop                                                     1e
      end



      SUBROUTINE RAW_MODULE_SEL()
c
c         Module selection parameters menu
c
c Module selection menu
c   0) exit
c   1) all
c   2) range
c   3) enumerate
c   4) query
c
c local variables
c  integer
c    i                  # index for enumerated module list
c    item               # selected menu item
c    Jresp              # function : integer response
c  subroutine
c    raw_enumerate_menu # menu for enumerating the list of modules
c
      include 'stdio.def'
c
      integer i, item, Jresp
      include 'rawlook.cmn'
c
c           Print the menu
c
c     start of loop                                                       1b
1         call newscr()
          write( STD_OUT, 2 )
2         format( ' b) Module selection menu' / '  0) exit' )
          if ( modul_sel .eq. MODUL_ALL ) then                                  2b
              write( STD_OUT, 3 )
3             format( '  1) all       X' )
          else                                                            2m
              write( STD_OUT, 4 )
4             format( '  1) all' )
              end if                                                      2e
          if ( modul_sel .eq. MODUL_RANGE ) then                                2b
              write( STD_OUT, 5 ) modul_min, modul_max, modul_step
5             format( '  2) range     ', i5, ' to ', i5, ' step ', i5 )
          else                                                            2m
              write( STD_OUT, 6 )
6             format( '  2) range' )
              end if                                                      2e
          if ( modul_sel .eq. MODUL_ENUMERATE ) then                            2b
              write( STD_OUT, 7 ) ( modul_list(i), i = 1, modul_len )
7             format( '  3) enumerate ', 10i5 : / ( 16x, 10i5 ) )
          else                                                            2m
              write( STD_OUT, 8 )
8             format( '  3) enumerate' )
              end if                                                      2e
          if ( query_modul ) then                                         2b
              write( STD_OUT, 9 )
9             format( '  4) query' )
          else                                                            2m
              write( STD_OUT, 10 )
10            format( '  4) no query' )
              end if                                                      2e
          item = Jresp( STD_IN, 0, 4, MAX_TRIES )
c
c           RETURN
c
          if ( item .eq. 0 ) then                                         2b
              return
c
c           SELECT ALL MODULES
c
          else if ( item .eq. 1 ) then                                    2m
              modul_sel = MODUL_ALL
c
c           SELECT MODULE RANGE
c
          else if ( item .eq. 2 ) then                                    2m
              modul_sel = MODUL_RANGE
              call raw_range_menu()
c
c           ENUMERATE MODULES
c
          else if ( item .eq. 3 ) then                                    2m
              modul_sel = MODUL_ENUMERATE
              call raw_enumerate_menu()
c
c           QUERY SELECTED MODULES
c
          else if ( item .eq. 4 ) then                                    2m
              query_modul = .not. query_modul
              end if
          goto 1
c         end of loop                                                     1e
      end



      SUBROUTINE RAW_RANGE_MENU()
c
c c) Specify module range
c   0) Exit
c   1) Initial value
c   2) Final value
c   3) Step
c
c Local variables
c  integer item   # item selected from menu
c          Jresp  # function : integer response
c
      include 'stdio.def'
      integer item, Jresp
      include 'rawlook.cmn'
c     start of loop                                                       1b
c
1         call newscr()
          write( STD_OUT, 2 ) modul_min, modul_max, modul_step
2         format( / ' c) Specify module range' / '  0) Exit' /
     1        '  1) Initial value ', i5 /
     2        '  2) Final value   ', i5 /
     3        '  3) Step          ', i5, ' ', $ )
          item = Jresp( STD_IN, 0, 3, MAX_TRIES )
c
          if ( item .eq. 0 ) then                                         2b
              return
c
          else if ( item .eq. 1 ) then                                    2m
              write( STD_OUT, 3 )
3             format( ' Value ? ', $ )
              modul_min = Jresp( STD_IN, 1, 9999, MAX_TRIES )
c
          else if ( item .eq. 2 ) then                                    2m
              write( STD_OUT, 3 )
              modul_max = Jresp( STD_IN, 1, 9999, MAX_TRIES )
c
          else if ( item .eq. 3 ) then                                    2m
              write( STD_OUT, 3 )
              modul_step = Jresp( STD_IN,
     1            min( 1, modul_max - modul_min ),
     2            max( -1, modul_max - modul_min ), MAX_TRIES )
              end if                                                      2e
          goto 1
c         end of loop
      end



      SUBROUTINE RAW_ENUMERATE_MENU()
c
c c) Enumerate modules menu
c   0) Exit
c   1) Current index  14
c   2) Current module 23
c   3) Next module    25
c   4) Stream of modules
c   5) Sort module list
c   6) Clear from next module
c
c local variables
c  integer
c    enum_index         # index in the enumerated module list
c    i                  # array index
c    item               # item selected from menu
c    Jresp              # function : integer response
c    raw_compress_list  #          : compress unused places out of module list
c    raw_read_list      #          : read list of integers
c  subroutine
c    isortsh            # ascending sort of integer array
c
      include 'stdio.def'
      integer enum_index, i, item,
     1    Jresp, raw_compress_list, raw_read_list
      include 'rawlook.cmn'
      data enum_index / 1 /
      save enum_index
c
c     start of loop                                                       1b
1         call newscr()
          write( STD_OUT, 2 ) ( modul_list(i), i = 1, modul_len )
2         format( 10x, 10i6 )
          write( STD_OUT, 3 ) enum_index,
     1        modul_list( max( enum_index-1, 1 ) ),
     2        modul_list( enum_index ),
     3        modul_list( min( enum_index+1, MAX_LIST ) )
3         format( / ' c) Enumerate modules menu' / '  0) Exit' /
     1        '  1) Decrement index' /
     2        '  2) Selected  index ', i4 /
     3        '  3) Increment index' /
     4        '  4) Previous module ', i4 /
     5        '  5) Current module  ', i4 /
     6        '  6) Next module     ', i4 /
     7        '  7) Stream of modules' /
     8        '  8) Sort module list' /
     9        '  9) Clear from next module ', $ )
          item = Jresp( STD_IN, 0, 9, MAX_TRIES )
c
c                   EXIT FROM ENUMERATE MENU
c
          if ( item .eq. 0 ) then                                         2b
              modul_len = raw_compress_list( modul_list, MAX_LIST )
              return
c
c                   DECREMENT INDEX
c
          else if ( item .eq. 1 ) then                                    2m
              enum_index = max( enum_index - 1, 1 )
c
c                   CURRENT INDEX IN LIST OF MODULES
c
          else if ( item .eq. 2 ) then                                    2m
              write( STD_OUT, 4 )
4             format( ' Value ? ', $ )
              enum_index = Jresp( STD_IN, 1, MAX_LIST, MAX_TRIES )
c
c                   INCREMENT INDEX
c
          else if ( item .eq. 3 ) then                                    2m
              enum_index = min( enum_index + 1, MAX_LIST )
c
c                   PREVIOUS VALUE IN LIST OF MODULES
c
          else if ( item .eq. 4 ) then                                    2m
              write( STD_OUT, 4 )
              enum_index = max( enum_index - 1, 1 )
              modul_list(enum_index) =
     1            Jresp( STD_IN, 0, 16384, MAX_TRIES )
              modul_len = max( enum_index, modul_len )
c
c                   CURRENT VALUE IN LIST OF MODULES
c
          else if ( item .eq. 5 ) then                                    2m
              write( STD_OUT, 4 )
              modul_list(enum_index) =
     1            Jresp( STD_IN, 0, 16384, MAX_TRIES )
              modul_len = max( enum_index, modul_len )
c
c                   NEXT VALUE IN LIST OF MODULES
c
          else if ( item .eq. 6 ) then                                    2m
              write( STD_OUT, 4 )
              enum_index = min( enum_index + 1, MAX_LIST )
              modul_list(enum_index) =
     1            Jresp( STD_IN, 0, 16384, MAX_TRIES )
              modul_len = max( enum_index, modul_len )
c
c                   STREAM OF MODULES
c
          else if ( item .eq. 7 ) then                                    2m
              write( STD_OUT, 5 )
5             format( ' Enter list of modules' /
     1            ' (one value per line, terminate with "end")' )
              enum_index = enum_index +
     1            raw_read_list( modul_list(enum_index),
     2                           MAX_LIST + 1 - enum_index )
              modul_len = max( enum_index - 1, modul_len )
c
c                   SORT MODULE LIST
c
          else if ( item .eq. 8 ) then                                    2m
              modul_len = raw_compress_list( modul_list, MAX_LIST )
              call isortsh( modul_list, modul_len )
c
c                   CLEAR FROM NEXT MODULE
c
          else if ( item .eq. 9 ) then                                    2m
              do 6 i = enum_index + 1, MAX_LIST
                  modul_list(i) = 0
6                 continue
              modul_len = min( enum_index, modul_len )
              end if                                                      2e
          goto 1
c         end of loop                                                     1e
c
      end



      SUBROUTINE RAW_ANAL_MENU()
c
c b) Analysis parameters menu
c   0) Exit
c   1) Data display   Yes
c   2) Time history   Yes
c   3) Averaging      No
c   4) Power spectra  No
c
c Local variables
c  integer item         # selected menu item
c          Jresp        # function : integer response
c  character Cyes*3     # function : 'yes' or 'no'
c         Cdispl(0:2)*5 # 'No', 'Query', 'Yes'
c
      include 'stdio.def'
      integer item, Jresp
      character Cyes*3, Cdispl(0:2)*5
      include 'rawlook.cmn'
      data Cdispl / 'No   ', 'Query', 'Yes  ' /
c
c     start loop                                                          1b
1         call newscr()
          write( STD_OUT, 2 ) Cdispl(query_data), Cyes(time_hist),
     1        Cyes(averaging), Cyes(pow_spect)
2         format( / ' b) Analysis parameters menu' / '  0) Exit' /
     1        '  1) Read data     ', a /
     2        '  2) Time history  ', a /
     3        '  3) Averaging     ', a /
     4        '  4) Power spectra ', a, '  ', $ )
          item = Jresp( STD_IN, 0, 4, MAX_TRIES )
          if ( item .eq. 0 ) then                                         2b
              return
c
c             Display sub-block data ? -- tri-state switch
          else if ( item .eq. 1 ) then                                    2m
              query_data = mod( query_data + 1, 3 )
c
          else if ( item .eq. 2 ) then                                    2m
              time_hist = .not. time_hist
              if ( time_hist ) call raw_menu_time_hist()
c
          else if ( item .eq. 3 ) then                                    2m
              averaging = .not. averaging
              if ( averaging ) call raw_menu_averaging()
c
          else if ( item .eq. 4 ) then                                    2m
              pow_spect = .not. pow_spect
              if ( pow_spect ) call raw_menu_spectrum()
              end if                                                      2e
          goto 1
c         end of loop                                                     1e
      end



      SUBROUTINE RAW_MENU_TIME_HIST()
c
c c) Time-history parameters menu
c  0) Exit
c  1) Data window length  2000
c  2) Dump file           time_hist.dmp
c  3) Plot time history   yes
c  4) Capture file        time_hist.cap
c
c local variables
c  integer
c    capt_len         # length of capture file name
c    dump_len         # length of dump file name
c    item             # selected menu item
c    jljstr           # function : left justify string
c    Jresp            #          : integer response
c  character
c    Cdump_file*64    # name of dump file
c    Cyes*3           # function : 'yes' or 'no'
c
      include 'stdio.def'
      integer capt_len, dump_len, item, jljstr, Jresp
      character Cdump_file*64, Cyes*3
      include 'rawlook.cmn'
c
      data capt_len, dump_len / 1, 1 /
      data Cdump_file / ' ' /
      save capt_len, dump_len, Cdump_file
c
c     start of loop
1         call newscr()
          write( STD_OUT, 2 ) wind_len, wind_off,                         1b
     1        Cdump_file(1:dump_len), Cyes(plot_thist)
2         format( / ' c) Time-history parameters menu' / '  0) Exit' /
     1        '  1) Data window length  ', i6 /
     2        '  2) Data window offset  ', i6 /
     3        '  3) Dump file           ', a /
     4        '  4) Plot time history   ', a )
          if ( plot_thist ) then                                          2b
              write( STD_OUT, 3 ) Cap_thist(1:capt_len), Cyes(hist_wait)
3             format( '  5) Capture file        ', a /
     1                '  6) Wait after plotting ', a, ' ', $ )
              end if                                                      2e
          item = Jresp( STD_IN, 0, 6, MAX_TRIES )
c
c           RETURN
c           close/open dump file as necessary
c
          if ( item .eq. 0 ) then                                         2b
              call raw_open_dump( T_HISTORY, hist_lu, Cdump_file )
              return
c
c           DATA WINDOW LENGTH
c
          else if ( item .eq. 1 ) then                                    2m
              write( STD_OUT, 4 )
4             format( ' How many samples per data window ? ', $ )
              wind_len = Jresp( STD_IN, 32, MAX_DATA, MAX_TRIES )
c
c           DATA WINDOW OFFSET
c
          else if ( item .eq. 2 ) then                                    2m
              write( STD_OUT, 5 )
5             format( ' Data window offset ? ', $ )
              wind_off = Jresp( STD_IN, 0, MAX_DATA, MAX_TRIES )
c
c           NAME OF DUMP FILE FILE
c
          else if ( item .eq. 3 ) then                                    2m
              write( STD_OUT, 6 )
6             format( ' Name of dump file ? ', $ )
              call Cresp( STD_IN, Cdump_file, MAX_TRIES )
              dump_len = max( jljstr( Cdump_file ), 1 )
c
c           PLOT TIME HISTORIES ?
c
          else if ( item .eq. 4 ) then                                    2m
              plot_thist = .not. plot_thist
c
c           NAME OF CAPTURE FILE
c
          else if ( plot_thist .and. item .eq. 5 ) then                   2m
              write( STD_OUT, 7 )
7             format( ' Name of capture file ? ', $ )
              call Cresp( STD_IN, Cap_thist, MAX_TRIES )
              capt_len = max( jljstr( Cap_thist ), 1 )
c
c           WAIT AFTER PLOTTING
c
          else if ( plot_thist .and. item .eq. 6 ) then                   2m
              hist_wait = .not. hist_wait
              end if                                                      2e
          goto 1
c         end of loop                                                     1e
      end



      SUBROUTINE RAW_MENU_AVERAGING()
c
c c) Averaging parameters menu
c  0) Exit
c  1) Maximum moment order 4
c  2) Dump file            averages.dmp
c
c Local variables
c  integer
c    dump_len       # length of dump file name
c    item           # selected menu item
c    jljstr         # function : left justify string
c    Jresp          #          : integer response
c  character
c    Cdump_file*64  # dump file name
c  subroutine
c    Cresp          # read a line
c
      include 'stdio.def'
      integer dump_len, item, jljstr, Jresp
      character Cdump_file*64
      include 'rawlook.cmn'
c
      data dump_len / 1 /
      data Cdump_file / ' ' /
      save dump_len, Cdump_file
c
c     start of loop
1         call newscr()
          write( STD_OUT, 2 ) max_moment, Cdump_file(1:dump_len)
2         format( / ' c) Averaging parameters menu' / '  0) Exit' /
     1        '  1) Maximum moment order ', i2 /
     2        '  2) Dump file            ', a, ' ', $ )
          item = Jresp( STD_IN, 0, 2, MAX_TRIES )
c
c           RETURN
c           close/open dump file as necessary
c
          if ( item .eq. 0 ) then
              call raw_open_dump( AVERAGE, mean_lu, Cdump_file )
              return
c
c           MAXIMUM MOMENT ORDER
c
          else if ( item .eq. 1 ) then                                    2m
              write( STD_OUT, 3 )
3             format( ' What is the maximum moment to be calculated ? '
     1            / ' ( 1=mean, 2=rms, 3=skewness, 4=flatness )   ', $ )
              max_moment = Jresp( STD_IN, 1, MAX_MOM, MAX_TRIES )
c
c           NAME OF DUMP FILE FILE
c
          else if ( item .eq. 2 ) then                                    2m
              write( STD_OUT, 4 )
4             format( ' Name of dump file ? ', $ )
              call Cresp( STD_IN, Cdump_file, MAX_TRIES )
              dump_len = max( jljstr( Cdump_file ), 1 )
              end if                                                      2e
          goto 1
      end



      SUBROUTINE RAW_MENU_SPECTRUM()
c
c c) Power spectral density menu
c  0) Exit
c  1) Length of FFT             2048
c  2) Hanning (time) window     yes
c  3) Tukey (smoothing) window  no
c  4) Half integer frequencies  no
c  5) Dump file                 power_spect.dmp
c  6) Plot spectrum             yes
c  7) Capture file              power_spect.cap
c
c Local variables
c  integer
c    dump_len         # length of dump file name
c    capt_len         # length of capture file name
c    item             # selected menu item
c    max_len_fft      # maximum allowed length of FFT - depends on half_freq
c    x_scale          # x scaling : 1=linear, 2=log
c    y_scale          # y scaling : 1=linear, 2=log
c    jljstr           # function : left justify string
c    Jresp            #          : integer response
c  logical
c    half_freq        # spectrum with half integer frequencies
c    hanning_wind     # hanning time window on time data
c    tukey_wind       # Tukey smoothing of spectrum
c  character
c    Cdump_file*64    # name of dump file
c    Cscale(2)*3      # 'lin', 'log' for scaling laws
c    Cyes*3           # function : 'yes' or 'no'
c  subroutine
c    Cresp            # read a line
c
      include 'stdio.def'
      integer dump_len, capt_len, item, max_len_fft, x_scale, y_scale,
     1        jljstr, Jresp
      logical half_freq, hanning_wind, tukey_wind
      character Cdump_file*64, Cscale(2)*3, Cyes*3
      include 'rawlook.cmn'
c
      data Cdump_file, Cscale / ' ', 'lin', 'log' /
      data dump_len, capt_len, x_scale, y_scale / 1, 1, 1, 1 /
      data half_freq, tukey_wind, hanning_wind / 2* .FALSE., .TRUE. /
      save Cdump_file, dump_len, capt_len, x_scale, y_scale,
     1     half_freq, tukey_wind, hanning_wind
c
c     start of loop                                                       1b
1         if ( half_freq ) then                                           2b
              max_len_fft = MAX_FFT - 1
          else                                                            2m
              max_len_fft = MAX_FFT
              end if                                                      2e
          len_fft = min( len_fft, max_len_fft )
          call newscr()
          write( STD_OUT, 2 ) 2**len_fft, Cyes(Hanning_wind),
     1        Cyes(Tukey_wind), Cyes(half_freq), Cdump_file(1:dump_len),
     2        Cyes(plot_spec)
2         format( / ' Select spectral parameter' / '  0) exit' /
     1        '  1) length of FFT          ', i6 /
     2        '  2) Hanning (time) window    ', a /
     3        '  3) Tukey (smoothing) window ', a /
     4        '  4) Half integer frequencies ', a /
     5        '  5) Spectrum dump file       ', a /
     6        '  6) Plot spectrum enabled    ', a )
          if ( plot_spec ) then                                           2b
              write( STD_OUT, 3 ) Cap_spect(1:capt_len),
     1            Cyes(spec_wait), Cscale(x_scale), Cscale(y_scale)
3             format( '  7) Capture file             ', a /
     1            '  8) Wait after plotting      ', a /
     2            '  9) X-axis scaling           ', a /
     3            ' 10) Y-axis scaling           ', a, ' ', $ )
              end if                                                      2e
          item = Jresp( STD_IN, 0, 10, MAX_TRIES )
c
c           RETURN
c           close/open dump file as necessary
c
          if ( item .eq. 0 ) then                                         2b
              call raw_open_dump( SPECTRUM, spec_lu, Cdump_file )
c
c           set the window types
              item = 1
              if ( Hanning_wind ) then                                    3b
                  Cspect_window(item:item) = 'h'
                  item = item + 1
                  end if                                                  3e
              if ( Tukey_wind ) then                                      3b
                  Cspect_window(item:item) = 'a'
                  item = item + 1
                  end if                                                  3e
              if ( half_freq ) then                                       3b
                  Cspect_window(item:item) = 'z'
                  end if                                                  3e
c
c           x & y scaling laws
c
              Cspec_xlaw = Cscale(x_scale)
              Cspec_ylaw = Cscale(y_scale)
              return
c
c           LENGTH OF FFT
c
          else if ( item .eq. 1 ) then                                    2m
              write( STD_OUT, 4 )
4             format( ' Length of FFT ? ', $ )
              len_fft = Jresp( STD_IN, 16, 2**max_len_fft, MAX_TRIES )
c                      ensure len_fft is a power of 2
              len_fft =
     1            int( log( real( len_fft ) ) / log( 2.0 ) + 0.00001 )
c
c           HANNING (TIME) WINDOW
c
          else if ( item .eq. 2 ) then                                    2m
              hanning_wind = .not. hanning_wind
c
c           TUKEY (SMOOTHING) WINDOW
c
          else if ( item .eq. 3 ) then                                    2m
              tukey_wind = .not. tukey_wind
c
c           HALF INTEGER FREQUENCIES
c
          else if ( item .eq. 4 ) then                                    2m
              half_freq = .not. half_freq
c
c           SPECTRUM DUMP FILE
c
          else if ( item .eq. 5 ) then                                    2m
              write( STD_OUT, 5 )
5             format( ' Name of spectrum dump file ? ', $ )
              call Cresp( STD_IN, Cdump_file, MAX_TRIES )
              dump_len = max( jljstr( Cdump_file ), 1 )
c
c           PLOT SPECTRUM ENABLED
c
          else if ( item .eq. 6 ) then                                    2m
              plot_spec = .not. plot_spec
c
c           NAME OF CAPTURE FILE
c
          else if ( plot_spec .and. item .eq. 7 ) then                    2m
              write( STD_OUT, 6 )
6             format( ' Name of capture file ? ', $ )
              call Cresp( STD_IN, Cap_spect, MAX_TRIES )
              capt_len = max( jljstr( Cap_spect ), 1 )
c
c           WAIT AFTER PLOTTING
c
          else if ( plot_spec .and. item .eq. 8 ) then                    2m
              spec_wait = .not. spec_wait
c
c           X-AXIS SCALING
c
          else if ( plot_spec .and. item .eq. 9 ) then                    2m
              x_scale = 3 - x_scale
c
c           Y-AXIS SCALING
c
          else if ( plot_spec .and. item .eq. 10 ) then                   2m
              y_scale = 3 - y_scale
              end if                                                      2e
          goto 1
c         end of loop                                                     1e
      end



cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccc                                                                cccc
cccc                    DATA ANALYSIS ROUTINES                      cccc
cccc                                                                cccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc



      SUBROUTINE RAW_EXAMINE( CDATA_FILE, EDIT_MODE )
c
c  Examine the contents of the raw data file CDATA_FILE .
c  This function does ALL the raw data file handling -- apart from
c  extraction of data sub-block header information .
c
c Arguments
c  character Cdata_file*(*)   # name of the raw data file
c  logical   edit_mode        # enable editing of sub-block headers
c
c Local variables
c  integer
c    avail_size       # max allowed no. of samples
c    nsamples         # number of data samples read by erdfacq
c    idirptr          # directory pointer = module number
c    irdfrec          # data file record pointer
c    iresrec          # record no.- reserved if data may follow
c    itnbyt           # total no. of data bytes - close block
c    modul_index      # index into the list of enumerate modules
c    nchans           # number of channels used in A/D
c    ncycles          # number of acquisition cycles
c  logical
c    ok_data          # permission to examine sub-block data
c    ok_modul         # permission to examine a module
c  real
c    rapbar           # barometric pressure
c    raptem           # ambient temperature
c    time_offset      # time offset for time-history plot
c  character
c    Cmhdlab*8        # module header record label
c    Csublab*8        # sub-block header label
c    Cold_data*64     # name of previous data file
c
c  integer function : rdflib
c    Jextcyln         # get no. of chans
c    Jextmdln         # get record no of module
c    Jextnocy         # get no of cycles
c  logical function
c    equery           # logical response
c    erdfacq          # read acquisition sub-block
c    erdfopn          # rdflib : open raw data file
c  subroutine : local
c    raw_bug          # report fatal bug in RAWLOOK
c    raw_do_averaging # get average statistics from data
c    raw_do_pow_spect # calculate power spectral density of data
c    raw_do_time_hist # examine time histories
c  subroutine : rdflib
c    caltvs           # print traverse calibration
c    sextall          # display all Acquire sub-block header
c    srdfclos         # display close block header
c    srdfcls          # close raw data file
c    srdferr          # display error message
c    srdfhost         # specify source of data file
c    srdfmhd          # get next module header
c    srdfmute         # set verbosity flag
c    srdfxxx          # edit sub-block header
c    srdfinit         # display initialize block header
c
c
      include 'stdio.def'
      character Zlabel*7
      parameter( Zlabel='RAWLOOK' )
c
      integer avail_size, nsamples, idirptr, irdfrec, iresrec, itnbyt,
     1    modul_index, nchans, ncycles, Jextcyln, Jextmdln, Jextnocy
      logical edit_mode, ok_data, ok_modul, Equery, erdfacq, erdfopn
      real Rapbar, Raptem, time_offset
      character Cdata_file*(*), Cold_data*64
      include 'rawlook.cmn'
c
      data open_data / .FALSE. /
      data Cold_data / ' ' /
c
c
c           close the old data file if the name has changed.
c           open a new data file if none are opened
c
      if ( Cold_data .ne. Cdata_file .and. open_data ) then
          call srdfcls()
          open_data = .FALSE.
          end if
      if ( .not. open_data ) then
          open_data = erdfopn( Cdata_file, irdfrec, aux_lu )
          if ( open_data ) then
              Cold_data = Cdata_file
              end if
          end if
      if ( open_data ) then                                               1b
c
c           environment
c
         call srdfmute( verbosity )
         call srdfhost( host )
c
c           Initialize the directory pointer (points at a module)
c

         if ( modul_sel .eq. MODUL_ALL ) then                             2b
            idirptr = 1
         else if ( modul_sel .eq. MODUL_ENUMERATE ) then                  2m
            modul_index = 1
            idirptr = modul_list(1)
         else if ( modul_sel .eq. MODUL_RANGE ) then                      2m
            idirptr = modul_min
         else                                                             2m
            call raw_bug( 'Unknown method of selecting modules' )
            end if                                                        2e
c
c           test if we have gone beyond the last module
c
c        start of loop                                                    2b
1           if ( modul_sel .eq. MODUL_ALL ) then                          3b
               if ( idirptr .gt. Jextmdln( 0 ) ) return
            else if ( modul_sel .eq. MODUL_ENUMERATE ) then               3m
               if ( modul_index .gt. modul_len ) return
            else if ( modul_sel .eq. MODUL_RANGE ) then                   3m
               if ( idirptr .gt. modul_max ) return
            else                                                          3m
               call raw_bug( 'Unknown method of selecting modules' )
               end if                                                     3e
c
c           Permission to display module header
c
            write( STD_OUT, 2 ) idirptr
2           format( / ' Module Number ', i4 )
            if ( query_modul ) then                                       3b
               ok_modul = equery( STD_IN,
     1                            'Display this module header ?' )
            else                                                          3m
               ok_modul = .TRUE.
               end if                                                     3e
            if ( ok_modul ) then                                          3b
c
c           display module header and then block headers
c
               irdfrec = Jextmdln( idirptr )
               call srdfmhd( Cmhdlab, irdfrec )
c
c           read initialize block header
c
               if ( Cmhdlab .eq. '#initial' ) then                        4b
                  call srdfinit( Rapbar, Raptem, irdfrec )
c
c           read traverse calibration block
c
               else if ( Cmhdlab .eq. '#caltvs' ) then                    4m
                  call caltvs( irdfrec )
c
c           read acquisition block
c
               else if ( Cmhdlab .eq. '#acquire' .or.
     1                   Cmhdlab .eq. '#calbar ' .or.
     2                   Cmhdlab .eq. '#calhw1 ' .or.
     3                   Cmhdlab .eq. '#calxhw ' ) then                   4m
                  iresrec = irdfrec
c
c           read sub-blocks until there are no more in the module
c                 start of sub-block "while" loop
c
3                 if ( erdfacq( Csublab, nsamples, Mdata, 0, irdfrec,
     1                          .FALSE. ) ) then                          5b
c                    Note that irdfrec now points to AFTER the subblock
c                    so that srdfxxx must use the saved value in iresrec
c
                     if ( edit_mode ) then                                6b
                        call srdfxxx( iresrec )
                     else                                                 6m
                        call sextall
c
c           can only read data from primary or secondary data sub-blocks

                        if ( Csublab .eq. '###1dat1' .or.
     1                       Csublab .eq. '###2dat2' ) then               7b
c
c           permission to read sub-block data
c
                           if ( query_data .eq. 0 ) then                  8b
                              ok_data = .FALSE.
                           else if ( query_data .eq. 1 ) then             8m
                              ok_data = Equery( STD_IN,
     1                                          'Examine data ?' )
                           else if ( query_data .eq. 2 ) then             8m
                              ok_data = .TRUE.
                              end if                                      8e
                           if ( ok_data ) then                            8b
c
c           restore irdfrec to the value before the previous call to erdfacq
c
                              irdfrec = iresrec
c
c           find out how much array space to make available
c
                              nchans = Jextcyln()
                              ncycles = Jextnocy()
                              avail_size = max_rec_len / nchans * nchans
                              if ( avail_size .lt. ncycles*nchans ) then  9b
                                 write( STD_OUT, 4 )
4     format( ' RAWLOOK: WARNING: Splitting data record .',
     1        ' Too much data for array size .' )
                                 end if                                   9e
c
c           start of "read data window" loop                                     8b
c           this loop terminates if erdfacq cannot read data
c
                              time_offset = 0.0
5                             if ( .not. erdfacq( Csublab, nsamples,
     1                                       Mdata, avail_size,
     2                                       irdfrec, .true. ) ) then     9b
                                  call srdferr( Zlabel, 9 )
                              else if ( nsamples .gt. 0 ) then            9m
c
c           process the data
c
                                 if ( time_hist )
     1                              call raw_do_time_hist( nsamples,
     2                                                     time_offset )
                                 if ( averaging )
     1                              call raw_do_averaging( nsamples,
     2                                                     time_offset )
                                 if ( pow_spect )
     1                              call raw_do_pow_spect( nsamples,
     2                                                     time_offset )
c
c           If more data remains to be read, the user has the option
c           reading more data from the file and processing it
c           independently of the data read previously from this sub-block
c           Calling erdfacq with nsamples=0 tells it to drop the sub-block
c           and go on to the next one .
c
                                 if ( nsamples .eq. avail_size ) then     ab
                                    if ( .not. Equery( STD_IN,
     1                                      'More (split data) ?' ) )
     2                                  avail_size = 0
                                    goto 5
                                    end if                                ae
                                 end if                                   9e
c                                end of "read data window" loop
c
                              end if                                      8e
                           end if                                         7e
c                          end of reading sub-block data
c
                        end if                                            6e
c                       end of reading sub-block headers
c
                     iresrec = irdfrec
                     goto 3
                     end if                                               5e
c                    end of sub-block "while" loop
c
c           close data block header
c
               else if ( Cmhdlab .eq. '#close  ' ) then                   4m
                  call srdfclos( itnbyt, irdfrec )
               else                                                       4m
                  call srdferr( 'RAWLOOK', 1 )
                  end if                                                  4e
c
c              end of displaying module
               end if                                                     3e
c
c           At the bottom of the main loop .
c           Advance the directory pointer
c
            if ( modul_sel .eq. MODUL_ALL ) then                          3b
               idirptr = idirptr + 1
            else if ( modul_sel .eq. MODUL_ENUMERATE ) then               3m
               modul_index = modul_index + 1
               idirptr = modul_list( modul_index )
            else if ( modul_sel .eq. MODUL_RANGE ) then                   3m
               idirptr = idirptr + modul_step
            else                                                          3m
               call raw_bug( 'Unknown method of selecting modules' )
               end if                                                     3e
            if ( .not. edit_mode ) call ilgwait()
            goto 1
c           end of loop                                                   2e
      else                                                                1m
         call ilgwait()
         end if                                                           1e
      end



      SUBROUTINE RAW_DO_TIME_HIST( NSAMPLES, TIME_OFFSET )
c
c  Display time histories . NSAMPLES of raw data are contained in MDATA .
c
c Argument
c  integer nsamples   # number of data samples in Mdata
c  real time_offset   # time offset -- is zero, except for split time records
c
c Local variables
c  integer
c    destin       # destination index
c    source       # source index
c    ichan        # channel number
c    nchans       # total number of data channels
c    ncycles      # number of acquistion cycles
c    npoints      # number of points to plot
c    nxaxis       # x axis specification code for ilgraph
c    nxplts, nyplts   # number of graphs on the page
c    nypos        # location of graph on the page
c    Jextadid     # rdflib : identify A/D converter
c    Jextchls     #        : get A/D channel number
c    Jextcyln     #        : number of A/D channels used
c    Jextnocy     #        : number of acquisition cycles
c  real
c    cycle_time   # A/D cycle time
c    sam_interv   # A/D channel to channel sampling interval
c    time         # time from first sample
c    old_time_offset  # time offset for time-history plot
c    to_volts     # conversion factor to volts (digits/Volt)
c    Uadvolts(4)  # digits/Volt for each A/D converter
c    Qextcytm     # rdflib : get A/D cycle time
c    Qextsamt     #        : sampling interval
c  character
c    Ctitle*23    # graph title
c    Cxlabel*13   # x axis label
c    Gextadid*8   # rdflib : specify A/D used
c    Gextblk*8    #        : get block header
c  subroutines
c    ilgopen, ilgchar, ilgpage, ilgraph, ilgdata, ilgxlab, ilgtitl
c
c
      include 'stdio.def'
      integer destin, ichan, nchans, ncycles, npoints, nsamples,
     1        nxaxis, nxplts, nyplts, nypos, source,
     2        Jextadid, Jextchls, Jextcyln, Jextnocy
      real cycle_time, sam_interv, time, time_offset, old_time_offset,
     1     to_volts, Uadvolts(4), Qextcytm, Qextsamt
      character Ctitle*23, Cxlabel*14, Gextadid*8, Gextblk*8
      include 'rawlook.cmn'
      data Uadvolts / 400.0, 3*409.6 /
      data Cxlabel / 'time (seconds)' /
c
c           get header information on the data
c
      cycle_time = Qextcytm()
      sam_interv = Qextsamt()
      nchans  = Jextcyln()
      ncycles = Jextnocy()
      to_volts = Uadvolts( Jextadid() )
      old_time_offset = time_offset
c
c           cannot do anything if the data does not fall in the
c           display window .
c
      npoints = min( wind_len, nsamples / nchans - wind_off )
      if ( nsamples / nchans .gt. wind_off + 1 ) then                     1b
c
c           PLOT TIME HISTORIES
c           *******************
c
          if ( plot_thist ) then                                          2b
              write( STD_OUT, 1 )
1             format( ' Plotting time histories' )
c
              nxplts = ( nchans - 1 ) / 8 + 1
              nyplts = ( nchans + nxplts - 1 ) / nxplts
              call ilgopen( Cap_thist )
              call ilgchar( chrsiz, 1.0 )
              call ilgpage( 'A4', 'wide', nxplts, nyplts )

              do 4 ichan = 0, nchans - 1                                  3b
c
c           determine graph location and axis types
c
                  nypos = mod( ichan, nyplts ) + 1
                  nxaxis = 1
                  if ( nypos .eq. nyplts .or. ichan .ge. nchans - 1 )
     1                nxaxis = 2
                  call ilgraph( ichan/nyplts+1, nypos, nxaxis, 2, 0 )
c
c           transfer data to real arrays
c           Then update the time offset for the next part of a split record
c
                  source = ( wind_off + ichan ) * nchans + 1
                  time   = old_time_offset +
     1                     wind_off * cycle_time + ichan * sam_interv
                  do 2 destin = 1, npoints                                4b
                      x(destin) = time
                      y(destin) = Mdata(source+ichan) / to_volts
                      time = time + cycle_time
                      source = source + nchans
2                     continue                                            4e
                  time_offset = time
c
c           plot data & labels
c
                  call ilgdata( x, y, 1, npoints, 1 )
                  if ( nxaxis .eq. 2 )
     1                call ilgxlab( Cxlabel )
                  write( Ctitle, 3 ) Gextadid(), Jextchls(ichan+1)
3                 format( a12, ' Channel ', i2 )
                  call ilgtitl( Ctitle )
4                 continue                                                3e
              if ( hist_wait )
     1            call ilgwait()
              call ilgclos()
              end if                                                      2e
c
c           DUMP TIME HISTORIES TO FILE
c           ***************************

          if ( hist_lu .ne. 0 ) then                                      2b
              write( STD_OUT, 5 )
5             format( ' Dumping time history to file' )
              write( hist_lu, 6 ) Cmhdlab, Gextblk(), Csublab,
     1            cycle_time, sam_interv, ncycles, nchans,
     2            ( Jextchls(destin), destin=1,nchans )
6             format( ' ;' /
     1            ' ; module     : ', a /
     2            ' ; block      : ', a /
     3            ' ; sub-block  : ', a /
     4            ' ; cycle time : ', g12.5, 'seconds' /
     5            ' ; chan to chan time : ', g12.5, 'seconds' /
     6            ' ; ', i8, ' cycles, ', i2, ' channels' /
     7            ' ; channels', 8i8 : / 11x, 8i8 )
              source = wind_off * nchans
              time = old_time_offset +
     1            wind_off * cycle_time + ichan * sam_interv
              do 8 destin = 1, npoints                                    3b
                  write( hist_lu, 7 ) time,
     1               ( Mdata(source+ichan) / to_volts, ichan= 1,nchans )
7                 format( 1x, g13.6, 8f8.4 : / 14x, 8f8.4 )
                  time = time + cycle_time
                  source = source + nchans
8                 continue                                                3e
              time_offset = time
              end if                                                      2e
      else                                                                1m
          write( STD_OUT, 9 ) wind_off, nsamples
9         format( ' RAWLOOK : WARNING : Display window is beyond data' /
     1            '   window offset =', i5 /
     2            i9, ' data samples per sample' )
          call ilgwait()
          end if                                                          1e
      return
      end



      SUBROUTINE RAW_DO_AVERAGING( NSAMPLES, TIME_OFFSET )
c
c  Average the data from each channel of the A/D converter
c
c Argument
c  integer nsamples   # number of samples in data array Mdata
c  real time_offset   # time offset -- is zero, except for split time records
c
c local variables
c  integer
c    ichan      # A/D channel number
c    nchans     # number of A/D channels used
c    ncycles      # number of acquistion cycles
c    destin     # destination array index
c    source     # source array index
c    Jextadid   # rdflib : specify A/D converter used
c    Jextchls   #        : list of A/D channels used
c    Jextcyln   #        : number of A/D channels used
c    Jextnocy   #        : number of acquisition cycles
c  real
c    denom      # integer power of rms
c    to_volts   # conversion factor to volts (digits/Volt)
c    Uadvolts(4)# digits/Volt for each A/D converter
c  character
c    Cmoment(8)*13 # descriptive names of statistical moments
c    Gextblk*8  # rdflib : get block header
c  subroutine
c    smeang     # calculate mean & higher moments
c    raw_bug    # report fatal bug
c
      include 'stdio.def'
      integer ichan, nchans, ncycles, nsamples, destin, source,
     1        Jextadid, Jextchls, Jextcyln, Jextnocy
      real denom, time_offset, to_volts, Uadvolts(4)
      character Cmoment(8)*13, Gextblk*8
      data Cmoment / 'mean (Volts) ', 'rms (Volts)  ', 'skewness     ',
     1               'flatness     ', 'superskewness', 'superflatness',
     2               'hyperskewness', 'hyperflatness' /
      data Uadvolts / 400.0, 3*409.6 /
      include 'rawlook.cmn'
c
c           don't do averaging if the maximum moment is illegal
c
      if ( 1 .le. max_moment .and. max_moment .le. MAX_MOM ) then         1b
          nchans  = Jextcyln()
          ncycles = Jextnocy()
          to_volts = Uadvolts( Jextadid() )
c
c           calculate moments, loop once for each channel
c
          do 5 ichan = 1, nchans                                          2b
c
c           put data into real array
c
              source = ichan
              do 1 destin = 1, nsamples / nchans                          3b
                  y(destin) = Mdata(source) / to_volts
                  source = source + nchans
1                 continue                                                3e
              call smeang( y, 1, nsamples/nchans, moments(1,ichan),
     1                     max_moment )
c
c           variance --> rms
c
              if ( max_moment .gt. 1 ) then                               3b
                  moments(2,ichan) = sqrt( moments(2,ichan) )
                  end if                                                  3e
c
c           higher moments --> skewness, flatness etc
c
              if ( max_moment .gt. 2 ) then                               3b
                  if ( moments(2,ichan) .ne. 0.0 ) then                   4b
                      denom = moments(2,ichan) **3
                      do 2 source = 3, max_moment                         5b
                          moments(source,ichan) = moments(source,ichan)
     1                        / denom
                          denom = denom * moments(2,ichan)
2                         continue                                        5e
                  else                                                    4m
                      write( STD_OUT, 3 )  Jextchls(ichan)
3                     format( ' RAWLOOK : WARNING : Zero variance ',
     1                        'on channel ', i2 )
                      do 4 source = 3, max_moment                         5b
                          moments(source,ichan) = 0.0
4                         continue                                        5e
                      end if                                              4e
                  end if                                                  3e
5             continue                                                    2e
c
c               write results for all channels
c
          if ( mean_lu .ne. 0 ) then                                      2b
              write( mean_lu, 6 ) Cmhdlab, Gextblk(), Csublab,
     1            ncycles, nchans, ( Jextchls(destin), destin=1,nchans )
6             format( ' ;' /
     1            ' ; module     : ', a /
     2            ' ; block      : ', a /
     3            ' ; sub-block  : ', a /
     4            ' ; ', i8, ' cycles, ', i2, ' channels' /
     5            ' ; channels ', 4i13 : / ( 12x, 4i8 ) )
              if ( nchans * ncycles .gt. nsamples ) then                  3b
                  write( mean_lu, 7 ) time_offset
7                 format( ' Split data : time offset = ', g13.6,
     1                    ' seconds' )
                  end if                                                  3e
              end if                                                      2e
c
          do 9 source = 1, max_moment                                     2b
              write( STD_OUT, 8 ) Cmoment(source),
     1            ( moments(source,ichan), ichan = 1, nchans )
8             format( 1x, a13, 1x, 4g13.5 : / ( 15x, 4g13.5 ) )
              if ( mean_lu .ne. 0 )
     1            write( mean_lu, 8 ) Cmoment(source),
     2                ( moments(source,ichan), ichan = 1, nchans )
9             continue                                                    2e
      else                                                                1m
          call raw_bug( 'RAW_DO_AVERAGING : Illegal max_moment' )
          end if                                                          1e
      return
      end



      SUBROUTINE RAW_DO_POW_SPECT( NSAMPLES , TIME_OFFSET )
c
c Calculate power spectral density of the data
c
c Argument
c  integer nsamples   # number of samples in data array Mdata
c  real time_offset   # time offset -- is zero, except for split time records
c
c constant
c    MAX_SPEC=8192  # maximum spectrum length 2**MAX_FFT+1
c local variables
c  integer
c    destin         # destination array index
c    source         # source array index
c    hist_len       # length of time history
c    ichan          # A/D channel number
c    ierror         # error code returned from SFFPSD
c    in_len         # input length of each FFT
c    iwork(16)      # work array for SFFPSD
c    nchans         # number of A/D channels used
c    ncycles      # number of acquistion cycles
c    nsamples       # number of A/D samples read from file
c    nxplts, nyplts # number of graphs on a page (x & y directions)
c    plot_no        # counts the graphs on a page
c    out_len        # number of data points in each output spectrum
c    spec_start     # starting index of each spectrum
c    Jextadid       # rdflib : specify A/D used
c    Jextcyln       #        : number of A/D channels used
c    Jextchls       #        : get A/D channels
c    Jextnocy       #        : number of acquisition cycles
c  logical
c    ein            # function : is String1 contained in String2
c  real
c    cycle_time     # A/D cycle time
c    delta_freq     # frequency step in spectrum
c    freq(MAX_SPEC) # array of FFT frequencies
c    frequency      # frequency
c    to_volts       # conversion factor to volts (digits/Volt)
c    Uadvolts(4)    # digits/Volt for each A/D converter
c    Qextcytm       # rdflib : cycle time
c  character
c    Ctitle*23      # graph title
c    Gextadid*8     # rdflib : specify A/D used
c    Gextblk*8      #        : get block header
c  complex
c    zwork(MAX_SPEC)# work array for SFFPSD
c  subroutine
c    sffpsd
c    ilgopen, ilgopen, ilgpage, ilgslaw, ilgraph, ilgdata, ilgwait
c
c
      include 'stdio.def'
      integer MAX_SPEC
      parameter( MAX_SPEC=8193 )
c
      integer destin, source, hist_len, ichan, ierror, in_len,
     1        iwork(16), nchans, ncycles, nsamples, nxplts, nyplts,
     2        plot_no, out_len, spec_start,
     3        Jextadid, Jextchls, Jextcyln, Jextnocy
      logical ein
      real cycle_time, delta_freq, frequency, time_offset, to_volts,
     1     Uadvolts(4), freq(MAX_SPEC), Qextcytm
      complex zwork(MAX_SPEC)
      character Cerror(3)*15, Ctitle*23, Gextadid*8, Gextblk*8
      include 'rawlook.cmn'
c
      equivalence( freq(1), zwork(1) )
      data Uadvolts / 400.0, 3*409.6 /
      data Cerror /
     1    'Argument <= 0  ', 'Not enough data', 'PSD value <=0  ' /
c
c           Check that there is sufficient data to do the FFT and
c           enough array space for the output
c
      in_len = 2** len_fft
      if ( ein( 'z', Cspect_window ) ) then                               1b
          out_len = in_len
      else                                                                1m
          out_len = in_len/2
          end if                                                          1e
      nchans   = Jextcyln()
      ncycles = Jextnocy()
      hist_len = nsamples / nchans
      if ( hist_len .lt. in_len ) then                                    1b
          write( STD_OUT, 1 ) hist_len, in_len
1         format( ' RAWLOOK : ABORT : Not enough data (', i6,
     1            ') is for FFT of the required length (', i5, ')' )
          call ilgwait()
      else if ( out_len * nchans .gt. MAX_DATA ) then                     1m
          write( STD_OUT, 2 ) MAX_DATA
2         format( 'RAWLOOK : ABORT : Output array not big enough ', i6 )
          call ilgwait()
      else
          to_volts = Uadvolts( Jextadid() )
          cycle_time = Qextcytm()
c
c           calculate spectrum  -- loop once for each channel
c           ******************
c
          spec_start = 1
          write( STD_OUT, 3 )
3         format( ' Calculating spectra' )
          do 7 ichan = 1, nchans                                          2b
c
c           put data into real array
c
              source = ichan
              do 4 destin = 1, nsamples / nchans                          3b
                  x(destin) = Mdata(source) / to_volts
                  source = source + nchans
4                 continue                                                3e
c
c           calculate spectrum
c
              ierror = 0
              call sffpsd( x, 1, hist_len, cycle_time, len_fft,
     1            Cspect_window, y(spec_start), 1, delta_freq,
     2            zwork, iwork, ierror )
c
c           check for errors in SFFPSD
c           -- if any, report them and clear the spectrum
c
              if ( ierror .ne. 0 ) then                                   3b
                  if ( 129 .le. ierror .and. ierror .le. 131 ) then       4b
                      write( STD_OUT, 5 ) Jextchls(ichan),
     1                    Cerror(ierror-128)
5                     format( ' RAWLOOK : ERROR : calculating power ',
     1                        'spectrum for channel ', i5, '.', a )
                  else                                                    4m
                      write( STD_OUT, 5 ) Jextchls(ichan), 'unknown'
                      end if                                              4e
                  call ilgwait()
                  do 6 destin = spec_start, spec_start + out_len - 1      4b
                      y(destin) = 1.0
6                     continue                                            4e
                  end if                                                  3e
              spec_start = spec_start + out_len
7             continue                                                    2e
c
c               Plot spectra
c               ************
c               first generate the abscissa array
c
          if ( plot_spec ) then                                           2b
              write( STD_OUT, 8 )
8             format( ' Plotting spectra' )
              freq(1) = 0.0
              do 9 destin = 2, out_len                                    3b
                  freq(destin) = freq(destin-1) + delta_freq
9                 continue                                                3e
c
c               decide the number of graphs on the page, 1, 2 or 4
c
              if ( nchans .eq. 1 ) then                                   3b
                  nxplts = 1
                  nyplts = 1
              else if ( nchans .eq. 2 ) then                              3m
                  nxplts = 2
                  nyplts = 1
              else                                                        3m
                  nxplts = 2
                  nyplts = 2
                  end if                                                  3e
c
              spec_start = 1
              do 11 ichan = 1, nchans                                     3b
c
c           initialize each page
c
                  plot_no = mod( ichan, nxplts * nyplts )
                  if ( plot_no .eq. 1 .or. nchans .eq. 1 ) then           4b
                      if ( ichan .eq. 1 ) then                            5b
                          call ilgopen( Cap_spect )
                      else if ( Cap_spect .ne. ' ' ) then                 5m
                          call ilgopen( '?' )
                      else                                                5m
                          call ilgopen( ' ' )
                          end if                                          5e
                      call ilgpage( 'a4', 'wide', nxplts, nyplts )
                      call ilgslaw( Cspec_xlaw, Cspec_ylaw )
                      call ilgraph( 1, 1, 27, 27, 1 )
                      end if                                              4e
c
c           plot each spectrum -- each scaled independently
c
                  if ( Cspec_xlaw .eq. 'log' ) then                       4b
                      call ilgdata( freq(2), y(spec_start+1), 1,
     1                    out_len-1, 1 )
                  else                                                    4m
                      call ilgdata( freq, y(spec_start), 1, out_len, 1 )
                      end if                                              4e
                  call ilgxlab( 'frequency (Hz)' )
                  call ilgylab( 'Volts|t2/Hz' )
                  write( Ctitle, 10 ) Gextadid(), Jextchls(ichan)
10                format( a12, ' Channel ', i2 )
                  call ilgtitl( Ctitle )
                  if ( spec_wait .and. plot_no .eq. 0 )
     1                call ilgwait()
                  spec_start = spec_start + out_len
11                continue                                                3e
              if ( spec_wait .and. plot_no .ne. 0 )
     1            call ilgwait()
              call ilgclos()
              end if                                                      2e
c
c               write results for all channels
c               ******************************
c
          if ( spec_lu .ne. 0 ) then                                      2b
              write( STD_OUT, 12 )
12            format( ' Writing spectrum to file' )
              write( spec_lu, 13 ) Cmhdlab, Gextblk(), Csublab,
     1            ncycles, nchans, ( Jextchls(destin), destin=1,nchans )
13            format( ' ;' /
     1            ' ; module     : ', a /
     2            ' ; block      : ', a /
     3            ' ; sub-block  : ', a /
     4            ' ; ', i8, ' cycles, ', i2, ' channels' /
     5            ' ; channels ', 4i14 : / ( 12x, 4i14 ) )
              if ( nchans * ncycles .gt. nsamples ) then                  3b
                  write( spec_lu, 14 ) time_offset
14                format( ' Split data : time offset = ', g13.6,
     1                    ' seconds' )
                  end if                                                  3e
              frequency = 0.0
              do 16 source = 1, out_len                                   3b
                  write( spec_lu, 15 ) frequency, ( y( source + ichan ),
     1                ichan = 0, out_len * ( nchans - 1 ), out_len )
15                format( 1x, 5g14.6 : / ( 15x, 4g14.6 ) )
                  frequency = frequency + delta_freq
16                continue                                                3e
              end if                                                      2e
          end if                                                          1e
      return
      end



cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccc                                                                cccc
cccc                      UTILITY ROUTINES                          cccc
cccc                                                                cccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc



      SUBROUTINE RAW_OPEN_DUMP( INDEX, FILE_LU, CFILE_NAME )
c
c       Open/Close Dump file .
c
c Argument
c  integer   file_lu        # required logical unit number
c            index          # AUXILLARY, T_HISTORY, AVERAGE, SPECTRUM
c  character Cfile_name*(*) # required file name
c
c Local variables
c  logical
c    first_call         # if first call to this routine
c  integer
c    i                  # array index
c    res_lu(MAX_FILES)  # list of reserved logical unit numbers
c    new_lun            # function : get new logical number
c    open_file          #          : open file
c  character Cold_file(MAX_FILES)*64  # list of previous file names
c
      include 'stdio.def'
      include 'rawlook.cmn'
      logical first_call
      integer file_lu, index, i, res_lu(MAX_FILES), new_lun, open_file
      character Cfile_name*(*), Cold_file(MAX_FILES)*64
c
      data first_call / .TRUE. /
      data Cold_file / MAX_FILES* ' ' /
c
c           reserve the required logical unit numbers
c
      if ( first_call ) then                                              1b
          do 1 i = 1, MAX_FILES                                           2b
              res_lu(i) = new_lun()
1             continue                                                    2e
          first_call = .FALSE.
          end if                                                          1e
c
c           close the file if it is open and the name has changed
c
      if ( file_lu .ne. 0 .and. Cfile_name .ne. Cold_file(index) ) then   1b
          close( UNIT=file_lu )
          file_lu = 0
          end if                                                          1e
c
c           open the file
c             'aux' = use auxillary file
c             'tty' = standard output
c
      if ( Cfile_name .ne. ' ' .and. file_lu .eq. 0 ) then                1b
          if ( index .ne. AUXILLARY .and. Cfile_name .eq. 'aux' .and.
     1             aux_lu .ne. 0 ) then                                   2b
              file_lu = aux_lu
          else if ( Cfile_name .eq. 'tty' ) then                          2m
              file_lu = STD_OUT
          else                                                            2m
              file_lu = open_file( res_lu(index), Cfile_name, 'new', 0 )
              end if                                                      2e
          if ( file_lu .ne. 0 ) then                                      2b
              Cold_file(index) = Cfile_name
              end if                                                      2e
          end if                                                          1e
      return
      end



      BLOCK DATA RAW_BLOCK
      include 'rawlook.cmn'
c
      data host, aux_lu, verbosity, max_rec_len / 2, 0, 1, MAX_DATA /
      data chrsiz / 1.0 /
c
      data query_modul / .TRUE. /
      data modul_len, modul_max, modul_min, modul_sel, modul_step /
     1     0, 10, 1, MODUL_ALL, 1 /
c
      data time_hist, averaging, pow_spect, plot_thist, plot_spec,
     1     hist_wait, spec_wait / 3 * .FALSE., 4 * .TRUE. /
      data hist_lu, mean_lu, spec_lu, query_data, wind_off, wind_len,
     1     max_moment, len_fft / 0, 0, 0, 2, 0, MAX_DATA, 4, 10 /
      data Cap_thist, Cap_spect, Cspect_window, Cspec_xlaw, Cspec_ylaw /
     1     ' ', ' ', 'h  ', 'lin', 'lin' /
c
      data open_data / .TRUE. /
      data Cmhdlab, Csublab / ' ', ' ' /
      end



      INTEGER FUNCTION RAW_COMPRESS_LIST( LIST, SIZE )
c
c Compress unused places out of list of integers LIST . Any value of zero
c or less is considered "unused" . SIZE is the length of the list . The
c returned value of RAW_COMPRESS_LIST is the number of items remaining in
c the list after compression .
c
c Arguments
c  integer list(*)    # list to be compressed
c          size       # length of list
c
c Local variables
c  integer destin     # destination list index
c          source     # source list index
c
      include 'stdio.def'
      integer destin, source, size, list(*)
c
      destin = 0
      do 1 source = 1, size                                               1b
          if ( list(source) .gt. 0 ) then                                 2b
              destin = destin + 1
              list(destin) = list(source)
          else                                                            2m
              list(source) = 0
              end if                                                      2e
1         continue                                                        1e
      raw_compress_list = destin
      return
      end



      SUBROUTINE ISORTSH( IARRAY, SIZE )
c
c               SORT ( SHell )
c (Shell) sort the contents of the array IARRAY into ascending order .
c
c Arguments
c   integer isortsh(*)    # operand array
c           size          # length of the array
c local variables
c   integer i1,i2,i3      # looping indices
c           id            # sort segment size
c
      implicit none
      integer iarray(*), size, i1, i2, i3, id, itmp
c
      if ( size .lt. 2 ) return
      id = 2 ** int( log( real( size ) ) / log( 2.0 ) + 0.0001 ) - 1
c     repeat                                                              1b
1         do 3 i1 = 1, size - id                                          2b
              do 2 i2 = i1, 1, -id                                        3b
                  i3 = i2 + id
                  if ( iarray(i2) .le. iarray(i3) ) goto 3
                  itmp = iarray(i3)
                  iarray(i3) = iarray(i2)
                  iarray(i2) = itmp
2                 continue                                                3e
3             continue                                                    2e
          id = id / 2
          if ( id .gt. 0 ) goto 1
c     until ( id <= 0 )                                                   1e
      return
      end



      INTEGER FUNCTION RAW_READ_LIST( LIST, MAX_SIZE )
c
c   Read a list of up to MAX_SIZE integers from the keyboard into the
c   array LIST . The returned value of RAW_READ_LIST is the number of
c   values actually read . The values read must be between 0 and 10000
c   inclusive .
c
c Arguments
c  integer list(*)      # OUT # list of values
c          max_size     # IN  # maximum number of values
c Local variables
c  integer count        # number of values read
c  character Cline*64   # one line of input
c  subroutine scase     # change case
c
      include 'stdio.def'
      integer count, list(*), max_size
      character Cline*64
c
      count = 0
c
c           check if the array is full
c
c     start of loop                                                       1b
1         if ( count .ge. max_size ) then                                 2b
              write( STD_OUT, 2 )
2             format( ' Module list is full' )
              raw_read_list = count
              return
              end if                                                      2e
c
c           read a line
c
          call Cresp( STD_IN, Cline, 4 )
          call scase( cline, cline, 'L' )
          if ( Cline .eq. 'end' ) then                                    2b
              raw_read_list = count
              return
              end if                                                      2e
c
c           decode integer value
c
          read( Cline, *, ERR=4 ) list(count+1)
          count = count + 1
          goto 1
c         end of loop                                                     1e
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c           error traps
c
4         write( STD_OUT, 5 )
5         format( ' Cannot decode value' )
          goto 1
      end



      CHARACTER *3 FUNCTION CYES( BOOLEAN )
c
c    Returns 'yes' if BOOLEAN is .TRUE. or 'no ' if BOOLEAN is .FALSE. .
c
      include 'stdio.def'
      logical boolean
c
      if ( boolean ) then                                                 1b
          Cyes = 'yes'
      else                                                                1m
          Cyes = 'no '
          end if                                                          1e
      return
      end



      SUBROUTINE RAW_BUG( MESSAGE )
c
c         Report bugs in program and stop .
c
      include 'stdio.def'
      character message*(*)
c
      write( STD_ERR, 1 ) message
1     format( ' RAWLOOK : FATAL BUG : ', a )
      stop
      end



