c
c    Copyright (C) 1997  Peter Vernon Lanspeary
c
c    This program is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    This program is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program; if not, write to the Free Software
c    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c



      PROGRAM TEST_BLM
c
c     Test the Boundary layer model routines GET_BLM, SET_BLM, PRIN_BLM,
c UPLUS_BLM, ERROR_BLM .
c
c Variables
c  logical error_BLM    # function : report error
c  integer item         # item from function selection menu
c          what         # identifies BLM parameter
c          Jresp        # function : integer response
c          str_length   #          : non-blank string length
c  real value           # value of BLM parameter
c       y_plus          # distance from wall
c       def_BLM         # function : default value of BLM parameter
c       get_BLM         #          : get BLM parameter
c       step_BLM        #          : BLM parameter step size
c       Qresp           #          : real response
c       Uplus_BLM       #          : calculate velocity from model
c  character message*79 # error message string
c       name_BLM*24     # function : name of BLM parameter
c       str*24          #
c
      include 'stdio.def'
      logical error_BLM
      integer item, what, Jresp, str_length
      real value, y_plus,
     1     def_BLM, get_BLM, Qresp, step_BLM, Uplus_BLM
      character message*79, name_BLM*24, str*24
c
c
c     start loop
1         write( STD_OUT, 2 )
2         format( ' Select routine 0) Exit' /
     1        16x, '1) set_BLM     2) get_BLM     3) prin_BLM' /
     2        16x, '4) Uplus_BLM   5) Error_BLM   6) step_BLM' /
     3        16x, '7) def_BLM     8) ref_BLM     9) name_BLM   ', $ )
          item = Jresp( STD_IN, 0, 9, 4 )
          if ( item .eq. 0 ) then
              stop
c
c
          else if ( item .eq. 2 ) then
              write( STD_OUT, 3 )
3             format( ' Select' /
     1  '   0) BLM_BL_model       1) BLM_Clauser    2) BLM_56Coles' /
     2  '   3) BLM_68Coles        4) BLM_MKBull     5) BLM_Beattie' /
     3  '   6) BLM_BG_68C         7) BLM_Spalding   8) BLM_Spld_68C'/
     3  '  10) BLM_Constant      11) BLM_Karmen'   /
     4  '  20) BLM_fs_speed      21) BLM_kin_visc' /
     5  '  30) BLM_friction_vel  31) BLM_PI_wake   32) BLM_delta'   /
     6  '  40) BLM_reset         41) BLM_clear     42) BLM_dimens'
     7  '  43) BLM_nondim' /
     8  '  50) BLM_n_opt   ', $ )
              what = Jresp( STD_IN, -1, 99, 4 )
              value = get_BLM( what )
              write( STD_OUT, 4 ) value, what
4             format( 1x, g12.5, ' = get_BLM( ', i4, ' )' )
c
c
          else if ( item .eq. 1 ) then
              write( STD_OUT, 3 )
              what = Jresp( STD_IN, -1, 99, 4 )
              write( STD_OUT, 5 )
5             format( ' Value of parameter ? ', $ )
              value = Qresp( STD_IN, 0.0, 1.0e5, 4 )
              call set_BLM( what, value )
c
c
          else if ( item .eq. 3 ) then
              call prin_BLM( STD_OUT )
c
          else if ( item .eq. 4 ) then
              write( STD_OUT, 6 )
6             format( ' Distance from wall ? ', $ )
              y_plus = Qresp( STD_IN, -10.0, 100000.0, 4 )
              value = Uplus_BLM( y_plus )
              write( STD_OUT, 7 ) value, y_plus
7             format( 1x, g12.5, ' = Uplus_BLM( ', g12.5, ' )' )
c
          else if ( item .eq. 5 ) then
              if ( error_BLM( message ) ) then
                  write( STD_OUT, 8 ) message(1:str_length(message))
8                 format( 1x, a )
              else
                  write( STD_OUT, 9 )
9                 format( ' No errors' )
                  end if
c
          else if ( item .eq. 6 ) then
              write( STD_OUT, 3 )
              what = Jresp( STD_IN, -1, 99, 4 )
              value = step_BLM( what )
              write( STD_OUT, 10 ) value, what
10            format( 1x, g12.5, ' = step_BLM( ', i4, ' )' )
c
          else if ( item .eq. 7 ) then
              write( STD_OUT, 3 )
              what = Jresp( STD_IN, -1, 99, 4 )
              value = def_BLM( what )
              write( STD_IN, 11 ) value, what
11            format( 1x, g12.5, ' = def_BLM( ', i4, ' )' )
          else if ( item .eq. 8 ) then
              call ref_BLM( STD_OUT )
          else if ( item .eq. 9 ) then
              write( STD_OUT, 3 )
              what = Jresp( STD_IN, -1, 99, 4 )
              str = name_BLM( what )
              write( STD_OUT, 12 ) str, what
12            format( 1x, a, ' = name_BLM( ', i4, ' )' )
              end if
          goto 1
c         end of loop
      end

