c
c    Copyright (C) 1997  Peter Vernon Lanspeary
c
c    This program is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    This program is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program; if not, write to the Free Software
c    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c


      PROGRAM TEST_DELTA
c
c Test progrm for bly_delt.for
c
c constants
c  MAX_DATA  = 4096
c  MAX_TRIES = 4
c
c local variables
c  integer
c   file_len          # length of file length
c   item              # selected menu item
c   n_columns         # number of data columns
c   n_rows            # number of rows in data file
c   profile_lu        # actual logical unit number of data file
c   res_lu            # reserved logical unit number of data file
c   iargc             # function : number of program arguments
c   Jresp             #          : read real
c   new_lun           #          : gete new logical unit number
c   open_file         #          : open file
c   str_length        #          : non-blank file length
c  real
c   array(MAX_DATA)   # data array containing profile data
c  character
c   profile_file*32   # name of file containing profile data
c  subroutine
c   cresp             # read string
c   getarg            # get program argument
c   ilgwait
c   read_data         # read data array from file
c   newscr            # clear alpha-numeric screen
c
      include 'stdio.def'
      include 'bly_delta.def'
      integer MAX_DATA, MAX_TRIES
      parameter( MAX_DATA=4096, MAX_TRIES=4 )
c
      integer file_len, item, n_columns, n_rows, profile_lu, res_lu,
     1        iargc, Jresp, new_lun, open_file, str_length
      real    array(MAX_DATA)
      character profile_file*32
c
      write( STD_OUT, 7 )
      if ( iargc() .gt. 0 ) then                                          1b
          call getarg( 1, profile_file )
          end if                                                          1e
      res_lu = new_lun()
c
c     start menu loop                                                     1b
1         call newscr()
          file_len = max( 1, str_length( profile_file ) )
          write( STD_OUT, 2 ) profile_file(:file_len)
2         format( ' Main menu' / '   0) Stop program' /
     1        '   1) Data file name   ', a /
     2        '   2) Read data file and go to calculation menu' /
     3        '   3) Help' )
          item = Jresp( STD_IN, 0, 3, MAX_TRIES )
          if ( item .eq. 0 ) then                                         2b
              stop
          else if ( item .eq. 1 ) then                                    2m
              write( STD_OUT, 3 )
3             format( ' ? ', $ )
              call cresp( STD_IN, profile_file, MAX_TRIES )
          else if ( item .eq. 2 ) then                                    2m
              profile_lu = open_file( res_lu, profile_file, 'old', 0 )
              if ( profile_lu .le. 0 ) then                               3b
                  write( STD_ERR, 4 )
4                 format( ' Need profile data file' )
                  call ilgwait()
              else                                                        3m
                  call read_data( profile_lu, array, MAX_DATA,
     1                            n_rows, n_columns )
                  close( UNIT=profile_lu )
                  if ( n_rows .lt. 10 .or. n_columns .lt. 2 ) then        4b
                      write( STD_ERR, 5 )
5                     format( ' Too few columns or rows of data' )
                      call ilgwait()
                  else                                                    4m
                      call calculate_menu( array, n_rows )
                      end if                                              4e
                  end if                                                  3e
          else if ( item .eq. 3 ) then
              write( STD_OUT, 6 )
6             format(
     1          ' Specify data file name and then read the data file' )
              call ilgwait()
              end if                                                      2e
          goto 1
c         end of menu loop                                                1e
      end



      SUBROUTINE CALCULATE_MENU( ARRAY, N_DATA )
c
c
c Arguments
c  real array(*)
c  integer n_data
c
c constants
c  MAX_TRIES=4
c
c local variables
c  integer
c   item
c   Jresp
c  real
c   delta_EN
c   delta_star
c   delta_99
c   free_stream
c   theta
c   work
c   qdelta_energy
c   qdelta_nn
c   qdelta_star
c   qdelta_theta
c   Qresp
c  subroutine
c   newscr
c   sdelta_set_menu
c
c
c
      include 'stdio.def'
      integer    MAX_DATA, MAX_TRIES
      parameter( MAX_DATA=4096, MAX_TRIES=4 )
c
      integer n_data, item, Jresp
      real    array(*), delta_EN, delta_star, delta_99, free_stream,
     1        theta, work(MAX_DATA),
     2        qdelta_energy, qdelta_nn, qdelta_star, qdelta_theta,
     3        Qresp
c
c     start of menu loop                                                  1b
1         call newscr()
          write( STD_OUT, 2 ) free_stream, delta_99,
     2                        delta_star, theta, delta_EN
2         format( ' Calculation menu' / '   0) Return to main menu' /
     1            '   1) Free stream speed           ', f10.6 /
     2            '   2) Set parameters menu' /
     3            '   3) Boundary layer thickness => ', f10.6 /
     4            '   4) Displacement thickness   => ', f10.6 /
     5            '   5) Momentum thickness       => ', f10.6 /
     6            '   6) Energy thickness         => ', f10.6 )
          item = Jresp( STD_IN, 0, 9, MAX_TRIES )
c
c                   EXIT
c
          if ( item .eq. 0 ) then                                         2b
              return
c
c                   FREE STREAM SPEED
c
          else if ( item .eq. 1 ) then                                    2m
              write( STD_OUT, 3 )
3             format( ' ? ', $ )
              free_stream = Qresp( STD_IN, 0.0, 100.0, MAX_TRIES )
c
c                   SET PARAMETERS MENU
c
          else if ( item .eq. 2 ) then                                    2m
              call sdelta_set_menu()
c
c                   BOUNDARY LAYER THICKNESS
c
          else if ( item .eq. 3 ) then                                    2m
              delta_99 = qdelta_nn( array(1), array(2),
     1            2, n_data, 0.99 * free_stream, work )
c
c                   DISPLACEMENT THICKNESS
c
          else if ( item .eq. 4 ) then                                    2m
              delta_star = qdelta_star( array(1), array(2),
     1            2, n_data, free_stream, work )
c
c                   MOMENTUM THICKNESS
c
          else if ( item .eq. 5 ) then                                    2m
              theta = qdelta_theta( array(1), array(2),
     1            2, n_data, free_stream, work )
c
c                   ENERGY THICKNESS
c
          else if ( item .eq. 6 ) then                                    2m
              delta_en = qdelta_energy( array(1), array(2),
     1            2, n_data, free_stream, work )
              end if                                                      2e
              goto 1
c        end of loop                                                      1e
      end

