c
c    Copyright (C) 1997  Peter Vernon Lanspeary
c
c    This program is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    This program is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program; if not, write to the Free Software
c    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c


      PROGRAM TEST_MODE
c
c Test the code in QVKVS.FOR which selects the mode of laminar vortex
c shedding from a cylinder.
c
c REAL FUNCTION QVKVS_RAW( HOT_WIRE_DATA, INCREM, N_POINTS, TIME_STEP,
c                          CYLIND_DIAM, KINEM_VISC, WORK, FORCE_PLOT )
c REAL FUNCTION QVKVS_EQN( ACTION_EQN, SHEDDING_FREQ, SHEDDING_ANG,
c                          AIR_SPEED, CYLIND_DIAM, KINEM_VISC )
c
c
      include 'stdio.def'
      include 'qvkvs.def'
      integer i, formula, item, Jresp
      character mode*1, Cvkvs_formula*10
      real angle, cyl_diam, cyl_len, Re, rRe, Ro, rRo,
     1     shedding_eqn, inv_shedding_eqn, Qresp,
     2     IP_mode_line, XI_mode_line
      data Re, Ro, angle, cyl_diam, cyl_len /
     1     60.0, 8.2, 10.0, 0.00163, 0.240 /
      data formula / 48 /
c
1     call newscr()
      write( STD_OUT, 2 ) Re, mode, Cvkvs_formula(formula), formula,
     1                    Ro, angle, cyl_diam * 1000.0, cyl_len * 1000.0
2     format( ' Select' / '  (0) Exit' /
     1   '  (1) Re     ', g12.5 /
     2   '  (2) mode     ', a /
     3   '  (3) formula  ', a, i4 /
     4   '  (4) Ro     ', g12.5 /
     5   '  (5) angle  ', g12.5 /
     6   '  (6) cyl diam ', g12.5, ' mm' /
     7   '  (7) cyl len  ', g12.5, ' mm' /
     8   '  (8) set_angle_formula(Re,mode)=>angle,formula' /
     9   '  (9) calculate etcs' /
     a   ' (10) svkvs_mode_set(Re,diam,len,visc)=>formula,angle,mode' )
      item = Jresp( STD_IN, 0, 10, 4 )
      if ( item .eq. 0 ) then
          stop
      else if ( item .eq. 1 ) then
          write ( STD_OUT, 3 )
3         format( ' ?' )
          Re = Qresp( STD_IN, 30.0, 170.0, 4 )
      else if ( item .eq. 2 ) then
4         write( STD_OUT, 3 )
          call Cresp( STD_IN, mode, 4 )
          if ( mode .ne. 'P' .and. mode .ne. 'I' .and. mode .ne. 'X' )
     1        goto 4
      else if ( item .eq. 3 ) then
          write( STD_OUT, 5 ) ( i, Cvkvs_formula(i*16), i=0,4 )
5         format( '  (', i1, ') ', a )
          formula = 16 * Jresp( STD_IN, 0, 4, 4 )
      else if ( item .eq. 4 ) then
          write( STD_OUT, 3 )
          Ro = Qresp( STD_IN, 4.0, 40.0, 4 )
      else if ( item .eq. 5 ) then
          write( STD_OUT, 3 )
          angle = Qresp( STD_IN, 0.0, 25.0, 4 )
      else if ( item .eq. 6 ) then
          write( STD_OUT, 3 )
          cyl_diam = Qresp( STD_IN, 0.5, 25.0, 4 ) / 1000.0
      else if ( item .eq. 7 ) then
          write( STD_OUT, 3 )
          cyl_len = Qresp( STD_IN, 10.0, 1000.0, 4 ) / 1000.0
      else if ( item .eq.  8 ) then
          call set_angle_formula( Re, mode, formula, angle )
      else if ( item .eq. 9 ) then
          rRo = shedding_eqn( formula, Re, angle )
          rRe = inv_shedding_eqn( formula, Ro, angle )
          write( STD_OUT, 6 ) IP_mode_line(Re), XI_mode_line(Re),
     1                        Re, rRo, Ro, rRe
6     format( ' IP_mode_line => aspect ratio = ', g12.5 /
     1        ' XI_mode_line => aspect ratio = ', g12.5 /
     2        ' shedding_eqn(', g12.5, ' ) => Ro = ', g12.5 /
     3        ' inv_shedding_eqn(', g12.5, ' ) => Re = ', g12.5 /
     4        ' Press <RETURN> to continue' )
          read( STD_IN, 7 )
7         format()
      else if ( item .eq. 10 ) then
          call svkvs_mode_set( .false., VK_UNUSED, Re, cyl_diam,
     1        cyl_len, 150e-6, formula, angle, mode )

          end if
      goto 1
      end


