c
c    Copyright (C) 1997  Peter Vernon Lanspeary
c
c    This program is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    This program is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program; if not, write to the Free Software
c    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c


      PROGRAM TEST_AMOEBA
c
c test AMOEBA -- multidimensional optimisation
c
      include 'stdio.def'
      include 'amoeba.def'
      integer iterations, n_dim, i, j, stop_crit
      real polyhed(4,5), values(5), work(20)
      external test_func
c
      data polyhed /
     1    8.0,  9.0, 12.0, 13.0,
     2    9.0,  9.0, 12.0, 13.0,
     3    8.0, 10.0, 12.0, 13.0,
     4    8.0,  9.0, 13.0, 13.0,
     5    8.0,  9.0, 12.0, 14.0 /
c
      n_dim      = 4
      iterations = -1
      stop_crit  = ABS_FUNC + POLY_size
      open( UNIT=11, FILE='tst_amoe.plt', STATUS='unknown' )
c
c      SUBROUTINE AMOEBA( FUNC, FUNC_VAL, N,
c     1                   POLYHED, POLY_ROWS,
c     2                   MAX_ITERATIONS, N_ITERATIONS,
c     3                   TYPE_TOL, FUNC_TOL, X_TOL,
c     4                   WORK )
c
      call amoeba( test_func, values, n_dim,
     1             polyhed, 4,
     2             1000, iterations,
     3             stop_crit, 0.0001, 0.00001,
     4             work )
      write( STD_OUT, 1 ) iterations, n_dim
1     format( 1x, i12, ' iterations for a ', i6,
     1    ' dimensional problem' )
      do 3 i = 1, n_dim + 1
          write( STD_OUT, 2 ) ( polyhed(j,i), j = 1, n_dim ), values(i)
2         format( 1x, 5g14.6 )
3         continue
      stop
      end


      REAL FUNCTION TEST_FUNC( X )
      include 'stdio.def'
      integer n
      real x(*)
      save n
      data n / 0 /
c
      n = n + 1
      test_func = 4.0 * ( x(1) - 5.0 ) **2 + ( x(2) - 6.0 ) **2 +
     1            8.0 * ( x(3) - 7.0 ) **2 + 2.0 * ( x(4) - 8.0 ) **2
      write( 11, 1 ) n, x(1), x(2), x(3), x(4), test_func
1     format( 1x, i4, 4f10.6, g13.6 )
      return
      end
