c
c    Copyright (C) 1997  Peter Vernon Lanspeary
c
c    This program is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    This program is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program; if not, write to the Free Software
c    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c


      PROGRAM TEST
c
c test FFT2C -- complex Fast (and discrete) Fourier Transform algorithm
c
      include 'stdio.def'
      integer    MAX_DATA
      real       PI
      parameter( MAX_DATA=4096, PI=3.1415926 )
c
      integer i
      real    time(MAX_DATA), psd(MAX_DATA)
      complex array(MAX_DATA)
c
      do 1 i = 1, MAX_DATA
        time(i)  = real( i - 1 ) / MAX_DATA
        psd(i)   = 0.25 * sin( real( i ) * 2.0 * PI * 0.11 ) +
     1             0.50 * sin( real( i ) * 2.0 * PI * 0.21 ) +
     2             0.75 * sin( real( i ) * 2.0 * PI * 0.31 ) +
     3             1.00 * sin( real( i ) * 2.0 * PI * 0.41 )
        array(i) = psd(i)
1       continue
      call ilgopen( ' ' )
      call ilgpage( 'a4', 'wide', 1, 2 )
      call ilgdata( time, psd, 1, MAX_DATA, 1 )
      call fft2c( array, 12, i )
      do 2 i = 1, MAX_DATA
          psd(i) = max( 1.0,
     1                  real( array(i) ) **2 + aimag( array(i) ) **2 )
2         continue
      call ilgslaw( 'lin', 'log' )
      call ilgdata( time, psd, 1, MAX_DATA, 1 )
      call ilgwait()
      call ilgclos()
      stop
      end

