c
c    Copyright (C) 1997  Peter Vernon Lanspeary
c
c    This program is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    This program is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program; if not, write to the Free Software
c    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c

      PROGRAM FILTER_TEST
c
c Test the finite impulse response filter routine JFIR_filt -- integer data
c
      include 'stdio.def'
      integer    ARRAY_SIZE,
     1           MAX_TRIES,   MAX_LEN
      parameter( ARRAY_SIZE=4096,
     1           MAX_TRIES=4, MAX_LEN=128 )
c
      integer col, columns, data_lu, i, item, length, max_plots,
     1        method, new_plot, n_done(32), n_plot, rows,
     2        IFIR_filt, Jresp, new_lun, open_file
      integer *2 in_data(ARRAY_SIZE), out_data(ARRAY_SIZE)
      logical got_filter, EFIR_read
      real    offset, time_shift, temp_data(ARRAY_SIZE), Qresp
      double precision coeffs(MAX_LEN)
      character filter_file*64, Cyes*5
      data max_plots, method, new_plot, col / 4, 0, 1, 2 /
      data offset / 0.0 /
      data filter_file / 'prx_050.fil' /
c     subroutine read_data, newscr, Cresp, ilgopen, ilgpage, ilgdata
c
      data_lu = open_file( new_lun(), 'tst_filt.dat', 'old', 0 )
      if ( data_lu .gt. 0 ) then
          call read_data( data_lu, temp_data, ARRAY_SIZE, rows, columns)
          do 12 i = 1, rows * columns
              in_data(i)  = temp_data(i) * 1000
              out_data(i) = temp_data(i) * 1000
12            continue
          close( UNIT=data_lu )
          call ilgopen( ' ' )
          call ilgpage( 'a4', 'wide', 1, max_plots )
c
1             call newscr()
              write( STD_OUT, 2 ) method, filter_file, got_filter, col,
     1            max_plots, Cyes( new_plot ), offset
2             format( '  0) Stop' /
     1                '  1) Method              ', i2 /
     2                '  2) Filter spec file    ', a /
     3                '  3) Read filter spec    ', l2 /
     4                '  4) Current data column ', i2 /
     5                '  5) Filter data' /
     6                '  6) Plot unfiltered data' /
     7                '  7) Plot filtered data' /
     8                '  8) Clear plot' /
     9                '  9) No. of graphs/page  ', i2 /
     a                ' 10) New graph           ', a /
     b                ' 11) Filtered offset     ', g12.5 )
              item = Jresp( STD_IN, 0, 11, MAX_TRIES )
              if ( item .eq. 0 ) then
                  call ilgclos()
                  stop
              else if ( item .eq. 1 ) then
                  write( STD_OUT, 3 )
3                 format( ' Method ?' )
                  method = Jresp( STD_IN, -1, 11, MAX_TRIES )
              else if ( item .eq. 2 ) then
                  write( STD_OUT, 4 )
4                 format( ' Filter file name ?' )
                  call Cresp( STD_IN, filter_file, MAX_TRIES )
              else if ( item .eq. 3 ) then
                  got_filter =
     1                EFIR_read( filter_file, MAX_LEN, coeffs, length )
                  if ( got_filter ) then
                      do 10 i = 1, columns
                          n_done(i) = 0
10                        continue
                      time_shift = ( in_data(columns+1) - in_data(1) ) *
     1                    length / 2
                      do 11 i = 1, ( rows - 1 ) * columns + 1, columns
                          out_data(i) = in_data(i) - time_shift
11                        continue
                      end if
              else if ( item .eq. 4 ) then
                  write( STD_OUT, 6 )
6                 format( ' Which column ?' )
                  col = Jresp( STD_IN, 2, columns, MAX_TRIES )
              else if ( item .eq. 5 ) then
                  n_done(col) = IFIR_filt( in_data(col), out_data(col),
     1                 columns, rows, coeffs, length, method )
                  write( STD_OUT, 7 ) n_done(col)
7                 format( ' JFIR_filt = ', i12 )
                  call ilgwait()
              else if ( item .eq. 6 ) then
                  call ilgfset( 0.0, 0.0 )
                  do 13 i = 1, rows * columns
                      temp_data(i) = in_data(i)
13                    continue
                  call ilgdata( temp_data(1), temp_data(col),
     1                          columns, rows, new_plot )
              else if ( item .eq. 7 ) then
                  if ( n_done(col) .gt. 0 ) then
                      do 14 i = 1, rows * columns
                          temp_data(i) = out_data(i)
14                        continue
                      call ilgfset( 0.0, offset )
                      call ilgdata( temp_data(1), temp_data(col),
     1                              columns, n_done(col), new_plot )
                      end if
              else if ( item .eq. 8 ) then
                  call ilgopen( ' ' )
                  call ilgpage( 'a4', 'wide', 1, max_plots )
              else if ( item .eq. 9 ) then
                  write( STD_ERR, 8 )
8                 format( ' No. of graphs per page ?' )
                  max_plots = Jresp( STD_IN, 1, 6, MAX_TRIES )
                  call ilgopen( ' ' )
                  call ilgpage( 'a4', 'wide', 1, max_plots )
              else if ( item .eq. 10 ) then
                  new_plot = mod( new_plot + 1, 2 )
              else if ( item .eq. 11 ) then
                  write( STD_ERR, 9 )
9                 format( ' Filtered Offset ?' )
                  offset = Qresp( STD_IN, -10.0, 10.0, MAX_TRIES )
                  end if
              goto 1
          end if
      end
