c
c    Copyright (C) 1997  Peter Vernon Lanspeary
c
c    This program is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    This program is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program; if not, write to the Free Software
c    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c


c                      #######################################
c                      ###                                 ###
c                      ###     RAW DATA FILE HANDLING      ###
c                      ###     fortran object library      ###
c                      ###       by P.V. Lanspeary         ###
c                      ###                                 ###
c                      #######################################
c
c All access to the data files written by GENACQ is through this library
c


      SUBROUTINE SRDFHOST( IIHOST )
c
c     Set HOST
c       Set the identity of the host machine, i.e. the machine which generated
c  the GENACQ data file .
c Argument
c  integer *4 iihost   # identifies the machine on which the data
c                      #  file was generated   0 = VAX       - VMS
c                                              1 = PDP 11/34 - unix
c                                              2 = IBM PC    - MS-DOS
c
      implicit none
      integer *2 Hvdulu
      parameter( Hvdulu=6 )
c
      integer *4 iihost
      include 'rdflib.cmn'
c
      if ( iihost .lt. 0 .or. iihost .gt. 2 ) then
        ihost = 0
        write( Hvdulu, 1 ) iihost
1       format( ' SRDFHOST : ABORT : Unknown host ', i12 )
      else
        ihost = iihost
        end if
      return
      end


      REAL FUNCTION QRDFREAL( RFOREIGN )
c
c       Convert the foreign bit pattern of the 32 bit real number RFOREIGN to
c  a VAX bit pattern 32 bit real number . This routine only actually has to do
c  anything if the host machine is an IBM XT/AT .
c
      implicit none
      real rforeign, qieeedec
      include 'rdflib.cmn'
c
      if ( ihost .eq. 2 ) then
        qrdfreal = qieeedec( rforeign )
      else
        qrdfreal = rforeign
        end if
      return
      end


      REAL FUNCTION QRDFRPUT( RVAX )
c
c       Convert the VAX bit pattern of the 32 bit real number RVAX to
c  a foreign bit pattern 32 bit real number . This routine only actually has to
c  do anything if the host machine is an IBM XT/AT .
c
      implicit none
      real rvax, qdecieee
      include 'rdflib.cmn'
c
      if ( ihost .eq. 2 ) then
        qrdfrput = qdecieee( rvax )
      else
        qrdfrput = rvax
        end if
      return
      end


      INTEGER *4 FUNCTION JRDFINT4( IFOREIGN )
c
c       Convert the foreign bit pattern of the 32 bit integer IFOREGN to
c  a VAX bit pattern 32 bit integer . This routine only actually has to do
c  anything if the host machine is a PDP 11/34 .
c
      implicit none
      integer *4 iforeign, jp11vax
      include 'rdflib.cmn'
c
      if ( ihost .eq. 1 ) then
        jrdfint4 = jp11vax( iforeign )
      else
        jrdfint4 = iforeign
        end if
      return
      end


      LOGICAL FUNCTION ERDFOPN( FILE_NAME, IRDFREC, IAUXLU )
c
c      Raw Data File OPeN
c    Raw data file is direct access unformatted with a fixed record length
c of 512 bytes . The first record contains the number of module header records,
c followed by a directory ( ie list ) of record numbers of each module header
c record . The directory is read into DIRREC . Only one raw data file can be
c open at any one time .
c    If 0 < IAUXOP < 100 , most terminal output is also sent to the auxiliary
c output file with logical unit number IAUXOP .
c
c If the file is already open or is successfully opened the returned result
c is .TRUE., otherwise it is .FALSE. .
c
c constants
c     Hvdulu        # v.d.u. logical unit number
c     Hkbdlu        # keyboard logical unit number
c     Hreclen       # data file record length in bytes'
c variables
c  integer irdfrec  # data file record pointer
c          iauxlu   # auxiliary output file logical unit number
c          new_lun  # function : get new logical unit no.
c  logical daopen   # open direct access file
c          daget    # get data from direct access file
c
      implicit none
      integer Hvdulu, Hkbdlu, Hreclen
      parameter( Hvdulu=6, Hkbdlu=5, Hreclen = 512 )
c
      integer irdfrec, iauxlu, new_lun
      logical daopen, daget
      character file_name*(*)
c
      include 'rdflib.cmn'
c
      iauxop = iauxlu
      if ( .not. frdfopn ) then
          if ( irdflu .eq. 0 ) then
              irdflu = new_lun()
              end if
          erdfopn = daopen( irdflu, file_name, Hreclen )
          if ( erdfopn ) then
              irdfrec = 1
              erdfopn = daget( irdfrec, dirrec, Hreclen )
              if ( erdfopn ) then
                  frdfopn = .TRUE.
                  idirptr = 2
                  Cblklab = '        '
                  imute = 2
                  dnxtrec = irdfrec
                  fdata = .false.
                  fchange = .true.
                  end if
              end if
      else
          erdfopn = .TRUE.
          end if
      if ( .not. erdfopn )
     1    write( Hvdulu, 1 ) file_name
1         format( ' ERDFOPN : ABORT : Cannot open data file ', a )
      return
      end



      SUBROUTINE SRDFOPN( IRDFREC, IAUXLU )
c
c      Raw Data File OPeN
c    Raw data file is direct access unformatted with a fixed record length
c of 512 bytes . The first record contains the number of module header records,
c followed by a directory ( ie list ) of record numbers of each module header
c record . The directory is read into DIRREC . Only one raw data file can be
c open at any one time .
c    If 0 < IAUXOP < 100 , most terminal output is also sent to the auxiliary
c output file with logical unit number IAUXOP .
c
c constants
c     Hvdulu        # v.d.u. logical unit number
c     Hkbdlu        # keyboard logical unit number
c     Hreclen       # data file record length in bytes'
c variables
c  integer irdfrec  # data file record pointer
c          iauxlu   # auxiliary output file logical unit number
c          new_lun  # function : get new logical unit no.
c  logical daopen   # open direct access file
c          daget    # get data from direct access file
c
      implicit none
      integer Hvdulu, Hkbdlu, Hreclen
      parameter( Hvdulu=6, Hkbdlu=5, Hreclen = 512 )
c
      integer irdfrec, iauxlu, new_lun
      logical daopen, daget
c
      include 'rdflib.cmn'
c
      iauxop = iauxlu
      if ( .not. frdfopn ) then
c     repeat
1         write( Hvdulu, 2 )
2         format( ' Raw data ', $ )
          if ( irdflu .eq. 0 ) then
              irdflu = new_lun()
              end if
          if ( .not. daopen( irdflu, '?', Hreclen ) ) then
              write( Hvdulu, 3 )
3             format( 'SRDFOPN : Cannot open file' )
              goto 1
              end if
c             until( file is opened successfully )
          irdfrec = 1
          if ( .not. daget( irdfrec, dirrec, Hreclen ) )
     1        call srdferr( 'SRDFOPEN', Hrdfueof )
          frdfopn = .true.
          idirptr = 2
          Cblklab = '        '
          imute = 2
          dnxtrec = irdfrec
          fdata = .false.
          fchange = .true.
          end if
      return
      end



      SUBROUTINE SRDFCLS
c
c       Raw Data File CLoSe
c
      implicit none
      include 'rdflib.cmn'
c
      if ( frdfopn ) then
        close( UNIT=irdflu, STATUS='KEEP' )
        frdfopn = .false.
        end if
      return
      end



      LOGICAL *2 FUNCTION ERDFMHD( CLABEL, IRDFREC )
c
c       Raw Data File find Module HeaDer
c
c    Attempts to find and read the next module header record with the label
c CLABEL . If successful, the returned result is ERDFMHD = .true. , otherwise
c it is .false. . IRDFREC is the record number from which the search starts .
c On exit , IRDFREC is the next record number .
c
c constants
c    Hvdulu                    # v.d.u. logical unit number
c    Zlabel                    # Routine name
c variables
c  integer *4 irdfrec          # raw data file record number
c             iresrec          # original record number : reserved
c  integer *2 nmodul           # module number
c             iipf1            # primary input command file logical unit
c             iipf2            # secondary input command file logical unit
c             iopf1            # primary output command file logical unit
c  byte Bipf1(32)              # primary input command file name
c       Bipf2(32)              # secondary input command file name
c       Bopf1(32)              # primary output command file name
c       Bmhlab(8)              # actual block header label
c  logical *4 daget            # function : read direct access file
c  character *8 Clabel         # required module header label
c               Cmhlab         # actual block header label
c
      implicit none
      integer *2 Hvdulu
      character *7 Zlabel
      parameter( Hvdulu=6, Zlabel='ERDFMHD' )
c
      integer *4 irdfrec, iresrec
      integer *2 nbytes, nmodul, iipf1, iipf2,iopf1
      byte Bipf1(32), Bipf2(32), Bopf1(32), Bmhlab(8)
      logical *4 daget
      character Clabel*8, Cmhlab*8
c
      include 'rdflib.cmn'
      equivalence ( Mhdr(1), Bmhlab(1) ), ( Mhdr(5), nbytes ),
     1  ( Mhdr(6), iipf1 ), ( Mhdr(7), iipf2 ), ( Mhdr(8), iopf1 ),
     2  ( Mhdr(9), Bipf1(1) ), ( Mhdr(25), Bipf2(1) ),
     3  ( Mhdr(41), Bopf1(1) ), ( Mhdr(53), nmodul )
c
      iresrec = irdfrec
      erdfmhd = .false.
      if ( Clabel .ne. '#initial' .and. Clabel .ne. '#acquire' .and.
     1    Clabel .ne. '#close  ' .and. Clabel(1:4) .ne. '#cal' )
     2  call srdferr( Zlabel, Hrdfimod )
      call srdfind( irdfrec )
      do while ( idirptr .le. dirrec(1)+1 )
        irdfrec = dirrec( idirptr )                                        1
        idirptr = idirptr + 1
        call dainit
        if ( .not. daget( irdfrec, Mhdr, 114 ) ) goto 4
        call Sbytchr( Bmhlab, Cmhlab, 8 )
        if ( Cmhlab .eq. Clabel ) then                                     2
          if ( nbytes .ne. 108 )
     1      call srdferr( Zlabel, Hrdfbcnt )
          if ( imute .gt. 0 ) then
            write( Hvdulu, 1 ) Clabel, idirptr - 2
1           format( ' ERDFMHD : Module header : type = ', a8 /
     1        25x, ': directory entry = ', i5 )
            if ( iauxop .gt. 0 .and. iauxop .lt. 100 )
     1        write( iauxop, 1 ) Clabel, idirptr - 2
            end if
          if ( imute .ge. 2 ) then
            write( Hvdulu, 2 ) nmodul, iipf1, Bipf1, iipf2, Bipf2,
     1        iopf1, Bopf1
2           format( 25x, ': module number = ', i5 //
     1        11x, 'command files  logical unit   name' /
     2        11x, 'primary input', 5x, i6, 4x, 32a1 /
     3        9x, 'secondary input', 5x, i6, 4x, 32a1 /
     4        10x, 'primary output', 5x, i6, 4x, 32a1 / )
            if ( iauxop .gt. 0 .and. iauxop .lt. 100 )
     1        write( iauxop, 2 ) nmodul, iipf1, Bipf1, iipf2, Bipf2,
     2          iopf1, Bopf1
            end if
          erdfmhd = .true.
          return
          end if                                                           2
        end do                                                             1
4     irdfrec = iresrec
      if ( imute .ge. 0 )
     1  write( Hvdulu, 3 ) Clabel
3       format( 'ERDFMHD : ', a8, ' not found' )
      return
      end



      SUBROUTINE SRDFMHD( CLABEL, IRDFREC )
c
c       Raw Data File get next Module HeaDer
c
c    Reads the next module header record . IRDFREC is the record number from
c which the search starts . On exit , IRDFREC is the next record number .
c
c constants
c    Hvdulu                    # v.d.u. logical unit number
c    Zlabel                    # Routine name
c variables
c  integer *4 irdfrec          # raw data file record number
c  integer *2 nmodul           # module number
c             iipf1            # primary input command file logical unit
c             iipf2            # secondary input command file logical unit
c             iopf1            # primary output command file logical unit
c  byte Bipf1(32)              # primary input command file name
c       Bipf2(32)              # secondary input command file name
c       Bopf1(32)              # primary output command file name
c       Bmhlab(8)              # actual block header label
c  logical *4 daget            # function : read direct access file
c  character *8 Clabel         # required module header label
c
      implicit none
      integer *2 Hvdulu
      character *7 Zlabel
      parameter( Hvdulu=6, Zlabel='SRDFMHD' )
c
      integer *4 irdfrec
      logical *4 daget
      integer *2 nbytes, nmodul, iipf1, iipf2,iopf1
      byte Bipf1(32), Bipf2(32), Bopf1(32), Bmhlab(8)
      character Clabel*8
c
      include 'rdflib.cmn'
      equivalence ( Mhdr(1), Bmhlab(1) ), ( Mhdr(5), nbytes ),
     1  ( Mhdr(6), iipf1 ), ( Mhdr(7), iipf2 ), ( Mhdr(8), iopf1 ),
     2  ( Mhdr(9), Bipf1(1) ), ( Mhdr(25), Bipf2(1) ),
     3  ( Mhdr(41), Bopf1(1) ),( Mhdr(57), nmodul )
c
      call srdfind( irdfrec )
      irdfrec = dirrec( idirptr )
      idirptr = idirptr + 1
      call dainit
      if ( .not. daget( irdfrec, Mhdr, 114 ) )
     1  call srdferr( Zlabel, Hrdfueof )
      call Sbytchr( Bmhlab, Clabel, 8 )
      if ( Clabel .ne. '#initial' .and. Clabel .ne. '#acquire' .and.
     1    Clabel .ne. '#close  ' .and. Clabel(1:4) .ne. '#cal' )
     2  call srdferr( Zlabel, Hrdfimod )
      if ( nbytes .ne. 108 )
     1  call srdferr( Zlabel, Hrdfbcnt )
      if ( imute .gt. 0 ) then
        write( Hvdulu, 1 ) Clabel, idirptr - 2
1       format( ' SRDFMHD : Module header : type = ', a8 /
     1    25x, ': directory entry = ', i5 )
        if ( iauxop .gt. 0 .and. iauxop .lt. 100 )
     1    write( iauxop, 1 ) Clabel, idirptr - 2
        end if
      if ( imute .ge. 2 ) then
        write( Hvdulu, 2 ) nmodul, iipf1, Bipf1, iipf2, Bipf2,
     1    iopf1, Bopf1
2       format( 25x, ': module number = ', i5 //
     1    11x, 'command files  logical unit   name' /
     2    11x, 'primary input',  5x, i6, 4x, 32a1 /
     3    9x, 'secondary input', 5x, i6, 4x, 32a1 /
     4    10x, 'primary output', 5x, i6, 4x, 32a1 / )
        if ( iauxop .gt. 0 .and. iauxop .lt. 100 )
     1    write( iauxop, 2 ) nmodul, iipf1, Bipf1, iipf2, Bipf2,
     2      iopf1, Bopf1
        end if
      return
      end



      SUBROUTINE SRDFIND( IRDFREC )
c
c       FIND Raw Data File module header
c
c    Finds the directory entry which points to the next module header record .
c The search is started at the record IRDFREC and the directory pointer is
c adjusted until it points at the nearest module header after IRDFREC . The
c returned value is the directory pointer IDIRPTR in common block .
c
      implicit none
      integer *4 irdfrec
c
      include 'rdflib.cmn'
c
c         Check if already finished
c
      if ( irdfrec .eq. dirrec( idirptr ) )
     1  return
c
c         Check boundary conditions
c
      irdfrec = max( dirrec(2), min( dirrec( 1+dirrec(1) ), irdfrec ) )
      idirptr = max( 2, min( dirrec(1), idirptr ) )
c
c         Advance directory pointer
c
      if( irdfrec .gt. dirrec( idirptr ) ) then
        do while( irdfrec .gt. dirrec( idirptr ) )
          idirptr = idirptr + 1
          end do
c
c         Retard directory pointer
c
      else if( irdfrec .lt. dirrec( idirptr ) ) then
        do while( irdfrec .lt. dirrec( idirptr ) )
          idirptr = idirptr - 1
          end do
        if ( irdfrec .ne. dirrec(idirptr) )
     1    idirptr = idirptr + 1
        end if
      return
      end



      SUBROUTINE SRDFERR( CSOURCE, ISTATUS )
c
c       Display ERRor message from Raw Data File handler routine
c N.B. All errors except 5 are fatal .
c
c Arguments
c  character Csource*(*)       # name of source routine
c  integer *4 istatus          # error status & status
c
      implicit none
      integer *2 Hvdulu
      parameter( Hvdulu=6 )
c
      integer *4 istatus
      character Csource*(*)
c
      include 'rdflib.cmn'
c
      if ( istatus .eq. Hrdfimod ) then
        write( Hvdulu, 1 ) Csource
1       format( 1x, a, ' : FATAL : Invalid module requested' )
      else if ( istatus .eq. Hrdfbcnt ) then
        write( Hvdulu, 2 ) Csource
2       format( 1x, a, ' : FATAL : Wrong byte count in header' )
      else if ( istatus .eq. Hrdfsblk ) then
        write( Hvdulu, 3 ) Csource
3       format( 1x, a, ' : FATAL : Invalid sub-block label' )
      else if ( istatus .eq. Hrdfiblk ) then
        write( Hvdulu, 4 ) Csource
4       format( 1x, a, ' : FATAL : Invalid block label' )
      else if ( istatus .eq. Hrdfscnt ) then
        write( Hvdulu, 5 ) Csource
5       format( 1x, a, ' : WARNING : Data byte vs.  sample count' )
      else if ( istatus .eq. Hrdfunav ) then
        write( Hvdulu, 6 ) Csource
6       format( 1x, a, ' : FATAL : Quantity unavailable' )
      else if ( istatus .eq. Hrdfnoac ) then
        write( Hvdulu, 7 ) Csource
7       format( 1x, a, ' : FATAL : No acquisition block' )
      else if ( istatus .eq. Hrdfsmal ) then
        write( Hvdulu, 8 ) Csource
8       format( 1x, a, ' : FATAL : Data array too small' )
      else if ( istatus .eq. Hrdfueof ) then
        write( Hvdulu, 9 ) Csource
9       format( 1x, a, ' : FATAL : Uexpected EOF' )
      else
        write( Hvdulu, 10 ) Csource
10      format( 1x, a, ' : FATAL : Unknown' )
        end if
      if ( istatus .ne. 5 )
     1  stop
      return
      end


      SUBROUTINE SRDFINIT( RBARPRESS, RAMBTEMP, IRDFREC )
c
c       INITialize block header from Raw Data File
c   Reads an initialize block header record from an opened Raw Data File .
c The raw data file is assumed to have been opened by ERDFOPEN . IRDFREC - the
c data file record pointer , is assumed to point to the appropriate data
c record , and its value has been determined by a call to
c ERDFMHD( '#initial', irdfrec )  or SRDFMHD( Clabel, Irdfrec )
c with Clabel='#initial'
c
c constants
c    Hvdulu                    # v.d.u. logical unit number
c    Zlabel                    # Routine name
c variables
c  integer *4 irdfrec          # raw data file record number
c  integer *2 nbytes           # number of bytes remaining in record
c             lencmt           # total length of comment in bytes
c             icmt             # comment byte pointer
c             icol, icol1      # comment line character pointers
c  byte Bdfname(32)            # Unix data file name and path
c       Bdate(32)              # time and date of experiment
c  character *8  Clabel        # required module header label
c  real Rbarpress, Rapbar      # barometeric pressure in Pascals
c       Rambtemp, Raptem       # ambient temperature in Kelvin
c  logical *4 daget            # function : read Direct access file
c  subroutines
c    dainit, srdferr
c
      implicit none
      integer *2 Hvdulu
      character *8 Zlabel
      parameter( Hvdulu=6, Zlabel='SRDFINIT' )
c
      byte Bcmt(81)
      integer *4 irdfrec, Iapbar, Iaptem
      integer *2 nbytes, lencmt, icmt, icol, icol1
      byte Bdfname(32), Bdate(32), Blabel(8)
      logical *4 daget
      character Clabel*8
      real Rbarpress, Rambtemp, qrdfreal
c
      include 'rdflib.cmn'
      equivalence ( Mhdr(1), Blabel ), ( Mhdr(5), nbytes ),
     1  ( Mhdr(6), Bdfname ), ( Mhdr(22), Bdate ), ( Mhdr(38), Iapbar ),
     2  ( Mhdr(40), Iaptem ), ( Mhdr(42), lencmt )
c
c           read the initialize record up to the comment and check it
c
      call dainit
      if ( .not. daget( irdfrec, Mhdr, 84 ) )
     1  call srdferr( Zlabel, Hrdfueof )
      call Sbytchr( Blabel, Clabel, 8 )
      if ( Clabel .ne. '##init  ' )
     1  call srdferr( Zlabel, Hrdfiblk )
      if ( nbytes .lt. 74 .or. nbytes .ne. lencmt+74 )
     1  call srdferr( Zlabel, Hrdfbcnt )
      write( Hvdulu, 1 )
1     format( / 11x, 'Initialize block header' )
      if ( iauxop .gt. 0 .and. iauxop .lt. 100 )
     1  write( iauxop, 1 )
c
c           extract output args
c
      Rbarpress = qrdfreal( Iapbar )
      Rambtemp = qrdfreal( Iaptem )
c
c           display contents of header
c
      if ( imute .gt. 0 ) then
        write( Hvdulu, 2 ) nbytes + 10, Bdfname
2       format( 11x, 2( '=' ) / 6x, 'Bytes read = ', i4 /
     1    6x, 'UNIX file name = ', 32a1 )
        if ( iauxop .gt. 0 .and. iauxop .lt. 100 )
     1    write( iauxop, 2 ) nbytes + 10, Bdfname
        end if
      if ( imute .ge. 2 ) then
        write( Hvdulu, 3 ) Bdate, Rbarpress, Rambtemp
3       format( 6x, 'Time and Date    = ', 32a1 /
     1    6x, 'Barometric pressure (Pa) = ', f9.1 /
     2    6x, 'Ambient Temperature (K)  = ', f7.2 )
        if ( iauxop .gt. 0 .and. iauxop .lt. 100 )
     1    write( iauxop, 3 ) Bdate, Rbarpress, Rambtemp
        end if
c
c           read and display comment
c
      icmt = 0
      if ( lencmt .gt. 1 .and. imute .ge. 0 ) then                         1
        icol = 0
        do while ( icmt .lt. lencmt )                                      2
          icol = icol + 1
          icmt = icmt + 1
          if ( .not. daget( irdfrec, Bcmt(icol), 1 ) )
     1      call srdferr( Zlabel, Hrdfueof )
          if ( Bcmt(icol) .eq. 0 ) then                                    3
            write( Hvdulu, 4 ) ( Bcmt(icol1), icol1 = 1, icol - 1 )
4           format( 1x, 80a1 )
            if ( iauxop .gt. 0 .and. iauxop .lt. 100 )
     1        write( iauxop, 4 ) ( Bcmt(icol1), icol1 = 1, icol - 1 )
            icol = 0
            end if                                                         3
          end do                                                           2
        end if                                                             1
      return
      end



      SUBROUTINE SRDFCLOS( ITNBYT, IRDFREC )
c
c       Read CLOSe block from Raw Data File
c   Reads a close block header record from an opened Raw Data file .
c
c
c constants
c    Hvdulu                    # v.d.u. logical unit number
c    Zlabel                    # Routine name
c variables
c  integer *4 irdfrec          # raw data file record number
c             itnbyt,dtnbyt    #data file record pointer
c             lencmt           # total length of comment in bytes
c  integer *2 nbytes           # number of bytes remaining in header record
c             icmt             # comment byte pointer
c  logical *4 daget            # function : read direct access file
c  character *8  Clabel        # required header label
c  byte Blabel(8)              # required header label
c       Bcmt(81)               # comment line
c
      implicit none
      integer *2 Hvdulu
      character *8 Zlabel
      parameter( Hvdulu=6, Zlabel='SRDFCLOS' )
c
      byte Bcmt(81), Blabel(8)
      integer *4 irdfrec, itnbyt, dtnbyt, jrdfint4
      integer *2 nbytes, icol, lencmt
      logical *4 daget
      character Clabel*8
c
      include 'rdflib.cmn'
      equivalence ( Mhdr(1), Blabel ), ( Mhdr(5), nbytes ),
     1  ( Mhdr(11), dtnbyt ), ( Mhdr(13), lencmt )
c
c           read the close record up to the comment and check it
c
      call dainit
      if ( .not. daget( irdfrec, Mhdr, 26 ) )
     1  call srdferr( Zlabel, Hrdfueof )
      call Sbytchr( Blabel, Clabel, 8 )
      if ( Clabel .ne. '##close ' )
     1  call srdferr( Zlabel, Hrdfiblk )
      if ( nbytes .lt. 16 .or. nbytes .ne. lencmt + 16 )
     1  call srdferr( Zlabel, Hrdfbcnt )
      itnbyt = jrdfint4( dtnbyt )
      write( Hvdulu, 1 )
1     format( 11x, 'Close block header' / 11x, 18( '=' ) )
      if ( iauxop .gt. 0 .and. iauxop .lt. 100 )
     1  write( iauxop, 1 )
      if ( imute .ge. 2 ) then
        write( Hvdulu, 2 ) ( Mhdr(icol), icol = 6, 10 )
2       format( ' Master file entry : library = ', i5 /
     1    19x, ': series = ', i5, / 19x, ': volume = ', i5 /
     2    19x, ': acquisition mode = ', i2 /
     3    19x, ': no. of modules = ', i4 )
        if ( iauxop .gt. 0 .and. iauxop .lt. 100 )
     1    write( iauxop, 2 ) ( Mhdr(icol), icol = 6, 10 )
        end if
      if ( imute .gt. 0 ) then
        write( Hvdulu, 4 ) itnbyt
4       format( 19x, ': total no. of data bytes = ', i10 )
        if ( iauxop .gt. 0 .and. iauxop .lt. 100 )
     1    write( iauxop, 4 ) itnbyt
        end if
      if ( imute .gt. 1 .and. lencmt .gt. 1 ) then                                          2
        if ( .not. daget( irdfrec, Bcmt, jzext( lencmt - 1 ) ) )
     1    call srdferr( Zlabel, Hrdfueof )
        write( Hvdulu, 3 ) ( Bcmt( icol ), icol = 1, lencmt - 1 )
3       format( 19x, ': Comment : ', 40a1 : / 40a1 )
        if ( iauxop .gt. 0 .and. iauxop .lt. 100 )
     1    write( iauxop, 3 ) ( Bcmt( icol ), icol = 1, lencmt - 1 )
        end if
      return
      end



      LOGICAL *4 FUNCTION ERDFACQ( CSUBBLK, INSAMP, MDATA, ISIZE,
     1                             IRDFREC, FWINEN )
c
c        Routine to read the header information in the block and sub-block
c header records , and if it exists , the data sub-block of the Raw Data File
c , starting at record IRDFREC .
c        If the returned value ERDFACQ = .true. , a block header and a
c sub-block header were found . If ERDFACQ = .false. , there is no more data
c in the module , and ERDFMHD should be called to get the next module header .
c        The raw data file is assumed to have been opened by a ERDFOPN .
c IRDFREC is assumed to point to the appropriate data record , and its value
c has been determined by a call to ERDFMHD( '#acquire', irdfrec ) .
c        If there is a data sub-block , the INSAMP data samples are placed
c in the array MDATA of ISIZE 16-bit words . Packed data is automatically
c unpacked before putting it into MDATA .
c        In the special case of a '###file' sub-block , the data might not be
c integer *2 . ERDFACQ would not not know this , and so INSAMP is still the
c number of 16-bit words read , and ISIZE is still the size of the array MDATA
c ( whatever its data type ) in  16-bit words
c        If ISIZE = 0 , no data is read into MDATA . If FWINEN = .true. , a
c WINdow reading mode is ENabled , in which a maximum of ISIZE samples are read
c from file . By using this feature , the data can be read in small lumps . In
c this case ISIZE can be less than the number of data samples available . If
c ISIZE is otherwise less than INSAMP , a fatal error occurs .
c
c    ARGUMENTS
c   Name        Type       Description                        input or output
c  CSUBBLK  character*8  Sub block label                           output
c  INSAMP    integer*4   No. of samples read into MDATA            output
c  MDATA     integer*2   A/D data array                            output
c  ISIZE     integer*4   Max. no. of data samples to be read       input
c  IRDFREC   integer*4   Data file record pointer              input / output
c  FWINEN    logical*4   Window enable flag                        input
c
c constants
c  Zlabel                      # routine name
c variables
c logical *2 fwinen            # open window on data flag
c integer *2 nbytes            # number of remaining bytes in record
c            Mdata(*)          # data array
c            iadid             # A/D converter identifier
c            icylen            # A/D acquisition cycle length
c            nrec              # number of records in '###file' file
c            lenrec            # record length in bytes of '###file' file
c integer *4 irdfrec           # data file record pointer
c            insamp            # number of data samples received
c            isize             # size of data array - max no. of samples
c            dnbyt             # no. of data bytes to be read
c            jupnob            # function : calculate no. of packed bytes
c            jp11vax           # function : convert PDP11/34 to VAX int*4
c            jrdfdat           # function : copies data into MDATA
c byte Blab(8)                 # actual header record label
c  logical *4 daget            # function : read direct access file
c character *8 Clab            # actual header record label
c              Csubblk         # sub block header label
c subroutines
c  dainit, srdferr, sup250, supsim
c
      implicit none
      character *10 Zlabel
      parameter ( Zlabel='ERDFACQ : ' )
c
      byte Blab(8)
      logical *4 fwinen, daget
      integer *4 irdfrec, insamp, isize, dnbyt,
     1  jupnob, jrdfdat, jrdfint4
      integer *2 Mdata(*),nbytes, iadid, funpack, icylen, nrec,
     1  lenrec
      character *8 Clab, Csubblk
c
      include 'rdflib.cmn'
      equivalence ( Mhdr(1), Blab ), ( Mhdr(5), nbytes ),
     1  ( Mhdr(9), iadid ), ( Mhdr(10), funpack ),
     2  ( Mhdr(19), icylen ), ( Mhdr(22), nrec ), ( Mhdr(23), lenrec )
      data fdata / .false. /
c
c       if windowing data , get some more
c
      if ( fdata ) then                                                    1
        Csubblk = Csublab
        erdfacq = .true.
        fdata = drsamp .gt. 0
        insamp = 0
        if ( fdata )
     1    insamp = jrdfdat( Mdata, isize, irdfrec, fwinen )
      else
c
c       not windowing or first record .
c       read the next record and if it is a block header,
c         record the label and read the subblock header .
c
        erdfacq = .false.
        call dainit
        if ( .not. daget( irdfrec, Mhdr, 70 ) )
     1    call srdferr( Zlabel, Hrdfueof )
        call Sbytchr( Blab, Clab, 8 )
        if ( Clab(1:2) .eq. '##' ) then        ! block or sub block header 2
c
c       if a block header record , read block header records until a sub
c         block is encountered .
c
          do while ( Clab(3:3) .ne. '#' )                                  3
c
c       If a module header record , return with false result .
c
            if ( Clab(1:1) .eq. '#' .and. Clab(2:2) .ne. '#' ) then        4
              irdfrec = irdfrec - 1
              return
              end if                                                       4
            if ( Clab .ne. '##prelim' .and. Clab .ne. '##main  ' .and.
     1          Clab .ne. '##extra ' )
     2        call srdferr( Zlabel, Hrdfiblk )
c
c       If the block header contains time stamp, date stamp and time delay
c       information, extract it into global variables
c
            call srdfstmp( Mhdr )
            call dainit
            if ( .not. daget( irdfrec, Mhdr, 70 ) )
     1        call srdferr( Zlabel, Hrdfueof )
            call Sbytchr( Blab, Clab, 8 )
            end do
c
c           Check that the block and sub-block headers are OK
c
          if ( Cblklab .eq. '##prelim' .or. Cblklab .eq. '##main' .or.
     1        Cblklab .eq. '##extra ' ) then                               3
            if ( Clab .eq. '###pause' ) then                               4
              if ( nbytes .ne. 2 .and. nbytes .ne. 20 .and. nbytes .ne.
     1           28 ) call srdferr( Zlabel // Clab, Hrdfbcnt )
            else if ( Clab .eq. '###trav ' ) then
              if ( nbytes .ne. 42 )
     1          call srdferr( Zlabel // Clab, Hrdfbcnt )
            else if ( Clab .eq. '###1dat1' .or. Clab .eq. '###2dat2' )
     1          then
              dnocy = jrdfint4( Mhdr(17) )
              if ( nbytes .ne. 28 + icylen * iiand( iadid, 1 ) * 2 )
     1          call srdferr( Zlabel // Clab, Hrdfbcnt )
            else
              call srdferr( Zlabel, Hrdfsblk )                                    4
              endif
          else
            call srdferr( Zlabel, Hrdfiblk )                                      3
            end if
          erdfacq = .true.
          Csublab = Clab
          Csubblk = Csublab
          insamp = 0
c
c         If data records follow , read the number of data bytes DNBYT
c
          if ( Clab .eq. '###1dat1' .or. Clab .eq. '###2dat2' ) then       3
            call dainit
            if ( .not. daget( irdfrec, dnbyt, 4 ) )
     1        call srdferr( Zlabel, Hrdfueof )
            dnbyt = jrdfint4( dnbyt )
            dnxtrec = irdfrec + max0( 0, ( dnbyt + 3 ) / 512 )
            if ( dnbyt .gt. 0 ) then                                       4
              if ( isize .le. 0 ) then                                     5
                irdfrec = dnxtrec
              else
c
c         calculate number of samples
c
                istrw = icylen
                drsamp = icylen * dnocy
                fdata = .false.
                dupodd = 0
c
c         check no. of bytes vs no. of samples
c
                if ( iadid .gt. 1 .and. funpack .eq. 0 ) then                                    6
                  if ( dnbyt .ne. jupnob( drsamp, dupodd ) ) then
                    call srdferr( Zlabel, Hrdfscnt )
                    end if
                else
                  if ( dnbyt .ne. drsamp * 2 ) then
                    call srdferr( Zlabel, Hrdfscnt )
                    drsamp = min( jupnob( drsamp, dupodd ) / icylen,
     1                dnocy ) * icylen
                    end if
                   end if                                                  6
                insamp = drsamp
                insamp = jrdfdat( Mdata, isize, irdfrec, fwinen )
                end if                                                     5
              end if                                                       4
            end if                                                         3
        else
c
c         if not block or sub block header
c
1         irdfrec = irdfrec - 1
          end if                                                           2
        end if                                                             1
      return
      end



      INTEGER *4 FUNCTION JRDFDAT( MDATA,ISIZE,IRDFREC, FWINEN )
c
c   Reads all or some of the data from a data sub-block . The returned value
c JRDFDAT is the number of data samples actually read into the integer *2 data
c array MDATA . ISIZE is the size of MDATA , and is the maximum number of data
c samples that can be read in one lump .
c
c  ARGUMENTS
c integer *2 Mdata(*)          # data array
c integer *4 irdfrec           # data file record pointer
c            jrdfdat           # number of data samples received
c            isize             # size of data array - max no. of samples
c logical *2 fwinen            # open window on data flag
c
c constant
c  Hvdulu                      # vdu logical unit number
c
c  VARIABLES
c byte buf(400)                # input buffer for unpacking data
c      Blab(8)                 # actual sub block header label
c character Clab*8             # actual sub block header label
c integer *2 funpack           # data unpacked flag
c            iadid             # A/D converter identifier
c integer *4 dwncnt            # sample down count from JRDFDAT
c            dnbyt             # no. of data bytes to be read
c            disamp            # sample counter
c            dnbsam            # number of samples in chunk to be unpacked
c            jupnob            # function : calculate no. of packed bytes
c logical *4 daget             # function : read direct access file
c subroutines
c  dainit, srdferr, sup250, supsim
c
      implicit none
      integer *2 Hvdulu
      parameter( Hvdulu=6 )
c
      byte buf(400), Blab(8)
      logical *4 fwinen, daget
      integer *4 irdfrec, isize, dwncnt, dnbyt, disamp, dnbsam,
     1           jupnob
      integer *2 Mdata(*), iadid, funpack
      character *8 Clab
c
      include 'rdflib.cmn'
      equivalence ( Mhdr(1), Blab ), ( Mhdr(9), iadid ),
     1  ( Mhdr(10), funpack )
c
c           if data not found , skip to end
c
      if ( isize .le. 0 ) then                                            1
        irdfrec = dnxtrec
        jrdfdat = 0
        fdata = .false.
      else
        jrdfdat = drsamp
        if ( drsamp .gt. isize ) then                                     2
          if ( .not. fwinen )
     1      call srdferr( 'JRDFDAT', Hrdfsmal )
          jrdfdat = isize / istrw * istrw
          fdata = .true.
        else if ( .not. fwinen ) then
          fdata = .false.
          end if                                                          2
        dwncnt = jrdfdat
        if ( jrdfdat .gt. 0 ) then                                        2
          call Sbytchr( Blab, Clab, 8 )
          if ( iadid .gt. 1 .and. funpack .eq. 0 ) then                   3
c
c           read packed data and unpack it into Mdata
c
            do disamp = 1, jrdfdat, 256                                   4
              dnbsam = 256
              if ( dwncnt .lt. 256 ) dnbsam = dwncnt
              dnbyt = jupnob( dnbsam, dupodd )
              if ( .not. daget( irdfrec, buf( 1 + dupodd ), dnbyt ) )
     1          goto 1
              if ( iadid .eq. 4 ) then                                    5
                call supsim( buf, Mdata(disamp), dnbsam, dupodd )
              else
                call sup250( buf, Mdata(disamp), dnbsam, dupodd )
                end if                                                    5
              dwncnt = dwncnt - 256
              end do                                                      4
          else
c
c           or read non-packed data into Mdata
c
            if ( .not. daget( irdfrec, Mdata, jrdfdat * 2 ) ) goto 1
            end if                                                        3
          drsamp = drsamp - jrdfdat
c
c           force new record & sub-block if end of data
c
          if ( drsamp .le. 0 ) then
            if ( jrdfdat .lt. isize )
     1        fdata = .false.
            call dainit
            irdfrec = dnxtrec
            end if
          end if                                                          2
        end if                                                            1
      return
c
1     write( Hvdulu, 2 ) dwncnt
2     format( ' JRDFDAT : ERROR : Not enough data' )
      jrdfdat = jrdfdat - dwncnt
      return
      end


      SUBROUTINE SRDFSTMP( HEADER )
c
c If the block header contains time stamp, date stamp and time delay
c information, extract it into global variables .
c
c Argument
c  integer *2 header(*)   # data block header array
c
      implicit none
      integer *2 header(*)
      include 'rdflib.cmn'
c
      call Sbytchr( header(1), Cblklab, 8 )
      if ( header(5) .ge. 6 ) then
          tstamp(1) = header(6)
          tstamp(2) = header(7)
          tstamp(3) = header(8)
      else
          tstamp(1) = 0
          tstamp(2) = 0
          tstamp(3) = 0
          end if
      if ( header(5) .ge. 12 ) then
          dstamp(1) = header(9)
          dstamp(2) = header(10)
          dstamp(3) = header(11)
      else
          dstamp(1) = 0
          dstamp(2) = 0
          dstamp(3) = 0
          end if
      if ( header(5) .ge. 18 ) then
          idelay(1) = header(12)
          idelay(2) = header(13)
          idelay(3) = header(14)
      else
          idelay(1) = 0
          idelay(2) = 0
          idelay(3) = 0
          end if
      return
      end


      SUBROUTINE SRDFBUG(I)
      IMPLICIT NONE
      INTEGER I
c
      include 'rdflib.cmn'
c
      WRITE(6,1) I,IDIRPTR,IMUTE,ISTRW,DNXTREC, DRSAMP, DUPODD,
     1   CBLKLAB, CSUBLAB, FRDFOPN, FDATA
      WRITE(6,2) DIRREC, MHDR
1     FORMAT( / ' SRDFBUG : ', I5 /
     1 ' IDIRPTR, IMUTE, ISTRW = ', 3I10 /
     2 ' DNXTREC, DRSAMP, DUPODD = ', 3I10 /
     3 ' CBLKLAB, CSUBLAB = ', 2A8, ' FRDFOPN, FDATA ', 2L3 )
2     FORMAT( ' DIRREC = ' , 16( / 1X,16I4 ) / ' MHDR = ', 4A2,
     5 6 ( / 1X,10I7))
      RETURN
      END


      INTEGER *4 FUNCTION JUPNOB( NSAMP, ODDEVEN )
c
c               UnPack No. Of Bytes
c   Calculates the number of bytes to be read from packed data file in order
c to unpack NSAMPLES data samples .
c   FORTRAN call :
c       nbytes = Jupnob( nsamples, oddeven )
c integer *4 nsamples           # number of data samples
c integer *2 oddeven            # odd/even = 1/0 flag for 1st sample
c
c calculation
c   jupnob = imod( nsamples, 2 ) & ! oddeven + 3* nsamples /2
c
      implicit none
      integer *4 nsamp, oddeven
c
      jupnob = iand( iand( nsamp, 1 ), not( oddeven ) ) + 3 * nsamp / 2
      return
      end



      INTEGER *4 FUNCTION JEXTNOCY
c
c       EXTract NUmber of Cycles
c   Returned value is the number of A/D data acquisition cycles done in
c a '###pause' , '###1dat1' or '###2dat2' sub-block
c
c variables
c  integer *2 nbytes           # number of bytes remaining in header record
c  integer *4 jrdfint4         # function : convert PDP11 <=> VAX integer *4
c
      implicit none
c
      integer *2 nbytes
      integer *4 dhnocy, jrdfint4
c
      include 'rdflib.cmn'
      equivalence ( Mhdr(5), nbytes ), ( Mhdr(17), dhnocy )
c
      Jextnocy = 0
      if ( Csublab .eq. '###pause' ) then
        if ( nbytes .ge. 20 )
     1    Jextnocy = Mhdr(9)
      else if ( Csublab .eq. '###1dat1' .or. Csublab .eq. '###2dat2' )
     1    then
        Jextnocy = jrdfint4( dhnocy )
      else
        call srdferr( 'JEXTNOCY : ' // Csublab,  Hrdfunav )
        end if
      return
      end



      LOGICAL *4 FUNCTION EEXTAMON
c
c       EXTract Automatic Monitor flag
c   Returned value is EEXTAMON = .true. if the '###pause' sub-block is of the
c automatic monitor' type . Otherwise it is .false. .
c
c constants
c    Zlabel                    # Routine name
c variables
c  integer *2 nbytes           # number of bytes remaining in header record
c             fhamon           # automatic monitor flag
c
      implicit none
      character *11 Zlabel
      parameter( Zlabel='EEXTAMON : ' )
c
      integer *2 nbytes, fhamon
c
      include 'rdflib.cmn'
      equivalence ( Mhdr(5), nbytes ), ( Mhdr(13), fhamon )
c
      if ( Csublab .ne. '###pause' )
     1  call srdferr( Zlabel // Csublab , Hrdfunav )
      if ( nbytes .eq. 28 .xor. fhamon .gt. 0 )
     1  call srdferr( Zlabel, Hrdfbcnt )
      eextamon = .false.
      if ( nbytes .ge. 20 )
     1  eextamon = fhamon .gt. 0
      return
      end


      REAL FUNCTION QEXTTARG
c
c       EXTract monitor TARGet voltage
c   Returned value is the monitor target voltage of a '###pause' sub-block .
c If the '###pause' sub-block is not of 'automatic monitor' type , the returned
c value is QEXTTARG  = 999999.9e29
c
c constants
c    Zlabel                    # Routine name
c variables
c  integer *2 nbytes           # number of bytes remaining in header record
c             fhamon           # automatic monitor flag
c  real rtarg                  # monitor target value
c
      implicit none
      character *11 Zlabel
      parameter( Zlabel='QEXTTARG : ' )
c
      real  qrdfreal
      integer *2 nbytes, fhamon
c
      include 'rdflib.cmn'
      equivalence ( Mhdr(5), nbytes ), ( Mhdr(13), fhamon )
c
      if ( Csublab .ne. '###pause' )
     1  call srdferr( Zlabel // Csublab , Hrdfunav )
      if ( nbytes .eq. 28 .xor. fhamon .gt. 0 )
     1  call srdferr( Zlabel, Hrdfbcnt )
      qexttarg = 999999.9e29
      if ( fhamon .ge. 0 )
     1  qexttarg = qrdfreal( Mhdr(14) )
      return
      end



      REAL FUNCTION QEXTTOL
c
c       EXTract monitor TOLerance voltage
c   Returned value is the monitor tolerance voltage of a '###pause' sub-block .
c If the '###pause' sub-block is not of 'automatic monitor' type , the returned
c value is QEXTTOL = 999999.9e29
c
c constants
c    Zlabel                    # Routine name
c variables
c  integer *2 nbytes           # number of bytes remaining in header record
c             fhamon           # automatic monitor flag
c
      implicit none
      character *11 Zlabel
      parameter( Zlabel='QEXTTOL : ' )
c
      real qrdfreal
      integer *2 nbytes, fhamon
c
      include 'rdflib.cmn'
      equivalence ( Mhdr(5), nbytes ), ( Mhdr(13), fhamon )
c
      if ( Csublab .ne. '###pause' )
     1  call srdferr( Zlabel // Csublab , Hrdfunav )
      if ( nbytes .eq. 28 .xor. fhamon .gt. 0 )
     1  call srdferr( Zlabel, Hrdfbcnt )
      qexttol = 999999.9e29
      if ( fhamon .ge. 0 )
     1  qexttol = qrdfreal( Mhdr(15) )
      return
      end



      REAL FUNCTION QEXTAMON
c
c       EXTract Average MONitored voltage
c   Returned value is the average monitored voltage of a '###pause' sub-block .
c If the '###pause' sub-block is not of 'simple pause' type , the returned
c value is QEXTAMON = 999999.9e29
c
c constants
c    Zlabel                    # Routine name
c variables
c  integer *2 nbytes           # number of bytes remaining in header record
c             fhamon           # automatic monitor flag
c
      implicit none
      character *11 Zlabel
      parameter( Zlabel='QEXTAMON : ' )
c
      integer *2 nbytes, fhamon
      real qrdfreal
c
      include 'rdflib.cmn'
      equivalence ( Mhdr(5), nbytes ), ( Mhdr(13), fhamon )
c
      if ( Csublab .ne. '###pause' )
     1  call srdferr( Zlabel // Csublab , Hrdfunav )
c
      if ( nbytes .eq. 2 ) then
          qextamon = 999999.9e29
      else if ( nbytes .eq. 20 .and. fhamon .eq. 0 ) then
          qextamon = qrdfreal( Mhdr(14) )
      else if ( nbytes .eq. 28 .and. fhamon .eq. 1 ) then
          qextamon = qrdfreal( Mhdr(16) )
      else
          call srdferr( Zlabel, Hrdfbcnt )
          qextamon = 999999.9e29
          end if
      return
      end



      LOGICAL *4 FUNCTION EEXTKBDV
c
c       EXTract KeyBoarD Value used flag
c   Returned value is EEXTKBDV = .true. if a keyboard value was entered as part
c of the data at acquisition time .
c
      implicit none
      include 'rdflib.cmn'
c
      if ( Csublab .ne. '###1dat1' .and. Csublab .ne. '###2dat2' )
     1  call srdferr( 'EEXTKBDV : ' // Csublab, Hrdfunav )
      eextkbdv = .false.
      if ( Mhdr(6) .gt. 0 ) eextkbdv = .true.
      return
      end



      REAL FUNCTION QEXTKBDV
c
c       EXTract KeyBoarD Value
c   Returned value is the keyboard entry at data acquisition time .
c
      implicit none
      real qrdfreal
c
      include 'rdflib.cmn'
c
      if ( Csublab .ne. '###1dat1' .and. Csublab .ne. '###2dat2' )
     1  call srdferr( 'QEXTKBDV : ' // Csublab, Hrdfunav )
      qextkbdv = 999999.9e29
      if ( Mhdr(6) .gt. 0 ) qextkbdv = qrdfreal( Mhdr(7) )
      return
      end



      INTEGER *4 FUNCTION JEXTADID
c
c       EXTract A/D converter IDentity
c   Returned value is the identity of the A/D converter used .
c JEXTADID = 1 : DAS 1128
c            2 : DAS 250 seq - Fast A/D converter in sequential channel
c                              addressing mode .
c            3 : DAS 250 ran - fast A/D converter in random channel addressing
c                              mode .
c            4 : SIM ACQ     - fast simultaneous channel converter
c If no data is acquired in a pause sub-block , the returned value is
c JEXTADID = -1 .
c
c variables
c  integer *2 nbytes           # number of bytes remaining in record
c
      implicit none
      integer *2 nbytes
c
      include 'rdflib.cmn'
      equivalence ( Mhdr(5), nbytes )
c
      Jextadid = -1
      if ( Csublab .eq. '###pause' ) then
        if ( nbytes .ge. 20 )
     1    Jextadid = Mhdr(6) * 2 - 1
      else if ( Csublab .eq. '###1dat1' .or. Csublab .eq. '###2dat2' )
     1    then
        Jextadid = Mhdr(9)
      else
        call srdferr( 'JEXTADID : ' // Csublab, Hrdfunav )
        end if
      return
      end



      CHARACTER *12 FUNCTION GEXTADID
c
c       EXTract A/D converter IDentity
c   Returned value is a character string representing the identity of the A/D
c converter used .
c GEXTADID = 'DAS 1128 slo'
c            'DAS 250A seq' - Fast A/D converter in sequential channel
c                              addressing mode .
c            'DAS 250A ran' - fast A/D converter in random channel addressing
c                              mode .
c            'SIM ACQ fast' - fast simultaneous channel converter
c If no data is acquired in a pause sub-block , the returned value is
c GEXTADID = '            '
c
c constant
c  Cadid(4)*12                 # possible returned values
c variables
c  integer *2 nbytes           # number of bytes remaining in record
c
      implicit none
      integer *2 nbytes
      character Cadid(4)*12
c
      include 'rdflib.cmn'
      equivalence ( Mhdr(5), nbytes )
      data Cadid / 'DAS 1128 slo', 'DAS 250A seq', 'DAS 250A ran',
     1  'SIM ACQ fast' /
c
      Gextadid = '            '
      if ( Csublab .eq. '###pause' ) then
        if ( nbytes .ge. 20 )
     1    Gextadid = Cadid( Mhdr(6) * 2 - 1 )
      else if ( Csublab .eq. '###1dat1' .or. Csublab .eq. '###2dat2' )
     1    then
        Gextadid = Cadid( Mhdr(9) )
      else
        call srdferr( 'GEXTADID : ' // Csublab, Hrdfunav )
        end if
      return
      end



      INTEGER *4 FUNCTION JEXTCHLS( I )
c
c       EXTract a/d CHannel address LiSt element .
c   Returns the value of the Ith A/D converter channel address . The argument
c I is ignored for the '###pause' sub-block . If I is out of its range or no
c data is acquired in a '###pause' sub-block , the returned value is
c JEXTCHLS = -1 . If the A/D converter is used in sequential channel addressing
c mode , the returned value is , of course , JEXTCHLS = I-1
c
c variables
c
c  integer *2 nbytes           # number of bytes remaining in record
c             ichan(16)        # A/D channel address list
c             iadid            # A/D identifier
c  integer *4 i                # A/D channel pointer
c
      implicit none
      integer *2 nbytes, ichan(16), iadid
      integer *4 i
c
      include 'rdflib.cmn'
      equivalence ( Mhdr(5), nbytes ), ( Mhdr(9), iadid ),
     1  ( Mhdr(20), Ichan(1) )
c
      Jextchls = -1
      if ( Csublab .eq. '###pause' ) then
        if ( nbytes .ge. 20 )
     1    Jextchls = Mhdr(11)
      else if ( Csublab .eq. '###1dat1' .or. Csublab .eq. '###2dat2' )
     1    then
        if ( 0 .lt. i .or. i .le. Mhdr(19) ) then
          if ( iiand( iadid, 1 ) .gt. 0 ) then
            Jextchls = ichan(i)
          else
            Jextchls = i - 1
            end if
          end if
      else
        call srdferr( 'JEXTCHLS : ' // Csublab, Hrdfunav )
        end if
      return
      end


      INTEGER *4 FUNCTION JEXTCNTR
c
c       EXTract loop/event CouNTeR
c   Returned value is the loop / event counter
c
      implicit none
      include 'rdflib.cmn'
c
      if ( Csublab .ne. '###1dat1' .and. Csublab .ne. '###2dat2' )
     1    call srdferr( 'JEXTCNTR : ' // Csublab, Hrdfunav )
      Jextcntr = Mhdr(11)
      return
      end



      INTEGER *4 FUNCTION JEXTCYLN
c
c       EXTract a/d CYcle LeNgth
c   Returned value is the length of each data acquisition cycle .
c If no data is acquired in a '###pause' sub-block , the returned value is
c JEXTCYLN = -1
c
c variables
c  integer *2 nbytes           # number of bytes remaining in header record
c
      implicit none
      integer *2 nbytes
c
      include 'rdflib.cmn'
      equivalence ( Mhdr(5), nbytes )
c
      Jextcyln = -1 0
      if ( Csublab .eq. '###pause' ) then
        if ( nbytes .ge. 20 )
     1    Jextcyln = 1
      else if ( Csublab .eq. '###1dat1' .or. Csublab .eq. '###2dat2' )
     1    then
        Jextcyln = Mhdr( 19 )
      else
        call srdferr( 'JEXTCYLN : ' // Csublab,  Hrdfunav )
        end if
      return
      end


      CHARACTER *2 FUNCTION GEXTVSID
c
c       EXTract TraVerSe IDentity
c   Returns the two traverse identifier characters .
c
c variables
c  byte Btvsid(2)              # traverse identifier
c
      implicit none
      byte Btvsid(2)
c
      include 'rdflib.cmn'
      equivalence ( Mhdr(6), Btvsid(1) )
c
      if ( Csublab .ne. '###trav ' )
     1  call srdferr( 'GEXTVSID : ' // Csublab, Hrdfunav )
      call Sbytchr( Btvsid, Gextvsid, 2 )
      return
      end


      REAL FUNCTION QEXTCYTM
c
c       EXTract a/d Cycle Time
c   Returned value is the A/D converter cycle time .
c
c variables
c  integer *2 nbytes           # number of bytes remaining in record
c  real qrdfreal               # converts IEEE format real into DEC real
c
      implicit none
      integer *2 nbytes
      real qrdfreal
c
      include 'rdflib.cmn'
      equivalence ( Mhdr(5), nbytes )
c
      if ( Csublab .eq. '###pause' ) then
        if ( nbytes .ge. 20 )
     1    Qextcytm = qrdfreal( Mhdr(7) )
      else if ( Csublab .eq. '###1dat1' .or. Csublab .eq. '###2dat2' )
     1    then
        Qextcytm = qrdfreal( Mhdr(13) )
      else
        call srdferr( 'QEXTCYTM : ' // Csublab, Hrdfunav )
        end if
      return
      end



      REAL FUNCTION QEXTVREQ( IORD )
c
c       EXTract REQuired TraVerse ordinate
c   Returned value is the Ith ordinate of the required traverse position .
c The available traverse ordinates are
c  IORD = 1  :- x     - streamwise displacement (mm)
c         2  :- y     - normal displacement     (mm)
c         3  :- z     - spanwise displacement   (mm)
c         4  :- theta - yaw angle          (degrees)
c         5  :- phi   - pitch angle        (degrees)
c
c variables
c  integer *4 Iord             # index of required ordinate
c             Ireq(5)          # coordinates of required traverse position
c
      implicit none
      real qrdfreal
      integer *4 Iord, Ireq(5)
c
      include 'rdflib.cmn'
      equivalence ( Mhdr(7), Ireq(1) )
c
      if ( Csublab .ne. '###trav ' )
     1  call srdferr( 'QEXTVREQ : ' // Csublab, Hrdfunav )
      Qextvreq = qrdfreal( Ireq( Iord ) )
      return
      end



      REAL FUNCTION QEXTVACT( IORD )
c
c       EXTract ACTual TraVerse ordinate
c   Returned value is the Ith ordinate of the actual traverse position .
c The available traverse ordinates are
c  IORD = 1  :- x     - streamwise displacement (mm)
c         2  :- y     - normal displacement     (mm)
c         3  :- z     - spanwise displacement   (mm)
c         4  :- theta - yaw angle          (degrees)
c         5  :- phi   - pitch angle        (degrees)
c
c variables
c  integer *4 Iord             # index of required ordinate
c             Iact(5)          # coordinates of actual traverse position
c
      implicit none
      real qrdfreal
      integer *4 Iord, Iact(5)
c
      include 'rdflib.cmn'
      equivalence ( Mhdr(17), Iact(1) )
c
      if ( Csublab .ne. '###trav ' )
     1  call srdferr( 'QEXTVACT : ' // Csublab, Hrdfunav )
      Qextvact = qrdfreal( Iact( Iord ) )
      return
      end



      REAL FUNCTION QEXTSAMT
c
c       EXTract a/d SAMpling Time
c   Returned value is the A/D converter sampling periods in seconds .
c Available for the '###1dat1' and '###2dat2' sub-blocks only .
c
      implicit none
      real qrdfreal
c
      include 'rdflib.cmn'
c
      if ( Csublab .ne. '###1dat1' .and. Csublab .ne. '###2dat2' )
     1  call srdferr( 'QEXTSAMT : ' // Csublab, Hrdfunav )
      Qextsamt = qrdfreal( Mhdr(15) )
      return
      end



      SUBROUTINE SRDFXXX( IRDFREC )
c
c         Modify the contents of a sub-block header record
c
c constant
c   Hkbdlu                     # keyboard logical unit number
c   Hvdulu                     # v.d.u. logical unit number
c variables
c  integer *2 nbytes           # number of bytes remaining in record
c             Index            # sub-block listing reference index
c             ind              # array index of variable to be changed
c             itype            # type of the variable to be changed
c                      0 = nothing           2 = real on 32 bit boundary
c                      1 = integer*2         3 = real not on 32 bit boundary
c                      5 = 2 ASCII chars     4 = integer*4 on 32 bit boundary
c             indp(0:7)        # array indices for ###pause sub-block
c             indd(0:7)        # array indices for ###?dat? sub-block
c             itypep(0:7)      # type of variables in ###pause sub-block
c             ityped(0:7)      # type of variables in ###?dat? sub-block
c             iresmute         # remembered value of imute
c             i                # looping index
c  integer *4 irdfrec          # initial raw data file record number
c             irec             # record number of record to be changed
c             Dhdr(28)         # contents of header record
c             Jresp            # function : integer response
c             Jp11vax          #          : PDP11 <=> VAX integer *4 converter
c  logical *4 daget            # function : read direct access file
c  real       Rhdr(28)         # contents of header record
c             Shdr(28)         # contents of header record
c             Qresp            # function : real response
c  byte Blab(8)                # actual header record label
c  character Clab*8            # actual header record label
c  subroutine dainit           # initialize file input buffer pointer
c             daput            # put data onto file
c             daflush          # flush file output buffer
c             sbytchr          # convert byte string to character string
c             sextall          # display sub-block header
c
      implicit none
      integer *2 Hkbdlu, Hvdulu
      parameter( Hkbdlu=5, Hvdulu=6 )
      integer *2 nbytes, Index, ind, itype, indp(0:7), indd(0:7),
     1   itypep(0:7), ityped(0:7), iresmute, i
      integer *4 irdfrec, irec, Dhdr(28), Jresp, Jrdfint4
      logical *4 daget
      real Rhdr(28), Shdr(28), Qresp, Qrdfrput
      byte Blab(8)
      character Clab*8
c
      include 'rdflib.cmn'
      equivalence( Mhdr(1), Blab(1), Rhdr(1), Dhdr(1) ),
     1  ( Mhdr(2), Shdr(1) ), ( Mhdr(5), nbytes )
c
      data Indp   / 0, 6, 11, 9, 4, 7, 8, 9 /
      data Itypep / 0, 1, 1, 1, 2, 3, 3, 3 /
      data Indd   / 0, 4, 11, 9, 7, 8, 9, 19 /
      data Ityped / 0, 2, 1, 1, 2, 2, 4, 1 /
c
c           find the sub-block header record
c
      iresmute = imute
      imute = 2
      irec = irdfrec
      call dainit
      if ( .not. daget( irec, Mhdr, 70 ) )
     1  call srdferr( 'SRDFXXX', Hrdfueof )
      call Sbytchr( Blab, Clab, 8 )
      if ( Clab(1:2) .eq. '##' ) then        ! block or sub block header    1b
c
c       if a block header record , read block header records until a sub
c         block is encountered .
c
        do while ( Clab(3:3) .ne. '#' )                                     2b
c
c       If a module header record , return with false result .
c
          if ( Clab(1:1) .eq. '#' .and. Clab(2:2) .ne. '#' ) goto 12
c
c       If the block header contains time stamp, date stamp and time delay
c       information, extract it into global variables
c
          call srdfstmp( Mhdr )
          call dainit
          if ( .not. daget( irec, Mhdr, 70 ) )
     1      call srdferr( 'SRDFXXX', Hrdfueof )
          call Sbytchr( Blab, Clab, 8 )
          end do                                                            2e
c
c       Advice
c
        call sextall
        if ( fchange ) then                                                 2b
          write( Hvdulu, 1 ) nbytes, Clab, irec
1         format( / 11x, 'SUB-BLOCK HEADER RECORD MODIFIER' /
     1      11x, 32( '=' ) / 6x, 'You can now modify some of the ',
     2      i3, ' bytes in the ', a8, ' sub-block at' /
     3      6x, 'record number ', i7 ' .' / 6x, 'You are warned that'
     4      ' the data files constructed by GENACQ are syntactically' /
     5      6x, 'and numerically consistent . In modifying the sub-'
     6      'block header record,' / 6x, 'you can easily destroy this'
     7      ' consistency  ; so  BE  VERY  CAREFUL ,' / 6x, 'otherwise '
     8      'you may render the data file unreadable by RDFLIB' /
     9      6x, ' routines .' )
          fchange = .false.
        else                                                               2m
          write( Hvdulu, 13 ) Clab, irec
13        format( / ' Modifying ', a8, ' sub-block at record ', i7 )
          end if                                                           2e
c
c       main loop
c
        do while( .true. )                                                 2b
          write( Hvdulu, 2 )
2         format( 6x, 'What do you want to modify ?' /
     1      12x, '( enter an item number enclosed by () in the' /
     2      14x, 'above sub-block listing ; N.B. 0 = nothing   ) ', $ )
c
c       Determine index & type of value to be modified
c
          if ( Clab .eq. '###pause' ) then                                 3b
            Index = Jresp( Hkbdlu, 0, 7, 3 )
            ind = indp( index )
            itype = itypep( index )
          else if ( Clab .eq. '###trav ' ) then                            3m
            Index = Jresp( Hkbdlu, 0, 11, 3 )
            itype = 5
            ind = 6
            if ( Index .gt. 1 ) then                                       4b
              itype = 2
              ind = Index + 1
              end if                                                       4e
          else if ( Clab .eq. '###1dat1' .or. Clab .eq. '###2dat2' )then   3m
            Index = Jresp( Hkbdlu, 0, 19, 3 )
            ind = Index + 12
            Itype = 1
            if ( index .le. 7 ) then                                       4b
              ind = Indd( index )
              itype = ityped( index )
              end if                                                       4e
            end if                                                         3e
c
c             assign the value
c
          if ( index .eq. 0 ) goto 10
          if ( itype .eq. 1 ) then                                         3b
            write( Hvdulu, 3 )
3           format( ' Enter a 16 bit integer value  ', $ )
            Mhdr( ind ) = Jresp( Hkbdlu, -32768, 32767, 3 )
          else if ( itype .eq. 2 ) then                                    3m
            write( Hvdulu, 4 )
4           format( ' Enter a 32 bit, single precision real value  ', $)
            Rhdr( ind ) = qrdfrput( Qresp( Hkbdlu, -1.6e-37, 1.6e37, 3))
          else if ( itype .eq. 3 ) then                                    3m
            write( Hvdulu, 4 )
            Shdr( ind ) = qrdfrput( Qresp( Hkbdlu, -1.6e-37, 1.6e37, 3))
          else if ( itype .eq. 4 ) then                                    3m
            write( Hvdulu, 5 )
5           format( ' Enter a 32 bit integer value  ', $ )
            Dhdr( ind ) = Jrdfint4( Jresp( Hkbdlu, -2147483648,
     1        2147483647, 3 ) )
          else if ( itype .eq. 5 ) then                                    3m
            write( Hvdulu, 6 )
6           format( ' Enter 2 ASCII characters  ', $ )
            read( Hkbdlu, 7 ) Mhdr( ind )
7           format( a2 )
            end if                                                         3e
          call sextall
          end do                                                           2e
c
c             re-write the sub-block header record
c
10      irec = irec - 1
        call daput( irec, Mhdr, 70 )
        call daflush( irec )                                               1e
        end if
12    imute = iresmute
      return
      end


      SUBROUTINE SEXTALL
c
c       EXTract ALL header information
c   Displays all the information in the current block header and sub-block
c header records from an '#acquire', '#calbar', or 'calhw1' raw data file
c module .
c
c constants
c    Hvdulu                    # v.d.u. logical unit number
c
      implicit none
      integer *2 Hvdulu
      parameter( Hvdulu=6 )
c
      include 'rdflib.cmn'
c
      call sextalll( Hvdulu )
      if ( iauxop .gt. 0 .and. iauxop .lt. 100 )
     1  call sextalll( iauxop )
      return
      end


      SUBROUTINE SEXTALLL( IOPFLU )
c
c       EXTract ALL header information
c   Puts all the information in the current block header and sub-block
c header records from an '#acquire', '#calbar', or 'calhw1' raw data file
c module onto file with logical unit IAUXLU .
c
c constants
c    Hvdulu                    # v.d.u. logical unit number
c    Zlabel                    # Routine name
c    Cadid(4)*12               # A/D converter types
c    Cdtype(4)*6               # filed data type - in ###file sub-block
c variables
c  integer *2 nbytes           # number of bytes remaining in record
c             iopflu           # output file logical unit number
c             i                # looping index
c
c '###pause' subblock
c  integer *2 ihadid           # A/D converter identifier
c             ihnocy           # no. of A/D acquisition cycles
c             ihchan           # A/D channel address
c             fhamon           # automatic monitor flag
c  real rhcyt                  # A/D cycle time
c       rhtarg                 # monitor target voltage
c       rhtol                  # monitor voltage tolerance
c       rhmonav                # average monitored voltage
c
c '###trav ' sub-block
c  byte Btvsid(2)              # traverse identifier
c  real rtvxxr(5)              # required traverse position coordinates
c       rtvxxa(5)              # actual traverse position coordinates
c
c '###1dat1' and '###2dat2' sub-block
c  integer *2 fkbdv            # keyboard reference value used flag
c             icid             # A/D converter identifier
c             funpak           # data unpacked flag
c             icntr            # loop / event counter
c             icyln            # A/D cycle length
c             ichls(16)        # A/D channel address list
c  real rkbdv                  # keyboard reference value
c       rcytm                  # A/D cycle time
c       rsamt                  # A/D chan to chan sampling time
c
      implicit none
      integer *2 Hvdulu
      character *10 Zlabel
      parameter( Hvdulu=6, Zlabel='SEXTALL : ' )
c
      integer *4 ihcyt, ihtarg, ihtol, ihmonav, itvxxr(5),
     1  itvxxa(5), ikbdv, icytm, isamt, dhnocy, jrdfint4
      integer *2 nbytes, ihadid, ihnocy, ihchan, fhamon,fkbdv, icid,
     1  funpak, icntr, icyln, ichls(16), i, iopflu
      byte Btvsid(2)
      character Cadid(4)*12
      real qrdfreal
c
      include 'rdflib.cmn'
      equivalence ( Mhdr(5), nbytes ),
     1  ( Mhdr(6), ihadid, Btvsid, fkbdv ),
     2  ( Mhdr(7), ihcyt, itvxxr(1), ikbdv ), ( Mhdr(9), ihnocy, icid ),
     3  ( Mhdr(10), funpak ),               ( Mhdr(11), ihchan, icntr ),
     4  ( Mhdr(13), fhamon, icytm ),               ( Mhdr(14), ihtarg ),
     5  ( Mhdr(15), isamt ),                        ( Mhdr(16), ihtol ),
     6  ( Mhdr(17), dhnocy, itvxxa(1) ),          ( Mhdr(18), ihmonav ),
     7  ( Mhdr(19), icyln ), ( Mhdr(20), ichls(1) )
c
      data Cadid / 'DAS 1128 slo', 'DAS 250A seq', 'DAS 250A ran',
     1  'SIM ACQ fast' /
c
c           display block label
c
      if ( Cblklab .eq. '##main  ' ) then
        write( iopflu, 1 )
1       format( / 21x, 'MAIN DATA BLOCK' )
      else if ( Cblklab .eq. '##prelim' ) then
        write( iopflu, 2 )
2       format( / 21x, 'PRELIMINARY DATA BLOCK' )
      else if ( Cblklab .eq. '##extra ' ) then
        write( iopflu, 3 )
3       format( / 21x, 'EXTRA DATA BLOCK' )
      else
        call srdferr( Zlabel // Cblklab, Hrdfiblk )
        end if
      if ( tstamp(1) .ne. 0 .or. tstamp(2) .ne. 0 .or.
     1     tstamp(3) .ne. 0 ) then
        write( iopflu, 4 ) tstamp(1), tstamp(2), tstamp(3)
4       format( 25x, 'time   ', i2, ':', i2, ':', i2 )
        end if
      if ( dstamp(1) .ne. 0 .or. dstamp(2) .ne. 0 .or.
     1     dstamp(3) .ne. 0 ) then
        write( iopflu, 5 ) dstamp(1), dstamp(2), dstamp(3)
5       format( 25x, 'date   ', i2, '/', i2, '/', i2 )
        end if
      if ( idelay(1) .ne. 0 .or. idelay(2) .ne. 0 .or.
     1     idelay(3) .ne. 0 ) then
        write( iopflu, 6 ) idelay(1), idelay(2), idelay(3)
6       format( 25x, 'initial time delay  ', i5, ' minutes' /
     1          45x, i5, ' seconds' / 45x, i5, ' millisec' )
        end if
c
c           pause sub-block
c
      if ( Csublab .eq. '###pause' ) then
        if ( nbytes .lt. 20 ) then
          write( iopflu, 7 )
7         format( 11x, 'PAUSE sub-block : simple pause ' )
        else
          write( iopflu, 8 )
8         format( 11x, 'PAUSE sub-block : active monitoring' )
          if ( imute .gt. 1 )
     1      write( iopflu, 9 ) Cadid( ihadid*2-1 ), ihchan, ihnocy,
     2       qrdfreal( ihcyt )
9           format( 6x, '(1) A/D converter used             =   ', a13 /
     1        6x, '(2) A/D channel address            =   ', i2 /
     2        6x, '(3) No. of A/D acquisition cycles  = ', i5 /
     3        6x, '(4) A/D acquisition cycle period   = ', g14.6,
     4        ' seconds' )
          if ( imute .gt. 0 ) then
            if ( nbytes .lt. 28 ) then
              write( iopflu, 10 ) qrdfreal( ihtarg )
10            format( 10x, 'Monitoring mode', 16x, '=    manual' /
     1          6x, '(5) Average monitored voltage      = ', f10.4,
     2           ' Volts' )
            else
              write( iopflu, 11 )
11            format( 10x, 'Monitoring mode', 16x, '=    automatic')
              if ( imute .gt. 1 )
     1          write( iopflu, 12 ) qrdfreal(ihtarg), qrdfreal(ihtol)
12              format( 6x, '(5) Target monitor voltage         = ',
     1            f10.4, ' Volts' / 6x, '(6) Monitor tolerance voltage',
     2            '      = ', f10.4, ' Volts' )
              write( iopflu, 13 ) qrdfreal( ihmonav )
13            format( 6x, '(7) Average monitored voltage      = ',
     1          f10.4, ' Volts' )
              end if
            end if
          end if
c
c           traverse sub-block
c
      else if ( Csublab .eq. '###trav ' ) then
        write( iopflu, 14 )
14      format( 11x, 'TRAVERSE sub-block :' )
        if ( imute .eq. 1 )
     1    write( iopflu, 15 ) Btvsid, ( qrdfreal( itvxxa(i) ), i=1,5 )
15        format( 6x, 'Traverse id = ', 2a1 /
     1      6x, 'Position = ( ', 5f9.4, ' )' )
        if ( imute .gt. 1 )
     1    write( iopflu, 16 ) Btvsid,
     2      ( qrdfreal( itvxxr(i) ), qrdfreal( itvxxa(i) ), i=1,5 )
16      format( 6x, '(1) Traverse identifier : ', 2a1 /
     1    6x, 'Probe position coordinates     required     actual' /
     2    8x, '(3)(8)  Streamwise displacement   ', 2f9.4, ' mm' /
     3    8x, '(4)(9)  Normal displacement       ', 2f9.4, ' mm' /
     4    8x, '(5)(10) Spanwise displacement     ', 2f9.4, ' mm' /
     5    8x, '(6)(11) Yaw angle                 ', 2f9.3, ' degrees' /
     6    8x, '(7)(12) Pitch angle               ', 2f9.3, ' degrees' )
c
c           primary and secondary data blocks
c
      else if ( Csublab .eq. '###1dat1' .or. Csublab .eq. '###2dat2' )
     1    then
        if ( Csublab .eq. '###1dat1' ) then
          write( iopflu, 17 )
17        format( 11x, 'PRIMARY DATA sub-block :' )
        else
          write( iopflu, 18 )
18        format( 11x, 'SECONDARY DATA sub-block :' )
          end if
        if ( fkbdv .gt. 0 )
     1    write( iopflu, 19 ) qrdfreal( ikbdv )
19        format( 6x, '(1) Keyboard reference value       =', g15.6 )
        if ( imute .gt. 1 )
     1    write( iopflu, 20 ) icntr, Cadid( icid ), qrdfreal( icytm ),
     2     qrdfreal( isamt )
20        format( 6x, '(2) Loop /event counter            = ', i7 /
     1      6x, '(3) A/D converter                  =   ', a12 /
     2      6x, '(4) Acquisition cycle time         = ', g14.6, ' sec' /
     3      6x, '(5) chan to chan sampling time     = ', g14.6, ' sec' )
        if ( imute .gt. 0 )
     1    write( iopflu, 21 ) jrdfint4( dhnocy ), icyln
21        format( 6x, '(6) Number of acquisition cycles   =   ', i10 /
     1      6x, '(7) Acquisition cycle length       =   ', i3,
     2      ' channels' )
        if ( imute .gt. 1 ) then
          if ( iiand( icid, 1 ) .gt. 0 ) then
            write( iopflu, 22 ) ( ichls(i), i = 1, icyln )
          else
            write( iopflu, 22 ) ( i, i = 0, icyln-1 )
            end if
22        format( 6x, '(>=8) A/D channel address list     = ', 8i3 :/
     1      39x, 8i3 )
          end if
c
c           unidentified sub-block
c
      else
        call srdferr( Zlabel // Csublab, Hrdfsblk )
        end if
      return
      end



      CHARACTER *8 FUNCTION GEXTBLK
c
c       EXTract BLocK label
c   Returned value is the current raw data file block label .
c
      implicit none
      include 'rdflib.cmn'
c
      Gextblk = Cblklab
      return
      end



      CHARACTER *8 FUNCTION GEXTSUBL()
c
c       EXTract SUB-block Label
c   Returned value is the current raw data file sub-block label .
c
      implicit none
      include 'rdflib.cmn'
c
      Gextsubl = Csublab
      return
      end



      SUBROUTINE SRDFMUTE( MUTE )
c
c   Set the verbosity flag
c
      implicit none
      integer *4 Mute
      include 'rdflib.cmn'
c
      imute = mute
      return
      end


      SUBROUTINE SEXTTIME( HOUR, MINUTE, SECOND )
c
c       EXTract the TIME stamp of the current block header record . All
c arguments are returned values .
c
c Arguments
c  integer hour,    # hour of the day -- 24 hour clock
c          minute,
c          second
c
      implicit none
      integer hour, minute, second
      include 'rdflib.cmn'
c
      hour   = tstamp(1)
      minute = tstamp(2)
      second = tstamp(3)
      return
      end


      SUBROUTINE SEXTDATE( DAY, MONTH, YEAR )
c
c       EXTract the DATE stamp of the current block header record . All
c arguments are returned values .
c
c Arguments
c  integer day,     # day of the month   1 -- 31
c          month,   # month of the year  1 -- 12
c          year     # two least significant digits of the year
c
      implicit none
      integer day, month, year
      include 'rdflib.cmn'
c
      day   = dstamp(1)
      month = dstamp(2)
      year  = dstamp(3)
      return
      end


      SUBROUTINE SEXTDELAY( MINUTES, SECONDS, MILLISECS )
c
c       EXTract the time delay of the current block header record . All
c arguments are returned values between  1 and 32767 inclusive .
c
c Arguments
c  integer minutes,
c          seconds,
c          millisecs
c
      implicit none
      integer minutes, seconds, millisecs
      include 'rdflib.cmn'
c
      minutes = idelay(1)
      seconds = idelay(2)
      millisecs = idelay(3)
      return
      end


      INTEGER *4 FUNCTION JEXTMDLN( I )
c
c       EXTract the record Number of the Ith MoDuLe header .
c  If I <= 0 , the returned value is the total number of modules in the file .
c  If I > JEXTMDLN( 0 ) , the returned value is the record number of the last
c  module header .
c
c variables
c  integer *4 i                # module number
c
      implicit none
      integer *4 i
      include 'rdflib.cmn'
c
      jextmdln = dirrec( max( 1, min( dirrec(1) + 1, i + 1 ) ) )
      return
      end



      SUBROUTINE CALTVS( IRDFREC )
c
c       Display the traverse calibration table
c   It is assumed that a module header record with a '#caltvs ' label has just
c been read .by a call to ERDFMHD or SRDFMHD .
c
c constants
c    Hvdulu                    # v.d.u. logical unit number
c    Zlabel                    # Routine label
c
c variables
c  integer *4 irdfrec          # data file record pointer
c  integer *2 nbytes           # number of bytes remaining in record
c             Mpdsiz(8)        # number of p/d calibration points for each DOF
c             i1, i2           # looping indices
c  real Utvpot(30,8)           # Potentiometer readings table
c       Utvdis(30,8)           # Traverse displacements table
c       Utvoff(8)              # Traverse displacement offsets
c       Upddgc(8)              # Pot/displ. drift gradient corrections
c       Upddoc(8)              # Pot/displ. drift offset correction
c       Uproff(5,3)            # Probe offset for each traverse
c  byte Ftvdone(8)             # DOFs calibrated flags
c       Blab(8)                # actual header record label
c
      implicit none
      character *6 Zlabel
      integer *2 Hvdulu
      parameter( Hvdulu=6, Zlabel='CALTVS' )
c
      integer *2 nbytes, Mpdsiz(8), Mtvord(8), i1, i2
      integer *4 irdfrec, Mtvpot(30,8), Mtvdis(30,8), Mtvoff(8),
     1  Mpddgc(8), Mpddoc(8), Mtvpol(12,8), Mpdoff(8), Mproff(5,3)
      real qrdfreal
      byte Blab(8), Ftvdone(8)
c
      include 'rdflib.cmn'
      equivalence ( Mhdr(1), Blab(1) ), ( Mhdr(5), nbytes ),
     1  ( Mhdr(6), Ftvdone(1) ), ( Mhdr(10), Mpdsiz(1) ), ( Mtvpot(1,1),
     2  Mtvdis(1,1), Mtvoff(1), Mpddgc(1), Mpddoc(1), Mtvpol(1,1),
     3  Mproff(1,1) )
c
c             get label, byte count, calibrated flags & array size
c
      call dainit
      call daget( irdfrec, Mhdr, 34 )
      call sbytchr( Blab, Cblklab, 8 )
      if ( Cblklab .ne. '##caltvs' )
     1  call srdferr( Zlabel, Hrdfiblk )
c
c           This code must work for version 1 & version 2 traverse calibrations
c
c             version 1 & 2
      if ( nbytes .ne. 2100 .and. nbytes .ne. 2500 )
     1  call srdferr( Zlabel, Hrdfbcnt )
      write( Hvdulu, 1 ) ftvdone, Mpdsiz
1     format( 21x, 'CALIBRATE TRAVERSE block' // 11x, 'DOFs calibrated'
     1  / 5x, 7( l1, 9x ), l1 //
     2  11x, 'Number of Pot.<=>Displ. calibration points' /
     3  4x, 7( i3, 7x ), i3 // 11x, 'Potentiometer readings table' )
      if ( iauxop .gt. 0 .and. iauxop .lt. 100 )
     1  write( iauxop, 1 ) ftvdone, Mpdsiz
c
c             version 2 only
      if ( nbytes .eq. 2500 ) then
        call daget( irdfrec, Mtvord, 16 )
        write( Hvdulu, 8 ) Mtvord
8       format( 11x, 'Polynomial order' / 4x, 7( i3, 7x ), i3 )
        if ( iauxop .gt. 0 .and. iauxop .lt. 100 )
     1     write( iauxop, 8 ) Mtvord
        end if
c
c             get potentiometer readings table
c
c             version 1 & 2
      call daget( irdfrec, Mtvpot, 960 )
      write( Hvdulu, 2 ) ( ( qrdfreal( Mtvpot(i1,i2) ), i2 = 1, 8 ),
     1  i1 = 1, 30 )
2     format( 1x, 8f10.3 )
      if ( iauxop .gt. 0 .and. iauxop .lt. 100 )
     1  write( iauxop, 2 ) ( ( qrdfreal( Mtvpot(i1,i2) ), i2 = 1, 8 ),
     2    i1 = 1, 30 )
c
c             get traverse displacements table
c
c             version 1 & 2
      call daget( irdfrec, Mtvdis, 960 )
      write( Hvdulu, 3 )
3     format( / 11x, 'Traverse displacements table' )
      write( Hvdulu, 2 ) ( ( qrdfreal( Mtvdis(i1,i2) ), i2 = 1, 8 ),
     1  i1 = 1, 30 )
      if ( iauxop .gt. 0 .and. iauxop .lt. 100 ) then
        write( iauxop, 3 )
        write( iauxop, 2 ) ( ( qrdfreal( Mtvdis(i1,i2) ), i2 = 1, 8 ),
     1    i1 = 1, 30 )
        end if
c
c             get traverse displacement offsets
c
c             version 1 & 2
      call daget( irdfrec, Mtvoff, 32 )
      write( Hvdulu, 4 )
4     format( / 11x, 'Traverse displacement offsets' )
      write( Hvdulu, 2 ) ( qrdfreal( Mtvoff(i1) ), i1 = 1, 8 )
      if ( iauxop .gt. 0 .and. iauxop .lt. 100 ) then
        write( iauxop, 4 )
        write( iauxop, 2 ) ( qrdfreal( Mtvoff(i1) ), i1 = 1, 8 )
        end if
c
c             get Pot. / Displ. drift gradient corrections
c
c             version 1 & 2
      call daget( irdfrec, Mpddgc, 32 )
      write( Hvdulu, 5 )
5     format( / 11x, 'Pot./Displ. drift gradient corrections' )
      write( Hvdulu, 2 ) ( qrdfreal( Mpddgc(i1) ), i1 = 1, 8 )
      if ( iauxop .gt. 0 .and. iauxop .lt. 100 ) then
        write( iauxop, 5 )
        write( iauxop, 2 ) ( qrdfreal( Mpddgc(i1) ), i1 = 1, 8 )
        end if
c
c             get Pot. / Displ. drift offset corrections
c
c             version 1 & 2
      call daget( irdfrec, Mpddoc, 32 )
      write( Hvdulu, 6 )
6     format( / 11x, 'Pot./Displ. drift offset corrections' )
      write( Hvdulu, 2 ) ( qrdfreal( Mpddoc(i1) ), i1 = 1, 8 )
      if ( iauxop .gt. 0 .and. iauxop .lt. 100 ) then
        write( iauxop, 6 )
        write( iauxop, 2 ) ( qrdfreal( Mpddoc(i1) ), i1 = 1, 8 )
        end if
c
c             version 2 only
      if ( nbytes .eq. 2500 ) then
        call daget( irdfrec, Mtvpol, 384 )
        write( Hvdulu, 9 )
9       format( / 11x, 'Coefficients of fitted polynomials' )
        write( Hvdulu, 10 ) ( ( qrdfreal( Mtvpol(i1,i2) ), i2 = 1, 8 ),
     1      i1 = 1, 12 )
10      format( 1x, 4g15.7 / 9x, 4g15.7 )
        if ( iauxop .gt. 0 .and. iauxop .lt. 100 ) then
          write( iauxop, 9 )
          write( iauxop, 10 ) ( ( qrdfreal( Mtvpol(i1,i2) ),
     1      i2 = 1, 8 ), i1 = 1, 12 )
          end if
        end if
c
c             get probe offsets
c
c             version 1 & 2
      call daget( irdfrec, Mproff, 60 )
      write( Hvdulu, 7 ) ( ( qrdfreal( Mproff(i1,i2) ), i1 = 1, 5 ),
     1  i2 = 1, 3 )
7     format( / 11x, 'Probe offset coordinates for each traverse' /
     1  ( 1x, 5f12.3 ) )
      if ( iauxop .gt. 0 .and. iauxop .lt. 100 )
     1  write( iauxop, 7 ) ( ( qrdfreal( Mproff(i1,i2) ), i1 = 1, 5 ),
     2  i2 = 1, 3 )
      return
      end
