c
c    Copyright (C) 1997  Peter Vernon Lanspeary
c
c    This program is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    This program is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program; if not, write to the Free Software
c    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c

      PROGRAM TEST_BAR
c
c Test BARLIB
c
      include 'stdio.def'
      integer MAX_AD, MAX_DATA, MAX_TRIES
      parameter( MAX_AD=4095, MAX_DATA=512, MAX_TRIES=4 )
c
      logical ok, EBAR_ADtoP, ebar_open
      integer aux_len, aux_lu, calib_len, cal_rec, i, item, npts,
     1    jljstr, Jresp, new_lun, open_file
      integer *2 AD_max, AD_min, AD_reading, AD_sig(MAX_DATA)
      real press, pressure(MAX_DATA), step, ts_dynamic, volts,
     1    QBAR_ADtoE, QBAR_EtoP, Qresp, qtsdyn
      character aux_file*64, calib_file*64
c
c     subroutine Cresp, ilgwait, newscr, sbar_close, sbar_exam
      data aux_lu, aux_len, calib_len, cal_rec, npts / 0, 1, 1, 1, 5 /
      data aux_file, calib_file / ' ', ' ' /
c
c
c     start of loop
1         call newscr()
          write( STD_OUT, 2 ) cal_rec, calib_file(:calib_len),
     1      aux_file(:aux_len), volts, AD_reading, AD_min, AD_max, npts
2         format(
     9        '  -8) Calibration record no. ', i2 /
     8        '  -7) Calibration file name  ', a /
     7        '  -6) Auxillary file         ', a /
     6        '  -5) Voltage                ', g13.6 /
     4        '  -4) A/D converter reading  ', i4 /
     3        '  -3) Minimum signal         ', i4 /
     2        '  -2) Maximum signal         ', i4 /
     1        '  -1) Number of A/D samples  ', i4 /
     Z        '   0) Exit' /
     1        '   1) EBAR_OPEN( CAL_REC, CALIB_FILE, AUX_LUN )' /
     2        '   2) EBAR_ADtoP( AD_SIG, PRESS, INCREM, NPTS )' /
     3        '   3) QBAR_ADtoE( AD_SIG )' /
     4        '   4) QBAR_EtoP( VOLTS )' /
     5        '   5) QTSDYN( RDYNQ, NPLUG )' /
     6        '   6) SBAR_CLOSE()' /
     7        '   7) SBAR_EXAM()   ', $ )
          item = Jresp( STD_IN, -9, 7, MAX_TRIES )
c
          if ( item .eq. -8 ) then
              write( STD_OUT, 3 )
3             format( ' Calibration record no. ? ', $ )
              cal_rec = Jresp( STD_IN, 0, 10, MAX_TRIES )
          else if ( item .eq. -7 ) then
              write( STD_OUT, 4 )
4             format( ' Calibration file name ? ', $ )
              call Cresp( STD_IN, calib_file, MAX_TRIES )
              calib_len = max( 1, jljstr( calib_file ) )
          else if ( item .eq. -6 ) then
              write( STD_OUT, 5 )
5             format( ' Auxillary file name ? ', $ )
              call Cresp( STD_IN, aux_file, MAX_TRIES )
              if ( aux_file .ne. ' ' ) then
                  aux_lu = open_file( new_lun(), aux_file, 'new', 0 )
              else if ( aux_lu .ne. 0 ) then
                  close( UNIT=aux_lu )
                  aux_lu = 0
              else
                  aux_lu = 0
                  end if
              aux_len = max( 1, jljstr( aux_file ) )
          else if ( item .eq. -5 ) then
              write( STD_OUT, 6 )
6             format( ' Voltage at A/D converter ? ', $ )
              volts = Qresp( STD_IN, 0.0, 10.24, MAX_TRIES )
          else if ( item .eq. -4 ) then
              write( STD_OUT, 7 )
7             format( ' A/D converter reading ? ', $ )
              AD_reading = Jresp( STD_IN, 0, MAX_AD, MAX_TRIES )
          else if ( item .eq. -3 ) then
              write( STD_OUT, 8 )
8             format( ' Minimum signal ? ', $ )
              AD_min = Jresp( STD_IN, 0, MAX_AD, MAX_TRIES )
          else if ( item .eq. -2 ) then
              write( STD_OUT, 9 )
9             format( ' Maximum signal ? ', $ )
              AD_max = Jresp( STD_IN, 0, MAX_AD, MAX_TRIES )
          else if ( item .eq. -1 ) then
              write( STD_OUT, 10 )
10            format( ' Number of A/D samples ? ', $ )
              npts = Jresp( STD_IN, 2, MAX_DATA, MAX_TRIES )
          else if ( item .eq. 0 ) then
              stop
          else if ( item .eq. 1 ) then
              ok = ebar_open( cal_rec, calib_file, aux_lu )
              write( STD_OUT, 12 ) ok
12            format( ' EHW1_OPEN = ', l1 )
          else if ( item .eq. 2 ) then
              step = max( 1, ( AD_max - AD_min ) / ( npts - 1 ) )
              npts = min( npts, AD_max - AD_min + 1 )
              AD_sig(1) = AD_min
              do 13 i = 2, npts
                  AD_sig(i) = AD_sig(i-1) + step
13                continue
              ok = EBAR_ADtoP( AD_sig, pressure, 1, npts )
              write( STD_OUT, 14 ) ok
14            format( ' EBAR_ADtoP = ', l1 )
              write( STD_OUT, 15 ) ( i, AD_sig(i), pressure(i),
     1            i = 1, npts )
15            format( '    A/D signal  air-speed' /
     1                ( i3, 5x, i4, 3x, g13.5 ) )
          else if ( item .eq. 3 ) then
              volts = QBAR_ADtoE( AD_reading )
              write( STD_OUT, 16 ) volts
16            format( ' QBAR_ADtoE = ', g13.6 )
          else if ( item .eq. 4 ) then
              press = QBAR_EtoP( volts )
              write( STD_OUT, 17 ) press
17            format( ' QBAR_EtoP = ', g13.6 )
          else if ( item .eq. 5 ) then
              ts_dynamic = qtsdyn( press, 1 )
              write( STD_OUT, 18 ) ts_dynamic
18            format( ' Qtsdyn = ', g13.6 )
          else if ( item .eq. 6 ) then
              call sbar_close()
          else if ( item .eq. 7 ) then
              call sbar_exam()
              end if
          if ( 1 .le. item .and. item .le. 7 )
     1        call ilgwait()
          goto 1
c         end of loop
      end

