c
c    Copyright (C) 1997  Peter Vernon Lanspeary
c
c    This program is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 2 of the License, or
c    (at your option) any later version.
c
c    This program is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program; if not, write to the Free Software
c    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
c

      PROGRAM TEST_HW1
c
c Test HW1LIB.FOR
c
      include 'stdio.def'
      integer MAX_TRIES, MAX_DATA, MAX_AD
      parameter( MAX_TRIES=4, MAX_DATA=512, MAX_AD=4095 )
c
      logical ok, EHW1_OPEN, EHW1_ADtoU
      integer aux_len, aux_lu, cal_rec, calib_len, i, item, method,
     1    n_clip, npts, step,
     2    Jresp, JHW1_lower, JHW1_upper, jljstr, new_lun, open_file
      integer *2 AD_max, AD_min, AD_reading, AD_sig(MAX_DATA),
     1    JHW1_E2toAD, JHW1_METHOD
      real CTA_sq, speed, speeds(MAX_DATA),
     1    QHW1_ADtoE2, QHW1_E2toU, QHW1_UtoE2, Qresp
      character aux_file*64, calib_file*64
c     subroutine cresp, newscr, shw1_close, shw1_exam, ilgwait
      data aux_lu, aux_len, calib_len, cal_rec, npts / 0, 1, 1, 1, 5 /
      data aux_file, calib_file / ' ', ' ' /
c
c
c     start of loop
1         call newscr()
          write( STD_OUT, 2 ) method, cal_rec, calib_file(:calib_len),
     1        aux_file(:aux_len), CTA_sq, speed, AD_reading,
     2        AD_min, AD_max, npts
2         format(
     T        ' -10) Method                 ', i2 /
     9        '  -9) Calibration record no. ', i2 /
     8        '  -8) Calibration file name  ', a /
     7        '  -7) Auxillary file         ', a /
     6        '  -6) CTA output squared     ', g13.6 /
     5        '  -5) Air speed              ', g13.6 /
     4        '  -4) A/D converter reading  ', i4 /
     3        '  -3) Minimum signal         ', i4 /
     2        '  -2) Maximum signal         ', i4 /
     1        '  -1) Number of A/D samples  ', i4 /
     Z        '   0) Exit' /
     1        '   1) EHW1_OPEN( CAL_REC, CALIB_FILE, AUX_LU )' /
     2        '   2) SHW1_CLOSE' /
     3        '   3) QHW1_ADtoE2( IADSIG )' /
     4        '   4) JHW1_E2toAD( CTA_SQ )' /
     5        '   5) QHW1_UtoE2( SPEED )' /
     6        '   6) QHW1_E2toU( CTA_SQ )' /
     7        '   7) EHW1_ADtoU( AD_SIG, SPEEDS, INCREM, NPTS )' /
     8        '   8) SHW1_EXAM' /
     9        '   9) JHW1_UPPER( SPEEDS, INCREM, NPTS )' /
     T        '  10) JHW1_LOWER( SPEEDS, INCREM, NPTS )' /
     1        '  11) JHW1_METHOD( HOW )   ', $ )
          item = Jresp( STD_IN, -10, 11, 4 )
c
          if ( item .eq. -10 ) then
              write( STD_OUT, 23 )
23            format( ' Method ? ', $ )
              method = Jresp( STD_IN, -10, 10, MAX_TRIES )
          else if ( item .eq. -9 ) then
              write( STD_OUT, 3 )
3             format( ' Calibration record no. ? ', $ )
              cal_rec = Jresp( STD_IN, 0, 10, MAX_TRIES )
          else if ( item .eq. -8 ) then
              write( STD_OUT, 4 )
4             format( ' Calibration file name ? ', $ )
              call Cresp( STD_IN, calib_file, MAX_TRIES )
              calib_len = max( 1, jljstr( calib_file ) )
          else if ( item .eq. -7 ) then
              write( STD_OUT, 5 )
5             format( ' Auxillary file name ? ', $ )
              call Cresp( STD_IN, aux_file, MAX_TRIES )
              if ( aux_file .ne. ' ' ) then
                  aux_lu = open_file( new_lun(), aux_file, 'new', 0 )
              else if ( aux_lu .ne. 0 ) then
                  close( UNIT=aux_lu )
                  aux_lu = 0
              else
                  aux_lu = 0
                  end if
              aux_len = max( 1, jljstr( aux_file ) )
          else if ( item .eq. -6 ) then
              write( STD_OUT, 6 )
6             format( ' CTA output squared ? ', $ )
              CTA_sq = Qresp( STD_IN, 0.0, 150.0, MAX_TRIES )
          else if ( item .eq. -5 ) then
              write( STD_OUT, 7 )
7             format( ' Air speed ? ', $ )
              speed = Qresp( STD_IN, 0.0, 12.0, MAX_TRIES )
          else if ( item .eq. -4 ) then
              write( STD_OUT, 8 )
8             format( ' A/D converter reading ? ', $ )
              AD_reading = Jresp( STD_IN, 0, MAX_AD, MAX_TRIES )
          else if ( item .eq. -3 ) then
              write( STD_OUT, 9 )
9             format( ' Minimum signal ? ', $ )
              AD_min = Jresp( STD_IN, 0, MAX_AD, MAX_TRIES )
          else if ( item .eq. -2 ) then
              write( STD_OUT, 10 )
10            format( ' Maximum signal ? ', $ )
              AD_max = Jresp( STD_IN, 0, MAX_AD, MAX_TRIES )
          else if ( item .eq. -1 ) then
              write( STD_OUT, 11 )
11            format( ' Number of A/D samples ? ', $ )
              npts = Jresp( STD_IN, 2, MAX_DATA, MAX_TRIES )
          else if ( item .eq. 0 ) then
              stop
          else if ( item .eq. 1 ) then
              ok = ehw1_open( cal_rec, calib_file, aux_lu )
              write( STD_OUT, 12 ) ok
12            format( ' EHW1_OPEN = ', l1 )
          else if ( item .eq. 2 ) then
              call shw1_close()
          else if ( item .eq. 3 ) then
              CTA_sq = QHW1_ADtoE2( AD_reading )
              write( STD_OUT, 13 ) CTA_sq
13            format( ' QHW1_ADtoE2 = ', g13.6 )
          else if ( item .eq. 4 ) then
              AD_reading = JHW1_E2toAD( cta_sq )
              write( STD_OUT, 14 ) AD_reading
14            format( ' JHW1_E2toAD = ', i4 )
          else if ( item .eq. 5 ) then
              CTA_sq = QHW1_UtoE2( speed )
              write( STD_OUT, 15 ) CTA_sq
15            format( ' QHW1_UtoE2 = ', g13.6 )
          else if ( item .eq. 6 ) then
              speed = QHW1_E2toU( CTA_sq )
              write( STD_OUT, 16 ) speed
16            format( ' QHW1_E2toU = ', g13.6 )
          else if ( item .eq. 7 ) then
              step = max( 1, ( AD_max - AD_min ) / ( npts - 1 ) )
              npts = min( npts, AD_max - AD_min + 1 )
              AD_sig(1) = AD_min
              do 20 i = 2, npts
                  AD_sig(i) = AD_sig(i-1) + step
20                continue
              ok = EHW1_ADtoU( AD_sig, speeds, 1, npts )
              write( STD_OUT, 17 ) ok
17            format( ' EHW1_ADtoU = ', l1 )
              write( STD_OUT, 21 ) ( i, AD_sig(i), speeds(i), i=1,npts )
21            format( '    A/D signal  air-speed' /
     1                ( i3, 5x, i4, 3x, g13.5 ) )
          else if ( item .eq. 8 ) then
              call shw1_exam()
          else if ( item .eq. 9 ) then
              n_clip = JHW1_upper( speeds, 1, npts )
              write( STD_OUT, 18 ) n_clip
18            format( ' JHW1_upper = ', i8 )
          else if ( item .eq. 10 ) then
              n_clip = JHW1_lower( speeds, 1, npts )
              write( STD_OUT, 19 ) n_clip
19            format( ' JHW1_upper = ', i8 )
          else if ( item .eq. 11 ) then
              method = JHW1_method( method )
              write( STD_OUT, 22 ) method
22            format( ' JHW1_method = ', i2 )
              end if
          if ( 1 .le. item .and. item .le. 12 )
     1        call ilgwait()
          goto 1
c         end of loop
      end

